# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ServiceDiscoveryRuleArgs', 'ServiceDiscoveryRule']

@pulumi.input_type
class ServiceDiscoveryRuleArgs:
    def __init__(__self__, *,
                 discovery_rules: pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleDiscoveryRuleArgs']]],
                 log_file_suffixes: pulumi.Input[Sequence[pulumi.Input[str]]],
                 name_rules: pulumi.Input['ServiceDiscoveryRuleNameRulesArgs'],
                 service_type: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 detect_log_enabled: Optional[pulumi.Input[bool]] = None,
                 discovery_rule_enabled: Optional[pulumi.Input[bool]] = None,
                 is_default_rule: Optional[pulumi.Input[bool]] = None,
                 log_path_rules: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleLogPathRuleArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 region: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ServiceDiscoveryRule resource.
        :param pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleDiscoveryRuleArgs']]] discovery_rules: Specifies the discovery rule. If the array contains multiple conditions, only the
               processes that meet all the conditions will be matched. If the value of `check_type` is **cmdLine**, set the value of
               `check_mode` to **contain**. `check_content` is in the format of ["xxx"], indicating that the process must contain
               the xxx parameter. If the value of `check_type` is **env**, set the value of `check_mode` to **contain**.
               `check_content` is in the format of ["k1","v1"], indicating that the process must contain the environment variable
               whose name is k1 and value is v1. If the value of `check_type` is **scope**, set the value of `check_mode`
               to **equals**. `check_content` is in the format of ["hostId1","hostId2"], indicating that the rule takes effect only
               on specified nodes. If no nodes are specified, the rule applies to all nodes of the project.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] log_file_suffixes: Specifies the log file suffix. This is a list of strings.
               The values can be: **log**, **trace**, and **out**.
        :param pulumi.Input['ServiceDiscoveryRuleNameRulesArgs'] name_rules: Specifies the naming rules for discovered services and applications.
               The object structure is documented below.
        :param pulumi.Input[str] service_type: Specifies the service type, which is used only for rule classification and UI display.
               You can enter any field. For example, enter Java or Python by technology stack, or enter collector or database by function.
        :param pulumi.Input[str] description: Specifies the rule description.
        :param pulumi.Input[bool] detect_log_enabled: Specifies whether to enable log collection. The default value is true.
        :param pulumi.Input[bool] discovery_rule_enabled: Specifies whether the rule is enabled. The default value is true.
        :param pulumi.Input[bool] is_default_rule: Specifies whether the rule is the default one. The default value is false.
        :param pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleLogPathRuleArgs']]] log_path_rules: Specifies the log path configuration rule. If cmdLineHash is a fixed string,
               logs in the specified log path or log file are collected. Otherwise, only the files whose names end with
               .log or .trace are collected. If the value of `name_type` is **cmdLineHash**, args is in the format of ["00001"] and
               value is in the format of ["/xxx/xx.log"], indicating that the log path is /xxx/xx.log when the startup command is 00001.
        :param pulumi.Input[str] name: Specifies the rule name, which contains `4` to `63` characters. It must start
               with a lowercase letter but cannot end with a hyphen (-). Only digits, lowercase letters, and hyphens are allowed.
        :param pulumi.Input[int] priority: Specifies the rule priority. Value range: 1 to 9999. The default value is 9999.
        :param pulumi.Input[str] region: The region in which to create the service discovery rule resource. If omitted,
               the provider-level region will be used. Changing this creates a new resource.
        """
        pulumi.set(__self__, "discovery_rules", discovery_rules)
        pulumi.set(__self__, "log_file_suffixes", log_file_suffixes)
        pulumi.set(__self__, "name_rules", name_rules)
        pulumi.set(__self__, "service_type", service_type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if detect_log_enabled is not None:
            pulumi.set(__self__, "detect_log_enabled", detect_log_enabled)
        if discovery_rule_enabled is not None:
            pulumi.set(__self__, "discovery_rule_enabled", discovery_rule_enabled)
        if is_default_rule is not None:
            pulumi.set(__self__, "is_default_rule", is_default_rule)
        if log_path_rules is not None:
            pulumi.set(__self__, "log_path_rules", log_path_rules)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if priority is not None:
            pulumi.set(__self__, "priority", priority)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="discoveryRules")
    def discovery_rules(self) -> pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleDiscoveryRuleArgs']]]:
        """
        Specifies the discovery rule. If the array contains multiple conditions, only the
        processes that meet all the conditions will be matched. If the value of `check_type` is **cmdLine**, set the value of
        `check_mode` to **contain**. `check_content` is in the format of ["xxx"], indicating that the process must contain
        the xxx parameter. If the value of `check_type` is **env**, set the value of `check_mode` to **contain**.
        `check_content` is in the format of ["k1","v1"], indicating that the process must contain the environment variable
        whose name is k1 and value is v1. If the value of `check_type` is **scope**, set the value of `check_mode`
        to **equals**. `check_content` is in the format of ["hostId1","hostId2"], indicating that the rule takes effect only
        on specified nodes. If no nodes are specified, the rule applies to all nodes of the project.
        """
        return pulumi.get(self, "discovery_rules")

    @discovery_rules.setter
    def discovery_rules(self, value: pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleDiscoveryRuleArgs']]]):
        pulumi.set(self, "discovery_rules", value)

    @property
    @pulumi.getter(name="logFileSuffixes")
    def log_file_suffixes(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Specifies the log file suffix. This is a list of strings.
        The values can be: **log**, **trace**, and **out**.
        """
        return pulumi.get(self, "log_file_suffixes")

    @log_file_suffixes.setter
    def log_file_suffixes(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "log_file_suffixes", value)

    @property
    @pulumi.getter(name="nameRules")
    def name_rules(self) -> pulumi.Input['ServiceDiscoveryRuleNameRulesArgs']:
        """
        Specifies the naming rules for discovered services and applications.
        The object structure is documented below.
        """
        return pulumi.get(self, "name_rules")

    @name_rules.setter
    def name_rules(self, value: pulumi.Input['ServiceDiscoveryRuleNameRulesArgs']):
        pulumi.set(self, "name_rules", value)

    @property
    @pulumi.getter(name="serviceType")
    def service_type(self) -> pulumi.Input[str]:
        """
        Specifies the service type, which is used only for rule classification and UI display.
        You can enter any field. For example, enter Java or Python by technology stack, or enter collector or database by function.
        """
        return pulumi.get(self, "service_type")

    @service_type.setter
    def service_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "service_type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the rule description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="detectLogEnabled")
    def detect_log_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether to enable log collection. The default value is true.
        """
        return pulumi.get(self, "detect_log_enabled")

    @detect_log_enabled.setter
    def detect_log_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "detect_log_enabled", value)

    @property
    @pulumi.getter(name="discoveryRuleEnabled")
    def discovery_rule_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether the rule is enabled. The default value is true.
        """
        return pulumi.get(self, "discovery_rule_enabled")

    @discovery_rule_enabled.setter
    def discovery_rule_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "discovery_rule_enabled", value)

    @property
    @pulumi.getter(name="isDefaultRule")
    def is_default_rule(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether the rule is the default one. The default value is false.
        """
        return pulumi.get(self, "is_default_rule")

    @is_default_rule.setter
    def is_default_rule(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_default_rule", value)

    @property
    @pulumi.getter(name="logPathRules")
    def log_path_rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleLogPathRuleArgs']]]]:
        """
        Specifies the log path configuration rule. If cmdLineHash is a fixed string,
        logs in the specified log path or log file are collected. Otherwise, only the files whose names end with
        .log or .trace are collected. If the value of `name_type` is **cmdLineHash**, args is in the format of ["00001"] and
        value is in the format of ["/xxx/xx.log"], indicating that the log path is /xxx/xx.log when the startup command is 00001.
        """
        return pulumi.get(self, "log_path_rules")

    @log_path_rules.setter
    def log_path_rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleLogPathRuleArgs']]]]):
        pulumi.set(self, "log_path_rules", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the rule name, which contains `4` to `63` characters. It must start
        with a lowercase letter but cannot end with a hyphen (-). Only digits, lowercase letters, and hyphens are allowed.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def priority(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the rule priority. Value range: 1 to 9999. The default value is 9999.
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        The region in which to create the service discovery rule resource. If omitted,
        the provider-level region will be used. Changing this creates a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)


@pulumi.input_type
class _ServiceDiscoveryRuleState:
    def __init__(__self__, *,
                 created_at: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 detect_log_enabled: Optional[pulumi.Input[bool]] = None,
                 discovery_rule_enabled: Optional[pulumi.Input[bool]] = None,
                 discovery_rules: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleDiscoveryRuleArgs']]]] = None,
                 is_default_rule: Optional[pulumi.Input[bool]] = None,
                 log_file_suffixes: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 log_path_rules: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleLogPathRuleArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 name_rules: Optional[pulumi.Input['ServiceDiscoveryRuleNameRulesArgs']] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 rule_id: Optional[pulumi.Input[str]] = None,
                 service_type: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ServiceDiscoveryRule resources.
        :param pulumi.Input[str] created_at: The rule create time.
        :param pulumi.Input[str] description: Specifies the rule description.
        :param pulumi.Input[bool] detect_log_enabled: Specifies whether to enable log collection. The default value is true.
        :param pulumi.Input[bool] discovery_rule_enabled: Specifies whether the rule is enabled. The default value is true.
        :param pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleDiscoveryRuleArgs']]] discovery_rules: Specifies the discovery rule. If the array contains multiple conditions, only the
               processes that meet all the conditions will be matched. If the value of `check_type` is **cmdLine**, set the value of
               `check_mode` to **contain**. `check_content` is in the format of ["xxx"], indicating that the process must contain
               the xxx parameter. If the value of `check_type` is **env**, set the value of `check_mode` to **contain**.
               `check_content` is in the format of ["k1","v1"], indicating that the process must contain the environment variable
               whose name is k1 and value is v1. If the value of `check_type` is **scope**, set the value of `check_mode`
               to **equals**. `check_content` is in the format of ["hostId1","hostId2"], indicating that the rule takes effect only
               on specified nodes. If no nodes are specified, the rule applies to all nodes of the project.
        :param pulumi.Input[bool] is_default_rule: Specifies whether the rule is the default one. The default value is false.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] log_file_suffixes: Specifies the log file suffix. This is a list of strings.
               The values can be: **log**, **trace**, and **out**.
        :param pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleLogPathRuleArgs']]] log_path_rules: Specifies the log path configuration rule. If cmdLineHash is a fixed string,
               logs in the specified log path or log file are collected. Otherwise, only the files whose names end with
               .log or .trace are collected. If the value of `name_type` is **cmdLineHash**, args is in the format of ["00001"] and
               value is in the format of ["/xxx/xx.log"], indicating that the log path is /xxx/xx.log when the startup command is 00001.
        :param pulumi.Input[str] name: Specifies the rule name, which contains `4` to `63` characters. It must start
               with a lowercase letter but cannot end with a hyphen (-). Only digits, lowercase letters, and hyphens are allowed.
        :param pulumi.Input['ServiceDiscoveryRuleNameRulesArgs'] name_rules: Specifies the naming rules for discovered services and applications.
               The object structure is documented below.
        :param pulumi.Input[int] priority: Specifies the rule priority. Value range: 1 to 9999. The default value is 9999.
        :param pulumi.Input[str] region: The region in which to create the service discovery rule resource. If omitted,
               the provider-level region will be used. Changing this creates a new resource.
        :param pulumi.Input[str] rule_id: The rule ID in uuid format.
        :param pulumi.Input[str] service_type: Specifies the service type, which is used only for rule classification and UI display.
               You can enter any field. For example, enter Java or Python by technology stack, or enter collector or database by function.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if detect_log_enabled is not None:
            pulumi.set(__self__, "detect_log_enabled", detect_log_enabled)
        if discovery_rule_enabled is not None:
            pulumi.set(__self__, "discovery_rule_enabled", discovery_rule_enabled)
        if discovery_rules is not None:
            pulumi.set(__self__, "discovery_rules", discovery_rules)
        if is_default_rule is not None:
            pulumi.set(__self__, "is_default_rule", is_default_rule)
        if log_file_suffixes is not None:
            pulumi.set(__self__, "log_file_suffixes", log_file_suffixes)
        if log_path_rules is not None:
            pulumi.set(__self__, "log_path_rules", log_path_rules)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if name_rules is not None:
            pulumi.set(__self__, "name_rules", name_rules)
        if priority is not None:
            pulumi.set(__self__, "priority", priority)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if rule_id is not None:
            pulumi.set(__self__, "rule_id", rule_id)
        if service_type is not None:
            pulumi.set(__self__, "service_type", service_type)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[str]]:
        """
        The rule create time.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the rule description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="detectLogEnabled")
    def detect_log_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether to enable log collection. The default value is true.
        """
        return pulumi.get(self, "detect_log_enabled")

    @detect_log_enabled.setter
    def detect_log_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "detect_log_enabled", value)

    @property
    @pulumi.getter(name="discoveryRuleEnabled")
    def discovery_rule_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether the rule is enabled. The default value is true.
        """
        return pulumi.get(self, "discovery_rule_enabled")

    @discovery_rule_enabled.setter
    def discovery_rule_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "discovery_rule_enabled", value)

    @property
    @pulumi.getter(name="discoveryRules")
    def discovery_rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleDiscoveryRuleArgs']]]]:
        """
        Specifies the discovery rule. If the array contains multiple conditions, only the
        processes that meet all the conditions will be matched. If the value of `check_type` is **cmdLine**, set the value of
        `check_mode` to **contain**. `check_content` is in the format of ["xxx"], indicating that the process must contain
        the xxx parameter. If the value of `check_type` is **env**, set the value of `check_mode` to **contain**.
        `check_content` is in the format of ["k1","v1"], indicating that the process must contain the environment variable
        whose name is k1 and value is v1. If the value of `check_type` is **scope**, set the value of `check_mode`
        to **equals**. `check_content` is in the format of ["hostId1","hostId2"], indicating that the rule takes effect only
        on specified nodes. If no nodes are specified, the rule applies to all nodes of the project.
        """
        return pulumi.get(self, "discovery_rules")

    @discovery_rules.setter
    def discovery_rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleDiscoveryRuleArgs']]]]):
        pulumi.set(self, "discovery_rules", value)

    @property
    @pulumi.getter(name="isDefaultRule")
    def is_default_rule(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether the rule is the default one. The default value is false.
        """
        return pulumi.get(self, "is_default_rule")

    @is_default_rule.setter
    def is_default_rule(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_default_rule", value)

    @property
    @pulumi.getter(name="logFileSuffixes")
    def log_file_suffixes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Specifies the log file suffix. This is a list of strings.
        The values can be: **log**, **trace**, and **out**.
        """
        return pulumi.get(self, "log_file_suffixes")

    @log_file_suffixes.setter
    def log_file_suffixes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "log_file_suffixes", value)

    @property
    @pulumi.getter(name="logPathRules")
    def log_path_rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleLogPathRuleArgs']]]]:
        """
        Specifies the log path configuration rule. If cmdLineHash is a fixed string,
        logs in the specified log path or log file are collected. Otherwise, only the files whose names end with
        .log or .trace are collected. If the value of `name_type` is **cmdLineHash**, args is in the format of ["00001"] and
        value is in the format of ["/xxx/xx.log"], indicating that the log path is /xxx/xx.log when the startup command is 00001.
        """
        return pulumi.get(self, "log_path_rules")

    @log_path_rules.setter
    def log_path_rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceDiscoveryRuleLogPathRuleArgs']]]]):
        pulumi.set(self, "log_path_rules", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the rule name, which contains `4` to `63` characters. It must start
        with a lowercase letter but cannot end with a hyphen (-). Only digits, lowercase letters, and hyphens are allowed.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="nameRules")
    def name_rules(self) -> Optional[pulumi.Input['ServiceDiscoveryRuleNameRulesArgs']]:
        """
        Specifies the naming rules for discovered services and applications.
        The object structure is documented below.
        """
        return pulumi.get(self, "name_rules")

    @name_rules.setter
    def name_rules(self, value: Optional[pulumi.Input['ServiceDiscoveryRuleNameRulesArgs']]):
        pulumi.set(self, "name_rules", value)

    @property
    @pulumi.getter
    def priority(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the rule priority. Value range: 1 to 9999. The default value is 9999.
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        The region in which to create the service discovery rule resource. If omitted,
        the provider-level region will be used. Changing this creates a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> Optional[pulumi.Input[str]]:
        """
        The rule ID in uuid format.
        """
        return pulumi.get(self, "rule_id")

    @rule_id.setter
    def rule_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_id", value)

    @property
    @pulumi.getter(name="serviceType")
    def service_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the service type, which is used only for rule classification and UI display.
        You can enter any field. For example, enter Java or Python by technology stack, or enter collector or database by function.
        """
        return pulumi.get(self, "service_type")

    @service_type.setter
    def service_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "service_type", value)


class ServiceDiscoveryRule(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 detect_log_enabled: Optional[pulumi.Input[bool]] = None,
                 discovery_rule_enabled: Optional[pulumi.Input[bool]] = None,
                 discovery_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleDiscoveryRuleArgs']]]]] = None,
                 is_default_rule: Optional[pulumi.Input[bool]] = None,
                 log_file_suffixes: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 log_path_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleLogPathRuleArgs']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 name_rules: Optional[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleNameRulesArgs']]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 service_type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages an AOM service discovery rule resource within HuaweiCloud.

        ## Example Usage
        ### Basic example

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        discovery_rule = huaweicloud.aom.ServiceDiscoveryRule("discoveryRule",
            detect_log_enabled=True,
            discovery_rule_enabled=True,
            discovery_rules=[huaweicloud.aom.ServiceDiscoveryRuleDiscoveryRuleArgs(
                check_contents=["java"],
                check_mode="contain",
                check_type="cmdLine",
            )],
            is_default_rule=False,
            log_file_suffixes=["log"],
            log_path_rules=[huaweicloud.aom.ServiceDiscoveryRuleLogPathRuleArgs(
                args=["java"],
                name_type="cmdLineHash",
                values=["/tmp/log"],
            )],
            name_rules=huaweicloud.aom.ServiceDiscoveryRuleNameRulesArgs(
                application_name_rules=[huaweicloud.aom.ServiceDiscoveryRuleNameRulesApplicationNameRuleArgs(
                    args=["java"],
                    name_type="str",
                )],
                service_name_rules=[huaweicloud.aom.ServiceDiscoveryRuleNameRulesServiceNameRuleArgs(
                    args=["java"],
                    name_type="str",
                )],
            ),
            priority=9999,
            service_type="Java")
        ```

        ## Import

        AOM service discovery rules can be imported using the `name`, e.g. bash

        ```sh
         $ pulumi import huaweicloud:Aom/serviceDiscoveryRule:ServiceDiscoveryRule alarm_rule <name>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Specifies the rule description.
        :param pulumi.Input[bool] detect_log_enabled: Specifies whether to enable log collection. The default value is true.
        :param pulumi.Input[bool] discovery_rule_enabled: Specifies whether the rule is enabled. The default value is true.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleDiscoveryRuleArgs']]]] discovery_rules: Specifies the discovery rule. If the array contains multiple conditions, only the
               processes that meet all the conditions will be matched. If the value of `check_type` is **cmdLine**, set the value of
               `check_mode` to **contain**. `check_content` is in the format of ["xxx"], indicating that the process must contain
               the xxx parameter. If the value of `check_type` is **env**, set the value of `check_mode` to **contain**.
               `check_content` is in the format of ["k1","v1"], indicating that the process must contain the environment variable
               whose name is k1 and value is v1. If the value of `check_type` is **scope**, set the value of `check_mode`
               to **equals**. `check_content` is in the format of ["hostId1","hostId2"], indicating that the rule takes effect only
               on specified nodes. If no nodes are specified, the rule applies to all nodes of the project.
        :param pulumi.Input[bool] is_default_rule: Specifies whether the rule is the default one. The default value is false.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] log_file_suffixes: Specifies the log file suffix. This is a list of strings.
               The values can be: **log**, **trace**, and **out**.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleLogPathRuleArgs']]]] log_path_rules: Specifies the log path configuration rule. If cmdLineHash is a fixed string,
               logs in the specified log path or log file are collected. Otherwise, only the files whose names end with
               .log or .trace are collected. If the value of `name_type` is **cmdLineHash**, args is in the format of ["00001"] and
               value is in the format of ["/xxx/xx.log"], indicating that the log path is /xxx/xx.log when the startup command is 00001.
        :param pulumi.Input[str] name: Specifies the rule name, which contains `4` to `63` characters. It must start
               with a lowercase letter but cannot end with a hyphen (-). Only digits, lowercase letters, and hyphens are allowed.
        :param pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleNameRulesArgs']] name_rules: Specifies the naming rules for discovered services and applications.
               The object structure is documented below.
        :param pulumi.Input[int] priority: Specifies the rule priority. Value range: 1 to 9999. The default value is 9999.
        :param pulumi.Input[str] region: The region in which to create the service discovery rule resource. If omitted,
               the provider-level region will be used. Changing this creates a new resource.
        :param pulumi.Input[str] service_type: Specifies the service type, which is used only for rule classification and UI display.
               You can enter any field. For example, enter Java or Python by technology stack, or enter collector or database by function.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ServiceDiscoveryRuleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages an AOM service discovery rule resource within HuaweiCloud.

        ## Example Usage
        ### Basic example

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        discovery_rule = huaweicloud.aom.ServiceDiscoveryRule("discoveryRule",
            detect_log_enabled=True,
            discovery_rule_enabled=True,
            discovery_rules=[huaweicloud.aom.ServiceDiscoveryRuleDiscoveryRuleArgs(
                check_contents=["java"],
                check_mode="contain",
                check_type="cmdLine",
            )],
            is_default_rule=False,
            log_file_suffixes=["log"],
            log_path_rules=[huaweicloud.aom.ServiceDiscoveryRuleLogPathRuleArgs(
                args=["java"],
                name_type="cmdLineHash",
                values=["/tmp/log"],
            )],
            name_rules=huaweicloud.aom.ServiceDiscoveryRuleNameRulesArgs(
                application_name_rules=[huaweicloud.aom.ServiceDiscoveryRuleNameRulesApplicationNameRuleArgs(
                    args=["java"],
                    name_type="str",
                )],
                service_name_rules=[huaweicloud.aom.ServiceDiscoveryRuleNameRulesServiceNameRuleArgs(
                    args=["java"],
                    name_type="str",
                )],
            ),
            priority=9999,
            service_type="Java")
        ```

        ## Import

        AOM service discovery rules can be imported using the `name`, e.g. bash

        ```sh
         $ pulumi import huaweicloud:Aom/serviceDiscoveryRule:ServiceDiscoveryRule alarm_rule <name>
        ```

        :param str resource_name: The name of the resource.
        :param ServiceDiscoveryRuleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ServiceDiscoveryRuleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 detect_log_enabled: Optional[pulumi.Input[bool]] = None,
                 discovery_rule_enabled: Optional[pulumi.Input[bool]] = None,
                 discovery_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleDiscoveryRuleArgs']]]]] = None,
                 is_default_rule: Optional[pulumi.Input[bool]] = None,
                 log_file_suffixes: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 log_path_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleLogPathRuleArgs']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 name_rules: Optional[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleNameRulesArgs']]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 service_type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ServiceDiscoveryRuleArgs.__new__(ServiceDiscoveryRuleArgs)

            __props__.__dict__["description"] = description
            __props__.__dict__["detect_log_enabled"] = detect_log_enabled
            __props__.__dict__["discovery_rule_enabled"] = discovery_rule_enabled
            if discovery_rules is None and not opts.urn:
                raise TypeError("Missing required property 'discovery_rules'")
            __props__.__dict__["discovery_rules"] = discovery_rules
            __props__.__dict__["is_default_rule"] = is_default_rule
            if log_file_suffixes is None and not opts.urn:
                raise TypeError("Missing required property 'log_file_suffixes'")
            __props__.__dict__["log_file_suffixes"] = log_file_suffixes
            __props__.__dict__["log_path_rules"] = log_path_rules
            __props__.__dict__["name"] = name
            if name_rules is None and not opts.urn:
                raise TypeError("Missing required property 'name_rules'")
            __props__.__dict__["name_rules"] = name_rules
            __props__.__dict__["priority"] = priority
            __props__.__dict__["region"] = region
            if service_type is None and not opts.urn:
                raise TypeError("Missing required property 'service_type'")
            __props__.__dict__["service_type"] = service_type
            __props__.__dict__["created_at"] = None
            __props__.__dict__["rule_id"] = None
        super(ServiceDiscoveryRule, __self__).__init__(
            'huaweicloud:Aom/serviceDiscoveryRule:ServiceDiscoveryRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            created_at: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            detect_log_enabled: Optional[pulumi.Input[bool]] = None,
            discovery_rule_enabled: Optional[pulumi.Input[bool]] = None,
            discovery_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleDiscoveryRuleArgs']]]]] = None,
            is_default_rule: Optional[pulumi.Input[bool]] = None,
            log_file_suffixes: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            log_path_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleLogPathRuleArgs']]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            name_rules: Optional[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleNameRulesArgs']]] = None,
            priority: Optional[pulumi.Input[int]] = None,
            region: Optional[pulumi.Input[str]] = None,
            rule_id: Optional[pulumi.Input[str]] = None,
            service_type: Optional[pulumi.Input[str]] = None) -> 'ServiceDiscoveryRule':
        """
        Get an existing ServiceDiscoveryRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] created_at: The rule create time.
        :param pulumi.Input[str] description: Specifies the rule description.
        :param pulumi.Input[bool] detect_log_enabled: Specifies whether to enable log collection. The default value is true.
        :param pulumi.Input[bool] discovery_rule_enabled: Specifies whether the rule is enabled. The default value is true.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleDiscoveryRuleArgs']]]] discovery_rules: Specifies the discovery rule. If the array contains multiple conditions, only the
               processes that meet all the conditions will be matched. If the value of `check_type` is **cmdLine**, set the value of
               `check_mode` to **contain**. `check_content` is in the format of ["xxx"], indicating that the process must contain
               the xxx parameter. If the value of `check_type` is **env**, set the value of `check_mode` to **contain**.
               `check_content` is in the format of ["k1","v1"], indicating that the process must contain the environment variable
               whose name is k1 and value is v1. If the value of `check_type` is **scope**, set the value of `check_mode`
               to **equals**. `check_content` is in the format of ["hostId1","hostId2"], indicating that the rule takes effect only
               on specified nodes. If no nodes are specified, the rule applies to all nodes of the project.
        :param pulumi.Input[bool] is_default_rule: Specifies whether the rule is the default one. The default value is false.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] log_file_suffixes: Specifies the log file suffix. This is a list of strings.
               The values can be: **log**, **trace**, and **out**.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleLogPathRuleArgs']]]] log_path_rules: Specifies the log path configuration rule. If cmdLineHash is a fixed string,
               logs in the specified log path or log file are collected. Otherwise, only the files whose names end with
               .log or .trace are collected. If the value of `name_type` is **cmdLineHash**, args is in the format of ["00001"] and
               value is in the format of ["/xxx/xx.log"], indicating that the log path is /xxx/xx.log when the startup command is 00001.
        :param pulumi.Input[str] name: Specifies the rule name, which contains `4` to `63` characters. It must start
               with a lowercase letter but cannot end with a hyphen (-). Only digits, lowercase letters, and hyphens are allowed.
        :param pulumi.Input[pulumi.InputType['ServiceDiscoveryRuleNameRulesArgs']] name_rules: Specifies the naming rules for discovered services and applications.
               The object structure is documented below.
        :param pulumi.Input[int] priority: Specifies the rule priority. Value range: 1 to 9999. The default value is 9999.
        :param pulumi.Input[str] region: The region in which to create the service discovery rule resource. If omitted,
               the provider-level region will be used. Changing this creates a new resource.
        :param pulumi.Input[str] rule_id: The rule ID in uuid format.
        :param pulumi.Input[str] service_type: Specifies the service type, which is used only for rule classification and UI display.
               You can enter any field. For example, enter Java or Python by technology stack, or enter collector or database by function.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ServiceDiscoveryRuleState.__new__(_ServiceDiscoveryRuleState)

        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["description"] = description
        __props__.__dict__["detect_log_enabled"] = detect_log_enabled
        __props__.__dict__["discovery_rule_enabled"] = discovery_rule_enabled
        __props__.__dict__["discovery_rules"] = discovery_rules
        __props__.__dict__["is_default_rule"] = is_default_rule
        __props__.__dict__["log_file_suffixes"] = log_file_suffixes
        __props__.__dict__["log_path_rules"] = log_path_rules
        __props__.__dict__["name"] = name
        __props__.__dict__["name_rules"] = name_rules
        __props__.__dict__["priority"] = priority
        __props__.__dict__["region"] = region
        __props__.__dict__["rule_id"] = rule_id
        __props__.__dict__["service_type"] = service_type
        return ServiceDiscoveryRule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[str]:
        """
        The rule create time.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the rule description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="detectLogEnabled")
    def detect_log_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether to enable log collection. The default value is true.
        """
        return pulumi.get(self, "detect_log_enabled")

    @property
    @pulumi.getter(name="discoveryRuleEnabled")
    def discovery_rule_enabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether the rule is enabled. The default value is true.
        """
        return pulumi.get(self, "discovery_rule_enabled")

    @property
    @pulumi.getter(name="discoveryRules")
    def discovery_rules(self) -> pulumi.Output[Sequence['outputs.ServiceDiscoveryRuleDiscoveryRule']]:
        """
        Specifies the discovery rule. If the array contains multiple conditions, only the
        processes that meet all the conditions will be matched. If the value of `check_type` is **cmdLine**, set the value of
        `check_mode` to **contain**. `check_content` is in the format of ["xxx"], indicating that the process must contain
        the xxx parameter. If the value of `check_type` is **env**, set the value of `check_mode` to **contain**.
        `check_content` is in the format of ["k1","v1"], indicating that the process must contain the environment variable
        whose name is k1 and value is v1. If the value of `check_type` is **scope**, set the value of `check_mode`
        to **equals**. `check_content` is in the format of ["hostId1","hostId2"], indicating that the rule takes effect only
        on specified nodes. If no nodes are specified, the rule applies to all nodes of the project.
        """
        return pulumi.get(self, "discovery_rules")

    @property
    @pulumi.getter(name="isDefaultRule")
    def is_default_rule(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether the rule is the default one. The default value is false.
        """
        return pulumi.get(self, "is_default_rule")

    @property
    @pulumi.getter(name="logFileSuffixes")
    def log_file_suffixes(self) -> pulumi.Output[Sequence[str]]:
        """
        Specifies the log file suffix. This is a list of strings.
        The values can be: **log**, **trace**, and **out**.
        """
        return pulumi.get(self, "log_file_suffixes")

    @property
    @pulumi.getter(name="logPathRules")
    def log_path_rules(self) -> pulumi.Output[Optional[Sequence['outputs.ServiceDiscoveryRuleLogPathRule']]]:
        """
        Specifies the log path configuration rule. If cmdLineHash is a fixed string,
        logs in the specified log path or log file are collected. Otherwise, only the files whose names end with
        .log or .trace are collected. If the value of `name_type` is **cmdLineHash**, args is in the format of ["00001"] and
        value is in the format of ["/xxx/xx.log"], indicating that the log path is /xxx/xx.log when the startup command is 00001.
        """
        return pulumi.get(self, "log_path_rules")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Specifies the rule name, which contains `4` to `63` characters. It must start
        with a lowercase letter but cannot end with a hyphen (-). Only digits, lowercase letters, and hyphens are allowed.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nameRules")
    def name_rules(self) -> pulumi.Output['outputs.ServiceDiscoveryRuleNameRules']:
        """
        Specifies the naming rules for discovered services and applications.
        The object structure is documented below.
        """
        return pulumi.get(self, "name_rules")

    @property
    @pulumi.getter
    def priority(self) -> pulumi.Output[Optional[int]]:
        """
        Specifies the rule priority. Value range: 1 to 9999. The default value is 9999.
        """
        return pulumi.get(self, "priority")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        The region in which to create the service discovery rule resource. If omitted,
        the provider-level region will be used. Changing this creates a new resource.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> pulumi.Output[str]:
        """
        The rule ID in uuid format.
        """
        return pulumi.get(self, "rule_id")

    @property
    @pulumi.getter(name="serviceType")
    def service_type(self) -> pulumi.Output[str]:
        """
        Specifies the service type, which is used only for rule classification and UI display.
        You can enter any field. For example, enter Java or Python by technology stack, or enter collector or database by function.
        """
        return pulumi.get(self, "service_type")

