# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['PolicyArgs', 'Policy']

@pulumi.input_type
class PolicyArgs:
    def __init__(__self__, *,
                 scaling_group_id: pulumi.Input[str],
                 scaling_policy_name: pulumi.Input[str],
                 scaling_policy_type: pulumi.Input[str],
                 action: Optional[pulumi.Input[str]] = None,
                 alarm_id: Optional[pulumi.Input[str]] = None,
                 cool_down_time: Optional[pulumi.Input[int]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 scaling_policy_action: Optional[pulumi.Input['PolicyScalingPolicyActionArgs']] = None,
                 scheduled_policy: Optional[pulumi.Input['PolicyScheduledPolicyArgs']] = None):
        """
        The set of arguments for constructing a Policy resource.
        :param pulumi.Input[str] scaling_group_id: Specifies the AS group ID. Changing this creates a new AS policy.
        :param pulumi.Input[str] scaling_policy_name: Specifies the name of the AS policy. The name contains only letters, digits,
               underscores(_), and hyphens(-), and cannot exceed 64 characters.
        :param pulumi.Input[str] scaling_policy_type: Specifies the AS policy type. The value can be `ALARM`, `SCHEDULED` or `RECURRENCE`.
               + **ALARM**: indicates that the scaling action is triggered by an alarm.
               + **SCHEDULED**: indicates that the scaling action is triggered as scheduled.
               + **RECURRENCE**: indicates that the scaling action is triggered periodically.
        :param pulumi.Input[str] action: Specifies the operation for the AS policy.
               The default value is **resume**. The valid values are as follows:
               + **resume**: Enables the AS policy.
               + **pause**: Disables the AS policy.
        :param pulumi.Input[int] cool_down_time: Specifies the cooling duration (in seconds).
               The value ranges from 0 to 86400 and is 300 by default.
        :param pulumi.Input[str] region: Specifies the region in which to create the AS policy. If omitted, the
               provider-level region will be used. Changing this creates a new AS policy.
        :param pulumi.Input['PolicyScalingPolicyActionArgs'] scaling_policy_action: Specifies the action of the AS policy.
               The object structure is documented below.
        :param pulumi.Input['PolicyScheduledPolicyArgs'] scheduled_policy: Specifies the periodic or scheduled AS policy.
               This parameter is mandatory when `scaling_policy_type` is set to `SCHEDULED` or `RECURRENCE`.
               The object structure is documented below.
        """
        pulumi.set(__self__, "scaling_group_id", scaling_group_id)
        pulumi.set(__self__, "scaling_policy_name", scaling_policy_name)
        pulumi.set(__self__, "scaling_policy_type", scaling_policy_type)
        if action is not None:
            pulumi.set(__self__, "action", action)
        if alarm_id is not None:
            pulumi.set(__self__, "alarm_id", alarm_id)
        if cool_down_time is not None:
            pulumi.set(__self__, "cool_down_time", cool_down_time)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if scaling_policy_action is not None:
            pulumi.set(__self__, "scaling_policy_action", scaling_policy_action)
        if scheduled_policy is not None:
            pulumi.set(__self__, "scheduled_policy", scheduled_policy)

    @property
    @pulumi.getter(name="scalingGroupId")
    def scaling_group_id(self) -> pulumi.Input[str]:
        """
        Specifies the AS group ID. Changing this creates a new AS policy.
        """
        return pulumi.get(self, "scaling_group_id")

    @scaling_group_id.setter
    def scaling_group_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "scaling_group_id", value)

    @property
    @pulumi.getter(name="scalingPolicyName")
    def scaling_policy_name(self) -> pulumi.Input[str]:
        """
        Specifies the name of the AS policy. The name contains only letters, digits,
        underscores(_), and hyphens(-), and cannot exceed 64 characters.
        """
        return pulumi.get(self, "scaling_policy_name")

    @scaling_policy_name.setter
    def scaling_policy_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "scaling_policy_name", value)

    @property
    @pulumi.getter(name="scalingPolicyType")
    def scaling_policy_type(self) -> pulumi.Input[str]:
        """
        Specifies the AS policy type. The value can be `ALARM`, `SCHEDULED` or `RECURRENCE`.
        + **ALARM**: indicates that the scaling action is triggered by an alarm.
        + **SCHEDULED**: indicates that the scaling action is triggered as scheduled.
        + **RECURRENCE**: indicates that the scaling action is triggered periodically.
        """
        return pulumi.get(self, "scaling_policy_type")

    @scaling_policy_type.setter
    def scaling_policy_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "scaling_policy_type", value)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the operation for the AS policy.
        The default value is **resume**. The valid values are as follows:
        + **resume**: Enables the AS policy.
        + **pause**: Disables the AS policy.
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter(name="alarmId")
    def alarm_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "alarm_id")

    @alarm_id.setter
    def alarm_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "alarm_id", value)

    @property
    @pulumi.getter(name="coolDownTime")
    def cool_down_time(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the cooling duration (in seconds).
        The value ranges from 0 to 86400 and is 300 by default.
        """
        return pulumi.get(self, "cool_down_time")

    @cool_down_time.setter
    def cool_down_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "cool_down_time", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to create the AS policy. If omitted, the
        provider-level region will be used. Changing this creates a new AS policy.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="scalingPolicyAction")
    def scaling_policy_action(self) -> Optional[pulumi.Input['PolicyScalingPolicyActionArgs']]:
        """
        Specifies the action of the AS policy.
        The object structure is documented below.
        """
        return pulumi.get(self, "scaling_policy_action")

    @scaling_policy_action.setter
    def scaling_policy_action(self, value: Optional[pulumi.Input['PolicyScalingPolicyActionArgs']]):
        pulumi.set(self, "scaling_policy_action", value)

    @property
    @pulumi.getter(name="scheduledPolicy")
    def scheduled_policy(self) -> Optional[pulumi.Input['PolicyScheduledPolicyArgs']]:
        """
        Specifies the periodic or scheduled AS policy.
        This parameter is mandatory when `scaling_policy_type` is set to `SCHEDULED` or `RECURRENCE`.
        The object structure is documented below.
        """
        return pulumi.get(self, "scheduled_policy")

    @scheduled_policy.setter
    def scheduled_policy(self, value: Optional[pulumi.Input['PolicyScheduledPolicyArgs']]):
        pulumi.set(self, "scheduled_policy", value)


@pulumi.input_type
class _PolicyState:
    def __init__(__self__, *,
                 action: Optional[pulumi.Input[str]] = None,
                 alarm_id: Optional[pulumi.Input[str]] = None,
                 cool_down_time: Optional[pulumi.Input[int]] = None,
                 create_time: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 scaling_group_id: Optional[pulumi.Input[str]] = None,
                 scaling_policy_action: Optional[pulumi.Input['PolicyScalingPolicyActionArgs']] = None,
                 scaling_policy_name: Optional[pulumi.Input[str]] = None,
                 scaling_policy_type: Optional[pulumi.Input[str]] = None,
                 scheduled_policy: Optional[pulumi.Input['PolicyScheduledPolicyArgs']] = None,
                 status: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Policy resources.
        :param pulumi.Input[str] action: Specifies the operation for the AS policy.
               The default value is **resume**. The valid values are as follows:
               + **resume**: Enables the AS policy.
               + **pause**: Disables the AS policy.
        :param pulumi.Input[int] cool_down_time: Specifies the cooling duration (in seconds).
               The value ranges from 0 to 86400 and is 300 by default.
        :param pulumi.Input[str] create_time: The creation time of the AS policy, in UTC format.
        :param pulumi.Input[str] region: Specifies the region in which to create the AS policy. If omitted, the
               provider-level region will be used. Changing this creates a new AS policy.
        :param pulumi.Input[str] scaling_group_id: Specifies the AS group ID. Changing this creates a new AS policy.
        :param pulumi.Input['PolicyScalingPolicyActionArgs'] scaling_policy_action: Specifies the action of the AS policy.
               The object structure is documented below.
        :param pulumi.Input[str] scaling_policy_name: Specifies the name of the AS policy. The name contains only letters, digits,
               underscores(_), and hyphens(-), and cannot exceed 64 characters.
        :param pulumi.Input[str] scaling_policy_type: Specifies the AS policy type. The value can be `ALARM`, `SCHEDULED` or `RECURRENCE`.
               + **ALARM**: indicates that the scaling action is triggered by an alarm.
               + **SCHEDULED**: indicates that the scaling action is triggered as scheduled.
               + **RECURRENCE**: indicates that the scaling action is triggered periodically.
        :param pulumi.Input['PolicyScheduledPolicyArgs'] scheduled_policy: Specifies the periodic or scheduled AS policy.
               This parameter is mandatory when `scaling_policy_type` is set to `SCHEDULED` or `RECURRENCE`.
               The object structure is documented below.
        :param pulumi.Input[str] status: The AS policy status. The value can be *INSERVICE*, *PAUSED* or *EXECUTING*.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if alarm_id is not None:
            pulumi.set(__self__, "alarm_id", alarm_id)
        if cool_down_time is not None:
            pulumi.set(__self__, "cool_down_time", cool_down_time)
        if create_time is not None:
            pulumi.set(__self__, "create_time", create_time)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if scaling_group_id is not None:
            pulumi.set(__self__, "scaling_group_id", scaling_group_id)
        if scaling_policy_action is not None:
            pulumi.set(__self__, "scaling_policy_action", scaling_policy_action)
        if scaling_policy_name is not None:
            pulumi.set(__self__, "scaling_policy_name", scaling_policy_name)
        if scaling_policy_type is not None:
            pulumi.set(__self__, "scaling_policy_type", scaling_policy_type)
        if scheduled_policy is not None:
            pulumi.set(__self__, "scheduled_policy", scheduled_policy)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the operation for the AS policy.
        The default value is **resume**. The valid values are as follows:
        + **resume**: Enables the AS policy.
        + **pause**: Disables the AS policy.
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter(name="alarmId")
    def alarm_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "alarm_id")

    @alarm_id.setter
    def alarm_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "alarm_id", value)

    @property
    @pulumi.getter(name="coolDownTime")
    def cool_down_time(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the cooling duration (in seconds).
        The value ranges from 0 to 86400 and is 300 by default.
        """
        return pulumi.get(self, "cool_down_time")

    @cool_down_time.setter
    def cool_down_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "cool_down_time", value)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> Optional[pulumi.Input[str]]:
        """
        The creation time of the AS policy, in UTC format.
        """
        return pulumi.get(self, "create_time")

    @create_time.setter
    def create_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "create_time", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to create the AS policy. If omitted, the
        provider-level region will be used. Changing this creates a new AS policy.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="scalingGroupId")
    def scaling_group_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the AS group ID. Changing this creates a new AS policy.
        """
        return pulumi.get(self, "scaling_group_id")

    @scaling_group_id.setter
    def scaling_group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scaling_group_id", value)

    @property
    @pulumi.getter(name="scalingPolicyAction")
    def scaling_policy_action(self) -> Optional[pulumi.Input['PolicyScalingPolicyActionArgs']]:
        """
        Specifies the action of the AS policy.
        The object structure is documented below.
        """
        return pulumi.get(self, "scaling_policy_action")

    @scaling_policy_action.setter
    def scaling_policy_action(self, value: Optional[pulumi.Input['PolicyScalingPolicyActionArgs']]):
        pulumi.set(self, "scaling_policy_action", value)

    @property
    @pulumi.getter(name="scalingPolicyName")
    def scaling_policy_name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the AS policy. The name contains only letters, digits,
        underscores(_), and hyphens(-), and cannot exceed 64 characters.
        """
        return pulumi.get(self, "scaling_policy_name")

    @scaling_policy_name.setter
    def scaling_policy_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scaling_policy_name", value)

    @property
    @pulumi.getter(name="scalingPolicyType")
    def scaling_policy_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the AS policy type. The value can be `ALARM`, `SCHEDULED` or `RECURRENCE`.
        + **ALARM**: indicates that the scaling action is triggered by an alarm.
        + **SCHEDULED**: indicates that the scaling action is triggered as scheduled.
        + **RECURRENCE**: indicates that the scaling action is triggered periodically.
        """
        return pulumi.get(self, "scaling_policy_type")

    @scaling_policy_type.setter
    def scaling_policy_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scaling_policy_type", value)

    @property
    @pulumi.getter(name="scheduledPolicy")
    def scheduled_policy(self) -> Optional[pulumi.Input['PolicyScheduledPolicyArgs']]:
        """
        Specifies the periodic or scheduled AS policy.
        This parameter is mandatory when `scaling_policy_type` is set to `SCHEDULED` or `RECURRENCE`.
        The object structure is documented below.
        """
        return pulumi.get(self, "scheduled_policy")

    @scheduled_policy.setter
    def scheduled_policy(self, value: Optional[pulumi.Input['PolicyScheduledPolicyArgs']]):
        pulumi.set(self, "scheduled_policy", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        The AS policy status. The value can be *INSERVICE*, *PAUSED* or *EXECUTING*.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)


class Policy(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 alarm_id: Optional[pulumi.Input[str]] = None,
                 cool_down_time: Optional[pulumi.Input[int]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 scaling_group_id: Optional[pulumi.Input[str]] = None,
                 scaling_policy_action: Optional[pulumi.Input[pulumi.InputType['PolicyScalingPolicyActionArgs']]] = None,
                 scaling_policy_name: Optional[pulumi.Input[str]] = None,
                 scaling_policy_type: Optional[pulumi.Input[str]] = None,
                 scheduled_policy: Optional[pulumi.Input[pulumi.InputType['PolicyScheduledPolicyArgs']]] = None,
                 __props__=None):
        """
        Manages an AS policy resource within HuaweiCloud.

        ## Example Usage
        ### AS Recurrence Policy

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        as_group_id = config.require_object("asGroupId")
        my_aspolicy = huaweicloud.as_.Policy("myAspolicy",
            scaling_policy_name="my_aspolicy",
            scaling_policy_type="RECURRENCE",
            scaling_group_id=as_group_id,
            scaling_policy_action=huaweicloud.as_.PolicyScalingPolicyActionArgs(
                operation="ADD",
                instance_number=1,
            ),
            scheduled_policy=huaweicloud.as_.PolicyScheduledPolicyArgs(
                launch_time="07:00",
                recurrence_type="Daily",
                start_time="2022-11-30T12:00Z",
                end_time="2022-12-30T12:00Z",
            ))
        ```
        ### AS Scheduled Policy

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        as_group_id = config.require_object("asGroupId")
        my_aspolicy1 = huaweicloud.as_.Policy("myAspolicy1",
            scaling_policy_name="my_aspolicy_1",
            scaling_policy_type="SCHEDULED",
            scaling_group_id=as_group_id,
            scaling_policy_action=huaweicloud.as_.PolicyScalingPolicyActionArgs(
                operation="REMOVE",
                instance_number=1,
            ),
            scheduled_policy=huaweicloud.as_.PolicyScheduledPolicyArgs(
                launch_time="2022-12-22T12:00Z",
            ))
        ```
        ### AS Alarm Policy

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        as_group_id = config.require_object("asGroupId")
        alarm_rule = huaweicloud.cse.Alarmrule("alarmRule",
            alarm_name="as_alarm_rule",
            metric=huaweicloud.cse.AlarmruleMetricArgs(
                namespace="SYS.AS",
                metric_name="cpu_util",
                dimensions=[huaweicloud.cse.AlarmruleMetricDimensionArgs(
                    name="AutoScalingGroup",
                    value=as_group_id,
                )],
            ),
            conditions=[huaweicloud.cse.AlarmruleConditionArgs(
                period=300,
                filter="average",
                comparison_operator=">=",
                value=60,
                unit="%",
                count=1,
            )],
            alarm_actions=[huaweicloud.cse.AlarmruleAlarmActionArgs(
                type="autoscaling",
                notification_lists=[],
            )])
        my_aspolicy2 = huaweicloud.as_.Policy("myAspolicy2",
            scaling_policy_name="my_aspolicy_2",
            scaling_policy_type="ALARM",
            scaling_group_id=as_group_id,
            alarm_id=alarm_rule.id,
            cool_down_time=900,
            scaling_policy_action=huaweicloud.as_.PolicyScalingPolicyActionArgs(
                operation="ADD",
                instance_number=1,
            ))
        ```

        ## Import

        AS policies can be imported by their `id`, e.g. bash

        ```sh
         $ pulumi import huaweicloud:As/policy:Policy test <id>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: Specifies the operation for the AS policy.
               The default value is **resume**. The valid values are as follows:
               + **resume**: Enables the AS policy.
               + **pause**: Disables the AS policy.
        :param pulumi.Input[int] cool_down_time: Specifies the cooling duration (in seconds).
               The value ranges from 0 to 86400 and is 300 by default.
        :param pulumi.Input[str] region: Specifies the region in which to create the AS policy. If omitted, the
               provider-level region will be used. Changing this creates a new AS policy.
        :param pulumi.Input[str] scaling_group_id: Specifies the AS group ID. Changing this creates a new AS policy.
        :param pulumi.Input[pulumi.InputType['PolicyScalingPolicyActionArgs']] scaling_policy_action: Specifies the action of the AS policy.
               The object structure is documented below.
        :param pulumi.Input[str] scaling_policy_name: Specifies the name of the AS policy. The name contains only letters, digits,
               underscores(_), and hyphens(-), and cannot exceed 64 characters.
        :param pulumi.Input[str] scaling_policy_type: Specifies the AS policy type. The value can be `ALARM`, `SCHEDULED` or `RECURRENCE`.
               + **ALARM**: indicates that the scaling action is triggered by an alarm.
               + **SCHEDULED**: indicates that the scaling action is triggered as scheduled.
               + **RECURRENCE**: indicates that the scaling action is triggered periodically.
        :param pulumi.Input[pulumi.InputType['PolicyScheduledPolicyArgs']] scheduled_policy: Specifies the periodic or scheduled AS policy.
               This parameter is mandatory when `scaling_policy_type` is set to `SCHEDULED` or `RECURRENCE`.
               The object structure is documented below.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PolicyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages an AS policy resource within HuaweiCloud.

        ## Example Usage
        ### AS Recurrence Policy

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        as_group_id = config.require_object("asGroupId")
        my_aspolicy = huaweicloud.as_.Policy("myAspolicy",
            scaling_policy_name="my_aspolicy",
            scaling_policy_type="RECURRENCE",
            scaling_group_id=as_group_id,
            scaling_policy_action=huaweicloud.as_.PolicyScalingPolicyActionArgs(
                operation="ADD",
                instance_number=1,
            ),
            scheduled_policy=huaweicloud.as_.PolicyScheduledPolicyArgs(
                launch_time="07:00",
                recurrence_type="Daily",
                start_time="2022-11-30T12:00Z",
                end_time="2022-12-30T12:00Z",
            ))
        ```
        ### AS Scheduled Policy

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        as_group_id = config.require_object("asGroupId")
        my_aspolicy1 = huaweicloud.as_.Policy("myAspolicy1",
            scaling_policy_name="my_aspolicy_1",
            scaling_policy_type="SCHEDULED",
            scaling_group_id=as_group_id,
            scaling_policy_action=huaweicloud.as_.PolicyScalingPolicyActionArgs(
                operation="REMOVE",
                instance_number=1,
            ),
            scheduled_policy=huaweicloud.as_.PolicyScheduledPolicyArgs(
                launch_time="2022-12-22T12:00Z",
            ))
        ```
        ### AS Alarm Policy

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        as_group_id = config.require_object("asGroupId")
        alarm_rule = huaweicloud.cse.Alarmrule("alarmRule",
            alarm_name="as_alarm_rule",
            metric=huaweicloud.cse.AlarmruleMetricArgs(
                namespace="SYS.AS",
                metric_name="cpu_util",
                dimensions=[huaweicloud.cse.AlarmruleMetricDimensionArgs(
                    name="AutoScalingGroup",
                    value=as_group_id,
                )],
            ),
            conditions=[huaweicloud.cse.AlarmruleConditionArgs(
                period=300,
                filter="average",
                comparison_operator=">=",
                value=60,
                unit="%",
                count=1,
            )],
            alarm_actions=[huaweicloud.cse.AlarmruleAlarmActionArgs(
                type="autoscaling",
                notification_lists=[],
            )])
        my_aspolicy2 = huaweicloud.as_.Policy("myAspolicy2",
            scaling_policy_name="my_aspolicy_2",
            scaling_policy_type="ALARM",
            scaling_group_id=as_group_id,
            alarm_id=alarm_rule.id,
            cool_down_time=900,
            scaling_policy_action=huaweicloud.as_.PolicyScalingPolicyActionArgs(
                operation="ADD",
                instance_number=1,
            ))
        ```

        ## Import

        AS policies can be imported by their `id`, e.g. bash

        ```sh
         $ pulumi import huaweicloud:As/policy:Policy test <id>
        ```

        :param str resource_name: The name of the resource.
        :param PolicyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PolicyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 alarm_id: Optional[pulumi.Input[str]] = None,
                 cool_down_time: Optional[pulumi.Input[int]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 scaling_group_id: Optional[pulumi.Input[str]] = None,
                 scaling_policy_action: Optional[pulumi.Input[pulumi.InputType['PolicyScalingPolicyActionArgs']]] = None,
                 scaling_policy_name: Optional[pulumi.Input[str]] = None,
                 scaling_policy_type: Optional[pulumi.Input[str]] = None,
                 scheduled_policy: Optional[pulumi.Input[pulumi.InputType['PolicyScheduledPolicyArgs']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PolicyArgs.__new__(PolicyArgs)

            __props__.__dict__["action"] = action
            __props__.__dict__["alarm_id"] = alarm_id
            __props__.__dict__["cool_down_time"] = cool_down_time
            __props__.__dict__["region"] = region
            if scaling_group_id is None and not opts.urn:
                raise TypeError("Missing required property 'scaling_group_id'")
            __props__.__dict__["scaling_group_id"] = scaling_group_id
            __props__.__dict__["scaling_policy_action"] = scaling_policy_action
            if scaling_policy_name is None and not opts.urn:
                raise TypeError("Missing required property 'scaling_policy_name'")
            __props__.__dict__["scaling_policy_name"] = scaling_policy_name
            if scaling_policy_type is None and not opts.urn:
                raise TypeError("Missing required property 'scaling_policy_type'")
            __props__.__dict__["scaling_policy_type"] = scaling_policy_type
            __props__.__dict__["scheduled_policy"] = scheduled_policy
            __props__.__dict__["create_time"] = None
            __props__.__dict__["status"] = None
        super(Policy, __self__).__init__(
            'huaweicloud:As/policy:Policy',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            action: Optional[pulumi.Input[str]] = None,
            alarm_id: Optional[pulumi.Input[str]] = None,
            cool_down_time: Optional[pulumi.Input[int]] = None,
            create_time: Optional[pulumi.Input[str]] = None,
            region: Optional[pulumi.Input[str]] = None,
            scaling_group_id: Optional[pulumi.Input[str]] = None,
            scaling_policy_action: Optional[pulumi.Input[pulumi.InputType['PolicyScalingPolicyActionArgs']]] = None,
            scaling_policy_name: Optional[pulumi.Input[str]] = None,
            scaling_policy_type: Optional[pulumi.Input[str]] = None,
            scheduled_policy: Optional[pulumi.Input[pulumi.InputType['PolicyScheduledPolicyArgs']]] = None,
            status: Optional[pulumi.Input[str]] = None) -> 'Policy':
        """
        Get an existing Policy resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: Specifies the operation for the AS policy.
               The default value is **resume**. The valid values are as follows:
               + **resume**: Enables the AS policy.
               + **pause**: Disables the AS policy.
        :param pulumi.Input[int] cool_down_time: Specifies the cooling duration (in seconds).
               The value ranges from 0 to 86400 and is 300 by default.
        :param pulumi.Input[str] create_time: The creation time of the AS policy, in UTC format.
        :param pulumi.Input[str] region: Specifies the region in which to create the AS policy. If omitted, the
               provider-level region will be used. Changing this creates a new AS policy.
        :param pulumi.Input[str] scaling_group_id: Specifies the AS group ID. Changing this creates a new AS policy.
        :param pulumi.Input[pulumi.InputType['PolicyScalingPolicyActionArgs']] scaling_policy_action: Specifies the action of the AS policy.
               The object structure is documented below.
        :param pulumi.Input[str] scaling_policy_name: Specifies the name of the AS policy. The name contains only letters, digits,
               underscores(_), and hyphens(-), and cannot exceed 64 characters.
        :param pulumi.Input[str] scaling_policy_type: Specifies the AS policy type. The value can be `ALARM`, `SCHEDULED` or `RECURRENCE`.
               + **ALARM**: indicates that the scaling action is triggered by an alarm.
               + **SCHEDULED**: indicates that the scaling action is triggered as scheduled.
               + **RECURRENCE**: indicates that the scaling action is triggered periodically.
        :param pulumi.Input[pulumi.InputType['PolicyScheduledPolicyArgs']] scheduled_policy: Specifies the periodic or scheduled AS policy.
               This parameter is mandatory when `scaling_policy_type` is set to `SCHEDULED` or `RECURRENCE`.
               The object structure is documented below.
        :param pulumi.Input[str] status: The AS policy status. The value can be *INSERVICE*, *PAUSED* or *EXECUTING*.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _PolicyState.__new__(_PolicyState)

        __props__.__dict__["action"] = action
        __props__.__dict__["alarm_id"] = alarm_id
        __props__.__dict__["cool_down_time"] = cool_down_time
        __props__.__dict__["create_time"] = create_time
        __props__.__dict__["region"] = region
        __props__.__dict__["scaling_group_id"] = scaling_group_id
        __props__.__dict__["scaling_policy_action"] = scaling_policy_action
        __props__.__dict__["scaling_policy_name"] = scaling_policy_name
        __props__.__dict__["scaling_policy_type"] = scaling_policy_type
        __props__.__dict__["scheduled_policy"] = scheduled_policy
        __props__.__dict__["status"] = status
        return Policy(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def action(self) -> pulumi.Output[str]:
        """
        Specifies the operation for the AS policy.
        The default value is **resume**. The valid values are as follows:
        + **resume**: Enables the AS policy.
        + **pause**: Disables the AS policy.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter(name="alarmId")
    def alarm_id(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "alarm_id")

    @property
    @pulumi.getter(name="coolDownTime")
    def cool_down_time(self) -> pulumi.Output[int]:
        """
        Specifies the cooling duration (in seconds).
        The value ranges from 0 to 86400 and is 300 by default.
        """
        return pulumi.get(self, "cool_down_time")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> pulumi.Output[str]:
        """
        The creation time of the AS policy, in UTC format.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        Specifies the region in which to create the AS policy. If omitted, the
        provider-level region will be used. Changing this creates a new AS policy.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="scalingGroupId")
    def scaling_group_id(self) -> pulumi.Output[str]:
        """
        Specifies the AS group ID. Changing this creates a new AS policy.
        """
        return pulumi.get(self, "scaling_group_id")

    @property
    @pulumi.getter(name="scalingPolicyAction")
    def scaling_policy_action(self) -> pulumi.Output['outputs.PolicyScalingPolicyAction']:
        """
        Specifies the action of the AS policy.
        The object structure is documented below.
        """
        return pulumi.get(self, "scaling_policy_action")

    @property
    @pulumi.getter(name="scalingPolicyName")
    def scaling_policy_name(self) -> pulumi.Output[str]:
        """
        Specifies the name of the AS policy. The name contains only letters, digits,
        underscores(_), and hyphens(-), and cannot exceed 64 characters.
        """
        return pulumi.get(self, "scaling_policy_name")

    @property
    @pulumi.getter(name="scalingPolicyType")
    def scaling_policy_type(self) -> pulumi.Output[str]:
        """
        Specifies the AS policy type. The value can be `ALARM`, `SCHEDULED` or `RECURRENCE`.
        + **ALARM**: indicates that the scaling action is triggered by an alarm.
        + **SCHEDULED**: indicates that the scaling action is triggered as scheduled.
        + **RECURRENCE**: indicates that the scaling action is triggered periodically.
        """
        return pulumi.get(self, "scaling_policy_type")

    @property
    @pulumi.getter(name="scheduledPolicy")
    def scheduled_policy(self) -> pulumi.Output['outputs.PolicyScheduledPolicy']:
        """
        Specifies the periodic or scheduled AS policy.
        This parameter is mandatory when `scaling_policy_type` is set to `SCHEDULED` or `RECURRENCE`.
        The object structure is documented below.
        """
        return pulumi.get(self, "scheduled_policy")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        The AS policy status. The value can be *INSERVICE*, *PAUSED* or *EXECUTING*.
        """
        return pulumi.get(self, "status")

