# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'InstanceBlockInfoArgs',
    'InstanceChannelArgs',
    'InstanceCouchdbArgs',
    'InstanceKafkaArgs',
    'InstancePeerOrgArgs',
    'InstancePeerOrgAddressArgs',
    'InstanceSfsTurboArgs',
]

@pulumi.input_type
class InstanceBlockInfoArgs:
    def __init__(__self__, *,
                 block_size: Optional[pulumi.Input[int]] = None,
                 generation_interval: Optional[pulumi.Input[int]] = None,
                 transaction_quantity: Optional[pulumi.Input[int]] = None):
        """
        :param pulumi.Input[int] block_size: Specifies the volume of the block, the unit is MB. The default value is 2.
               Changing this creates a new instance.
        :param pulumi.Input[int] generation_interval: Specifies the block generation time, the unit is second. The default
               value is 2. Changing this creates a new instance.
        :param pulumi.Input[int] transaction_quantity: Specifies the number of transactions included in the block. The
               default value is 500. Changing this creates a new instance.
        """
        if block_size is not None:
            pulumi.set(__self__, "block_size", block_size)
        if generation_interval is not None:
            pulumi.set(__self__, "generation_interval", generation_interval)
        if transaction_quantity is not None:
            pulumi.set(__self__, "transaction_quantity", transaction_quantity)

    @property
    @pulumi.getter(name="blockSize")
    def block_size(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the volume of the block, the unit is MB. The default value is 2.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "block_size")

    @block_size.setter
    def block_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "block_size", value)

    @property
    @pulumi.getter(name="generationInterval")
    def generation_interval(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the block generation time, the unit is second. The default
        value is 2. Changing this creates a new instance.
        """
        return pulumi.get(self, "generation_interval")

    @generation_interval.setter
    def generation_interval(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "generation_interval", value)

    @property
    @pulumi.getter(name="transactionQuantity")
    def transaction_quantity(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the number of transactions included in the block. The
        default value is 500. Changing this creates a new instance.
        """
        return pulumi.get(self, "transaction_quantity")

    @transaction_quantity.setter
    def transaction_quantity(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "transaction_quantity", value)


@pulumi.input_type
class InstanceChannelArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[str],
                 org_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        :param pulumi.Input[str] name: Specifies the name of the channel. Changing this creates a new instance.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] org_names: Specifies the name of the peer organization. Changing this creates a new
               instance.
        """
        pulumi.set(__self__, "name", name)
        if org_names is not None:
            pulumi.set(__self__, "org_names", org_names)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        Specifies the name of the channel. Changing this creates a new instance.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="orgNames")
    def org_names(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Specifies the name of the peer organization. Changing this creates a new
        instance.
        """
        return pulumi.get(self, "org_names")

    @org_names.setter
    def org_names(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "org_names", value)


@pulumi.input_type
class InstanceCouchdbArgs:
    def __init__(__self__, *,
                 password: pulumi.Input[str],
                 user_name: pulumi.Input[str]):
        """
        :param pulumi.Input[str] password: Specifies the password of the couch database. The password consists of 8 to
               26 characters and must consist at least three of following: uppercase letters, lowercase letters, digits, special
               characters(!@$%^-_=+[{}]:,./?). Changing this creates a new instance.
        :param pulumi.Input[str] user_name: Specifies the user name of the couch database. Changing this creates a new
               instance.
        """
        pulumi.set(__self__, "password", password)
        pulumi.set(__self__, "user_name", user_name)

    @property
    @pulumi.getter
    def password(self) -> pulumi.Input[str]:
        """
        Specifies the password of the couch database. The password consists of 8 to
        26 characters and must consist at least three of following: uppercase letters, lowercase letters, digits, special
        characters(!@$%^-_=+[{}]:,./?). Changing this creates a new instance.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: pulumi.Input[str]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter(name="userName")
    def user_name(self) -> pulumi.Input[str]:
        """
        Specifies the user name of the couch database. Changing this creates a new
        instance.
        """
        return pulumi.get(self, "user_name")

    @user_name.setter
    def user_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "user_name", value)


@pulumi.input_type
class InstanceKafkaArgs:
    def __init__(__self__, *,
                 availability_zones: pulumi.Input[Sequence[pulumi.Input[str]]],
                 flavor: pulumi.Input[str],
                 storage_size: pulumi.Input[int],
                 name: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[Sequence[pulumi.Input[str]]] availability_zones: Specifies the availability zone in which to create the kafka. The
               list must contain one or more than three availability zone. Please
               following [reference](https://developer.huaweicloud.com/en-us/endpoint/?all) for the values. Changing this creates a
               new instance.
        :param pulumi.Input[str] flavor: Specifies the kafka flavor type. Changing this creates a new instance.
               + `c3.mini` : Mini type, the reference bandwidth is 100MB/s.
               + `c3.small.2` : Small type, the reference bandwidth is 300MB/s.
               + `c3.middle.2` : Middle type, the reference bandwidth is 600MB/s.
               + `c3.high.2` : High type, the reference bandwidth is 1200MB/s.
        :param pulumi.Input[int] storage_size: Specifies the kafka storage capacity. The storage capacity must be an
               integral multiple of 100 and the maximum is 90000GB. Changing this creates a new instance.
               + The minimum storage capacity of mini type is 600GB.
               + The minimum storage capacity of small type is 1200GB.
               + The minimum storage capacity of middle type is 2400GB.
               + The minimum storage capacity of high type is 4800GB.
        :param pulumi.Input[str] name: Specifies the name of the channel. Changing this creates a new instance.
        """
        pulumi.set(__self__, "availability_zones", availability_zones)
        pulumi.set(__self__, "flavor", flavor)
        pulumi.set(__self__, "storage_size", storage_size)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="availabilityZones")
    def availability_zones(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Specifies the availability zone in which to create the kafka. The
        list must contain one or more than three availability zone. Please
        following [reference](https://developer.huaweicloud.com/en-us/endpoint/?all) for the values. Changing this creates a
        new instance.
        """
        return pulumi.get(self, "availability_zones")

    @availability_zones.setter
    def availability_zones(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "availability_zones", value)

    @property
    @pulumi.getter
    def flavor(self) -> pulumi.Input[str]:
        """
        Specifies the kafka flavor type. Changing this creates a new instance.
        + `c3.mini` : Mini type, the reference bandwidth is 100MB/s.
        + `c3.small.2` : Small type, the reference bandwidth is 300MB/s.
        + `c3.middle.2` : Middle type, the reference bandwidth is 600MB/s.
        + `c3.high.2` : High type, the reference bandwidth is 1200MB/s.
        """
        return pulumi.get(self, "flavor")

    @flavor.setter
    def flavor(self, value: pulumi.Input[str]):
        pulumi.set(self, "flavor", value)

    @property
    @pulumi.getter(name="storageSize")
    def storage_size(self) -> pulumi.Input[int]:
        """
        Specifies the kafka storage capacity. The storage capacity must be an
        integral multiple of 100 and the maximum is 90000GB. Changing this creates a new instance.
        + The minimum storage capacity of mini type is 600GB.
        + The minimum storage capacity of small type is 1200GB.
        + The minimum storage capacity of middle type is 2400GB.
        + The minimum storage capacity of high type is 4800GB.
        """
        return pulumi.get(self, "storage_size")

    @storage_size.setter
    def storage_size(self, value: pulumi.Input[int]):
        pulumi.set(self, "storage_size", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the channel. Changing this creates a new instance.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class InstancePeerOrgArgs:
    def __init__(__self__, *,
                 count: pulumi.Input[int],
                 org_name: pulumi.Input[str],
                 addresses: Optional[pulumi.Input[Sequence[pulumi.Input['InstancePeerOrgAddressArgs']]]] = None,
                 pvc_name: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 status_detail: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[int] count: Specifies the number of peers in organization. Changing this creates a new
               instance.
        :param pulumi.Input[str] org_name: Specifies the name of the peer organization. Changing this creates a new
               instance.
        :param pulumi.Input[str] status: The status of the BCS instance.
        """
        pulumi.set(__self__, "count", count)
        pulumi.set(__self__, "org_name", org_name)
        if addresses is not None:
            pulumi.set(__self__, "addresses", addresses)
        if pvc_name is not None:
            pulumi.set(__self__, "pvc_name", pvc_name)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if status_detail is not None:
            pulumi.set(__self__, "status_detail", status_detail)

    @property
    @pulumi.getter
    def count(self) -> pulumi.Input[int]:
        """
        Specifies the number of peers in organization. Changing this creates a new
        instance.
        """
        return pulumi.get(self, "count")

    @count.setter
    def count(self, value: pulumi.Input[int]):
        pulumi.set(self, "count", value)

    @property
    @pulumi.getter(name="orgName")
    def org_name(self) -> pulumi.Input[str]:
        """
        Specifies the name of the peer organization. Changing this creates a new
        instance.
        """
        return pulumi.get(self, "org_name")

    @org_name.setter
    def org_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "org_name", value)

    @property
    @pulumi.getter
    def addresses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InstancePeerOrgAddressArgs']]]]:
        return pulumi.get(self, "addresses")

    @addresses.setter
    def addresses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InstancePeerOrgAddressArgs']]]]):
        pulumi.set(self, "addresses", value)

    @property
    @pulumi.getter(name="pvcName")
    def pvc_name(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "pvc_name")

    @pvc_name.setter
    def pvc_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "pvc_name", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        The status of the BCS instance.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter(name="statusDetail")
    def status_detail(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "status_detail")

    @status_detail.setter
    def status_detail(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status_detail", value)


@pulumi.input_type
class InstancePeerOrgAddressArgs:
    def __init__(__self__, *,
                 domain_port: Optional[pulumi.Input[str]] = None,
                 ip_port: Optional[pulumi.Input[str]] = None):
        if domain_port is not None:
            pulumi.set(__self__, "domain_port", domain_port)
        if ip_port is not None:
            pulumi.set(__self__, "ip_port", ip_port)

    @property
    @pulumi.getter(name="domainPort")
    def domain_port(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "domain_port")

    @domain_port.setter
    def domain_port(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "domain_port", value)

    @property
    @pulumi.getter(name="ipPort")
    def ip_port(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "ip_port")

    @ip_port.setter
    def ip_port(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip_port", value)


@pulumi.input_type
class InstanceSfsTurboArgs:
    def __init__(__self__, *,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 flavor: Optional[pulumi.Input[str]] = None,
                 share_type: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] availability_zone: Specifies the availability zone in which to create the kafka. The
               list must contain one or more than three availability zone. Please
               following [reference](https://developer.huaweicloud.com/en-us/endpoint/?all) for the values. Changing this creates a
               new instance.
        :param pulumi.Input[str] flavor: Specifies the kafka flavor type. Changing this creates a new instance.
               + `c3.mini` : Mini type, the reference bandwidth is 100MB/s.
               + `c3.small.2` : Small type, the reference bandwidth is 300MB/s.
               + `c3.middle.2` : Middle type, the reference bandwidth is 600MB/s.
               + `c3.high.2` : High type, the reference bandwidth is 1200MB/s.
        :param pulumi.Input[str] share_type: Specifies the share type of the SFS turbo. Changing this creates a new
               instance.
        :param pulumi.Input[str] type: Specifies the type of SFS turbo. Changing this creates a new instance.
        """
        if availability_zone is not None:
            pulumi.set(__self__, "availability_zone", availability_zone)
        if flavor is not None:
            pulumi.set(__self__, "flavor", flavor)
        if share_type is not None:
            pulumi.set(__self__, "share_type", share_type)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the availability zone in which to create the kafka. The
        list must contain one or more than three availability zone. Please
        following [reference](https://developer.huaweicloud.com/en-us/endpoint/?all) for the values. Changing this creates a
        new instance.
        """
        return pulumi.get(self, "availability_zone")

    @availability_zone.setter
    def availability_zone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_zone", value)

    @property
    @pulumi.getter
    def flavor(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the kafka flavor type. Changing this creates a new instance.
        + `c3.mini` : Mini type, the reference bandwidth is 100MB/s.
        + `c3.small.2` : Small type, the reference bandwidth is 300MB/s.
        + `c3.middle.2` : Middle type, the reference bandwidth is 600MB/s.
        + `c3.high.2` : High type, the reference bandwidth is 1200MB/s.
        """
        return pulumi.get(self, "flavor")

    @flavor.setter
    def flavor(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "flavor", value)

    @property
    @pulumi.getter(name="shareType")
    def share_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the share type of the SFS turbo. Changing this creates a new
        instance.
        """
        return pulumi.get(self, "share_type")

    @share_type.setter
    def share_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "share_type", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the type of SFS turbo. Changing this creates a new instance.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


