# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ClusterCertificateRevokeArgs', 'ClusterCertificateRevoke']

@pulumi.input_type
class ClusterCertificateRevokeArgs:
    def __init__(__self__, *,
                 cluster_id: pulumi.Input[str],
                 agency_id: Optional[pulumi.Input[str]] = None,
                 enable_force_new: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 user_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ClusterCertificateRevoke resource.
        :param pulumi.Input[str] cluster_id: Specifies the cluster ID.
        :param pulumi.Input[str] agency_id: Specifies the agency ID.
        :param pulumi.Input[str] region: Specifies the region in which to create the node sync resource.
               If omitted, the provider-level region will be used. Changing this will create a new resource.
        :param pulumi.Input[str] user_id: Specifies the user ID.
        """
        pulumi.set(__self__, "cluster_id", cluster_id)
        if agency_id is not None:
            pulumi.set(__self__, "agency_id", agency_id)
        if enable_force_new is not None:
            pulumi.set(__self__, "enable_force_new", enable_force_new)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if user_id is not None:
            pulumi.set(__self__, "user_id", user_id)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Input[str]:
        """
        Specifies the cluster ID.
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter(name="agencyId")
    def agency_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the agency ID.
        """
        return pulumi.get(self, "agency_id")

    @agency_id.setter
    def agency_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "agency_id", value)

    @property
    @pulumi.getter(name="enableForceNew")
    def enable_force_new(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "enable_force_new")

    @enable_force_new.setter
    def enable_force_new(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enable_force_new", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to create the node sync resource.
        If omitted, the provider-level region will be used. Changing this will create a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the user ID.
        """
        return pulumi.get(self, "user_id")

    @user_id.setter
    def user_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_id", value)


@pulumi.input_type
class _ClusterCertificateRevokeState:
    def __init__(__self__, *,
                 agency_id: Optional[pulumi.Input[str]] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 enable_force_new: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 user_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ClusterCertificateRevoke resources.
        :param pulumi.Input[str] agency_id: Specifies the agency ID.
        :param pulumi.Input[str] cluster_id: Specifies the cluster ID.
        :param pulumi.Input[str] region: Specifies the region in which to create the node sync resource.
               If omitted, the provider-level region will be used. Changing this will create a new resource.
        :param pulumi.Input[str] user_id: Specifies the user ID.
        """
        if agency_id is not None:
            pulumi.set(__self__, "agency_id", agency_id)
        if cluster_id is not None:
            pulumi.set(__self__, "cluster_id", cluster_id)
        if enable_force_new is not None:
            pulumi.set(__self__, "enable_force_new", enable_force_new)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if user_id is not None:
            pulumi.set(__self__, "user_id", user_id)

    @property
    @pulumi.getter(name="agencyId")
    def agency_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the agency ID.
        """
        return pulumi.get(self, "agency_id")

    @agency_id.setter
    def agency_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "agency_id", value)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the cluster ID.
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter(name="enableForceNew")
    def enable_force_new(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "enable_force_new")

    @enable_force_new.setter
    def enable_force_new(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enable_force_new", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to create the node sync resource.
        If omitted, the provider-level region will be used. Changing this will create a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the user ID.
        """
        return pulumi.get(self, "user_id")

    @user_id.setter
    def user_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_id", value)


class ClusterCertificateRevoke(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 agency_id: Optional[pulumi.Input[str]] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 enable_force_new: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Use this resource to revoke the certificate of a CCE cluster within HuaweiCloud.

        ## Example Usage
        ### Basic Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        cluster_id = config.require_object("clusterId")
        user_id = config.require_object("userId")
        test = huaweicloud.cce.ClusterCertificateRevoke("test",
            cluster_id=cluster_id,
            user_id=user_id)
        ```

        > Deleting certificate revoke resource is not supported, it will only be removed from the state.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] agency_id: Specifies the agency ID.
        :param pulumi.Input[str] cluster_id: Specifies the cluster ID.
        :param pulumi.Input[str] region: Specifies the region in which to create the node sync resource.
               If omitted, the provider-level region will be used. Changing this will create a new resource.
        :param pulumi.Input[str] user_id: Specifies the user ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ClusterCertificateRevokeArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Use this resource to revoke the certificate of a CCE cluster within HuaweiCloud.

        ## Example Usage
        ### Basic Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        cluster_id = config.require_object("clusterId")
        user_id = config.require_object("userId")
        test = huaweicloud.cce.ClusterCertificateRevoke("test",
            cluster_id=cluster_id,
            user_id=user_id)
        ```

        > Deleting certificate revoke resource is not supported, it will only be removed from the state.

        :param str resource_name: The name of the resource.
        :param ClusterCertificateRevokeArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ClusterCertificateRevokeArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 agency_id: Optional[pulumi.Input[str]] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 enable_force_new: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ClusterCertificateRevokeArgs.__new__(ClusterCertificateRevokeArgs)

            __props__.__dict__["agency_id"] = agency_id
            if cluster_id is None and not opts.urn:
                raise TypeError("Missing required property 'cluster_id'")
            __props__.__dict__["cluster_id"] = cluster_id
            __props__.__dict__["enable_force_new"] = enable_force_new
            __props__.__dict__["region"] = region
            __props__.__dict__["user_id"] = user_id
        super(ClusterCertificateRevoke, __self__).__init__(
            'huaweicloud:Cce/clusterCertificateRevoke:ClusterCertificateRevoke',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            agency_id: Optional[pulumi.Input[str]] = None,
            cluster_id: Optional[pulumi.Input[str]] = None,
            enable_force_new: Optional[pulumi.Input[str]] = None,
            region: Optional[pulumi.Input[str]] = None,
            user_id: Optional[pulumi.Input[str]] = None) -> 'ClusterCertificateRevoke':
        """
        Get an existing ClusterCertificateRevoke resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] agency_id: Specifies the agency ID.
        :param pulumi.Input[str] cluster_id: Specifies the cluster ID.
        :param pulumi.Input[str] region: Specifies the region in which to create the node sync resource.
               If omitted, the provider-level region will be used. Changing this will create a new resource.
        :param pulumi.Input[str] user_id: Specifies the user ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ClusterCertificateRevokeState.__new__(_ClusterCertificateRevokeState)

        __props__.__dict__["agency_id"] = agency_id
        __props__.__dict__["cluster_id"] = cluster_id
        __props__.__dict__["enable_force_new"] = enable_force_new
        __props__.__dict__["region"] = region
        __props__.__dict__["user_id"] = user_id
        return ClusterCertificateRevoke(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="agencyId")
    def agency_id(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the agency ID.
        """
        return pulumi.get(self, "agency_id")

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Output[str]:
        """
        Specifies the cluster ID.
        """
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter(name="enableForceNew")
    def enable_force_new(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "enable_force_new")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        Specifies the region in which to create the node sync resource.
        If omitted, the provider-level region will be used. Changing this will create a new resource.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the user ID.
        """
        return pulumi.get(self, "user_id")

