# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetClusterCertificatesResult',
    'AwaitableGetClusterCertificatesResult',
    'get_cluster_certificates',
    'get_cluster_certificates_output',
]

@pulumi.output_type
class GetClusterCertificatesResult:
    """
    A collection of values returned by getClusterCertificates.
    """
    def __init__(__self__, cluster_id=None, clusters=None, contexts=None, current_context=None, duration=None, id=None, kube_config_raw=None, region=None, users=None):
        if cluster_id and not isinstance(cluster_id, str):
            raise TypeError("Expected argument 'cluster_id' to be a str")
        pulumi.set(__self__, "cluster_id", cluster_id)
        if clusters and not isinstance(clusters, list):
            raise TypeError("Expected argument 'clusters' to be a list")
        pulumi.set(__self__, "clusters", clusters)
        if contexts and not isinstance(contexts, list):
            raise TypeError("Expected argument 'contexts' to be a list")
        pulumi.set(__self__, "contexts", contexts)
        if current_context and not isinstance(current_context, str):
            raise TypeError("Expected argument 'current_context' to be a str")
        pulumi.set(__self__, "current_context", current_context)
        if duration and not isinstance(duration, int):
            raise TypeError("Expected argument 'duration' to be a int")
        pulumi.set(__self__, "duration", duration)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if kube_config_raw and not isinstance(kube_config_raw, str):
            raise TypeError("Expected argument 'kube_config_raw' to be a str")
        pulumi.set(__self__, "kube_config_raw", kube_config_raw)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if users and not isinstance(users, list):
            raise TypeError("Expected argument 'users' to be a list")
        pulumi.set(__self__, "users", users)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> str:
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter
    def clusters(self) -> Sequence['outputs.GetClusterCertificatesClusterResult']:
        """
        The clusters information of the cluster certificate.
        The clusters structure is documented below.
        """
        return pulumi.get(self, "clusters")

    @property
    @pulumi.getter
    def contexts(self) -> Sequence['outputs.GetClusterCertificatesContextResult']:
        """
        The contexts information of the cluster certificate.
        The contexts structure is documented below.
        """
        return pulumi.get(self, "contexts")

    @property
    @pulumi.getter(name="currentContext")
    def current_context(self) -> str:
        """
        The current context of the cluster certificate.
        """
        return pulumi.get(self, "current_context")

    @property
    @pulumi.getter
    def duration(self) -> int:
        return pulumi.get(self, "duration")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="kubeConfigRaw")
    def kube_config_raw(self) -> str:
        """
        Raw Kubernetes config to be used by kubectl and other compatible tools.
        """
        return pulumi.get(self, "kube_config_raw")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def users(self) -> Sequence['outputs.GetClusterCertificatesUserResult']:
        """
        The users information of cluster the certificate.
        The users structure is documented below.
        """
        return pulumi.get(self, "users")


class AwaitableGetClusterCertificatesResult(GetClusterCertificatesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetClusterCertificatesResult(
            cluster_id=self.cluster_id,
            clusters=self.clusters,
            contexts=self.contexts,
            current_context=self.current_context,
            duration=self.duration,
            id=self.id,
            kube_config_raw=self.kube_config_raw,
            region=self.region,
            users=self.users)


def get_cluster_certificates(cluster_id: Optional[str] = None,
                             duration: Optional[int] = None,
                             region: Optional[str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetClusterCertificatesResult:
    """
    Use this data source to get the certificate of a CCE cluster within HuaweiCloud.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    cluster_id = config.require_object("clusterId")
    test = huaweicloud.Cce.get_cluster_certificates(cluster_id=cluster_id,
        duration=30)
    ```


    :param str cluster_id: Specifies the cluster ID which the cluster certificate in.
    :param int duration: Specifies the duration of the cluster certificate. The unit is days. The valid value in
           [1, 1827]. If the input value is -1, it will use the maximum 1827 as `duration` value.
    :param str region: Specifies the region in which to obtain the CCE cluster certificate. If omitted, the
           provider-level region will be used.
    """
    __args__ = dict()
    __args__['clusterId'] = cluster_id
    __args__['duration'] = duration
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Cce/getClusterCertificates:getClusterCertificates', __args__, opts=opts, typ=GetClusterCertificatesResult).value

    return AwaitableGetClusterCertificatesResult(
        cluster_id=__ret__.cluster_id,
        clusters=__ret__.clusters,
        contexts=__ret__.contexts,
        current_context=__ret__.current_context,
        duration=__ret__.duration,
        id=__ret__.id,
        kube_config_raw=__ret__.kube_config_raw,
        region=__ret__.region,
        users=__ret__.users)


@_utilities.lift_output_func(get_cluster_certificates)
def get_cluster_certificates_output(cluster_id: Optional[pulumi.Input[str]] = None,
                                    duration: Optional[pulumi.Input[int]] = None,
                                    region: Optional[pulumi.Input[Optional[str]]] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetClusterCertificatesResult]:
    """
    Use this data source to get the certificate of a CCE cluster within HuaweiCloud.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    cluster_id = config.require_object("clusterId")
    test = huaweicloud.Cce.get_cluster_certificates(cluster_id=cluster_id,
        duration=30)
    ```


    :param str cluster_id: Specifies the cluster ID which the cluster certificate in.
    :param int duration: Specifies the duration of the cluster certificate. The unit is days. The valid value in
           [1, 1827]. If the input value is -1, it will use the maximum 1827 as `duration` value.
    :param str region: Specifies the region in which to obtain the CCE cluster certificate. If omitted, the
           provider-level region will be used.
    """
    ...
