# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetBlackWhiteListsResult',
    'AwaitableGetBlackWhiteListsResult',
    'get_black_white_lists',
    'get_black_white_lists_output',
]

@pulumi.output_type
class GetBlackWhiteListsResult:
    """
    A collection of values returned by getBlackWhiteLists.
    """
    def __init__(__self__, address=None, address_type=None, description=None, direction=None, fw_instance_id=None, id=None, list_id=None, list_type=None, object_id=None, port=None, protocol=None, records=None, region=None):
        if address and not isinstance(address, str):
            raise TypeError("Expected argument 'address' to be a str")
        pulumi.set(__self__, "address", address)
        if address_type and not isinstance(address_type, str):
            raise TypeError("Expected argument 'address_type' to be a str")
        pulumi.set(__self__, "address_type", address_type)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if direction and not isinstance(direction, str):
            raise TypeError("Expected argument 'direction' to be a str")
        pulumi.set(__self__, "direction", direction)
        if fw_instance_id and not isinstance(fw_instance_id, str):
            raise TypeError("Expected argument 'fw_instance_id' to be a str")
        pulumi.set(__self__, "fw_instance_id", fw_instance_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if list_id and not isinstance(list_id, str):
            raise TypeError("Expected argument 'list_id' to be a str")
        pulumi.set(__self__, "list_id", list_id)
        if list_type and not isinstance(list_type, int):
            raise TypeError("Expected argument 'list_type' to be a int")
        pulumi.set(__self__, "list_type", list_type)
        if object_id and not isinstance(object_id, str):
            raise TypeError("Expected argument 'object_id' to be a str")
        pulumi.set(__self__, "object_id", object_id)
        if port and not isinstance(port, str):
            raise TypeError("Expected argument 'port' to be a str")
        pulumi.set(__self__, "port", port)
        if protocol and not isinstance(protocol, int):
            raise TypeError("Expected argument 'protocol' to be a int")
        pulumi.set(__self__, "protocol", protocol)
        if records and not isinstance(records, list):
            raise TypeError("Expected argument 'records' to be a list")
        pulumi.set(__self__, "records", records)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter
    def address(self) -> Optional[str]:
        """
        The IP address.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="addressType")
    def address_type(self) -> Optional[str]:
        """
        The IP address type.
        """
        return pulumi.get(self, "address_type")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        The description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def direction(self) -> Optional[str]:
        """
        The direction of a black or white address.
        """
        return pulumi.get(self, "direction")

    @property
    @pulumi.getter(name="fwInstanceId")
    def fw_instance_id(self) -> Optional[str]:
        return pulumi.get(self, "fw_instance_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="listId")
    def list_id(self) -> Optional[str]:
        """
        The blacklist/whitelist ID.
        """
        return pulumi.get(self, "list_id")

    @property
    @pulumi.getter(name="listType")
    def list_type(self) -> int:
        return pulumi.get(self, "list_type")

    @property
    @pulumi.getter(name="objectId")
    def object_id(self) -> str:
        return pulumi.get(self, "object_id")

    @property
    @pulumi.getter
    def port(self) -> Optional[str]:
        """
        The port.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter
    def protocol(self) -> Optional[int]:
        """
        The protocol type.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter
    def records(self) -> Sequence['outputs.GetBlackWhiteListsRecordResult']:
        """
        The blacklist and whitelist records.
        """
        return pulumi.get(self, "records")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")


class AwaitableGetBlackWhiteListsResult(GetBlackWhiteListsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBlackWhiteListsResult(
            address=self.address,
            address_type=self.address_type,
            description=self.description,
            direction=self.direction,
            fw_instance_id=self.fw_instance_id,
            id=self.id,
            list_id=self.list_id,
            list_type=self.list_type,
            object_id=self.object_id,
            port=self.port,
            protocol=self.protocol,
            records=self.records,
            region=self.region)


def get_black_white_lists(address: Optional[str] = None,
                          address_type: Optional[str] = None,
                          description: Optional[str] = None,
                          direction: Optional[str] = None,
                          fw_instance_id: Optional[str] = None,
                          list_id: Optional[str] = None,
                          list_type: Optional[int] = None,
                          object_id: Optional[str] = None,
                          port: Optional[str] = None,
                          protocol: Optional[int] = None,
                          region: Optional[str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBlackWhiteListsResult:
    """
    Use this data source to get the list of CFW blacklists and whitelists.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    object_id = config.require_object("objectId")
    list_type = config.require_object("listType")
    test = huaweicloud.Cfw.get_black_white_lists(object_id=object_id,
        list_type=list_type)
    ```


    :param str address: Specifies the IP address.
    :param str address_type: Specifies the IP address type.
           The valid value can be **0** (IPv4).
    :param str description: Specifies the description.
    :param str direction: Specifies the direction of a black or white address.
           The options are as follows:
           + **0**: source address;
           + **1**: destination address;
    :param str fw_instance_id: Specifies the firewall instance ID.
    :param str list_id: Specifies the blacklist/whitelist ID.
    :param int list_type: Specifies the blacklist/whitelist type.
           The options are `4` (blacklist) and `5` (whitelist).
    :param str object_id: Specifies the protected object ID.
    :param str port: Specifies the port.
    :param int protocol: Specifies The protocol type.
           The options are as follows:
           + **6**: TCP;
           + **17**: UDP;
           + **1**: ICMP;
           + **-1**: any protocol;
    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    """
    __args__ = dict()
    __args__['address'] = address
    __args__['addressType'] = address_type
    __args__['description'] = description
    __args__['direction'] = direction
    __args__['fwInstanceId'] = fw_instance_id
    __args__['listId'] = list_id
    __args__['listType'] = list_type
    __args__['objectId'] = object_id
    __args__['port'] = port
    __args__['protocol'] = protocol
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Cfw/getBlackWhiteLists:getBlackWhiteLists', __args__, opts=opts, typ=GetBlackWhiteListsResult).value

    return AwaitableGetBlackWhiteListsResult(
        address=__ret__.address,
        address_type=__ret__.address_type,
        description=__ret__.description,
        direction=__ret__.direction,
        fw_instance_id=__ret__.fw_instance_id,
        id=__ret__.id,
        list_id=__ret__.list_id,
        list_type=__ret__.list_type,
        object_id=__ret__.object_id,
        port=__ret__.port,
        protocol=__ret__.protocol,
        records=__ret__.records,
        region=__ret__.region)


@_utilities.lift_output_func(get_black_white_lists)
def get_black_white_lists_output(address: Optional[pulumi.Input[Optional[str]]] = None,
                                 address_type: Optional[pulumi.Input[Optional[str]]] = None,
                                 description: Optional[pulumi.Input[Optional[str]]] = None,
                                 direction: Optional[pulumi.Input[Optional[str]]] = None,
                                 fw_instance_id: Optional[pulumi.Input[Optional[str]]] = None,
                                 list_id: Optional[pulumi.Input[Optional[str]]] = None,
                                 list_type: Optional[pulumi.Input[int]] = None,
                                 object_id: Optional[pulumi.Input[str]] = None,
                                 port: Optional[pulumi.Input[Optional[str]]] = None,
                                 protocol: Optional[pulumi.Input[Optional[int]]] = None,
                                 region: Optional[pulumi.Input[Optional[str]]] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetBlackWhiteListsResult]:
    """
    Use this data source to get the list of CFW blacklists and whitelists.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    object_id = config.require_object("objectId")
    list_type = config.require_object("listType")
    test = huaweicloud.Cfw.get_black_white_lists(object_id=object_id,
        list_type=list_type)
    ```


    :param str address: Specifies the IP address.
    :param str address_type: Specifies the IP address type.
           The valid value can be **0** (IPv4).
    :param str description: Specifies the description.
    :param str direction: Specifies the direction of a black or white address.
           The options are as follows:
           + **0**: source address;
           + **1**: destination address;
    :param str fw_instance_id: Specifies the firewall instance ID.
    :param str list_id: Specifies the blacklist/whitelist ID.
    :param int list_type: Specifies the blacklist/whitelist type.
           The options are `4` (blacklist) and `5` (whitelist).
    :param str object_id: Specifies the protected object ID.
    :param str port: Specifies the port.
    :param int protocol: Specifies The protocol type.
           The options are as follows:
           + **6**: TCP;
           + **17**: UDP;
           + **1**: ICMP;
           + **-1**: any protocol;
    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    """
    ...
