# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetIpsRuleDetailsResult',
    'AwaitableGetIpsRuleDetailsResult',
    'get_ips_rule_details',
    'get_ips_rule_details_output',
]

@pulumi.output_type
class GetIpsRuleDetailsResult:
    """
    A collection of values returned by getIpsRuleDetails.
    """
    def __init__(__self__, datas=None, fw_instance_id=None, id=None, region=None):
        if datas and not isinstance(datas, list):
            raise TypeError("Expected argument 'datas' to be a list")
        pulumi.set(__self__, "datas", datas)
        if fw_instance_id and not isinstance(fw_instance_id, str):
            raise TypeError("Expected argument 'fw_instance_id' to be a str")
        pulumi.set(__self__, "fw_instance_id", fw_instance_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter
    def datas(self) -> Sequence['outputs.GetIpsRuleDetailsDataResult']:
        """
        The IPS information.
        """
        return pulumi.get(self, "datas")

    @property
    @pulumi.getter(name="fwInstanceId")
    def fw_instance_id(self) -> str:
        return pulumi.get(self, "fw_instance_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")


class AwaitableGetIpsRuleDetailsResult(GetIpsRuleDetailsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetIpsRuleDetailsResult(
            datas=self.datas,
            fw_instance_id=self.fw_instance_id,
            id=self.id,
            region=self.region)


def get_ips_rule_details(fw_instance_id: Optional[str] = None,
                         region: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetIpsRuleDetailsResult:
    """
    Use this data source to get the list of CFW IPS rule details.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    fw_instance_id = config.require_object("fwInstanceId")
    test = huaweicloud.Cfw.get_ips_rule_details(fw_instance_id=fw_instance_id)
    ```


    :param str fw_instance_id: Specifies the firewall ID.
    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    """
    __args__ = dict()
    __args__['fwInstanceId'] = fw_instance_id
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Cfw/getIpsRuleDetails:getIpsRuleDetails', __args__, opts=opts, typ=GetIpsRuleDetailsResult).value

    return AwaitableGetIpsRuleDetailsResult(
        datas=__ret__.datas,
        fw_instance_id=__ret__.fw_instance_id,
        id=__ret__.id,
        region=__ret__.region)


@_utilities.lift_output_func(get_ips_rule_details)
def get_ips_rule_details_output(fw_instance_id: Optional[pulumi.Input[str]] = None,
                                region: Optional[pulumi.Input[Optional[str]]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetIpsRuleDetailsResult]:
    """
    Use this data source to get the list of CFW IPS rule details.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    fw_instance_id = config.require_object("fwInstanceId")
    test = huaweicloud.Cfw.get_ips_rule_details(fw_instance_id=fw_instance_id)
    ```


    :param str fw_instance_id: Specifies the firewall ID.
    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    """
    ...
