# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'AclRuleCustomService',
    'AclRuleCustomServiceGroups',
    'AclRuleDestinationRegionList',
    'AclRulePredefinedServiceGroups',
    'AclRuleSequence',
    'AclRuleSourceRegionList',
    'AntiVirusScanProtocolConfig',
    'CaptureTaskDestination',
    'CaptureTaskService',
    'CaptureTaskSource',
    'DomainNameGroupDomainName',
    'EipProtectionProtectedEip',
    'FirewallFlavor',
    'FirewallProtectObject',
    'GetAccessControlLogsRecordResult',
    'GetAddressGroupMembersRecordResult',
    'GetAddressGroupsAddressGroupResult',
    'GetAttackLogsRecordResult',
    'GetAttackLogsRecordPacketMessageResult',
    'GetBlackWhiteListsRecordResult',
    'GetCaptureTaskResultsFileListResult',
    'GetCaptureTaskResultsRequestHeaderResult',
    'GetCaptureTasksRecordResult',
    'GetDomainNameGroupsRecordResult',
    'GetDomainNameGroupsRecordDomainNameResult',
    'GetDomainNameGroupsRecordRuleResult',
    'GetFirewallsRecordResult',
    'GetFirewallsRecordFlavorResult',
    'GetFirewallsRecordProtectObjectResult',
    'GetFirewallsRecordResourceResult',
    'GetFlowLogsRecordResult',
    'GetIpsCustomRulesRecordResult',
    'GetIpsRuleDetailsDataResult',
    'GetIpsRulesRecordResult',
    'GetProtectionRulesRecordResult',
    'GetProtectionRulesRecordDestinationResult',
    'GetProtectionRulesRecordDestinationRegionListResult',
    'GetProtectionRulesRecordServiceResult',
    'GetProtectionRulesRecordServiceCustomServiceResult',
    'GetProtectionRulesRecordSourceResult',
    'GetProtectionRulesRecordSourceRegionListResult',
    'GetResourceTagsTagResult',
    'GetServiceGroupMembersRecordResult',
    'GetServiceGroupsServiceGroupResult',
    'GetTagsTagResult',
]

@pulumi.output_type
class AclRuleCustomService(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "destPort":
            suggest = "dest_port"
        elif key == "sourcePort":
            suggest = "source_port"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AclRuleCustomService. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AclRuleCustomService.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AclRuleCustomService.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dest_port: str,
                 protocol: int,
                 source_port: str):
        """
        :param str dest_port: The destination port.
        :param int protocol: The protocol type.
        :param str source_port: The source port.
        """
        pulumi.set(__self__, "dest_port", dest_port)
        pulumi.set(__self__, "protocol", protocol)
        pulumi.set(__self__, "source_port", source_port)

    @property
    @pulumi.getter(name="destPort")
    def dest_port(self) -> str:
        """
        The destination port.
        """
        return pulumi.get(self, "dest_port")

    @property
    @pulumi.getter
    def protocol(self) -> int:
        """
        The protocol type.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter(name="sourcePort")
    def source_port(self) -> str:
        """
        The source port.
        """
        return pulumi.get(self, "source_port")


@pulumi.output_type
class AclRuleCustomServiceGroups(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "groupIds":
            suggest = "group_ids"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AclRuleCustomServiceGroups. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AclRuleCustomServiceGroups.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AclRuleCustomServiceGroups.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 group_ids: Sequence[str],
                 protocols: Sequence[int]):
        """
        :param Sequence[str] group_ids: The IDs of the predefined service groups.
        :param Sequence[int] protocols: The protocols used in the predefined service groups.
        """
        pulumi.set(__self__, "group_ids", group_ids)
        pulumi.set(__self__, "protocols", protocols)

    @property
    @pulumi.getter(name="groupIds")
    def group_ids(self) -> Sequence[str]:
        """
        The IDs of the predefined service groups.
        """
        return pulumi.get(self, "group_ids")

    @property
    @pulumi.getter
    def protocols(self) -> Sequence[int]:
        """
        The protocols used in the predefined service groups.
        """
        return pulumi.get(self, "protocols")


@pulumi.output_type
class AclRuleDestinationRegionList(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "regionId":
            suggest = "region_id"
        elif key == "regionType":
            suggest = "region_type"
        elif key == "descriptionCn":
            suggest = "description_cn"
        elif key == "descriptionEn":
            suggest = "description_en"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AclRuleDestinationRegionList. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AclRuleDestinationRegionList.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AclRuleDestinationRegionList.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 region_id: str,
                 region_type: int,
                 description_cn: Optional[str] = None,
                 description_en: Optional[str] = None):
        """
        :param str region_id: The region ID.
        :param int region_type: The region type.
        :param str description_cn: The Chinese description of the region.
        :param str description_en: The English description of the region.
        """
        pulumi.set(__self__, "region_id", region_id)
        pulumi.set(__self__, "region_type", region_type)
        if description_cn is not None:
            pulumi.set(__self__, "description_cn", description_cn)
        if description_en is not None:
            pulumi.set(__self__, "description_en", description_en)

    @property
    @pulumi.getter(name="regionId")
    def region_id(self) -> str:
        """
        The region ID.
        """
        return pulumi.get(self, "region_id")

    @property
    @pulumi.getter(name="regionType")
    def region_type(self) -> int:
        """
        The region type.
        """
        return pulumi.get(self, "region_type")

    @property
    @pulumi.getter(name="descriptionCn")
    def description_cn(self) -> Optional[str]:
        """
        The Chinese description of the region.
        """
        return pulumi.get(self, "description_cn")

    @property
    @pulumi.getter(name="descriptionEn")
    def description_en(self) -> Optional[str]:
        """
        The English description of the region.
        """
        return pulumi.get(self, "description_en")


@pulumi.output_type
class AclRulePredefinedServiceGroups(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "groupIds":
            suggest = "group_ids"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AclRulePredefinedServiceGroups. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AclRulePredefinedServiceGroups.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AclRulePredefinedServiceGroups.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 group_ids: Sequence[str],
                 protocols: Sequence[int]):
        """
        :param Sequence[str] group_ids: The IDs of the predefined service groups.
        :param Sequence[int] protocols: The protocols used in the predefined service groups.
        """
        pulumi.set(__self__, "group_ids", group_ids)
        pulumi.set(__self__, "protocols", protocols)

    @property
    @pulumi.getter(name="groupIds")
    def group_ids(self) -> Sequence[str]:
        """
        The IDs of the predefined service groups.
        """
        return pulumi.get(self, "group_ids")

    @property
    @pulumi.getter
    def protocols(self) -> Sequence[int]:
        """
        The protocols used in the predefined service groups.
        """
        return pulumi.get(self, "protocols")


@pulumi.output_type
class AclRuleSequence(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "destRuleId":
            suggest = "dest_rule_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AclRuleSequence. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AclRuleSequence.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AclRuleSequence.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 bottom: Optional[int] = None,
                 dest_rule_id: Optional[str] = None,
                 top: Optional[int] = None):
        """
        :param int bottom: Whether to pin on bottom.
               The options are as follows:
               + **0**: no;
               + **1**: yes;
        :param str dest_rule_id: The ID of the rule that the added rule will follow.
        :param int top: Whether to pin on top.
               The options are as follows:
               + **0**: no;
               + **1**: yes;
        """
        if bottom is not None:
            pulumi.set(__self__, "bottom", bottom)
        if dest_rule_id is not None:
            pulumi.set(__self__, "dest_rule_id", dest_rule_id)
        if top is not None:
            pulumi.set(__self__, "top", top)

    @property
    @pulumi.getter
    def bottom(self) -> Optional[int]:
        """
        Whether to pin on bottom.
        The options are as follows:
        + **0**: no;
        + **1**: yes;
        """
        return pulumi.get(self, "bottom")

    @property
    @pulumi.getter(name="destRuleId")
    def dest_rule_id(self) -> Optional[str]:
        """
        The ID of the rule that the added rule will follow.
        """
        return pulumi.get(self, "dest_rule_id")

    @property
    @pulumi.getter
    def top(self) -> Optional[int]:
        """
        Whether to pin on top.
        The options are as follows:
        + **0**: no;
        + **1**: yes;
        """
        return pulumi.get(self, "top")


@pulumi.output_type
class AclRuleSourceRegionList(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "regionId":
            suggest = "region_id"
        elif key == "regionType":
            suggest = "region_type"
        elif key == "descriptionCn":
            suggest = "description_cn"
        elif key == "descriptionEn":
            suggest = "description_en"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AclRuleSourceRegionList. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AclRuleSourceRegionList.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AclRuleSourceRegionList.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 region_id: str,
                 region_type: int,
                 description_cn: Optional[str] = None,
                 description_en: Optional[str] = None):
        """
        :param str region_id: The region ID.
        :param int region_type: The region type.
        :param str description_cn: The Chinese description of the region.
        :param str description_en: The English description of the region.
        """
        pulumi.set(__self__, "region_id", region_id)
        pulumi.set(__self__, "region_type", region_type)
        if description_cn is not None:
            pulumi.set(__self__, "description_cn", description_cn)
        if description_en is not None:
            pulumi.set(__self__, "description_en", description_en)

    @property
    @pulumi.getter(name="regionId")
    def region_id(self) -> str:
        """
        The region ID.
        """
        return pulumi.get(self, "region_id")

    @property
    @pulumi.getter(name="regionType")
    def region_type(self) -> int:
        """
        The region type.
        """
        return pulumi.get(self, "region_type")

    @property
    @pulumi.getter(name="descriptionCn")
    def description_cn(self) -> Optional[str]:
        """
        The Chinese description of the region.
        """
        return pulumi.get(self, "description_cn")

    @property
    @pulumi.getter(name="descriptionEn")
    def description_en(self) -> Optional[str]:
        """
        The English description of the region.
        """
        return pulumi.get(self, "description_en")


@pulumi.output_type
class AntiVirusScanProtocolConfig(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "protocolType":
            suggest = "protocol_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AntiVirusScanProtocolConfig. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AntiVirusScanProtocolConfig.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AntiVirusScanProtocolConfig.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 action: int,
                 protocol_type: int):
        """
        :param int action: The anti virus action. The valid value can be **0** (observe) or **1** (block).
        :param int protocol_type: The protocol type.
               The valid values are as follows:
               + **0**: HTTP;
               + **1**: SMTP;
               + **2**: POP3;
               + **3**: IMAP4;
               + **4**: FTP;
               + **5**: SMB;
               + **6**: Malicious Access Control;
        """
        pulumi.set(__self__, "action", action)
        pulumi.set(__self__, "protocol_type", protocol_type)

    @property
    @pulumi.getter
    def action(self) -> int:
        """
        The anti virus action. The valid value can be **0** (observe) or **1** (block).
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter(name="protocolType")
    def protocol_type(self) -> int:
        """
        The protocol type.
        The valid values are as follows:
        + **0**: HTTP;
        + **1**: SMTP;
        + **2**: POP3;
        + **3**: IMAP4;
        + **4**: FTP;
        + **5**: SMB;
        + **6**: Malicious Access Control;
        """
        return pulumi.get(self, "protocol_type")


@pulumi.output_type
class CaptureTaskDestination(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "addressType":
            suggest = "address_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in CaptureTaskDestination. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        CaptureTaskDestination.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        CaptureTaskDestination.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 address: str,
                 address_type: int):
        """
        :param str address: Specifies the address.
        :param int address_type: Specifies the address type.
               The valid values are:
               + **0**: indicates IPv4;
               + **1**: indicates IPv6.
        """
        pulumi.set(__self__, "address", address)
        pulumi.set(__self__, "address_type", address_type)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        Specifies the address.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="addressType")
    def address_type(self) -> int:
        """
        Specifies the address type.
        The valid values are:
        + **0**: indicates IPv4;
        + **1**: indicates IPv6.
        """
        return pulumi.get(self, "address_type")


@pulumi.output_type
class CaptureTaskService(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "destPort":
            suggest = "dest_port"
        elif key == "sourcePort":
            suggest = "source_port"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in CaptureTaskService. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        CaptureTaskService.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        CaptureTaskService.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 protocol: int,
                 dest_port: Optional[str] = None,
                 source_port: Optional[str] = None):
        """
        :param int protocol: Specifies the protocol type.
               The valid values are:
               + **6**: indicates TCP;
               + **17**: indicates UDP;
               + **1**: indicates ICMP;
               + **58**: indicates ICMPv6;
               + **-1**: indicates any protocol.
        :param str dest_port: Specifies the destination port.
        :param str source_port: Specifies the source port.
        """
        pulumi.set(__self__, "protocol", protocol)
        if dest_port is not None:
            pulumi.set(__self__, "dest_port", dest_port)
        if source_port is not None:
            pulumi.set(__self__, "source_port", source_port)

    @property
    @pulumi.getter
    def protocol(self) -> int:
        """
        Specifies the protocol type.
        The valid values are:
        + **6**: indicates TCP;
        + **17**: indicates UDP;
        + **1**: indicates ICMP;
        + **58**: indicates ICMPv6;
        + **-1**: indicates any protocol.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter(name="destPort")
    def dest_port(self) -> Optional[str]:
        """
        Specifies the destination port.
        """
        return pulumi.get(self, "dest_port")

    @property
    @pulumi.getter(name="sourcePort")
    def source_port(self) -> Optional[str]:
        """
        Specifies the source port.
        """
        return pulumi.get(self, "source_port")


@pulumi.output_type
class CaptureTaskSource(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "addressType":
            suggest = "address_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in CaptureTaskSource. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        CaptureTaskSource.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        CaptureTaskSource.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 address: str,
                 address_type: int):
        """
        :param str address: Specifies the address.
        :param int address_type: Specifies the address type.
               The valid values are:
               + **0**: indicates IPv4;
               + **1**: indicates IPv6.
        """
        pulumi.set(__self__, "address", address)
        pulumi.set(__self__, "address_type", address_type)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        Specifies the address.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="addressType")
    def address_type(self) -> int:
        """
        Specifies the address type.
        The valid values are:
        + **0**: indicates IPv4;
        + **1**: indicates IPv6.
        """
        return pulumi.get(self, "address_type")


@pulumi.output_type
class DomainNameGroupDomainName(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "domainName":
            suggest = "domain_name"
        elif key == "dnsIps":
            suggest = "dns_ips"
        elif key == "domainAddressId":
            suggest = "domain_address_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in DomainNameGroupDomainName. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        DomainNameGroupDomainName.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        DomainNameGroupDomainName.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 domain_name: str,
                 description: Optional[str] = None,
                 dns_ips: Optional[str] = None,
                 domain_address_id: Optional[str] = None):
        """
        :param str domain_name: Specifies the domain name.
        :param str description: Specifies the description.
        :param str dns_ips: The DNS IP list.
        :param str domain_address_id: The domain address ID.
        """
        pulumi.set(__self__, "domain_name", domain_name)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if dns_ips is not None:
            pulumi.set(__self__, "dns_ips", dns_ips)
        if domain_address_id is not None:
            pulumi.set(__self__, "domain_address_id", domain_address_id)

    @property
    @pulumi.getter(name="domainName")
    def domain_name(self) -> str:
        """
        Specifies the domain name.
        """
        return pulumi.get(self, "domain_name")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Specifies the description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="dnsIps")
    def dns_ips(self) -> Optional[str]:
        """
        The DNS IP list.
        """
        return pulumi.get(self, "dns_ips")

    @property
    @pulumi.getter(name="domainAddressId")
    def domain_address_id(self) -> Optional[str]:
        """
        The domain address ID.
        """
        return pulumi.get(self, "domain_address_id")


@pulumi.output_type
class EipProtectionProtectedEip(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "publicIpv4":
            suggest = "public_ipv4"
        elif key == "publicIpv6":
            suggest = "public_ipv6"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in EipProtectionProtectedEip. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        EipProtectionProtectedEip.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        EipProtectionProtectedEip.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 id: str,
                 public_ipv4: Optional[str] = None,
                 public_ipv6: Optional[str] = None):
        """
        :param str id: The ID of the protected EIP.
        :param str public_ipv4: The IPv4 address of the protected EIP.
        :param str public_ipv6: The IPv6 address of the protected EIP.
        """
        pulumi.set(__self__, "id", id)
        if public_ipv4 is not None:
            pulumi.set(__self__, "public_ipv4", public_ipv4)
        if public_ipv6 is not None:
            pulumi.set(__self__, "public_ipv6", public_ipv6)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the protected EIP.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="publicIpv4")
    def public_ipv4(self) -> Optional[str]:
        """
        The IPv4 address of the protected EIP.
        """
        return pulumi.get(self, "public_ipv4")

    @property
    @pulumi.getter(name="publicIpv6")
    def public_ipv6(self) -> Optional[str]:
        """
        The IPv6 address of the protected EIP.
        """
        return pulumi.get(self, "public_ipv6")


@pulumi.output_type
class FirewallFlavor(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "defaultBandwidth":
            suggest = "default_bandwidth"
        elif key == "defaultEipCount":
            suggest = "default_eip_count"
        elif key == "defaultLogStorage":
            suggest = "default_log_storage"
        elif key == "defaultVpcCount":
            suggest = "default_vpc_count"
        elif key == "eipCount":
            suggest = "eip_count"
        elif key == "extendBandwidth":
            suggest = "extend_bandwidth"
        elif key == "extendEipCount":
            suggest = "extend_eip_count"
        elif key == "extendVpcCount":
            suggest = "extend_vpc_count"
        elif key == "logStorage":
            suggest = "log_storage"
        elif key == "totalRuleCount":
            suggest = "total_rule_count"
        elif key == "usedRuleCount":
            suggest = "used_rule_count"
        elif key == "vpcBandwidth":
            suggest = "vpc_bandwidth"
        elif key == "vpcCount":
            suggest = "vpc_count"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in FirewallFlavor. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        FirewallFlavor.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        FirewallFlavor.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 version: str,
                 bandwidth: Optional[int] = None,
                 default_bandwidth: Optional[int] = None,
                 default_eip_count: Optional[int] = None,
                 default_log_storage: Optional[int] = None,
                 default_vpc_count: Optional[int] = None,
                 eip_count: Optional[int] = None,
                 extend_bandwidth: Optional[int] = None,
                 extend_eip_count: Optional[int] = None,
                 extend_vpc_count: Optional[int] = None,
                 log_storage: Optional[int] = None,
                 total_rule_count: Optional[int] = None,
                 used_rule_count: Optional[int] = None,
                 vpc_bandwidth: Optional[int] = None,
                 vpc_count: Optional[int] = None):
        """
        :param str version: Specifies the version of the firewall.
               When the charging_mode is **prePaid**: the value can be **Standard** and **Prefessional**.
               When the charging_mode is **postPaid**: the value can be **Prefessional**.
               Changing this parameter will create a new resource.
        :param int bandwidth: The bandwidth of the firewall.
        :param int default_bandwidth: The default bandwidth of the firewall.
        :param int default_eip_count: The default EIP number of the firewall.
        :param int default_log_storage: The default log storage of the firewall.
        :param int default_vpc_count: The default VPC number of the firewall.
        :param int eip_count: The EIP number of the firewall.
        :param int extend_bandwidth: Specifies the extend bandwidth of the firewall.
               Only works when the charging_mode is **prePaid**.
               Changing this parameter will create a new resource.
        :param int extend_eip_count: Specifies the extend EIP number of the firewall.
               Only works when the charging_mode is **prePaid**.
               Changing this parameter will create a new resource.
        :param int extend_vpc_count: Specifies the extend VPC number of the firewall.
               Only works when the charging_mode is **prePaid**.
               Changing this parameter will create a new resource.
        :param int log_storage: The log storage of the firewall.
        :param int total_rule_count: The total rule count of the firewall.
        :param int used_rule_count: The used rule count of the firewall.
        :param int vpc_bandwidth: The VPC bandwidth of the firewall.
        :param int vpc_count: The VPC number of the firewall.
        """
        pulumi.set(__self__, "version", version)
        if bandwidth is not None:
            pulumi.set(__self__, "bandwidth", bandwidth)
        if default_bandwidth is not None:
            pulumi.set(__self__, "default_bandwidth", default_bandwidth)
        if default_eip_count is not None:
            pulumi.set(__self__, "default_eip_count", default_eip_count)
        if default_log_storage is not None:
            pulumi.set(__self__, "default_log_storage", default_log_storage)
        if default_vpc_count is not None:
            pulumi.set(__self__, "default_vpc_count", default_vpc_count)
        if eip_count is not None:
            pulumi.set(__self__, "eip_count", eip_count)
        if extend_bandwidth is not None:
            pulumi.set(__self__, "extend_bandwidth", extend_bandwidth)
        if extend_eip_count is not None:
            pulumi.set(__self__, "extend_eip_count", extend_eip_count)
        if extend_vpc_count is not None:
            pulumi.set(__self__, "extend_vpc_count", extend_vpc_count)
        if log_storage is not None:
            pulumi.set(__self__, "log_storage", log_storage)
        if total_rule_count is not None:
            pulumi.set(__self__, "total_rule_count", total_rule_count)
        if used_rule_count is not None:
            pulumi.set(__self__, "used_rule_count", used_rule_count)
        if vpc_bandwidth is not None:
            pulumi.set(__self__, "vpc_bandwidth", vpc_bandwidth)
        if vpc_count is not None:
            pulumi.set(__self__, "vpc_count", vpc_count)

    @property
    @pulumi.getter
    def version(self) -> str:
        """
        Specifies the version of the firewall.
        When the charging_mode is **prePaid**: the value can be **Standard** and **Prefessional**.
        When the charging_mode is **postPaid**: the value can be **Prefessional**.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "version")

    @property
    @pulumi.getter
    def bandwidth(self) -> Optional[int]:
        """
        The bandwidth of the firewall.
        """
        return pulumi.get(self, "bandwidth")

    @property
    @pulumi.getter(name="defaultBandwidth")
    def default_bandwidth(self) -> Optional[int]:
        """
        The default bandwidth of the firewall.
        """
        return pulumi.get(self, "default_bandwidth")

    @property
    @pulumi.getter(name="defaultEipCount")
    def default_eip_count(self) -> Optional[int]:
        """
        The default EIP number of the firewall.
        """
        return pulumi.get(self, "default_eip_count")

    @property
    @pulumi.getter(name="defaultLogStorage")
    def default_log_storage(self) -> Optional[int]:
        """
        The default log storage of the firewall.
        """
        return pulumi.get(self, "default_log_storage")

    @property
    @pulumi.getter(name="defaultVpcCount")
    def default_vpc_count(self) -> Optional[int]:
        """
        The default VPC number of the firewall.
        """
        return pulumi.get(self, "default_vpc_count")

    @property
    @pulumi.getter(name="eipCount")
    def eip_count(self) -> Optional[int]:
        """
        The EIP number of the firewall.
        """
        return pulumi.get(self, "eip_count")

    @property
    @pulumi.getter(name="extendBandwidth")
    def extend_bandwidth(self) -> Optional[int]:
        """
        Specifies the extend bandwidth of the firewall.
        Only works when the charging_mode is **prePaid**.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "extend_bandwidth")

    @property
    @pulumi.getter(name="extendEipCount")
    def extend_eip_count(self) -> Optional[int]:
        """
        Specifies the extend EIP number of the firewall.
        Only works when the charging_mode is **prePaid**.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "extend_eip_count")

    @property
    @pulumi.getter(name="extendVpcCount")
    def extend_vpc_count(self) -> Optional[int]:
        """
        Specifies the extend VPC number of the firewall.
        Only works when the charging_mode is **prePaid**.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "extend_vpc_count")

    @property
    @pulumi.getter(name="logStorage")
    def log_storage(self) -> Optional[int]:
        """
        The log storage of the firewall.
        """
        return pulumi.get(self, "log_storage")

    @property
    @pulumi.getter(name="totalRuleCount")
    def total_rule_count(self) -> Optional[int]:
        """
        The total rule count of the firewall.
        """
        return pulumi.get(self, "total_rule_count")

    @property
    @pulumi.getter(name="usedRuleCount")
    def used_rule_count(self) -> Optional[int]:
        """
        The used rule count of the firewall.
        """
        return pulumi.get(self, "used_rule_count")

    @property
    @pulumi.getter(name="vpcBandwidth")
    def vpc_bandwidth(self) -> Optional[int]:
        """
        The VPC bandwidth of the firewall.
        """
        return pulumi.get(self, "vpc_bandwidth")

    @property
    @pulumi.getter(name="vpcCount")
    def vpc_count(self) -> Optional[int]:
        """
        The VPC number of the firewall.
        """
        return pulumi.get(self, "vpc_count")


@pulumi.output_type
class FirewallProtectObject(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "objectId":
            suggest = "object_id"
        elif key == "objectName":
            suggest = "object_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in FirewallProtectObject. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        FirewallProtectObject.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        FirewallProtectObject.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 object_id: Optional[str] = None,
                 object_name: Optional[str] = None,
                 type: Optional[int] = None):
        """
        :param str object_id: The protected object ID.
        :param str object_name: The protected object name.
        :param int type: The object type.
               The options are as follows: 0: north-south; 1: east-west.
        """
        if object_id is not None:
            pulumi.set(__self__, "object_id", object_id)
        if object_name is not None:
            pulumi.set(__self__, "object_name", object_name)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="objectId")
    def object_id(self) -> Optional[str]:
        """
        The protected object ID.
        """
        return pulumi.get(self, "object_id")

    @property
    @pulumi.getter(name="objectName")
    def object_name(self) -> Optional[str]:
        """
        The protected object name.
        """
        return pulumi.get(self, "object_name")

    @property
    @pulumi.getter
    def type(self) -> Optional[int]:
        """
        The object type.
        The options are as follows: 0: north-south; 1: east-west.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetAccessControlLogsRecordResult(dict):
    def __init__(__self__, *,
                 action: str,
                 app: str,
                 dst_city_id: str,
                 dst_city_name: str,
                 dst_host: str,
                 dst_ip: str,
                 dst_port: int,
                 dst_province_id: str,
                 dst_province_name: str,
                 dst_region_id: str,
                 dst_region_name: str,
                 hit_time: str,
                 log_id: str,
                 protocol: str,
                 rule_id: str,
                 rule_name: str,
                 src_city_id: str,
                 src_city_name: str,
                 src_ip: str,
                 src_port: int,
                 src_province_id: str,
                 src_province_name: str,
                 src_region_id: str,
                 src_region_name: str):
        """
        :param str action: Specifies the action. The values can be **allow** and **deny**.
        :param str app: Specifies the application protocol.
        :param str dst_city_id: The destination city ID.
        :param str dst_city_name: Specifies the destination city name.
        :param str dst_host: The destination host.
        :param str dst_ip: Specifies the destination IP address.
        :param int dst_port: Specifies the destination port.
        :param str dst_province_id: The destination province ID.
        :param str dst_province_name: Specifies the destination province name.
        :param str dst_region_id: The destination region ID.
        :param str dst_region_name: Specifies the destination region name.
        :param str hit_time: The hit time.
        :param str log_id: The document ID.
        :param str protocol: The protocol type.
        :param str rule_id: The rule ID.
        :param str rule_name: Specifies the rule name.
        :param str src_city_id: The source city ID.
        :param str src_city_name: Specifies the source city name.
        :param str src_ip: Specifies the source IP address.
        :param int src_port: Specifies the source port.
        :param str src_province_id: The source province ID.
        :param str src_province_name: Specifies the source province name.
        :param str src_region_id: The source region ID.
        :param str src_region_name: Specifies the source region name.
        """
        pulumi.set(__self__, "action", action)
        pulumi.set(__self__, "app", app)
        pulumi.set(__self__, "dst_city_id", dst_city_id)
        pulumi.set(__self__, "dst_city_name", dst_city_name)
        pulumi.set(__self__, "dst_host", dst_host)
        pulumi.set(__self__, "dst_ip", dst_ip)
        pulumi.set(__self__, "dst_port", dst_port)
        pulumi.set(__self__, "dst_province_id", dst_province_id)
        pulumi.set(__self__, "dst_province_name", dst_province_name)
        pulumi.set(__self__, "dst_region_id", dst_region_id)
        pulumi.set(__self__, "dst_region_name", dst_region_name)
        pulumi.set(__self__, "hit_time", hit_time)
        pulumi.set(__self__, "log_id", log_id)
        pulumi.set(__self__, "protocol", protocol)
        pulumi.set(__self__, "rule_id", rule_id)
        pulumi.set(__self__, "rule_name", rule_name)
        pulumi.set(__self__, "src_city_id", src_city_id)
        pulumi.set(__self__, "src_city_name", src_city_name)
        pulumi.set(__self__, "src_ip", src_ip)
        pulumi.set(__self__, "src_port", src_port)
        pulumi.set(__self__, "src_province_id", src_province_id)
        pulumi.set(__self__, "src_province_name", src_province_name)
        pulumi.set(__self__, "src_region_id", src_region_id)
        pulumi.set(__self__, "src_region_name", src_region_name)

    @property
    @pulumi.getter
    def action(self) -> str:
        """
        Specifies the action. The values can be **allow** and **deny**.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def app(self) -> str:
        """
        Specifies the application protocol.
        """
        return pulumi.get(self, "app")

    @property
    @pulumi.getter(name="dstCityId")
    def dst_city_id(self) -> str:
        """
        The destination city ID.
        """
        return pulumi.get(self, "dst_city_id")

    @property
    @pulumi.getter(name="dstCityName")
    def dst_city_name(self) -> str:
        """
        Specifies the destination city name.
        """
        return pulumi.get(self, "dst_city_name")

    @property
    @pulumi.getter(name="dstHost")
    def dst_host(self) -> str:
        """
        The destination host.
        """
        return pulumi.get(self, "dst_host")

    @property
    @pulumi.getter(name="dstIp")
    def dst_ip(self) -> str:
        """
        Specifies the destination IP address.
        """
        return pulumi.get(self, "dst_ip")

    @property
    @pulumi.getter(name="dstPort")
    def dst_port(self) -> int:
        """
        Specifies the destination port.
        """
        return pulumi.get(self, "dst_port")

    @property
    @pulumi.getter(name="dstProvinceId")
    def dst_province_id(self) -> str:
        """
        The destination province ID.
        """
        return pulumi.get(self, "dst_province_id")

    @property
    @pulumi.getter(name="dstProvinceName")
    def dst_province_name(self) -> str:
        """
        Specifies the destination province name.
        """
        return pulumi.get(self, "dst_province_name")

    @property
    @pulumi.getter(name="dstRegionId")
    def dst_region_id(self) -> str:
        """
        The destination region ID.
        """
        return pulumi.get(self, "dst_region_id")

    @property
    @pulumi.getter(name="dstRegionName")
    def dst_region_name(self) -> str:
        """
        Specifies the destination region name.
        """
        return pulumi.get(self, "dst_region_name")

    @property
    @pulumi.getter(name="hitTime")
    def hit_time(self) -> str:
        """
        The hit time.
        """
        return pulumi.get(self, "hit_time")

    @property
    @pulumi.getter(name="logId")
    def log_id(self) -> str:
        """
        The document ID.
        """
        return pulumi.get(self, "log_id")

    @property
    @pulumi.getter
    def protocol(self) -> str:
        """
        The protocol type.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> str:
        """
        The rule ID.
        """
        return pulumi.get(self, "rule_id")

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> str:
        """
        Specifies the rule name.
        """
        return pulumi.get(self, "rule_name")

    @property
    @pulumi.getter(name="srcCityId")
    def src_city_id(self) -> str:
        """
        The source city ID.
        """
        return pulumi.get(self, "src_city_id")

    @property
    @pulumi.getter(name="srcCityName")
    def src_city_name(self) -> str:
        """
        Specifies the source city name.
        """
        return pulumi.get(self, "src_city_name")

    @property
    @pulumi.getter(name="srcIp")
    def src_ip(self) -> str:
        """
        Specifies the source IP address.
        """
        return pulumi.get(self, "src_ip")

    @property
    @pulumi.getter(name="srcPort")
    def src_port(self) -> int:
        """
        Specifies the source port.
        """
        return pulumi.get(self, "src_port")

    @property
    @pulumi.getter(name="srcProvinceId")
    def src_province_id(self) -> str:
        """
        The source province ID.
        """
        return pulumi.get(self, "src_province_id")

    @property
    @pulumi.getter(name="srcProvinceName")
    def src_province_name(self) -> str:
        """
        Specifies the source province name.
        """
        return pulumi.get(self, "src_province_name")

    @property
    @pulumi.getter(name="srcRegionId")
    def src_region_id(self) -> str:
        """
        The source region ID.
        """
        return pulumi.get(self, "src_region_id")

    @property
    @pulumi.getter(name="srcRegionName")
    def src_region_name(self) -> str:
        """
        Specifies the source region name.
        """
        return pulumi.get(self, "src_region_name")


@pulumi.output_type
class GetAddressGroupMembersRecordResult(dict):
    def __init__(__self__, *,
                 address: str,
                 address_type: int,
                 description: str,
                 item_id: str):
        """
        :param str address: Specifies the IP address
        :param int address_type: The address type.
        :param str description: The address group member description.
        :param str item_id: Specifies the address group member ID.
        """
        pulumi.set(__self__, "address", address)
        pulumi.set(__self__, "address_type", address_type)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "item_id", item_id)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        Specifies the IP address
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="addressType")
    def address_type(self) -> int:
        """
        The address type.
        """
        return pulumi.get(self, "address_type")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The address group member description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="itemId")
    def item_id(self) -> str:
        """
        Specifies the address group member ID.
        """
        return pulumi.get(self, "item_id")


@pulumi.output_type
class GetAddressGroupsAddressGroupResult(dict):
    def __init__(__self__, *,
                 address_type: int,
                 description: str,
                 id: str,
                 name: str,
                 object_id: str,
                 ref_count: int,
                 type: int):
        """
        :param int address_type: Specifies the IP address type.
               The value can be **0** (IPv4) or **1** (IPv6).
        :param str description: The address groups description.
        :param str id: The ID of the IP address group.
        :param str name: Specifies the name of the address group.
        :param str object_id: Specifies the protected object ID.
        :param int ref_count: The number of times this address group has been referenced.
        :param int type: The address group type.
        """
        pulumi.set(__self__, "address_type", address_type)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "object_id", object_id)
        pulumi.set(__self__, "ref_count", ref_count)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="addressType")
    def address_type(self) -> int:
        """
        Specifies the IP address type.
        The value can be **0** (IPv4) or **1** (IPv6).
        """
        return pulumi.get(self, "address_type")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The address groups description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the IP address group.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Specifies the name of the address group.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="objectId")
    def object_id(self) -> str:
        """
        Specifies the protected object ID.
        """
        return pulumi.get(self, "object_id")

    @property
    @pulumi.getter(name="refCount")
    def ref_count(self) -> int:
        """
        The number of times this address group has been referenced.
        """
        return pulumi.get(self, "ref_count")

    @property
    @pulumi.getter
    def type(self) -> int:
        """
        The address group type.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetAttackLogsRecordResult(dict):
    def __init__(__self__, *,
                 action: str,
                 app: str,
                 attack_rule: str,
                 attack_rule_id: str,
                 attack_type: str,
                 direction: str,
                 dst_city_id: str,
                 dst_city_name: str,
                 dst_ip: str,
                 dst_port: int,
                 dst_province_id: str,
                 dst_province_name: str,
                 dst_region_id: str,
                 dst_region_name: str,
                 event_time: str,
                 level: str,
                 log_id: str,
                 packet: str,
                 packet_length: int,
                 packet_messages: Sequence['outputs.GetAttackLogsRecordPacketMessageResult'],
                 protocol: str,
                 source: str,
                 src_city_id: str,
                 src_city_name: str,
                 src_ip: str,
                 src_port: int,
                 src_province_id: str,
                 src_province_name: str,
                 src_region_id: str,
                 src_region_name: str):
        """
        :param str action: The action.
        :param str app: Specifies the application protocol.
        :param str attack_rule: Specifies the intrusion event rule.
        :param str attack_rule_id: Specifies the attack rule ID.
        :param str attack_type: Specifies the intrusion event type.
        :param str direction: The direction.
        :param str dst_city_id: The destination city ID.
        :param str dst_city_name: Specifies the destination city name.
        :param str dst_ip: Specifies the destination IP address.
        :param int dst_port: Specifies the destination port.
        :param str dst_province_id: The destination province ID.
        :param str dst_province_name: Specifies the destination province name.
        :param str dst_region_id: The destination region ID.
        :param str dst_region_name: Specifies the destination region name.
        :param str event_time: The event time.
        :param str level: Specifies the threat level.
        :param str log_id: The log ID.
        :param str packet: The attack log packet.
        :param int packet_length: The packet length.
        :param Sequence['GetAttackLogsRecordPacketMessageArgs'] packet_messages: The packet messages.
        :param str protocol: The protocol.
        :param str source: The source.
        :param str src_city_id: The source city ID.
        :param str src_city_name: Specifies the source city name.
        :param str src_ip: Specifies the source IP address.
        :param int src_port: Specifies the source port.
        :param str src_province_id: The source province ID.
        :param str src_province_name: Specifies the source province name.
        :param str src_region_id: The source region ID.
        :param str src_region_name: Specifies the source region name.
        """
        pulumi.set(__self__, "action", action)
        pulumi.set(__self__, "app", app)
        pulumi.set(__self__, "attack_rule", attack_rule)
        pulumi.set(__self__, "attack_rule_id", attack_rule_id)
        pulumi.set(__self__, "attack_type", attack_type)
        pulumi.set(__self__, "direction", direction)
        pulumi.set(__self__, "dst_city_id", dst_city_id)
        pulumi.set(__self__, "dst_city_name", dst_city_name)
        pulumi.set(__self__, "dst_ip", dst_ip)
        pulumi.set(__self__, "dst_port", dst_port)
        pulumi.set(__self__, "dst_province_id", dst_province_id)
        pulumi.set(__self__, "dst_province_name", dst_province_name)
        pulumi.set(__self__, "dst_region_id", dst_region_id)
        pulumi.set(__self__, "dst_region_name", dst_region_name)
        pulumi.set(__self__, "event_time", event_time)
        pulumi.set(__self__, "level", level)
        pulumi.set(__self__, "log_id", log_id)
        pulumi.set(__self__, "packet", packet)
        pulumi.set(__self__, "packet_length", packet_length)
        pulumi.set(__self__, "packet_messages", packet_messages)
        pulumi.set(__self__, "protocol", protocol)
        pulumi.set(__self__, "source", source)
        pulumi.set(__self__, "src_city_id", src_city_id)
        pulumi.set(__self__, "src_city_name", src_city_name)
        pulumi.set(__self__, "src_ip", src_ip)
        pulumi.set(__self__, "src_port", src_port)
        pulumi.set(__self__, "src_province_id", src_province_id)
        pulumi.set(__self__, "src_province_name", src_province_name)
        pulumi.set(__self__, "src_region_id", src_region_id)
        pulumi.set(__self__, "src_region_name", src_region_name)

    @property
    @pulumi.getter
    def action(self) -> str:
        """
        The action.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def app(self) -> str:
        """
        Specifies the application protocol.
        """
        return pulumi.get(self, "app")

    @property
    @pulumi.getter(name="attackRule")
    def attack_rule(self) -> str:
        """
        Specifies the intrusion event rule.
        """
        return pulumi.get(self, "attack_rule")

    @property
    @pulumi.getter(name="attackRuleId")
    def attack_rule_id(self) -> str:
        """
        Specifies the attack rule ID.
        """
        return pulumi.get(self, "attack_rule_id")

    @property
    @pulumi.getter(name="attackType")
    def attack_type(self) -> str:
        """
        Specifies the intrusion event type.
        """
        return pulumi.get(self, "attack_type")

    @property
    @pulumi.getter
    def direction(self) -> str:
        """
        The direction.
        """
        return pulumi.get(self, "direction")

    @property
    @pulumi.getter(name="dstCityId")
    def dst_city_id(self) -> str:
        """
        The destination city ID.
        """
        return pulumi.get(self, "dst_city_id")

    @property
    @pulumi.getter(name="dstCityName")
    def dst_city_name(self) -> str:
        """
        Specifies the destination city name.
        """
        return pulumi.get(self, "dst_city_name")

    @property
    @pulumi.getter(name="dstIp")
    def dst_ip(self) -> str:
        """
        Specifies the destination IP address.
        """
        return pulumi.get(self, "dst_ip")

    @property
    @pulumi.getter(name="dstPort")
    def dst_port(self) -> int:
        """
        Specifies the destination port.
        """
        return pulumi.get(self, "dst_port")

    @property
    @pulumi.getter(name="dstProvinceId")
    def dst_province_id(self) -> str:
        """
        The destination province ID.
        """
        return pulumi.get(self, "dst_province_id")

    @property
    @pulumi.getter(name="dstProvinceName")
    def dst_province_name(self) -> str:
        """
        Specifies the destination province name.
        """
        return pulumi.get(self, "dst_province_name")

    @property
    @pulumi.getter(name="dstRegionId")
    def dst_region_id(self) -> str:
        """
        The destination region ID.
        """
        return pulumi.get(self, "dst_region_id")

    @property
    @pulumi.getter(name="dstRegionName")
    def dst_region_name(self) -> str:
        """
        Specifies the destination region name.
        """
        return pulumi.get(self, "dst_region_name")

    @property
    @pulumi.getter(name="eventTime")
    def event_time(self) -> str:
        """
        The event time.
        """
        return pulumi.get(self, "event_time")

    @property
    @pulumi.getter
    def level(self) -> str:
        """
        Specifies the threat level.
        """
        return pulumi.get(self, "level")

    @property
    @pulumi.getter(name="logId")
    def log_id(self) -> str:
        """
        The log ID.
        """
        return pulumi.get(self, "log_id")

    @property
    @pulumi.getter
    def packet(self) -> str:
        """
        The attack log packet.
        """
        return pulumi.get(self, "packet")

    @property
    @pulumi.getter(name="packetLength")
    def packet_length(self) -> int:
        """
        The packet length.
        """
        return pulumi.get(self, "packet_length")

    @property
    @pulumi.getter(name="packetMessages")
    def packet_messages(self) -> Sequence['outputs.GetAttackLogsRecordPacketMessageResult']:
        """
        The packet messages.
        """
        return pulumi.get(self, "packet_messages")

    @property
    @pulumi.getter
    def protocol(self) -> str:
        """
        The protocol.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter
    def source(self) -> str:
        """
        The source.
        """
        return pulumi.get(self, "source")

    @property
    @pulumi.getter(name="srcCityId")
    def src_city_id(self) -> str:
        """
        The source city ID.
        """
        return pulumi.get(self, "src_city_id")

    @property
    @pulumi.getter(name="srcCityName")
    def src_city_name(self) -> str:
        """
        Specifies the source city name.
        """
        return pulumi.get(self, "src_city_name")

    @property
    @pulumi.getter(name="srcIp")
    def src_ip(self) -> str:
        """
        Specifies the source IP address.
        """
        return pulumi.get(self, "src_ip")

    @property
    @pulumi.getter(name="srcPort")
    def src_port(self) -> int:
        """
        Specifies the source port.
        """
        return pulumi.get(self, "src_port")

    @property
    @pulumi.getter(name="srcProvinceId")
    def src_province_id(self) -> str:
        """
        The source province ID.
        """
        return pulumi.get(self, "src_province_id")

    @property
    @pulumi.getter(name="srcProvinceName")
    def src_province_name(self) -> str:
        """
        Specifies the source province name.
        """
        return pulumi.get(self, "src_province_name")

    @property
    @pulumi.getter(name="srcRegionId")
    def src_region_id(self) -> str:
        """
        The source region ID.
        """
        return pulumi.get(self, "src_region_id")

    @property
    @pulumi.getter(name="srcRegionName")
    def src_region_name(self) -> str:
        """
        Specifies the source region name.
        """
        return pulumi.get(self, "src_region_name")


@pulumi.output_type
class GetAttackLogsRecordPacketMessageResult(dict):
    def __init__(__self__, *,
                 hex_index: str,
                 hexs: Sequence[str],
                 utf8_string: str):
        """
        :param str hex_index: The hexadecimal index.
        :param Sequence[str] hexs: The hexadecimal series.
        :param str utf8_string: The utf-8 string.
        """
        pulumi.set(__self__, "hex_index", hex_index)
        pulumi.set(__self__, "hexs", hexs)
        pulumi.set(__self__, "utf8_string", utf8_string)

    @property
    @pulumi.getter(name="hexIndex")
    def hex_index(self) -> str:
        """
        The hexadecimal index.
        """
        return pulumi.get(self, "hex_index")

    @property
    @pulumi.getter
    def hexs(self) -> Sequence[str]:
        """
        The hexadecimal series.
        """
        return pulumi.get(self, "hexs")

    @property
    @pulumi.getter(name="utf8String")
    def utf8_string(self) -> str:
        """
        The utf-8 string.
        """
        return pulumi.get(self, "utf8_string")


@pulumi.output_type
class GetBlackWhiteListsRecordResult(dict):
    def __init__(__self__, *,
                 address: str,
                 address_type: str,
                 description: str,
                 direction: str,
                 list_id: str,
                 port: str,
                 protocol: int):
        """
        :param str address: Specifies the IP address.
        :param str address_type: Specifies the IP address type.
               The valid value can be **0** (IPv4).
        :param str description: Specifies the description.
        :param str direction: Specifies the direction of a black or white address.
               The options are as follows:
               + **0**: source address;
               + **1**: destination address;
        :param str list_id: Specifies the blacklist/whitelist ID.
        :param str port: Specifies the port.
        :param int protocol: Specifies The protocol type.
               The options are as follows:
               + **6**: TCP;
               + **17**: UDP;
               + **1**: ICMP;
               + **-1**: any protocol;
        """
        pulumi.set(__self__, "address", address)
        pulumi.set(__self__, "address_type", address_type)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "direction", direction)
        pulumi.set(__self__, "list_id", list_id)
        pulumi.set(__self__, "port", port)
        pulumi.set(__self__, "protocol", protocol)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        Specifies the IP address.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="addressType")
    def address_type(self) -> str:
        """
        Specifies the IP address type.
        The valid value can be **0** (IPv4).
        """
        return pulumi.get(self, "address_type")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Specifies the description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def direction(self) -> str:
        """
        Specifies the direction of a black or white address.
        The options are as follows:
        + **0**: source address;
        + **1**: destination address;
        """
        return pulumi.get(self, "direction")

    @property
    @pulumi.getter(name="listId")
    def list_id(self) -> str:
        """
        Specifies the blacklist/whitelist ID.
        """
        return pulumi.get(self, "list_id")

    @property
    @pulumi.getter
    def port(self) -> str:
        """
        Specifies the port.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter
    def protocol(self) -> int:
        """
        Specifies The protocol type.
        The options are as follows:
        + **6**: TCP;
        + **17**: UDP;
        + **1**: ICMP;
        + **-1**: any protocol;
        """
        return pulumi.get(self, "protocol")


@pulumi.output_type
class GetCaptureTaskResultsFileListResult(dict):
    def __init__(__self__, *,
                 file_name: str,
                 file_path: str,
                 url: str):
        """
        :param str file_name: The file name.
        :param str file_path: The file path.
        :param str url: The download link.
        """
        pulumi.set(__self__, "file_name", file_name)
        pulumi.set(__self__, "file_path", file_path)
        pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter(name="fileName")
    def file_name(self) -> str:
        """
        The file name.
        """
        return pulumi.get(self, "file_name")

    @property
    @pulumi.getter(name="filePath")
    def file_path(self) -> str:
        """
        The file path.
        """
        return pulumi.get(self, "file_path")

    @property
    @pulumi.getter
    def url(self) -> str:
        """
        The download link.
        """
        return pulumi.get(self, "url")


@pulumi.output_type
class GetCaptureTaskResultsRequestHeaderResult(dict):
    def __init__(__self__, *,
                 host: str):
        """
        :param str host: The host header information.
        """
        pulumi.set(__self__, "host", host)

    @property
    @pulumi.getter
    def host(self) -> str:
        """
        The host header information.
        """
        return pulumi.get(self, "host")


@pulumi.output_type
class GetCaptureTasksRecordResult(dict):
    def __init__(__self__, *,
                 capture_size: str,
                 created_at: str,
                 dest_address: str,
                 dest_address_type: int,
                 dest_port: str,
                 duration: int,
                 is_deleted: int,
                 max_packets: int,
                 name: str,
                 protocol: int,
                 remaining_days: int,
                 source_address: str,
                 source_address_type: int,
                 source_port: str,
                 status: int,
                 task_id: str,
                 updated_at: str):
        """
        :param str capture_size: The capture task size.
        :param str created_at: The creation time of the capture task.
        :param str dest_address: The destination address.
        :param int dest_address_type: The destination address type.
        :param str dest_port: The destination port.
        :param int duration: The capture task duration.
        :param int is_deleted: Whether is deleted.
        :param int max_packets: The max packets.
        :param str name: The capture task name.
        :param int protocol: The protocol type.
        :param int remaining_days: The remaining days.
        :param str source_address: The source address.
        :param int source_address_type: The source address type.
        :param str source_port: The source port.
        :param int status: The capture task status.
        :param str task_id: The capture task ID.
        :param str updated_at: The update time of the capture task.
        """
        pulumi.set(__self__, "capture_size", capture_size)
        pulumi.set(__self__, "created_at", created_at)
        pulumi.set(__self__, "dest_address", dest_address)
        pulumi.set(__self__, "dest_address_type", dest_address_type)
        pulumi.set(__self__, "dest_port", dest_port)
        pulumi.set(__self__, "duration", duration)
        pulumi.set(__self__, "is_deleted", is_deleted)
        pulumi.set(__self__, "max_packets", max_packets)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "protocol", protocol)
        pulumi.set(__self__, "remaining_days", remaining_days)
        pulumi.set(__self__, "source_address", source_address)
        pulumi.set(__self__, "source_address_type", source_address_type)
        pulumi.set(__self__, "source_port", source_port)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "task_id", task_id)
        pulumi.set(__self__, "updated_at", updated_at)

    @property
    @pulumi.getter(name="captureSize")
    def capture_size(self) -> str:
        """
        The capture task size.
        """
        return pulumi.get(self, "capture_size")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> str:
        """
        The creation time of the capture task.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="destAddress")
    def dest_address(self) -> str:
        """
        The destination address.
        """
        return pulumi.get(self, "dest_address")

    @property
    @pulumi.getter(name="destAddressType")
    def dest_address_type(self) -> int:
        """
        The destination address type.
        """
        return pulumi.get(self, "dest_address_type")

    @property
    @pulumi.getter(name="destPort")
    def dest_port(self) -> str:
        """
        The destination port.
        """
        return pulumi.get(self, "dest_port")

    @property
    @pulumi.getter
    def duration(self) -> int:
        """
        The capture task duration.
        """
        return pulumi.get(self, "duration")

    @property
    @pulumi.getter(name="isDeleted")
    def is_deleted(self) -> int:
        """
        Whether is deleted.
        """
        return pulumi.get(self, "is_deleted")

    @property
    @pulumi.getter(name="maxPackets")
    def max_packets(self) -> int:
        """
        The max packets.
        """
        return pulumi.get(self, "max_packets")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The capture task name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def protocol(self) -> int:
        """
        The protocol type.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter(name="remainingDays")
    def remaining_days(self) -> int:
        """
        The remaining days.
        """
        return pulumi.get(self, "remaining_days")

    @property
    @pulumi.getter(name="sourceAddress")
    def source_address(self) -> str:
        """
        The source address.
        """
        return pulumi.get(self, "source_address")

    @property
    @pulumi.getter(name="sourceAddressType")
    def source_address_type(self) -> int:
        """
        The source address type.
        """
        return pulumi.get(self, "source_address_type")

    @property
    @pulumi.getter(name="sourcePort")
    def source_port(self) -> str:
        """
        The source port.
        """
        return pulumi.get(self, "source_port")

    @property
    @pulumi.getter
    def status(self) -> int:
        """
        The capture task status.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="taskId")
    def task_id(self) -> str:
        """
        The capture task ID.
        """
        return pulumi.get(self, "task_id")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> str:
        """
        The update time of the capture task.
        """
        return pulumi.get(self, "updated_at")


@pulumi.output_type
class GetDomainNameGroupsRecordResult(dict):
    def __init__(__self__, *,
                 config_status: str,
                 description: str,
                 domain_names: Sequence['outputs.GetDomainNameGroupsRecordDomainNameResult'],
                 group_id: str,
                 message: str,
                 name: str,
                 ref_count: str,
                 rules: Sequence['outputs.GetDomainNameGroupsRecordRuleResult'],
                 type: str):
        """
        :param str config_status: Specifies the configuration status.
               The valid values are as follows:
               + **-1**: not configured.
               + **0**: configuration failed.
               + **1**: configuration succeeded.
               + **2**: configuration in progress.
               + **3**: normal.
               + **4**: configuration exception - domain group usage.
        :param str description: The description.
        :param Sequence['GetDomainNameGroupsRecordDomainNameArgs'] domain_names: The list of domain names.
        :param str group_id: Specifies the domain name group ID.
        :param str message: The configuration message.
        :param str name: Specifies the name of a domain name group.
        :param str ref_count: Specifies the domain name group reference count.
        :param Sequence['GetDomainNameGroupsRecordRuleArgs'] rules: The used rule list.
        :param str type: Specifies the domain name group type.
               The value can be:
               + **0**: means application type;
               + **1**: means network type.
        """
        pulumi.set(__self__, "config_status", config_status)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "domain_names", domain_names)
        pulumi.set(__self__, "group_id", group_id)
        pulumi.set(__self__, "message", message)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "ref_count", ref_count)
        pulumi.set(__self__, "rules", rules)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="configStatus")
    def config_status(self) -> str:
        """
        Specifies the configuration status.
        The valid values are as follows:
        + **-1**: not configured.
        + **0**: configuration failed.
        + **1**: configuration succeeded.
        + **2**: configuration in progress.
        + **3**: normal.
        + **4**: configuration exception - domain group usage.
        """
        return pulumi.get(self, "config_status")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="domainNames")
    def domain_names(self) -> Sequence['outputs.GetDomainNameGroupsRecordDomainNameResult']:
        """
        The list of domain names.
        """
        return pulumi.get(self, "domain_names")

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> str:
        """
        Specifies the domain name group ID.
        """
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter
    def message(self) -> str:
        """
        The configuration message.
        """
        return pulumi.get(self, "message")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Specifies the name of a domain name group.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="refCount")
    def ref_count(self) -> str:
        """
        Specifies the domain name group reference count.
        """
        return pulumi.get(self, "ref_count")

    @property
    @pulumi.getter
    def rules(self) -> Sequence['outputs.GetDomainNameGroupsRecordRuleResult']:
        """
        The used rule list.
        """
        return pulumi.get(self, "rules")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Specifies the domain name group type.
        The value can be:
        + **0**: means application type;
        + **1**: means network type.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetDomainNameGroupsRecordDomainNameResult(dict):
    def __init__(__self__, *,
                 description: str,
                 domain_address_id: str,
                 domain_name: str):
        """
        :param str description: The description.
        :param str domain_address_id: The domain address ID.
        :param str domain_name: The domain name.
        """
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "domain_address_id", domain_address_id)
        pulumi.set(__self__, "domain_name", domain_name)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="domainAddressId")
    def domain_address_id(self) -> str:
        """
        The domain address ID.
        """
        return pulumi.get(self, "domain_address_id")

    @property
    @pulumi.getter(name="domainName")
    def domain_name(self) -> str:
        """
        The domain name.
        """
        return pulumi.get(self, "domain_name")


@pulumi.output_type
class GetDomainNameGroupsRecordRuleResult(dict):
    def __init__(__self__, *,
                 id: str,
                 name: str):
        """
        :param str id: The rule ID.
        :param str name: Specifies the name of a domain name group.
        """
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The rule ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Specifies the name of a domain name group.
        """
        return pulumi.get(self, "name")


@pulumi.output_type
class GetFirewallsRecordResult(dict):
    def __init__(__self__, *,
                 charge_mode: int,
                 engine_type: int,
                 feature_toggle: Mapping[str, bool],
                 flavors: Sequence['outputs.GetFirewallsRecordFlavorResult'],
                 fw_instance_id: str,
                 ha_type: int,
                 is_old_firewall_instance: bool,
                 name: str,
                 protect_objects: Sequence['outputs.GetFirewallsRecordProtectObjectResult'],
                 resources: Sequence['outputs.GetFirewallsRecordResourceResult'],
                 service_type: int,
                 status: int,
                 support_ipv6: bool):
        """
        :param int charge_mode: The billing mode. The value can be 0 (yearly/monthly) or 1 (pay-per-use).
        :param int engine_type: The engine type.
        :param Mapping[str, bool] feature_toggle: The map of feature toggle.
        :param Sequence['GetFirewallsRecordFlavorArgs'] flavors: The flavor of the firewall.
               The Flavor structure is documented below.
        :param str fw_instance_id: Specifies the firewall instance ID.
               If not specified, the first instance will be returned.
        :param int ha_type: The cluster type.
        :param bool is_old_firewall_instance: Whether the engine is an old engine.
        :param str name: The firewall name.
        :param Sequence['GetFirewallsRecordProtectObjectArgs'] protect_objects: The project list.
               The Protect Object structure is documented below.
        :param Sequence['GetFirewallsRecordResourceArgs'] resources: The firewall instance resources.
               The Firewall Instance Resource structure is
               documented below.
        :param int service_type: Specifies the service type. The value can be:
               + **0**: North-south firewall;
               + **1**: East-west firewall;
        :param int status: The firewall status. The options are as follows:
               + **-1**: waiting for payment;
               + **0**: creating;
               + **1**: deleting;
               + **2**: running;
               + **3**: upgrading;
               + **4**: deletion completed;
               + **5**: freezing;
               + **6**: creation failed;
               + **7**: deletion failed;
               + **8**: freezing failed;
               + **9**: storage in progress;
               + **10**: storage failed;
               + **11**: upgrade failed;
        :param bool support_ipv6: Whether IPv6 is supported.
        """
        pulumi.set(__self__, "charge_mode", charge_mode)
        pulumi.set(__self__, "engine_type", engine_type)
        pulumi.set(__self__, "feature_toggle", feature_toggle)
        pulumi.set(__self__, "flavors", flavors)
        pulumi.set(__self__, "fw_instance_id", fw_instance_id)
        pulumi.set(__self__, "ha_type", ha_type)
        pulumi.set(__self__, "is_old_firewall_instance", is_old_firewall_instance)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "protect_objects", protect_objects)
        pulumi.set(__self__, "resources", resources)
        pulumi.set(__self__, "service_type", service_type)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "support_ipv6", support_ipv6)

    @property
    @pulumi.getter(name="chargeMode")
    def charge_mode(self) -> int:
        """
        The billing mode. The value can be 0 (yearly/monthly) or 1 (pay-per-use).
        """
        return pulumi.get(self, "charge_mode")

    @property
    @pulumi.getter(name="engineType")
    def engine_type(self) -> int:
        """
        The engine type.
        """
        return pulumi.get(self, "engine_type")

    @property
    @pulumi.getter(name="featureToggle")
    def feature_toggle(self) -> Mapping[str, bool]:
        """
        The map of feature toggle.
        """
        return pulumi.get(self, "feature_toggle")

    @property
    @pulumi.getter
    def flavors(self) -> Sequence['outputs.GetFirewallsRecordFlavorResult']:
        """
        The flavor of the firewall.
        The Flavor structure is documented below.
        """
        return pulumi.get(self, "flavors")

    @property
    @pulumi.getter(name="fwInstanceId")
    def fw_instance_id(self) -> str:
        """
        Specifies the firewall instance ID.
        If not specified, the first instance will be returned.
        """
        return pulumi.get(self, "fw_instance_id")

    @property
    @pulumi.getter(name="haType")
    def ha_type(self) -> int:
        """
        The cluster type.
        """
        return pulumi.get(self, "ha_type")

    @property
    @pulumi.getter(name="isOldFirewallInstance")
    def is_old_firewall_instance(self) -> bool:
        """
        Whether the engine is an old engine.
        """
        return pulumi.get(self, "is_old_firewall_instance")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The firewall name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="protectObjects")
    def protect_objects(self) -> Sequence['outputs.GetFirewallsRecordProtectObjectResult']:
        """
        The project list.
        The Protect Object structure is documented below.
        """
        return pulumi.get(self, "protect_objects")

    @property
    @pulumi.getter
    def resources(self) -> Sequence['outputs.GetFirewallsRecordResourceResult']:
        """
        The firewall instance resources.
        The Firewall Instance Resource structure is
        documented below.
        """
        return pulumi.get(self, "resources")

    @property
    @pulumi.getter(name="serviceType")
    def service_type(self) -> int:
        """
        Specifies the service type. The value can be:
        + **0**: North-south firewall;
        + **1**: East-west firewall;
        """
        return pulumi.get(self, "service_type")

    @property
    @pulumi.getter
    def status(self) -> int:
        """
        The firewall status. The options are as follows:
        + **-1**: waiting for payment;
        + **0**: creating;
        + **1**: deleting;
        + **2**: running;
        + **3**: upgrading;
        + **4**: deletion completed;
        + **5**: freezing;
        + **6**: creation failed;
        + **7**: deletion failed;
        + **8**: freezing failed;
        + **9**: storage in progress;
        + **10**: storage failed;
        + **11**: upgrade failed;
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="supportIpv6")
    def support_ipv6(self) -> bool:
        """
        Whether IPv6 is supported.
        """
        return pulumi.get(self, "support_ipv6")


@pulumi.output_type
class GetFirewallsRecordFlavorResult(dict):
    def __init__(__self__, *,
                 bandwidth: int,
                 eip_count: int,
                 log_storage: int,
                 version: int,
                 vpc_count: int):
        """
        :param int bandwidth: The bandwidth.
        :param int eip_count: The number of EIPs.
        :param int log_storage: The log storage.
        :param int version: The firewall version. The value can be 0 (standard edition), 1 (professional edition),
               2 (platinum edition), or 3 (basic edition).
        :param int vpc_count: The number of VPCs.
        """
        pulumi.set(__self__, "bandwidth", bandwidth)
        pulumi.set(__self__, "eip_count", eip_count)
        pulumi.set(__self__, "log_storage", log_storage)
        pulumi.set(__self__, "version", version)
        pulumi.set(__self__, "vpc_count", vpc_count)

    @property
    @pulumi.getter
    def bandwidth(self) -> int:
        """
        The bandwidth.
        """
        return pulumi.get(self, "bandwidth")

    @property
    @pulumi.getter(name="eipCount")
    def eip_count(self) -> int:
        """
        The number of EIPs.
        """
        return pulumi.get(self, "eip_count")

    @property
    @pulumi.getter(name="logStorage")
    def log_storage(self) -> int:
        """
        The log storage.
        """
        return pulumi.get(self, "log_storage")

    @property
    @pulumi.getter
    def version(self) -> int:
        """
        The firewall version. The value can be 0 (standard edition), 1 (professional edition),
        2 (platinum edition), or 3 (basic edition).
        """
        return pulumi.get(self, "version")

    @property
    @pulumi.getter(name="vpcCount")
    def vpc_count(self) -> int:
        """
        The number of VPCs.
        """
        return pulumi.get(self, "vpc_count")


@pulumi.output_type
class GetFirewallsRecordProtectObjectResult(dict):
    def __init__(__self__, *,
                 object_id: str,
                 object_name: str,
                 type: int):
        """
        :param str object_id: The protected object ID.
        :param str object_name: The protected object name.
        :param int type: The project type. The options are as follows:
               + **0**: north-south;
               + **1**: east-west;
        """
        pulumi.set(__self__, "object_id", object_id)
        pulumi.set(__self__, "object_name", object_name)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="objectId")
    def object_id(self) -> str:
        """
        The protected object ID.
        """
        return pulumi.get(self, "object_id")

    @property
    @pulumi.getter(name="objectName")
    def object_name(self) -> str:
        """
        The protected object name.
        """
        return pulumi.get(self, "object_name")

    @property
    @pulumi.getter
    def type(self) -> int:
        """
        The project type. The options are as follows:
        + **0**: north-south;
        + **1**: east-west;
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetFirewallsRecordResourceResult(dict):
    def __init__(__self__, *,
                 cloud_service_type: str,
                 resource_id: str,
                 resource_size: int,
                 resource_size_measure_id: int,
                 resource_spec_code: str,
                 resource_type: str):
        """
        :param str cloud_service_type: Service type, which is used by CBC. The value is **hws.service.type.cfw**.
        :param str resource_id: Resource ID.
        :param int resource_size: Resource quantity.
        :param int resource_size_measure_id: Resource unit name.
        :param str resource_spec_code: Inventory unit code.
        :param str resource_type: Resource type. The options are as follows:
               + **CFW**: hws.resource.type.cfw;
               + **EIP**: hws.resource.type.cfw.exp.eip;
               + **Bandwidth**: hws.resource.type.cfw.exp.bandwidth;
               + **VPC**: hws.resource.type.cfw.exp.vpc;
               + **Log storage**: hws.resource.type.cfw.exp.logaudit;
        """
        pulumi.set(__self__, "cloud_service_type", cloud_service_type)
        pulumi.set(__self__, "resource_id", resource_id)
        pulumi.set(__self__, "resource_size", resource_size)
        pulumi.set(__self__, "resource_size_measure_id", resource_size_measure_id)
        pulumi.set(__self__, "resource_spec_code", resource_spec_code)
        pulumi.set(__self__, "resource_type", resource_type)

    @property
    @pulumi.getter(name="cloudServiceType")
    def cloud_service_type(self) -> str:
        """
        Service type, which is used by CBC. The value is **hws.service.type.cfw**.
        """
        return pulumi.get(self, "cloud_service_type")

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> str:
        """
        Resource ID.
        """
        return pulumi.get(self, "resource_id")

    @property
    @pulumi.getter(name="resourceSize")
    def resource_size(self) -> int:
        """
        Resource quantity.
        """
        return pulumi.get(self, "resource_size")

    @property
    @pulumi.getter(name="resourceSizeMeasureId")
    def resource_size_measure_id(self) -> int:
        """
        Resource unit name.
        """
        return pulumi.get(self, "resource_size_measure_id")

    @property
    @pulumi.getter(name="resourceSpecCode")
    def resource_spec_code(self) -> str:
        """
        Inventory unit code.
        """
        return pulumi.get(self, "resource_spec_code")

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> str:
        """
        Resource type. The options are as follows:
        + **CFW**: hws.resource.type.cfw;
        + **EIP**: hws.resource.type.cfw.exp.eip;
        + **Bandwidth**: hws.resource.type.cfw.exp.bandwidth;
        + **VPC**: hws.resource.type.cfw.exp.vpc;
        + **Log storage**: hws.resource.type.cfw.exp.logaudit;
        """
        return pulumi.get(self, "resource_type")


@pulumi.output_type
class GetFlowLogsRecordResult(dict):
    def __init__(__self__, *,
                 app: str,
                 bytes: float,
                 direction: str,
                 dst_city_id: str,
                 dst_city_name: str,
                 dst_host: str,
                 dst_ip: str,
                 dst_port: int,
                 dst_province_id: str,
                 dst_province_name: str,
                 dst_region_id: str,
                 dst_region_name: str,
                 end_time: str,
                 log_id: str,
                 packets: int,
                 protocol: str,
                 src_city_id: str,
                 src_city_name: str,
                 src_ip: str,
                 src_port: int,
                 src_province_id: str,
                 src_province_name: str,
                 src_region_id: str,
                 src_region_name: str,
                 start_time: str):
        """
        :param str app: Specifies the application protocol.
        :param float bytes: The flow log bytes.
        :param str direction: Specifies the direction. The values can be **out2in** and **in2out**.
        :param str dst_city_id: The destination city ID.
        :param str dst_city_name: Specifies the destination city name.
        :param str dst_host: The destination host.
        :param str dst_ip: Specifies the destination IP address.
        :param int dst_port: Specifies the destination port.
        :param str dst_province_id: The destination province ID.
        :param str dst_province_name: Specifies the destination province name.
        :param str dst_region_id: The destination region ID.
        :param str dst_region_name: Specifies the destination region name.
        :param str end_time: Specifies the end time. The time is in UTC.
               The format is **yyyy-MM-dd HH:mm:ss**.
        :param str log_id: The document ID.
        :param int packets: The number of packets.
        :param str protocol: The protocol type.
        :param str src_city_id: The source city ID.
        :param str src_city_name: Specifies the source city name.
        :param str src_ip: Specifies the source IP address.
        :param int src_port: Specifies the source port.
        :param str src_province_id: The source province ID.
        :param str src_province_name: Specifies the source province name.
        :param str src_region_id: The source region ID.
        :param str src_region_name: Specifies the source region name.
        :param str start_time: Specifies the start time. The time is in UTC.
               The format is **yyyy-MM-dd HH:mm:ss**.
        """
        pulumi.set(__self__, "app", app)
        pulumi.set(__self__, "bytes", bytes)
        pulumi.set(__self__, "direction", direction)
        pulumi.set(__self__, "dst_city_id", dst_city_id)
        pulumi.set(__self__, "dst_city_name", dst_city_name)
        pulumi.set(__self__, "dst_host", dst_host)
        pulumi.set(__self__, "dst_ip", dst_ip)
        pulumi.set(__self__, "dst_port", dst_port)
        pulumi.set(__self__, "dst_province_id", dst_province_id)
        pulumi.set(__self__, "dst_province_name", dst_province_name)
        pulumi.set(__self__, "dst_region_id", dst_region_id)
        pulumi.set(__self__, "dst_region_name", dst_region_name)
        pulumi.set(__self__, "end_time", end_time)
        pulumi.set(__self__, "log_id", log_id)
        pulumi.set(__self__, "packets", packets)
        pulumi.set(__self__, "protocol", protocol)
        pulumi.set(__self__, "src_city_id", src_city_id)
        pulumi.set(__self__, "src_city_name", src_city_name)
        pulumi.set(__self__, "src_ip", src_ip)
        pulumi.set(__self__, "src_port", src_port)
        pulumi.set(__self__, "src_province_id", src_province_id)
        pulumi.set(__self__, "src_province_name", src_province_name)
        pulumi.set(__self__, "src_region_id", src_region_id)
        pulumi.set(__self__, "src_region_name", src_region_name)
        pulumi.set(__self__, "start_time", start_time)

    @property
    @pulumi.getter
    def app(self) -> str:
        """
        Specifies the application protocol.
        """
        return pulumi.get(self, "app")

    @property
    @pulumi.getter
    def bytes(self) -> float:
        """
        The flow log bytes.
        """
        return pulumi.get(self, "bytes")

    @property
    @pulumi.getter
    def direction(self) -> str:
        """
        Specifies the direction. The values can be **out2in** and **in2out**.
        """
        return pulumi.get(self, "direction")

    @property
    @pulumi.getter(name="dstCityId")
    def dst_city_id(self) -> str:
        """
        The destination city ID.
        """
        return pulumi.get(self, "dst_city_id")

    @property
    @pulumi.getter(name="dstCityName")
    def dst_city_name(self) -> str:
        """
        Specifies the destination city name.
        """
        return pulumi.get(self, "dst_city_name")

    @property
    @pulumi.getter(name="dstHost")
    def dst_host(self) -> str:
        """
        The destination host.
        """
        return pulumi.get(self, "dst_host")

    @property
    @pulumi.getter(name="dstIp")
    def dst_ip(self) -> str:
        """
        Specifies the destination IP address.
        """
        return pulumi.get(self, "dst_ip")

    @property
    @pulumi.getter(name="dstPort")
    def dst_port(self) -> int:
        """
        Specifies the destination port.
        """
        return pulumi.get(self, "dst_port")

    @property
    @pulumi.getter(name="dstProvinceId")
    def dst_province_id(self) -> str:
        """
        The destination province ID.
        """
        return pulumi.get(self, "dst_province_id")

    @property
    @pulumi.getter(name="dstProvinceName")
    def dst_province_name(self) -> str:
        """
        Specifies the destination province name.
        """
        return pulumi.get(self, "dst_province_name")

    @property
    @pulumi.getter(name="dstRegionId")
    def dst_region_id(self) -> str:
        """
        The destination region ID.
        """
        return pulumi.get(self, "dst_region_id")

    @property
    @pulumi.getter(name="dstRegionName")
    def dst_region_name(self) -> str:
        """
        Specifies the destination region name.
        """
        return pulumi.get(self, "dst_region_name")

    @property
    @pulumi.getter(name="endTime")
    def end_time(self) -> str:
        """
        Specifies the end time. The time is in UTC.
        The format is **yyyy-MM-dd HH:mm:ss**.
        """
        return pulumi.get(self, "end_time")

    @property
    @pulumi.getter(name="logId")
    def log_id(self) -> str:
        """
        The document ID.
        """
        return pulumi.get(self, "log_id")

    @property
    @pulumi.getter
    def packets(self) -> int:
        """
        The number of packets.
        """
        return pulumi.get(self, "packets")

    @property
    @pulumi.getter
    def protocol(self) -> str:
        """
        The protocol type.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter(name="srcCityId")
    def src_city_id(self) -> str:
        """
        The source city ID.
        """
        return pulumi.get(self, "src_city_id")

    @property
    @pulumi.getter(name="srcCityName")
    def src_city_name(self) -> str:
        """
        Specifies the source city name.
        """
        return pulumi.get(self, "src_city_name")

    @property
    @pulumi.getter(name="srcIp")
    def src_ip(self) -> str:
        """
        Specifies the source IP address.
        """
        return pulumi.get(self, "src_ip")

    @property
    @pulumi.getter(name="srcPort")
    def src_port(self) -> int:
        """
        Specifies the source port.
        """
        return pulumi.get(self, "src_port")

    @property
    @pulumi.getter(name="srcProvinceId")
    def src_province_id(self) -> str:
        """
        The source province ID.
        """
        return pulumi.get(self, "src_province_id")

    @property
    @pulumi.getter(name="srcProvinceName")
    def src_province_name(self) -> str:
        """
        Specifies the source province name.
        """
        return pulumi.get(self, "src_province_name")

    @property
    @pulumi.getter(name="srcRegionId")
    def src_region_id(self) -> str:
        """
        The source region ID.
        """
        return pulumi.get(self, "src_region_id")

    @property
    @pulumi.getter(name="srcRegionName")
    def src_region_name(self) -> str:
        """
        Specifies the source region name.
        """
        return pulumi.get(self, "src_region_name")

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> str:
        """
        Specifies the start time. The time is in UTC.
        The format is **yyyy-MM-dd HH:mm:ss**.
        """
        return pulumi.get(self, "start_time")


@pulumi.output_type
class GetIpsCustomRulesRecordResult(dict):
    def __init__(__self__, *,
                 action: int,
                 affected_os: int,
                 attack_type: int,
                 config_status: int,
                 content: str,
                 dst_port_type: int,
                 dst_ports: str,
                 group_id: str,
                 ips_cfw_id: str,
                 ips_id: str,
                 ips_name: str,
                 protocol: int,
                 severity: int,
                 software: int,
                 src_port_type: int,
                 src_ports: str):
        """
        :param int action: The action.
        :param int affected_os: Specifies the affected OS.
               The valid values are as follows:
               + **1**: Windows;
               + **2**: Linux;
               + **3**: FreeBSD;
               + **4**: Solaris;
               + **5**: Other Unix;
               + **6**: Network device;
               + **7**: MAC OS;
               + **8**: IOS;
               + **9**: Android;
               + **10**: Other;
        :param int attack_type: Specifies the attack type.
               The valid values are as follows:
               + **1**: access control;
               + **2**: vulnerability scan;
               + **3**: email phishing;
               + **4**: vulnerability exploits;
               + **5**: web attack;
               + **6**: password cracking;
               + **7**: hijacking attack;
               + **8**: protocol exception;
               + **9**: trojan;
               + **10**: worm;
               + **11**: buffer overflow;
               + **12**: hacker tool;
               + **13**: spyware;
               + **14**: DDoS flood;
               + **15**: application-layer DDoS attack;
               + **16**: other suspicious behavior;
               + **17**: suspicious DNS activity;
               + **18**: phishing;
               + **19**: spam;
        :param int config_status: The rule status.
        :param str content: The content storage in JSON format.
        :param int dst_port_type: The destination port type.
        :param str dst_ports: The destination port.
        :param str group_id: The firewall cluster ID.
        :param str ips_cfw_id: The ID of a custom IPS rule in CFW.
        :param str ips_id: The ID of a rule in Hillstone.
        :param str ips_name: Specifies the IPS custom rule name.
        :param int protocol: Specifies the protocol.
               The valid values are as follows:
               + **1**: FTP;
               + **2**: TELNET;
               + **3**: SMTP;
               + **4**: DNS-TCP;
               + **5**: DNS-UDP;
               + **6**: DHCP;
               + **7**: TFTP;
               + **8**: FINGER;
               + **9**: HTTP;
               + **10**: POP3;
               + **11**: SUNRPC-TCP;
               + **12**: SUNRPC-UDP;
               + **13**: NNTP;
               + **14**: MSRPC-TCP;
               + **15**: MSRPC-UDP;
               + **16**: NETBIOS-NAME_TCP;
               + **17**: NETBIOS-NAME_UDP;
               + **18**: NETBIOS-SMB;
               + **19**: NETBIOS-DATAGRAM;
               + **20**: IMAP4;
               + **21**: SNMP;
               + **22**: LDAP;
               + **23**: MSSQL;
               + **24**: ORACLE;
               + **25**: MYSQL;
               + **26**: VOIP-SIP-TCP;
               + **27**: VOIP-SIP-UDP;
               + **28**: VOIP-H245;
               + **29**: VOIP-Q931;
               + **30**: OTHER-TCP;
               + **31**: OTHER-UDP;
        :param int severity: Specifies the severity.
               The valid values are as follows:
               + **0**: critical;
               + **1**: high;
               + **2**: medium;
               + **3**: low;
        :param int software: Specifies the affected software.
               The valid values are as follows:
               + **1**: ADOBE;
               + **2**: APACHE;
               + **3**: APPLE;
               + **4**: CA;
               + **5**: CISCO;
               + **6**: GOOGLE CHROME;
               + **7**: HP;
               + **8**: IBM;
               + **9**: IE;
               + **10**: IIS;
               + **11**: MCAFEE;
               + **12**: MEDIAPLAYER;
               + **13**: MICROSOFT.NET;
               + **14**: MICROSOFT EDGE;
               + **15**: MICROSOFT EXCHANGE;
               + **16**: MICROSOFT OFFICE;
               + **17**: MICROSOFT OUTLOOK;
               + **18**: MICROSOFT SHAREPOINT;
               + **19**: MICROSOFT WINDOWS;
               + **20**: MOZILLA;
               + **21**: MSSQL;
               + **22**: MYSQL;
               + **23**: NOVELL;
               + **24**: ORACLE;
               + **25**: SAMBA;
               + **26**: SAMSUNG;
               + **27**: SAP;
               + **28**: SCADA;
               + **29**: SQUID;
               + **30**: SUN;
               + **31**: SYMANTEC;
               + **32**: TREND MICRO;
               + **33**: VMWARE;
               + **34**: WORDPRESS;
               + **35**: OTHER;
        :param int src_port_type: The source port type.
        :param str src_ports: The source port.
        """
        pulumi.set(__self__, "action", action)
        pulumi.set(__self__, "affected_os", affected_os)
        pulumi.set(__self__, "attack_type", attack_type)
        pulumi.set(__self__, "config_status", config_status)
        pulumi.set(__self__, "content", content)
        pulumi.set(__self__, "dst_port_type", dst_port_type)
        pulumi.set(__self__, "dst_ports", dst_ports)
        pulumi.set(__self__, "group_id", group_id)
        pulumi.set(__self__, "ips_cfw_id", ips_cfw_id)
        pulumi.set(__self__, "ips_id", ips_id)
        pulumi.set(__self__, "ips_name", ips_name)
        pulumi.set(__self__, "protocol", protocol)
        pulumi.set(__self__, "severity", severity)
        pulumi.set(__self__, "software", software)
        pulumi.set(__self__, "src_port_type", src_port_type)
        pulumi.set(__self__, "src_ports", src_ports)

    @property
    @pulumi.getter
    def action(self) -> int:
        """
        The action.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter(name="affectedOs")
    def affected_os(self) -> int:
        """
        Specifies the affected OS.
        The valid values are as follows:
        + **1**: Windows;
        + **2**: Linux;
        + **3**: FreeBSD;
        + **4**: Solaris;
        + **5**: Other Unix;
        + **6**: Network device;
        + **7**: MAC OS;
        + **8**: IOS;
        + **9**: Android;
        + **10**: Other;
        """
        return pulumi.get(self, "affected_os")

    @property
    @pulumi.getter(name="attackType")
    def attack_type(self) -> int:
        """
        Specifies the attack type.
        The valid values are as follows:
        + **1**: access control;
        + **2**: vulnerability scan;
        + **3**: email phishing;
        + **4**: vulnerability exploits;
        + **5**: web attack;
        + **6**: password cracking;
        + **7**: hijacking attack;
        + **8**: protocol exception;
        + **9**: trojan;
        + **10**: worm;
        + **11**: buffer overflow;
        + **12**: hacker tool;
        + **13**: spyware;
        + **14**: DDoS flood;
        + **15**: application-layer DDoS attack;
        + **16**: other suspicious behavior;
        + **17**: suspicious DNS activity;
        + **18**: phishing;
        + **19**: spam;
        """
        return pulumi.get(self, "attack_type")

    @property
    @pulumi.getter(name="configStatus")
    def config_status(self) -> int:
        """
        The rule status.
        """
        return pulumi.get(self, "config_status")

    @property
    @pulumi.getter
    def content(self) -> str:
        """
        The content storage in JSON format.
        """
        return pulumi.get(self, "content")

    @property
    @pulumi.getter(name="dstPortType")
    def dst_port_type(self) -> int:
        """
        The destination port type.
        """
        return pulumi.get(self, "dst_port_type")

    @property
    @pulumi.getter(name="dstPorts")
    def dst_ports(self) -> str:
        """
        The destination port.
        """
        return pulumi.get(self, "dst_ports")

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> str:
        """
        The firewall cluster ID.
        """
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter(name="ipsCfwId")
    def ips_cfw_id(self) -> str:
        """
        The ID of a custom IPS rule in CFW.
        """
        return pulumi.get(self, "ips_cfw_id")

    @property
    @pulumi.getter(name="ipsId")
    def ips_id(self) -> str:
        """
        The ID of a rule in Hillstone.
        """
        return pulumi.get(self, "ips_id")

    @property
    @pulumi.getter(name="ipsName")
    def ips_name(self) -> str:
        """
        Specifies the IPS custom rule name.
        """
        return pulumi.get(self, "ips_name")

    @property
    @pulumi.getter
    def protocol(self) -> int:
        """
        Specifies the protocol.
        The valid values are as follows:
        + **1**: FTP;
        + **2**: TELNET;
        + **3**: SMTP;
        + **4**: DNS-TCP;
        + **5**: DNS-UDP;
        + **6**: DHCP;
        + **7**: TFTP;
        + **8**: FINGER;
        + **9**: HTTP;
        + **10**: POP3;
        + **11**: SUNRPC-TCP;
        + **12**: SUNRPC-UDP;
        + **13**: NNTP;
        + **14**: MSRPC-TCP;
        + **15**: MSRPC-UDP;
        + **16**: NETBIOS-NAME_TCP;
        + **17**: NETBIOS-NAME_UDP;
        + **18**: NETBIOS-SMB;
        + **19**: NETBIOS-DATAGRAM;
        + **20**: IMAP4;
        + **21**: SNMP;
        + **22**: LDAP;
        + **23**: MSSQL;
        + **24**: ORACLE;
        + **25**: MYSQL;
        + **26**: VOIP-SIP-TCP;
        + **27**: VOIP-SIP-UDP;
        + **28**: VOIP-H245;
        + **29**: VOIP-Q931;
        + **30**: OTHER-TCP;
        + **31**: OTHER-UDP;
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter
    def severity(self) -> int:
        """
        Specifies the severity.
        The valid values are as follows:
        + **0**: critical;
        + **1**: high;
        + **2**: medium;
        + **3**: low;
        """
        return pulumi.get(self, "severity")

    @property
    @pulumi.getter
    def software(self) -> int:
        """
        Specifies the affected software.
        The valid values are as follows:
        + **1**: ADOBE;
        + **2**: APACHE;
        + **3**: APPLE;
        + **4**: CA;
        + **5**: CISCO;
        + **6**: GOOGLE CHROME;
        + **7**: HP;
        + **8**: IBM;
        + **9**: IE;
        + **10**: IIS;
        + **11**: MCAFEE;
        + **12**: MEDIAPLAYER;
        + **13**: MICROSOFT.NET;
        + **14**: MICROSOFT EDGE;
        + **15**: MICROSOFT EXCHANGE;
        + **16**: MICROSOFT OFFICE;
        + **17**: MICROSOFT OUTLOOK;
        + **18**: MICROSOFT SHAREPOINT;
        + **19**: MICROSOFT WINDOWS;
        + **20**: MOZILLA;
        + **21**: MSSQL;
        + **22**: MYSQL;
        + **23**: NOVELL;
        + **24**: ORACLE;
        + **25**: SAMBA;
        + **26**: SAMSUNG;
        + **27**: SAP;
        + **28**: SCADA;
        + **29**: SQUID;
        + **30**: SUN;
        + **31**: SYMANTEC;
        + **32**: TREND MICRO;
        + **33**: VMWARE;
        + **34**: WORDPRESS;
        + **35**: OTHER;
        """
        return pulumi.get(self, "software")

    @property
    @pulumi.getter(name="srcPortType")
    def src_port_type(self) -> int:
        """
        The source port type.
        """
        return pulumi.get(self, "src_port_type")

    @property
    @pulumi.getter(name="srcPorts")
    def src_ports(self) -> str:
        """
        The source port.
        """
        return pulumi.get(self, "src_ports")


@pulumi.output_type
class GetIpsRuleDetailsDataResult(dict):
    def __init__(__self__, *,
                 ips_type: int,
                 ips_version: str,
                 update_time: str):
        """
        :param int ips_type: The IPS type.
        :param str ips_version: The IPS version.
        :param str update_time: The update time.
        """
        pulumi.set(__self__, "ips_type", ips_type)
        pulumi.set(__self__, "ips_version", ips_version)
        pulumi.set(__self__, "update_time", update_time)

    @property
    @pulumi.getter(name="ipsType")
    def ips_type(self) -> int:
        """
        The IPS type.
        """
        return pulumi.get(self, "ips_type")

    @property
    @pulumi.getter(name="ipsVersion")
    def ips_version(self) -> str:
        """
        The IPS version.
        """
        return pulumi.get(self, "ips_version")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> str:
        """
        The update time.
        """
        return pulumi.get(self, "update_time")


@pulumi.output_type
class GetIpsRulesRecordResult(dict):
    def __init__(__self__, *,
                 affected_application: str,
                 create_time: str,
                 default_status: str,
                 ips_cve: str,
                 ips_group: str,
                 ips_id: str,
                 ips_level: str,
                 ips_name: str,
                 ips_rules_type: str,
                 ips_status: str):
        """
        :param str affected_application: The application affected by the rule.
        :param str create_time: The creation time.
        :param str default_status: The default status of the IPS rule.
        :param str ips_cve: The CVE.
        :param str ips_group: The IPS rule group.
        :param str ips_id: Specifies the IPS rule ID.
        :param str ips_level: The risk level.
        :param str ips_name: The IPS rule name.
        :param str ips_rules_type: The IPS rule type.
        :param str ips_status: Specifies the IPS rule status.
               The valid value can be **OBSERVE**, **ENABLE**, or **CLOSE**.
        """
        pulumi.set(__self__, "affected_application", affected_application)
        pulumi.set(__self__, "create_time", create_time)
        pulumi.set(__self__, "default_status", default_status)
        pulumi.set(__self__, "ips_cve", ips_cve)
        pulumi.set(__self__, "ips_group", ips_group)
        pulumi.set(__self__, "ips_id", ips_id)
        pulumi.set(__self__, "ips_level", ips_level)
        pulumi.set(__self__, "ips_name", ips_name)
        pulumi.set(__self__, "ips_rules_type", ips_rules_type)
        pulumi.set(__self__, "ips_status", ips_status)

    @property
    @pulumi.getter(name="affectedApplication")
    def affected_application(self) -> str:
        """
        The application affected by the rule.
        """
        return pulumi.get(self, "affected_application")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The creation time.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="defaultStatus")
    def default_status(self) -> str:
        """
        The default status of the IPS rule.
        """
        return pulumi.get(self, "default_status")

    @property
    @pulumi.getter(name="ipsCve")
    def ips_cve(self) -> str:
        """
        The CVE.
        """
        return pulumi.get(self, "ips_cve")

    @property
    @pulumi.getter(name="ipsGroup")
    def ips_group(self) -> str:
        """
        The IPS rule group.
        """
        return pulumi.get(self, "ips_group")

    @property
    @pulumi.getter(name="ipsId")
    def ips_id(self) -> str:
        """
        Specifies the IPS rule ID.
        """
        return pulumi.get(self, "ips_id")

    @property
    @pulumi.getter(name="ipsLevel")
    def ips_level(self) -> str:
        """
        The risk level.
        """
        return pulumi.get(self, "ips_level")

    @property
    @pulumi.getter(name="ipsName")
    def ips_name(self) -> str:
        """
        The IPS rule name.
        """
        return pulumi.get(self, "ips_name")

    @property
    @pulumi.getter(name="ipsRulesType")
    def ips_rules_type(self) -> str:
        """
        The IPS rule type.
        """
        return pulumi.get(self, "ips_rules_type")

    @property
    @pulumi.getter(name="ipsStatus")
    def ips_status(self) -> str:
        """
        Specifies the IPS rule status.
        The valid value can be **OBSERVE**, **ENABLE**, or **CLOSE**.
        """
        return pulumi.get(self, "ips_status")


@pulumi.output_type
class GetProtectionRulesRecordResult(dict):
    def __init__(__self__, *,
                 action_type: str,
                 address_type: int,
                 created_date: str,
                 description: str,
                 destinations: Sequence['outputs.GetProtectionRulesRecordDestinationResult'],
                 direction: str,
                 last_open_time: str,
                 long_connect_enable: int,
                 long_connect_time: int,
                 long_connect_time_hour: int,
                 long_connect_time_minute: int,
                 long_connect_time_second: int,
                 name: str,
                 rule_id: str,
                 services: Sequence['outputs.GetProtectionRulesRecordServiceResult'],
                 sources: Sequence['outputs.GetProtectionRulesRecordSourceResult'],
                 status: str,
                 tags: Mapping[str, str],
                 type: str):
        """
        :param str action_type: Specifies the rule action type.
               The options are as follows:
               + **0**: allow;
               + **1**: deny.
        :param int address_type: The address type.
        :param str created_date: The created time of a rule.
        :param str description: The custom service description.
        :param Sequence['GetProtectionRulesRecordDestinationArgs'] destinations: Specifies the destination address.
        :param str direction: Specifies the rule direction.
               The options are as follows:
               + **0**: inbound;
               + **1**: outbound.
        :param str last_open_time: The last open time.
        :param int long_connect_enable: Whether to support persistent connections.
        :param int long_connect_time: The persistent connection duration.
        :param int long_connect_time_hour: The persistent connection duration (hour).
        :param int long_connect_time_minute: The persistent connection duration (minute).
        :param int long_connect_time_second: The persistent connection duration (second).
        :param str name: Specifies the rule name.
        :param str rule_id: Specifies the rule ID.
        :param Sequence['GetProtectionRulesRecordServiceArgs'] services: The service.
        :param Sequence['GetProtectionRulesRecordSourceArgs'] sources: Specifies the source address.
        :param str status: Specifies the rule status.
               The options are as follows:
               + **0**: disabled;
               + **1**: enabled.
        :param Mapping[str, str] tags: Specifies the key/value pairs to associate with the protection rule.
               Tags should have only one key/value pair.
        :param str type: Specifies the rule type.
               The value can be **0** (Internet rule), **1** (VPC rule), or **2** (NAT rule).
        """
        pulumi.set(__self__, "action_type", action_type)
        pulumi.set(__self__, "address_type", address_type)
        pulumi.set(__self__, "created_date", created_date)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "destinations", destinations)
        pulumi.set(__self__, "direction", direction)
        pulumi.set(__self__, "last_open_time", last_open_time)
        pulumi.set(__self__, "long_connect_enable", long_connect_enable)
        pulumi.set(__self__, "long_connect_time", long_connect_time)
        pulumi.set(__self__, "long_connect_time_hour", long_connect_time_hour)
        pulumi.set(__self__, "long_connect_time_minute", long_connect_time_minute)
        pulumi.set(__self__, "long_connect_time_second", long_connect_time_second)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "rule_id", rule_id)
        pulumi.set(__self__, "services", services)
        pulumi.set(__self__, "sources", sources)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "tags", tags)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="actionType")
    def action_type(self) -> str:
        """
        Specifies the rule action type.
        The options are as follows:
        + **0**: allow;
        + **1**: deny.
        """
        return pulumi.get(self, "action_type")

    @property
    @pulumi.getter(name="addressType")
    def address_type(self) -> int:
        """
        The address type.
        """
        return pulumi.get(self, "address_type")

    @property
    @pulumi.getter(name="createdDate")
    def created_date(self) -> str:
        """
        The created time of a rule.
        """
        return pulumi.get(self, "created_date")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The custom service description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def destinations(self) -> Sequence['outputs.GetProtectionRulesRecordDestinationResult']:
        """
        Specifies the destination address.
        """
        return pulumi.get(self, "destinations")

    @property
    @pulumi.getter
    def direction(self) -> str:
        """
        Specifies the rule direction.
        The options are as follows:
        + **0**: inbound;
        + **1**: outbound.
        """
        return pulumi.get(self, "direction")

    @property
    @pulumi.getter(name="lastOpenTime")
    def last_open_time(self) -> str:
        """
        The last open time.
        """
        return pulumi.get(self, "last_open_time")

    @property
    @pulumi.getter(name="longConnectEnable")
    def long_connect_enable(self) -> int:
        """
        Whether to support persistent connections.
        """
        return pulumi.get(self, "long_connect_enable")

    @property
    @pulumi.getter(name="longConnectTime")
    def long_connect_time(self) -> int:
        """
        The persistent connection duration.
        """
        return pulumi.get(self, "long_connect_time")

    @property
    @pulumi.getter(name="longConnectTimeHour")
    def long_connect_time_hour(self) -> int:
        """
        The persistent connection duration (hour).
        """
        return pulumi.get(self, "long_connect_time_hour")

    @property
    @pulumi.getter(name="longConnectTimeMinute")
    def long_connect_time_minute(self) -> int:
        """
        The persistent connection duration (minute).
        """
        return pulumi.get(self, "long_connect_time_minute")

    @property
    @pulumi.getter(name="longConnectTimeSecond")
    def long_connect_time_second(self) -> int:
        """
        The persistent connection duration (second).
        """
        return pulumi.get(self, "long_connect_time_second")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Specifies the rule name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> str:
        """
        Specifies the rule ID.
        """
        return pulumi.get(self, "rule_id")

    @property
    @pulumi.getter
    def services(self) -> Sequence['outputs.GetProtectionRulesRecordServiceResult']:
        """
        The service.
        """
        return pulumi.get(self, "services")

    @property
    @pulumi.getter
    def sources(self) -> Sequence['outputs.GetProtectionRulesRecordSourceResult']:
        """
        Specifies the source address.
        """
        return pulumi.get(self, "sources")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        Specifies the rule status.
        The options are as follows:
        + **0**: disabled;
        + **1**: enabled.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def tags(self) -> Mapping[str, str]:
        """
        Specifies the key/value pairs to associate with the protection rule.
        Tags should have only one key/value pair.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Specifies the rule type.
        The value can be **0** (Internet rule), **1** (VPC rule), or **2** (NAT rule).
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetProtectionRulesRecordDestinationResult(dict):
    def __init__(__self__, *,
                 address: str,
                 address_groups: Sequence[str],
                 address_set_id: str,
                 address_set_name: str,
                 address_set_type: int,
                 address_type: int,
                 domain_address_name: str,
                 domain_set_id: str,
                 domain_set_name: str,
                 ip_addresses: Sequence[str],
                 region_lists: Sequence['outputs.GetProtectionRulesRecordDestinationRegionListResult'],
                 type: int):
        """
        :param str address: The source IP address.
        :param Sequence[str] address_groups: The address group.
        :param str address_set_id: The ID of the associated IP address group.
        :param str address_set_name: The IP address group name.
        :param int address_set_type: The address set type.
        :param int address_type: The address type.
        :param str domain_address_name: The name of the domain address.
        :param str domain_set_id: The ID of the domain group.
        :param str domain_set_name: The name of domain group.
        :param Sequence[str] ip_addresses: The IP address list.
        :param Sequence['GetProtectionRulesRecordDestinationRegionListArgs'] region_lists: The region list of a rule.
        :param int type: Specifies the rule type.
               The value can be **0** (Internet rule), **1** (VPC rule), or **2** (NAT rule).
        """
        pulumi.set(__self__, "address", address)
        pulumi.set(__self__, "address_groups", address_groups)
        pulumi.set(__self__, "address_set_id", address_set_id)
        pulumi.set(__self__, "address_set_name", address_set_name)
        pulumi.set(__self__, "address_set_type", address_set_type)
        pulumi.set(__self__, "address_type", address_type)
        pulumi.set(__self__, "domain_address_name", domain_address_name)
        pulumi.set(__self__, "domain_set_id", domain_set_id)
        pulumi.set(__self__, "domain_set_name", domain_set_name)
        pulumi.set(__self__, "ip_addresses", ip_addresses)
        pulumi.set(__self__, "region_lists", region_lists)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        The source IP address.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="addressGroups")
    def address_groups(self) -> Sequence[str]:
        """
        The address group.
        """
        return pulumi.get(self, "address_groups")

    @property
    @pulumi.getter(name="addressSetId")
    def address_set_id(self) -> str:
        """
        The ID of the associated IP address group.
        """
        return pulumi.get(self, "address_set_id")

    @property
    @pulumi.getter(name="addressSetName")
    def address_set_name(self) -> str:
        """
        The IP address group name.
        """
        return pulumi.get(self, "address_set_name")

    @property
    @pulumi.getter(name="addressSetType")
    def address_set_type(self) -> int:
        """
        The address set type.
        """
        return pulumi.get(self, "address_set_type")

    @property
    @pulumi.getter(name="addressType")
    def address_type(self) -> int:
        """
        The address type.
        """
        return pulumi.get(self, "address_type")

    @property
    @pulumi.getter(name="domainAddressName")
    def domain_address_name(self) -> str:
        """
        The name of the domain address.
        """
        return pulumi.get(self, "domain_address_name")

    @property
    @pulumi.getter(name="domainSetId")
    def domain_set_id(self) -> str:
        """
        The ID of the domain group.
        """
        return pulumi.get(self, "domain_set_id")

    @property
    @pulumi.getter(name="domainSetName")
    def domain_set_name(self) -> str:
        """
        The name of domain group.
        """
        return pulumi.get(self, "domain_set_name")

    @property
    @pulumi.getter(name="ipAddresses")
    def ip_addresses(self) -> Sequence[str]:
        """
        The IP address list.
        """
        return pulumi.get(self, "ip_addresses")

    @property
    @pulumi.getter(name="regionLists")
    def region_lists(self) -> Sequence['outputs.GetProtectionRulesRecordDestinationRegionListResult']:
        """
        The region list of a rule.
        """
        return pulumi.get(self, "region_lists")

    @property
    @pulumi.getter
    def type(self) -> int:
        """
        Specifies the rule type.
        The value can be **0** (Internet rule), **1** (VPC rule), or **2** (NAT rule).
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetProtectionRulesRecordDestinationRegionListResult(dict):
    def __init__(__self__, *,
                 description_cn: str,
                 description_en: str,
                 region_id: str,
                 region_type: int):
        """
        :param str description_cn: The Chinese description of a region.
        :param str description_en: The English description of a region.
        :param str region_id: The region ID.
        :param int region_type: The region type.
        """
        pulumi.set(__self__, "description_cn", description_cn)
        pulumi.set(__self__, "description_en", description_en)
        pulumi.set(__self__, "region_id", region_id)
        pulumi.set(__self__, "region_type", region_type)

    @property
    @pulumi.getter(name="descriptionCn")
    def description_cn(self) -> str:
        """
        The Chinese description of a region.
        """
        return pulumi.get(self, "description_cn")

    @property
    @pulumi.getter(name="descriptionEn")
    def description_en(self) -> str:
        """
        The English description of a region.
        """
        return pulumi.get(self, "description_en")

    @property
    @pulumi.getter(name="regionId")
    def region_id(self) -> str:
        """
        The region ID.
        """
        return pulumi.get(self, "region_id")

    @property
    @pulumi.getter(name="regionType")
    def region_type(self) -> int:
        """
        The region type.
        """
        return pulumi.get(self, "region_type")


@pulumi.output_type
class GetProtectionRulesRecordServiceResult(dict):
    def __init__(__self__, *,
                 custom_services: Sequence['outputs.GetProtectionRulesRecordServiceCustomServiceResult'],
                 dest_port: str,
                 protocol: int,
                 protocols: Sequence[int],
                 service_groups: Sequence[str],
                 service_set_id: str,
                 service_set_name: str,
                 service_set_type: int,
                 source_port: str,
                 type: int):
        """
        :param Sequence['GetProtectionRulesRecordServiceCustomServiceArgs'] custom_services: The custom service.
        :param str dest_port: The destination port.
        :param int protocol: The protocol type of the custom service.
        :param Sequence[int] protocols: The protocols.
        :param Sequence[str] service_groups: The service group list.
        :param str service_set_id: The service group ID.
        :param str service_set_name: The service group name.
        :param int service_set_type: The service set type.
        :param str source_port: The source port of the custom service.
        :param int type: Specifies the rule type.
               The value can be **0** (Internet rule), **1** (VPC rule), or **2** (NAT rule).
        """
        pulumi.set(__self__, "custom_services", custom_services)
        pulumi.set(__self__, "dest_port", dest_port)
        pulumi.set(__self__, "protocol", protocol)
        pulumi.set(__self__, "protocols", protocols)
        pulumi.set(__self__, "service_groups", service_groups)
        pulumi.set(__self__, "service_set_id", service_set_id)
        pulumi.set(__self__, "service_set_name", service_set_name)
        pulumi.set(__self__, "service_set_type", service_set_type)
        pulumi.set(__self__, "source_port", source_port)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="customServices")
    def custom_services(self) -> Sequence['outputs.GetProtectionRulesRecordServiceCustomServiceResult']:
        """
        The custom service.
        """
        return pulumi.get(self, "custom_services")

    @property
    @pulumi.getter(name="destPort")
    def dest_port(self) -> str:
        """
        The destination port.
        """
        return pulumi.get(self, "dest_port")

    @property
    @pulumi.getter
    def protocol(self) -> int:
        """
        The protocol type of the custom service.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter
    def protocols(self) -> Sequence[int]:
        """
        The protocols.
        """
        return pulumi.get(self, "protocols")

    @property
    @pulumi.getter(name="serviceGroups")
    def service_groups(self) -> Sequence[str]:
        """
        The service group list.
        """
        return pulumi.get(self, "service_groups")

    @property
    @pulumi.getter(name="serviceSetId")
    def service_set_id(self) -> str:
        """
        The service group ID.
        """
        return pulumi.get(self, "service_set_id")

    @property
    @pulumi.getter(name="serviceSetName")
    def service_set_name(self) -> str:
        """
        The service group name.
        """
        return pulumi.get(self, "service_set_name")

    @property
    @pulumi.getter(name="serviceSetType")
    def service_set_type(self) -> int:
        """
        The service set type.
        """
        return pulumi.get(self, "service_set_type")

    @property
    @pulumi.getter(name="sourcePort")
    def source_port(self) -> str:
        """
        The source port of the custom service.
        """
        return pulumi.get(self, "source_port")

    @property
    @pulumi.getter
    def type(self) -> int:
        """
        Specifies the rule type.
        The value can be **0** (Internet rule), **1** (VPC rule), or **2** (NAT rule).
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetProtectionRulesRecordServiceCustomServiceResult(dict):
    def __init__(__self__, *,
                 description: str,
                 dest_port: str,
                 name: str,
                 protocol: int,
                 source_port: str):
        """
        :param str description: The custom service description.
        :param str dest_port: The destination port.
        :param str name: Specifies the rule name.
        :param int protocol: The protocol type of the custom service.
        :param str source_port: The source port of the custom service.
        """
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "dest_port", dest_port)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "protocol", protocol)
        pulumi.set(__self__, "source_port", source_port)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The custom service description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="destPort")
    def dest_port(self) -> str:
        """
        The destination port.
        """
        return pulumi.get(self, "dest_port")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Specifies the rule name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def protocol(self) -> int:
        """
        The protocol type of the custom service.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter(name="sourcePort")
    def source_port(self) -> str:
        """
        The source port of the custom service.
        """
        return pulumi.get(self, "source_port")


@pulumi.output_type
class GetProtectionRulesRecordSourceResult(dict):
    def __init__(__self__, *,
                 address: str,
                 address_groups: Sequence[str],
                 address_set_id: str,
                 address_set_name: str,
                 address_set_type: int,
                 address_type: int,
                 domain_address_name: str,
                 ip_addresses: Sequence[str],
                 region_lists: Sequence['outputs.GetProtectionRulesRecordSourceRegionListResult'],
                 type: int):
        """
        :param str address: The source IP address.
        :param Sequence[str] address_groups: The address group.
        :param str address_set_id: The ID of the associated IP address group.
        :param str address_set_name: The IP address group name.
        :param int address_set_type: The address set type.
        :param int address_type: The address type.
        :param str domain_address_name: The name of the domain address.
        :param Sequence[str] ip_addresses: The IP address list.
        :param Sequence['GetProtectionRulesRecordSourceRegionListArgs'] region_lists: The region list of a rule.
        :param int type: Specifies the rule type.
               The value can be **0** (Internet rule), **1** (VPC rule), or **2** (NAT rule).
        """
        pulumi.set(__self__, "address", address)
        pulumi.set(__self__, "address_groups", address_groups)
        pulumi.set(__self__, "address_set_id", address_set_id)
        pulumi.set(__self__, "address_set_name", address_set_name)
        pulumi.set(__self__, "address_set_type", address_set_type)
        pulumi.set(__self__, "address_type", address_type)
        pulumi.set(__self__, "domain_address_name", domain_address_name)
        pulumi.set(__self__, "ip_addresses", ip_addresses)
        pulumi.set(__self__, "region_lists", region_lists)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        The source IP address.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="addressGroups")
    def address_groups(self) -> Sequence[str]:
        """
        The address group.
        """
        return pulumi.get(self, "address_groups")

    @property
    @pulumi.getter(name="addressSetId")
    def address_set_id(self) -> str:
        """
        The ID of the associated IP address group.
        """
        return pulumi.get(self, "address_set_id")

    @property
    @pulumi.getter(name="addressSetName")
    def address_set_name(self) -> str:
        """
        The IP address group name.
        """
        return pulumi.get(self, "address_set_name")

    @property
    @pulumi.getter(name="addressSetType")
    def address_set_type(self) -> int:
        """
        The address set type.
        """
        return pulumi.get(self, "address_set_type")

    @property
    @pulumi.getter(name="addressType")
    def address_type(self) -> int:
        """
        The address type.
        """
        return pulumi.get(self, "address_type")

    @property
    @pulumi.getter(name="domainAddressName")
    def domain_address_name(self) -> str:
        """
        The name of the domain address.
        """
        return pulumi.get(self, "domain_address_name")

    @property
    @pulumi.getter(name="ipAddresses")
    def ip_addresses(self) -> Sequence[str]:
        """
        The IP address list.
        """
        return pulumi.get(self, "ip_addresses")

    @property
    @pulumi.getter(name="regionLists")
    def region_lists(self) -> Sequence['outputs.GetProtectionRulesRecordSourceRegionListResult']:
        """
        The region list of a rule.
        """
        return pulumi.get(self, "region_lists")

    @property
    @pulumi.getter
    def type(self) -> int:
        """
        Specifies the rule type.
        The value can be **0** (Internet rule), **1** (VPC rule), or **2** (NAT rule).
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetProtectionRulesRecordSourceRegionListResult(dict):
    def __init__(__self__, *,
                 description_cn: str,
                 description_en: str,
                 region_id: str,
                 region_type: int):
        """
        :param str description_cn: The Chinese description of a region.
        :param str description_en: The English description of a region.
        :param str region_id: The region ID.
        :param int region_type: The region type.
        """
        pulumi.set(__self__, "description_cn", description_cn)
        pulumi.set(__self__, "description_en", description_en)
        pulumi.set(__self__, "region_id", region_id)
        pulumi.set(__self__, "region_type", region_type)

    @property
    @pulumi.getter(name="descriptionCn")
    def description_cn(self) -> str:
        """
        The Chinese description of a region.
        """
        return pulumi.get(self, "description_cn")

    @property
    @pulumi.getter(name="descriptionEn")
    def description_en(self) -> str:
        """
        The English description of a region.
        """
        return pulumi.get(self, "description_en")

    @property
    @pulumi.getter(name="regionId")
    def region_id(self) -> str:
        """
        The region ID.
        """
        return pulumi.get(self, "region_id")

    @property
    @pulumi.getter(name="regionType")
    def region_type(self) -> int:
        """
        The region type.
        """
        return pulumi.get(self, "region_type")


@pulumi.output_type
class GetResourceTagsTagResult(dict):
    def __init__(__self__, *,
                 key: str,
                 value: str):
        """
        :param str key: The tag key.
        :param str value: The tag value.
        """
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        The tag key.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        The tag value.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class GetServiceGroupMembersRecordResult(dict):
    def __init__(__self__, *,
                 description: str,
                 dest_port: str,
                 item_id: str,
                 protocol: int,
                 source_port: str):
        """
        :param str description: The service group member description.
        :param str dest_port: Specifies the destination port.
        :param str item_id: Specifies the service group member ID.
        :param int protocol: Specifies the protocol type.
               The options are as follows:
               + **6**: TCP;
               + **17**: UDP;
               + **1**: ICMP.
        :param str source_port: Specifies the source port.
        """
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "dest_port", dest_port)
        pulumi.set(__self__, "item_id", item_id)
        pulumi.set(__self__, "protocol", protocol)
        pulumi.set(__self__, "source_port", source_port)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The service group member description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="destPort")
    def dest_port(self) -> str:
        """
        Specifies the destination port.
        """
        return pulumi.get(self, "dest_port")

    @property
    @pulumi.getter(name="itemId")
    def item_id(self) -> str:
        """
        Specifies the service group member ID.
        """
        return pulumi.get(self, "item_id")

    @property
    @pulumi.getter
    def protocol(self) -> int:
        """
        Specifies the protocol type.
        The options are as follows:
        + **6**: TCP;
        + **17**: UDP;
        + **1**: ICMP.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter(name="sourcePort")
    def source_port(self) -> str:
        """
        Specifies the source port.
        """
        return pulumi.get(self, "source_port")


@pulumi.output_type
class GetServiceGroupsServiceGroupResult(dict):
    def __init__(__self__, *,
                 description: str,
                 id: str,
                 name: str,
                 protocols: Sequence[int],
                 ref_count: int,
                 type: int):
        """
        :param str description: The description of the service group.
        :param str id: The service group ID.
        :param str name: Specifies the name of the service group.
        :param Sequence[int] protocols: The protocols of the service group.
        :param int ref_count: The number of times this service group has been referenced.
        :param int type: The type of the Service group.
        """
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "protocols", protocols)
        pulumi.set(__self__, "ref_count", ref_count)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the service group.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The service group ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Specifies the name of the service group.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def protocols(self) -> Sequence[int]:
        """
        The protocols of the service group.
        """
        return pulumi.get(self, "protocols")

    @property
    @pulumi.getter(name="refCount")
    def ref_count(self) -> int:
        """
        The number of times this service group has been referenced.
        """
        return pulumi.get(self, "ref_count")

    @property
    @pulumi.getter
    def type(self) -> int:
        """
        The type of the Service group.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetTagsTagResult(dict):
    def __init__(__self__, *,
                 key: str,
                 values: Sequence[str]):
        """
        :param str key: The tag key.
        :param Sequence[str] values: The tag values.
        """
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter
    def key(self) -> str:
        """
        The tag key.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def values(self) -> Sequence[str]:
        """
        The tag values.
        """
        return pulumi.get(self, "values")


