# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'NotificationFilterArgs',
    'NotificationOperationArgs',
    'NotificationOperationUserArgs',
]

@pulumi.input_type
class NotificationFilterArgs:
    def __init__(__self__, *,
                 condition: pulumi.Input[str],
                 rules: pulumi.Input[Sequence[pulumi.Input[str]]]):
        """
        :param pulumi.Input[str] condition: Specifies the relationship between multiple rules. The valid values are as follows:
               + **AND**: Effective after all filtering conditions are met.
               + **OR**: Effective when any one of the conditions is met.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] rules: Specifies an array of filtering rules. It consists of three parts,
               the first part is the **key**, the second part is the **rule**, and the third part is the **value**,
               the format is: **key != value**.
               + The **key** can be: **api_version**, **code**, **trace_rating**, **trace_type**, **resource_id** and
               **resource_name**.
               When the key is **api_version**, the value needs to follow the regular constraint: **^ (a-zA-Z0-9_ -.) {1,64}$**.
               When the key is **code**, the length range of value is from `1` to `256`.
               When the key is **trace_rating**, the value can be **normal**, **warning** or **incident**.
               When the key is **trace_type**, the value can be **ConsoleAction**, **ApiCall** or **SystemAction**.
               When the key is **resource_id**, the length range of value is from `1` to `350`.
               When the key is **resource_name**, the length range of value is from `1` to `256`.
               + The **rule** can be: **!=** or **=**.
        """
        pulumi.set(__self__, "condition", condition)
        pulumi.set(__self__, "rules", rules)

    @property
    @pulumi.getter
    def condition(self) -> pulumi.Input[str]:
        """
        Specifies the relationship between multiple rules. The valid values are as follows:
        + **AND**: Effective after all filtering conditions are met.
        + **OR**: Effective when any one of the conditions is met.
        """
        return pulumi.get(self, "condition")

    @condition.setter
    def condition(self, value: pulumi.Input[str]):
        pulumi.set(self, "condition", value)

    @property
    @pulumi.getter
    def rules(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Specifies an array of filtering rules. It consists of three parts,
        the first part is the **key**, the second part is the **rule**, and the third part is the **value**,
        the format is: **key != value**.
        + The **key** can be: **api_version**, **code**, **trace_rating**, **trace_type**, **resource_id** and
        **resource_name**.
        When the key is **api_version**, the value needs to follow the regular constraint: **^ (a-zA-Z0-9_ -.) {1,64}$**.
        When the key is **code**, the length range of value is from `1` to `256`.
        When the key is **trace_rating**, the value can be **normal**, **warning** or **incident**.
        When the key is **trace_type**, the value can be **ConsoleAction**, **ApiCall** or **SystemAction**.
        When the key is **resource_id**, the length range of value is from `1` to `350`.
        When the key is **resource_name**, the length range of value is from `1` to `256`.
        + The **rule** can be: **!=** or **=**.
        """
        return pulumi.get(self, "rules")

    @rules.setter
    def rules(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "rules", value)


@pulumi.input_type
class NotificationOperationArgs:
    def __init__(__self__, *,
                 resource: pulumi.Input[str],
                 service: pulumi.Input[str],
                 trace_names: pulumi.Input[Sequence[pulumi.Input[str]]]):
        """
        :param pulumi.Input[str] resource: Specifies the resource type.
        :param pulumi.Input[str] service: Specifies the cloud service.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] trace_names: Specifies an array of trace names.
        """
        pulumi.set(__self__, "resource", resource)
        pulumi.set(__self__, "service", service)
        pulumi.set(__self__, "trace_names", trace_names)

    @property
    @pulumi.getter
    def resource(self) -> pulumi.Input[str]:
        """
        Specifies the resource type.
        """
        return pulumi.get(self, "resource")

    @resource.setter
    def resource(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource", value)

    @property
    @pulumi.getter
    def service(self) -> pulumi.Input[str]:
        """
        Specifies the cloud service.
        """
        return pulumi.get(self, "service")

    @service.setter
    def service(self, value: pulumi.Input[str]):
        pulumi.set(self, "service", value)

    @property
    @pulumi.getter(name="traceNames")
    def trace_names(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Specifies an array of trace names.
        """
        return pulumi.get(self, "trace_names")

    @trace_names.setter
    def trace_names(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "trace_names", value)


@pulumi.input_type
class NotificationOperationUserArgs:
    def __init__(__self__, *,
                 group: pulumi.Input[str],
                 users: pulumi.Input[Sequence[pulumi.Input[str]]]):
        """
        :param pulumi.Input[str] group: Specifies the IAM user group name.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] users: Specifies an array of IAM users in the group.
        """
        pulumi.set(__self__, "group", group)
        pulumi.set(__self__, "users", users)

    @property
    @pulumi.getter
    def group(self) -> pulumi.Input[str]:
        """
        Specifies the IAM user group name.
        """
        return pulumi.get(self, "group")

    @group.setter
    def group(self, value: pulumi.Input[str]):
        pulumi.set(self, "group", value)

    @property
    @pulumi.getter
    def users(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Specifies an array of IAM users in the group.
        """
        return pulumi.get(self, "users")

    @users.setter
    def users(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "users", value)


