# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['CertificateArgs', 'Certificate']

@pulumi.input_type
class CertificateArgs:
    def __init__(__self__, *,
                 certificate: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 domain: Optional[pulumi.Input[str]] = None,
                 enc_certificate: Optional[pulumi.Input[str]] = None,
                 enc_private_key: Optional[pulumi.Input[str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 scm_certificate_id: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Certificate resource.
        :param pulumi.Input[str] certificate: The public encrypted key of the Certificate, PEM format.
        :param pulumi.Input[str] description: Human-readable description for the Certificate.
        :param pulumi.Input[str] domain: The domain of the Certificate. The value contains a maximum of **100** characters. This
               parameter is valid only when `type` is set to **server**.
        :param pulumi.Input[str] enc_certificate: Specifies the body of the SM encryption certificate required by HTTPS listeners.
               The value must be PEM encoded. Maximum 65,536-character length is allowed, supports certificate chains with a maximum
               of 11 layers (including certificates and certificate chains). It is mandatory only when `type` is set to **server_sm**.
        :param pulumi.Input[str] enc_private_key: Specifies the private key of the SM encryption certificate required by HTTPS listeners.
               The value must be PEM encoded. Maximum 8,192-character length is allowed. It is mandatory only when `type` is set to
               **server_sm.**.
        :param pulumi.Input[str] enterprise_project_id: The enterprise project id of the certificate.
        :param pulumi.Input[str] name: Human-readable name for the Certificate. Does not have to be unique.
        :param pulumi.Input[str] private_key: The private encrypted key of the Certificate, PEM format. This parameter is valid
               and mandatory only when `type` is set to **server**.
        :param pulumi.Input[str] region: The region in which to create the ELB certificate resource. If omitted, the
               provider-level region will be used. Changing this creates a new certificate.
        :param pulumi.Input[str] scm_certificate_id: Specifies the SM certificate ID.
        :param pulumi.Input[str] type: Specifies the certificate type. Value options:
               + **server**: indicates the server certificate.
               + **client**: indicates the CA certificate.
               + **server_sm**: indicates the server SM certificate.
        """
        pulumi.set(__self__, "certificate", certificate)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if domain is not None:
            pulumi.set(__self__, "domain", domain)
        if enc_certificate is not None:
            pulumi.set(__self__, "enc_certificate", enc_certificate)
        if enc_private_key is not None:
            pulumi.set(__self__, "enc_private_key", enc_private_key)
        if enterprise_project_id is not None:
            pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if private_key is not None:
            pulumi.set(__self__, "private_key", private_key)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if scm_certificate_id is not None:
            pulumi.set(__self__, "scm_certificate_id", scm_certificate_id)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def certificate(self) -> pulumi.Input[str]:
        """
        The public encrypted key of the Certificate, PEM format.
        """
        return pulumi.get(self, "certificate")

    @certificate.setter
    def certificate(self, value: pulumi.Input[str]):
        pulumi.set(self, "certificate", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Human-readable description for the Certificate.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def domain(self) -> Optional[pulumi.Input[str]]:
        """
        The domain of the Certificate. The value contains a maximum of **100** characters. This
        parameter is valid only when `type` is set to **server**.
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "domain", value)

    @property
    @pulumi.getter(name="encCertificate")
    def enc_certificate(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the body of the SM encryption certificate required by HTTPS listeners.
        The value must be PEM encoded. Maximum 65,536-character length is allowed, supports certificate chains with a maximum
        of 11 layers (including certificates and certificate chains). It is mandatory only when `type` is set to **server_sm**.
        """
        return pulumi.get(self, "enc_certificate")

    @enc_certificate.setter
    def enc_certificate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enc_certificate", value)

    @property
    @pulumi.getter(name="encPrivateKey")
    def enc_private_key(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the private key of the SM encryption certificate required by HTTPS listeners.
        The value must be PEM encoded. Maximum 8,192-character length is allowed. It is mandatory only when `type` is set to
        **server_sm.**.
        """
        return pulumi.get(self, "enc_private_key")

    @enc_private_key.setter
    def enc_private_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enc_private_key", value)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[pulumi.Input[str]]:
        """
        The enterprise project id of the certificate.
        """
        return pulumi.get(self, "enterprise_project_id")

    @enterprise_project_id.setter
    def enterprise_project_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enterprise_project_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Human-readable name for the Certificate. Does not have to be unique.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> Optional[pulumi.Input[str]]:
        """
        The private encrypted key of the Certificate, PEM format. This parameter is valid
        and mandatory only when `type` is set to **server**.
        """
        return pulumi.get(self, "private_key")

    @private_key.setter
    def private_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "private_key", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        The region in which to create the ELB certificate resource. If omitted, the
        provider-level region will be used. Changing this creates a new certificate.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="scmCertificateId")
    def scm_certificate_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the SM certificate ID.
        """
        return pulumi.get(self, "scm_certificate_id")

    @scm_certificate_id.setter
    def scm_certificate_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scm_certificate_id", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the certificate type. Value options:
        + **server**: indicates the server certificate.
        + **client**: indicates the CA certificate.
        + **server_sm**: indicates the server SM certificate.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class _CertificateState:
    def __init__(__self__, *,
                 certificate: Optional[pulumi.Input[str]] = None,
                 common_name: Optional[pulumi.Input[str]] = None,
                 create_time: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 domain: Optional[pulumi.Input[str]] = None,
                 enc_certificate: Optional[pulumi.Input[str]] = None,
                 enc_private_key: Optional[pulumi.Input[str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[str]] = None,
                 expire_time: Optional[pulumi.Input[str]] = None,
                 fingerprint: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 scm_certificate_id: Optional[pulumi.Input[str]] = None,
                 subject_alternative_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 update_time: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Certificate resources.
        :param pulumi.Input[str] certificate: The public encrypted key of the Certificate, PEM format.
        :param pulumi.Input[str] common_name: Indicates the primary domain name of the certificate.
        :param pulumi.Input[str] create_time: Indicates the creation time.
        :param pulumi.Input[str] description: Human-readable description for the Certificate.
        :param pulumi.Input[str] domain: The domain of the Certificate. The value contains a maximum of **100** characters. This
               parameter is valid only when `type` is set to **server**.
        :param pulumi.Input[str] enc_certificate: Specifies the body of the SM encryption certificate required by HTTPS listeners.
               The value must be PEM encoded. Maximum 65,536-character length is allowed, supports certificate chains with a maximum
               of 11 layers (including certificates and certificate chains). It is mandatory only when `type` is set to **server_sm**.
        :param pulumi.Input[str] enc_private_key: Specifies the private key of the SM encryption certificate required by HTTPS listeners.
               The value must be PEM encoded. Maximum 8,192-character length is allowed. It is mandatory only when `type` is set to
               **server_sm.**.
        :param pulumi.Input[str] enterprise_project_id: The enterprise project id of the certificate.
        :param pulumi.Input[str] expire_time: Indicates the expiration time.
        :param pulumi.Input[str] fingerprint: Indicates the fingerprint of the certificate.
        :param pulumi.Input[str] name: Human-readable name for the Certificate. Does not have to be unique.
        :param pulumi.Input[str] private_key: The private encrypted key of the Certificate, PEM format. This parameter is valid
               and mandatory only when `type` is set to **server**.
        :param pulumi.Input[str] region: The region in which to create the ELB certificate resource. If omitted, the
               provider-level region will be used. Changing this creates a new certificate.
        :param pulumi.Input[str] scm_certificate_id: Specifies the SM certificate ID.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] subject_alternative_names: Indicates all the domain names of the certificate.
        :param pulumi.Input[str] type: Specifies the certificate type. Value options:
               + **server**: indicates the server certificate.
               + **client**: indicates the CA certificate.
               + **server_sm**: indicates the server SM certificate.
        :param pulumi.Input[str] update_time: Indicates the update time.
        """
        if certificate is not None:
            pulumi.set(__self__, "certificate", certificate)
        if common_name is not None:
            pulumi.set(__self__, "common_name", common_name)
        if create_time is not None:
            pulumi.set(__self__, "create_time", create_time)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if domain is not None:
            pulumi.set(__self__, "domain", domain)
        if enc_certificate is not None:
            pulumi.set(__self__, "enc_certificate", enc_certificate)
        if enc_private_key is not None:
            pulumi.set(__self__, "enc_private_key", enc_private_key)
        if enterprise_project_id is not None:
            pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if expire_time is not None:
            pulumi.set(__self__, "expire_time", expire_time)
        if fingerprint is not None:
            pulumi.set(__self__, "fingerprint", fingerprint)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if private_key is not None:
            pulumi.set(__self__, "private_key", private_key)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if scm_certificate_id is not None:
            pulumi.set(__self__, "scm_certificate_id", scm_certificate_id)
        if subject_alternative_names is not None:
            pulumi.set(__self__, "subject_alternative_names", subject_alternative_names)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if update_time is not None:
            pulumi.set(__self__, "update_time", update_time)

    @property
    @pulumi.getter
    def certificate(self) -> Optional[pulumi.Input[str]]:
        """
        The public encrypted key of the Certificate, PEM format.
        """
        return pulumi.get(self, "certificate")

    @certificate.setter
    def certificate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "certificate", value)

    @property
    @pulumi.getter(name="commonName")
    def common_name(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the primary domain name of the certificate.
        """
        return pulumi.get(self, "common_name")

    @common_name.setter
    def common_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "common_name", value)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the creation time.
        """
        return pulumi.get(self, "create_time")

    @create_time.setter
    def create_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "create_time", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Human-readable description for the Certificate.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def domain(self) -> Optional[pulumi.Input[str]]:
        """
        The domain of the Certificate. The value contains a maximum of **100** characters. This
        parameter is valid only when `type` is set to **server**.
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "domain", value)

    @property
    @pulumi.getter(name="encCertificate")
    def enc_certificate(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the body of the SM encryption certificate required by HTTPS listeners.
        The value must be PEM encoded. Maximum 65,536-character length is allowed, supports certificate chains with a maximum
        of 11 layers (including certificates and certificate chains). It is mandatory only when `type` is set to **server_sm**.
        """
        return pulumi.get(self, "enc_certificate")

    @enc_certificate.setter
    def enc_certificate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enc_certificate", value)

    @property
    @pulumi.getter(name="encPrivateKey")
    def enc_private_key(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the private key of the SM encryption certificate required by HTTPS listeners.
        The value must be PEM encoded. Maximum 8,192-character length is allowed. It is mandatory only when `type` is set to
        **server_sm.**.
        """
        return pulumi.get(self, "enc_private_key")

    @enc_private_key.setter
    def enc_private_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enc_private_key", value)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[pulumi.Input[str]]:
        """
        The enterprise project id of the certificate.
        """
        return pulumi.get(self, "enterprise_project_id")

    @enterprise_project_id.setter
    def enterprise_project_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enterprise_project_id", value)

    @property
    @pulumi.getter(name="expireTime")
    def expire_time(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the expiration time.
        """
        return pulumi.get(self, "expire_time")

    @expire_time.setter
    def expire_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "expire_time", value)

    @property
    @pulumi.getter
    def fingerprint(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the fingerprint of the certificate.
        """
        return pulumi.get(self, "fingerprint")

    @fingerprint.setter
    def fingerprint(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "fingerprint", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Human-readable name for the Certificate. Does not have to be unique.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> Optional[pulumi.Input[str]]:
        """
        The private encrypted key of the Certificate, PEM format. This parameter is valid
        and mandatory only when `type` is set to **server**.
        """
        return pulumi.get(self, "private_key")

    @private_key.setter
    def private_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "private_key", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        The region in which to create the ELB certificate resource. If omitted, the
        provider-level region will be used. Changing this creates a new certificate.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="scmCertificateId")
    def scm_certificate_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the SM certificate ID.
        """
        return pulumi.get(self, "scm_certificate_id")

    @scm_certificate_id.setter
    def scm_certificate_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scm_certificate_id", value)

    @property
    @pulumi.getter(name="subjectAlternativeNames")
    def subject_alternative_names(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Indicates all the domain names of the certificate.
        """
        return pulumi.get(self, "subject_alternative_names")

    @subject_alternative_names.setter
    def subject_alternative_names(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "subject_alternative_names", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the certificate type. Value options:
        + **server**: indicates the server certificate.
        + **client**: indicates the CA certificate.
        + **server_sm**: indicates the server SM certificate.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the update time.
        """
        return pulumi.get(self, "update_time")

    @update_time.setter
    def update_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "update_time", value)


class Certificate(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 certificate: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 domain: Optional[pulumi.Input[str]] = None,
                 enc_certificate: Optional[pulumi.Input[str]] = None,
                 enc_private_key: Optional[pulumi.Input[str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 scm_certificate_id: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages an ELB certificate resource within HuaweiCloud.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        certificate1 = huaweicloud.dedicated_elb.Certificate("certificate1",
            certificate=\"\"\"-----BEGIN CERTIFICATE-----
        MIIDpTCCAo2gAwIBAgIJAKdmmOBYnFvoMA0GCSqGSIb3DQEBCwUAMGkxCzAJBgNV
        BAYTAnh4MQswCQYDVQQIDAJ4eDELMAkGA1UEBwwCeHgxCzAJBgNVBAoMAnh4MQsw
        CQYDVQQLDAJ4eDELMAkGA1UEAwwCeHgxGTAXBgkqhkiG9w0BCQEWCnh4QDE2My5j
        b20wHhcNMTcxMjA0MDM0MjQ5WhcNMjAxMjAzMDM0MjQ5WjBpMQswCQYDVQQGEwJ4
        eDELMAkGA1UECAwCeHgxCzAJBgNVBAcMAnh4MQswCQYDVQQKDAJ4eDELMAkGA1UE
        CwwCeHgxCzAJBgNVBAMMAnh4MRkwFwYJKoZIhvcNAQkBFgp4eEAxNjMuY29tMIIB
        IjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAwZ5UJULAjWr7p6FVwGRQRjFN
        2s8tZ/6LC3X82fajpVsYqF1xqEuUDndDXVD09E4u83MS6HO6a3bIVQDp6/klnYld
        iE6Vp8HH5BSKaCWKVg8lGWg1UM9wZFnlryi14KgmpIFmcu9nA8yV/6MZAe6RSDmb
        3iyNBmiZ8aZhGw2pI1YwR+15MVqFFGB+7ExkziROi7L8CFCyCezK2/oOOvQsH1dz
        Q8z1JXWdg8/9Zx7Ktvgwu5PQM3cJtSHX6iBPOkMU8Z8TugLlTqQXKZOEgwajwvQ5
        mf2DPkVgM08XAgaLJcLigwD513koAdtJd5v+9irw+5LAuO3JclqwTvwy7u/YwwID
        AQABo1AwTjAdBgNVHQ4EFgQUo5A2tIu+bcUfvGTD7wmEkhXKFjcwHwYDVR0jBBgw
        FoAUo5A2tIu+bcUfvGTD7wmEkhXKFjcwDAYDVR0TBAUwAwEB/zANBgkqhkiG9w0B
        AQsFAAOCAQEAWJ2rS6Mvlqk3GfEpboezx2J3X7l1z8Sxoqg6ntwB+rezvK3mc9H0
        83qcVeUcoH+0A0lSHyFN4FvRQL6X1hEheHarYwJK4agb231vb5erasuGO463eYEG
        r4SfTuOm7SyiV2xxbaBKrXJtpBp4WLL/s+LF+nklKjaOxkmxUX0sM4CTA7uFJypY
        c8Tdr8lDDNqoUtMD8BrUCJi+7lmMXRcC3Qi3oZJW76ja+kZA5mKVFPd1ATih8TbA
        i34R7EQDtFeiSvBdeKRsPp8c0KT8H1B4lXNkkCQs2WX5p4lm99+ZtLD4glw8x6Ic
        i1YhgnQbn5E0hz55OLu5jvOkKQjPCW+8Kg==
        -----END CERTIFICATE-----

        \"\"\",
            description="terraform test certificate",
            domain="www.elb.com",
            private_key=\"\"\"-----BEGIN RSA PRIVATE KEY-----
        MIIEowIBAAKCAQEAwZ5UJULAjWr7p6FVwGRQRjFN2s8tZ/6LC3X82fajpVsYqF1x
        qEuUDndDXVD09E4u83MS6HO6a3bIVQDp6/klnYldiE6Vp8HH5BSKaCWKVg8lGWg1
        UM9wZFnlryi14KgmpIFmcu9nA8yV/6MZAe6RSDmb3iyNBmiZ8aZhGw2pI1YwR+15
        MVqFFGB+7ExkziROi7L8CFCyCezK2/oOOvQsH1dzQ8z1JXWdg8/9Zx7Ktvgwu5PQ
        M3cJtSHX6iBPOkMU8Z8TugLlTqQXKZOEgwajwvQ5mf2DPkVgM08XAgaLJcLigwD5
        13koAdtJd5v+9irw+5LAuO3JclqwTvwy7u/YwwIDAQABAoIBACU9S5fjD9/jTMXA
        DRs08A+gGgZUxLn0xk+NAPX3LyB1tfdkCaFB8BccLzO6h3KZuwQOBPv6jkdvEDbx
        Nwyw3eA/9GJsIvKiHc0rejdvyPymaw9I8MA7NbXHaJrY7KpqDQyk6sx+aUTcy5jg
        iMXLWdwXYHhJ/1HVOo603oZyiS6HZeYU089NDUcX+1SJi3e5Ke0gPVXEqCq1O11/
        rh24bMxnwZo4PKBWdcMBN5Zf/4ij9vrZE+fFzW7vGBO48A5lvZxWU2U5t/OZQRtN
        1uLOHmMFa0FIF2aWbTVfwdUWAFsvAOkHj9VV8BXOUwKOUuEktdkfAlvrxmsFrO/H
        yDeYYPkCgYEA/S55CBbR0sMXpSZ56uRn8JHApZJhgkgvYr+FqDlJq/e92nAzf01P
        RoEBUajwrnf1ycevN/SDfbtWzq2XJGqhWdJmtpO16b7KBsC6BdRcH6dnOYh31jgA
        vABMIP3wzI4zSVTyxRE8LDuboytF1mSCeV5tHYPQTZNwrplDnLQhywcCgYEAw8Yc
        Uk/eiFr3hfH/ZohMfV5p82Qp7DNIGRzw8YtVG/3+vNXrAXW1VhugNhQY6L+zLtJC
        aKn84ooup0m3YCg0hvINqJuvzfsuzQgtjTXyaE0cEwsjUusOmiuj09vVx/3U7siK
        Hdjd2ICPCvQ6Q8tdi8jV320gMs05AtaBkZdsiWUCgYEAtLw4Kk4f+xTKDFsrLUNf
        75wcqhWVBiwBp7yQ7UX4EYsJPKZcHMRTk0EEcAbpyaJZE3I44vjp5ReXIHNLMfPs
        uvI34J4Rfot0LN3n7cFrAi2+wpNo+MOBwrNzpRmijGP2uKKrq4JiMjFbKV/6utGF
        Up7VxfwS904JYpqGaZctiIECgYA1A6nZtF0riY6ry/uAdXpZHL8ONNqRZtWoT0kD
        79otSVu5ISiRbaGcXsDExC52oKrSDAgFtbqQUiEOFg09UcXfoR6HwRkba2CiDwve
        yHQLQI5Qrdxz8Mk0gIrNrSM4FAmcW9vi9z4kCbQyoC5C+4gqeUlJRpDIkQBWP2Y4
        2ct/bQKBgHv8qCsQTZphOxc31BJPa2xVhuv18cEU3XLUrVfUZ/1f43JhLp7gynS2
        ep++LKUi9D0VGXY8bqvfJjbECoCeu85vl8NpCXwe/LoVoIn+7KaVIZMwqoGMfgNl
        nEqm7HWkNxHhf8A6En/IjleuddS1sf9e/x+TJN1Xhnt9W6pe7Fk1
        -----END RSA PRIVATE KEY-----

        \"\"\")
        ```

        ## Import

        The ELB certificate can be imported using the `id`, e.g. bash

        ```sh
         $ pulumi import huaweicloud:DedicatedElb/certificate:Certificate test <id>
        ```

         Note that the imported state may not be identical to your resource definition, due to some attributes missing from the API response, security or some other reason. The missing attributes include`private_key` and `enc_private_key`. It is generally recommended running `terraform plan` after importing a certificate. You can then decide if changes should be applied to the certificate, or the resource definition should be updated to align with the certificate. Also you can ignore changes as below. hcl resource "huaweicloud_elb_certificate" "test" {

         ...

         lifecycle {

         ignore_changes = [

         private_key, enc_private_key

         ]

         } }

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] certificate: The public encrypted key of the Certificate, PEM format.
        :param pulumi.Input[str] description: Human-readable description for the Certificate.
        :param pulumi.Input[str] domain: The domain of the Certificate. The value contains a maximum of **100** characters. This
               parameter is valid only when `type` is set to **server**.
        :param pulumi.Input[str] enc_certificate: Specifies the body of the SM encryption certificate required by HTTPS listeners.
               The value must be PEM encoded. Maximum 65,536-character length is allowed, supports certificate chains with a maximum
               of 11 layers (including certificates and certificate chains). It is mandatory only when `type` is set to **server_sm**.
        :param pulumi.Input[str] enc_private_key: Specifies the private key of the SM encryption certificate required by HTTPS listeners.
               The value must be PEM encoded. Maximum 8,192-character length is allowed. It is mandatory only when `type` is set to
               **server_sm.**.
        :param pulumi.Input[str] enterprise_project_id: The enterprise project id of the certificate.
        :param pulumi.Input[str] name: Human-readable name for the Certificate. Does not have to be unique.
        :param pulumi.Input[str] private_key: The private encrypted key of the Certificate, PEM format. This parameter is valid
               and mandatory only when `type` is set to **server**.
        :param pulumi.Input[str] region: The region in which to create the ELB certificate resource. If omitted, the
               provider-level region will be used. Changing this creates a new certificate.
        :param pulumi.Input[str] scm_certificate_id: Specifies the SM certificate ID.
        :param pulumi.Input[str] type: Specifies the certificate type. Value options:
               + **server**: indicates the server certificate.
               + **client**: indicates the CA certificate.
               + **server_sm**: indicates the server SM certificate.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CertificateArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages an ELB certificate resource within HuaweiCloud.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        certificate1 = huaweicloud.dedicated_elb.Certificate("certificate1",
            certificate=\"\"\"-----BEGIN CERTIFICATE-----
        MIIDpTCCAo2gAwIBAgIJAKdmmOBYnFvoMA0GCSqGSIb3DQEBCwUAMGkxCzAJBgNV
        BAYTAnh4MQswCQYDVQQIDAJ4eDELMAkGA1UEBwwCeHgxCzAJBgNVBAoMAnh4MQsw
        CQYDVQQLDAJ4eDELMAkGA1UEAwwCeHgxGTAXBgkqhkiG9w0BCQEWCnh4QDE2My5j
        b20wHhcNMTcxMjA0MDM0MjQ5WhcNMjAxMjAzMDM0MjQ5WjBpMQswCQYDVQQGEwJ4
        eDELMAkGA1UECAwCeHgxCzAJBgNVBAcMAnh4MQswCQYDVQQKDAJ4eDELMAkGA1UE
        CwwCeHgxCzAJBgNVBAMMAnh4MRkwFwYJKoZIhvcNAQkBFgp4eEAxNjMuY29tMIIB
        IjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAwZ5UJULAjWr7p6FVwGRQRjFN
        2s8tZ/6LC3X82fajpVsYqF1xqEuUDndDXVD09E4u83MS6HO6a3bIVQDp6/klnYld
        iE6Vp8HH5BSKaCWKVg8lGWg1UM9wZFnlryi14KgmpIFmcu9nA8yV/6MZAe6RSDmb
        3iyNBmiZ8aZhGw2pI1YwR+15MVqFFGB+7ExkziROi7L8CFCyCezK2/oOOvQsH1dz
        Q8z1JXWdg8/9Zx7Ktvgwu5PQM3cJtSHX6iBPOkMU8Z8TugLlTqQXKZOEgwajwvQ5
        mf2DPkVgM08XAgaLJcLigwD513koAdtJd5v+9irw+5LAuO3JclqwTvwy7u/YwwID
        AQABo1AwTjAdBgNVHQ4EFgQUo5A2tIu+bcUfvGTD7wmEkhXKFjcwHwYDVR0jBBgw
        FoAUo5A2tIu+bcUfvGTD7wmEkhXKFjcwDAYDVR0TBAUwAwEB/zANBgkqhkiG9w0B
        AQsFAAOCAQEAWJ2rS6Mvlqk3GfEpboezx2J3X7l1z8Sxoqg6ntwB+rezvK3mc9H0
        83qcVeUcoH+0A0lSHyFN4FvRQL6X1hEheHarYwJK4agb231vb5erasuGO463eYEG
        r4SfTuOm7SyiV2xxbaBKrXJtpBp4WLL/s+LF+nklKjaOxkmxUX0sM4CTA7uFJypY
        c8Tdr8lDDNqoUtMD8BrUCJi+7lmMXRcC3Qi3oZJW76ja+kZA5mKVFPd1ATih8TbA
        i34R7EQDtFeiSvBdeKRsPp8c0KT8H1B4lXNkkCQs2WX5p4lm99+ZtLD4glw8x6Ic
        i1YhgnQbn5E0hz55OLu5jvOkKQjPCW+8Kg==
        -----END CERTIFICATE-----

        \"\"\",
            description="terraform test certificate",
            domain="www.elb.com",
            private_key=\"\"\"-----BEGIN RSA PRIVATE KEY-----
        MIIEowIBAAKCAQEAwZ5UJULAjWr7p6FVwGRQRjFN2s8tZ/6LC3X82fajpVsYqF1x
        qEuUDndDXVD09E4u83MS6HO6a3bIVQDp6/klnYldiE6Vp8HH5BSKaCWKVg8lGWg1
        UM9wZFnlryi14KgmpIFmcu9nA8yV/6MZAe6RSDmb3iyNBmiZ8aZhGw2pI1YwR+15
        MVqFFGB+7ExkziROi7L8CFCyCezK2/oOOvQsH1dzQ8z1JXWdg8/9Zx7Ktvgwu5PQ
        M3cJtSHX6iBPOkMU8Z8TugLlTqQXKZOEgwajwvQ5mf2DPkVgM08XAgaLJcLigwD5
        13koAdtJd5v+9irw+5LAuO3JclqwTvwy7u/YwwIDAQABAoIBACU9S5fjD9/jTMXA
        DRs08A+gGgZUxLn0xk+NAPX3LyB1tfdkCaFB8BccLzO6h3KZuwQOBPv6jkdvEDbx
        Nwyw3eA/9GJsIvKiHc0rejdvyPymaw9I8MA7NbXHaJrY7KpqDQyk6sx+aUTcy5jg
        iMXLWdwXYHhJ/1HVOo603oZyiS6HZeYU089NDUcX+1SJi3e5Ke0gPVXEqCq1O11/
        rh24bMxnwZo4PKBWdcMBN5Zf/4ij9vrZE+fFzW7vGBO48A5lvZxWU2U5t/OZQRtN
        1uLOHmMFa0FIF2aWbTVfwdUWAFsvAOkHj9VV8BXOUwKOUuEktdkfAlvrxmsFrO/H
        yDeYYPkCgYEA/S55CBbR0sMXpSZ56uRn8JHApZJhgkgvYr+FqDlJq/e92nAzf01P
        RoEBUajwrnf1ycevN/SDfbtWzq2XJGqhWdJmtpO16b7KBsC6BdRcH6dnOYh31jgA
        vABMIP3wzI4zSVTyxRE8LDuboytF1mSCeV5tHYPQTZNwrplDnLQhywcCgYEAw8Yc
        Uk/eiFr3hfH/ZohMfV5p82Qp7DNIGRzw8YtVG/3+vNXrAXW1VhugNhQY6L+zLtJC
        aKn84ooup0m3YCg0hvINqJuvzfsuzQgtjTXyaE0cEwsjUusOmiuj09vVx/3U7siK
        Hdjd2ICPCvQ6Q8tdi8jV320gMs05AtaBkZdsiWUCgYEAtLw4Kk4f+xTKDFsrLUNf
        75wcqhWVBiwBp7yQ7UX4EYsJPKZcHMRTk0EEcAbpyaJZE3I44vjp5ReXIHNLMfPs
        uvI34J4Rfot0LN3n7cFrAi2+wpNo+MOBwrNzpRmijGP2uKKrq4JiMjFbKV/6utGF
        Up7VxfwS904JYpqGaZctiIECgYA1A6nZtF0riY6ry/uAdXpZHL8ONNqRZtWoT0kD
        79otSVu5ISiRbaGcXsDExC52oKrSDAgFtbqQUiEOFg09UcXfoR6HwRkba2CiDwve
        yHQLQI5Qrdxz8Mk0gIrNrSM4FAmcW9vi9z4kCbQyoC5C+4gqeUlJRpDIkQBWP2Y4
        2ct/bQKBgHv8qCsQTZphOxc31BJPa2xVhuv18cEU3XLUrVfUZ/1f43JhLp7gynS2
        ep++LKUi9D0VGXY8bqvfJjbECoCeu85vl8NpCXwe/LoVoIn+7KaVIZMwqoGMfgNl
        nEqm7HWkNxHhf8A6En/IjleuddS1sf9e/x+TJN1Xhnt9W6pe7Fk1
        -----END RSA PRIVATE KEY-----

        \"\"\")
        ```

        ## Import

        The ELB certificate can be imported using the `id`, e.g. bash

        ```sh
         $ pulumi import huaweicloud:DedicatedElb/certificate:Certificate test <id>
        ```

         Note that the imported state may not be identical to your resource definition, due to some attributes missing from the API response, security or some other reason. The missing attributes include`private_key` and `enc_private_key`. It is generally recommended running `terraform plan` after importing a certificate. You can then decide if changes should be applied to the certificate, or the resource definition should be updated to align with the certificate. Also you can ignore changes as below. hcl resource "huaweicloud_elb_certificate" "test" {

         ...

         lifecycle {

         ignore_changes = [

         private_key, enc_private_key

         ]

         } }

        :param str resource_name: The name of the resource.
        :param CertificateArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CertificateArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 certificate: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 domain: Optional[pulumi.Input[str]] = None,
                 enc_certificate: Optional[pulumi.Input[str]] = None,
                 enc_private_key: Optional[pulumi.Input[str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 scm_certificate_id: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CertificateArgs.__new__(CertificateArgs)

            if certificate is None and not opts.urn:
                raise TypeError("Missing required property 'certificate'")
            __props__.__dict__["certificate"] = certificate
            __props__.__dict__["description"] = description
            __props__.__dict__["domain"] = domain
            __props__.__dict__["enc_certificate"] = enc_certificate
            __props__.__dict__["enc_private_key"] = enc_private_key
            __props__.__dict__["enterprise_project_id"] = enterprise_project_id
            __props__.__dict__["name"] = name
            __props__.__dict__["private_key"] = private_key
            __props__.__dict__["region"] = region
            __props__.__dict__["scm_certificate_id"] = scm_certificate_id
            __props__.__dict__["type"] = type
            __props__.__dict__["common_name"] = None
            __props__.__dict__["create_time"] = None
            __props__.__dict__["expire_time"] = None
            __props__.__dict__["fingerprint"] = None
            __props__.__dict__["subject_alternative_names"] = None
            __props__.__dict__["update_time"] = None
        super(Certificate, __self__).__init__(
            'huaweicloud:DedicatedElb/certificate:Certificate',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            certificate: Optional[pulumi.Input[str]] = None,
            common_name: Optional[pulumi.Input[str]] = None,
            create_time: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            domain: Optional[pulumi.Input[str]] = None,
            enc_certificate: Optional[pulumi.Input[str]] = None,
            enc_private_key: Optional[pulumi.Input[str]] = None,
            enterprise_project_id: Optional[pulumi.Input[str]] = None,
            expire_time: Optional[pulumi.Input[str]] = None,
            fingerprint: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            private_key: Optional[pulumi.Input[str]] = None,
            region: Optional[pulumi.Input[str]] = None,
            scm_certificate_id: Optional[pulumi.Input[str]] = None,
            subject_alternative_names: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            type: Optional[pulumi.Input[str]] = None,
            update_time: Optional[pulumi.Input[str]] = None) -> 'Certificate':
        """
        Get an existing Certificate resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] certificate: The public encrypted key of the Certificate, PEM format.
        :param pulumi.Input[str] common_name: Indicates the primary domain name of the certificate.
        :param pulumi.Input[str] create_time: Indicates the creation time.
        :param pulumi.Input[str] description: Human-readable description for the Certificate.
        :param pulumi.Input[str] domain: The domain of the Certificate. The value contains a maximum of **100** characters. This
               parameter is valid only when `type` is set to **server**.
        :param pulumi.Input[str] enc_certificate: Specifies the body of the SM encryption certificate required by HTTPS listeners.
               The value must be PEM encoded. Maximum 65,536-character length is allowed, supports certificate chains with a maximum
               of 11 layers (including certificates and certificate chains). It is mandatory only when `type` is set to **server_sm**.
        :param pulumi.Input[str] enc_private_key: Specifies the private key of the SM encryption certificate required by HTTPS listeners.
               The value must be PEM encoded. Maximum 8,192-character length is allowed. It is mandatory only when `type` is set to
               **server_sm.**.
        :param pulumi.Input[str] enterprise_project_id: The enterprise project id of the certificate.
        :param pulumi.Input[str] expire_time: Indicates the expiration time.
        :param pulumi.Input[str] fingerprint: Indicates the fingerprint of the certificate.
        :param pulumi.Input[str] name: Human-readable name for the Certificate. Does not have to be unique.
        :param pulumi.Input[str] private_key: The private encrypted key of the Certificate, PEM format. This parameter is valid
               and mandatory only when `type` is set to **server**.
        :param pulumi.Input[str] region: The region in which to create the ELB certificate resource. If omitted, the
               provider-level region will be used. Changing this creates a new certificate.
        :param pulumi.Input[str] scm_certificate_id: Specifies the SM certificate ID.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] subject_alternative_names: Indicates all the domain names of the certificate.
        :param pulumi.Input[str] type: Specifies the certificate type. Value options:
               + **server**: indicates the server certificate.
               + **client**: indicates the CA certificate.
               + **server_sm**: indicates the server SM certificate.
        :param pulumi.Input[str] update_time: Indicates the update time.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CertificateState.__new__(_CertificateState)

        __props__.__dict__["certificate"] = certificate
        __props__.__dict__["common_name"] = common_name
        __props__.__dict__["create_time"] = create_time
        __props__.__dict__["description"] = description
        __props__.__dict__["domain"] = domain
        __props__.__dict__["enc_certificate"] = enc_certificate
        __props__.__dict__["enc_private_key"] = enc_private_key
        __props__.__dict__["enterprise_project_id"] = enterprise_project_id
        __props__.__dict__["expire_time"] = expire_time
        __props__.__dict__["fingerprint"] = fingerprint
        __props__.__dict__["name"] = name
        __props__.__dict__["private_key"] = private_key
        __props__.__dict__["region"] = region
        __props__.__dict__["scm_certificate_id"] = scm_certificate_id
        __props__.__dict__["subject_alternative_names"] = subject_alternative_names
        __props__.__dict__["type"] = type
        __props__.__dict__["update_time"] = update_time
        return Certificate(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def certificate(self) -> pulumi.Output[str]:
        """
        The public encrypted key of the Certificate, PEM format.
        """
        return pulumi.get(self, "certificate")

    @property
    @pulumi.getter(name="commonName")
    def common_name(self) -> pulumi.Output[str]:
        """
        Indicates the primary domain name of the certificate.
        """
        return pulumi.get(self, "common_name")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> pulumi.Output[str]:
        """
        Indicates the creation time.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Human-readable description for the Certificate.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def domain(self) -> pulumi.Output[Optional[str]]:
        """
        The domain of the Certificate. The value contains a maximum of **100** characters. This
        parameter is valid only when `type` is set to **server**.
        """
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter(name="encCertificate")
    def enc_certificate(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the body of the SM encryption certificate required by HTTPS listeners.
        The value must be PEM encoded. Maximum 65,536-character length is allowed, supports certificate chains with a maximum
        of 11 layers (including certificates and certificate chains). It is mandatory only when `type` is set to **server_sm**.
        """
        return pulumi.get(self, "enc_certificate")

    @property
    @pulumi.getter(name="encPrivateKey")
    def enc_private_key(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the private key of the SM encryption certificate required by HTTPS listeners.
        The value must be PEM encoded. Maximum 8,192-character length is allowed. It is mandatory only when `type` is set to
        **server_sm.**.
        """
        return pulumi.get(self, "enc_private_key")

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> pulumi.Output[str]:
        """
        The enterprise project id of the certificate.
        """
        return pulumi.get(self, "enterprise_project_id")

    @property
    @pulumi.getter(name="expireTime")
    def expire_time(self) -> pulumi.Output[str]:
        """
        Indicates the expiration time.
        """
        return pulumi.get(self, "expire_time")

    @property
    @pulumi.getter
    def fingerprint(self) -> pulumi.Output[str]:
        """
        Indicates the fingerprint of the certificate.
        """
        return pulumi.get(self, "fingerprint")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Human-readable name for the Certificate. Does not have to be unique.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> pulumi.Output[Optional[str]]:
        """
        The private encrypted key of the Certificate, PEM format. This parameter is valid
        and mandatory only when `type` is set to **server**.
        """
        return pulumi.get(self, "private_key")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        The region in which to create the ELB certificate resource. If omitted, the
        provider-level region will be used. Changing this creates a new certificate.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="scmCertificateId")
    def scm_certificate_id(self) -> pulumi.Output[str]:
        """
        Specifies the SM certificate ID.
        """
        return pulumi.get(self, "scm_certificate_id")

    @property
    @pulumi.getter(name="subjectAlternativeNames")
    def subject_alternative_names(self) -> pulumi.Output[Sequence[str]]:
        """
        Indicates all the domain names of the certificate.
        """
        return pulumi.get(self, "subject_alternative_names")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        Specifies the certificate type. Value options:
        + **server**: indicates the server certificate.
        + **client**: indicates the CA certificate.
        + **server_sm**: indicates the server SM certificate.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> pulumi.Output[str]:
        """
        Indicates the update time.
        """
        return pulumi.get(self, "update_time")

