# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['PackageArgs', 'Package']

@pulumi.input_type
class PackageArgs:
    def __init__(__self__, *,
                 object_path: pulumi.Input[str],
                 type: pulumi.Input[str],
                 group_name: Optional[pulumi.Input[str]] = None,
                 is_async: Optional[pulumi.Input[bool]] = None,
                 owner: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a Package resource.
        :param pulumi.Input[str] object_path: Specifies the OBS storage path where the package is located.
               For example, `https://{bucket_name}.obs.{region}.myhuaweicloud.com/dli/packages/object_file.py`.
               Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[str] type: Specifies the package type.
               + **jar**: `.jar` or jar related files.
               + **pyFile**: `.py` or python related files.
               + **file**: Other user files.
               + **modelFile**: User AI model files.
        :param pulumi.Input[str] group_name: Specifies the group name which the package belongs to.
               Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[bool] is_async: Specifies whether to upload resource packages in asynchronous mode.
               The default value is **false**. Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[str] owner: Specifies the name of the package owner. The owner must be IAM user.
        :param pulumi.Input[str] region: Specifies the region in which to upload packages.
               If omitted, the provider-level region will be used.
               Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Specifies the key/value pairs to associate with the package.
        """
        pulumi.set(__self__, "object_path", object_path)
        pulumi.set(__self__, "type", type)
        if group_name is not None:
            pulumi.set(__self__, "group_name", group_name)
        if is_async is not None:
            pulumi.set(__self__, "is_async", is_async)
        if owner is not None:
            pulumi.set(__self__, "owner", owner)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="objectPath")
    def object_path(self) -> pulumi.Input[str]:
        """
        Specifies the OBS storage path where the package is located.
        For example, `https://{bucket_name}.obs.{region}.myhuaweicloud.com/dli/packages/object_file.py`.
        Changing this parameter will delete the current package and upload a new package.
        """
        return pulumi.get(self, "object_path")

    @object_path.setter
    def object_path(self, value: pulumi.Input[str]):
        pulumi.set(self, "object_path", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        Specifies the package type.
        + **jar**: `.jar` or jar related files.
        + **pyFile**: `.py` or python related files.
        + **file**: Other user files.
        + **modelFile**: User AI model files.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="groupName")
    def group_name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the group name which the package belongs to.
        Changing this parameter will delete the current package and upload a new package.
        """
        return pulumi.get(self, "group_name")

    @group_name.setter
    def group_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "group_name", value)

    @property
    @pulumi.getter(name="isAsync")
    def is_async(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether to upload resource packages in asynchronous mode.
        The default value is **false**. Changing this parameter will delete the current package and upload a new package.
        """
        return pulumi.get(self, "is_async")

    @is_async.setter
    def is_async(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_async", value)

    @property
    @pulumi.getter
    def owner(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the package owner. The owner must be IAM user.
        """
        return pulumi.get(self, "owner")

    @owner.setter
    def owner(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "owner", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to upload packages.
        If omitted, the provider-level region will be used.
        Changing this parameter will delete the current package and upload a new package.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Specifies the key/value pairs to associate with the package.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)


@pulumi.input_type
class _PackageState:
    def __init__(__self__, *,
                 created_at: Optional[pulumi.Input[str]] = None,
                 group_name: Optional[pulumi.Input[str]] = None,
                 is_async: Optional[pulumi.Input[bool]] = None,
                 object_name: Optional[pulumi.Input[str]] = None,
                 object_path: Optional[pulumi.Input[str]] = None,
                 owner: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 updated_at: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Package resources.
        :param pulumi.Input[str] created_at: Time when a queue is created.
        :param pulumi.Input[str] group_name: Specifies the group name which the package belongs to.
               Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[bool] is_async: Specifies whether to upload resource packages in asynchronous mode.
               The default value is **false**. Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[str] object_name: The package name.
        :param pulumi.Input[str] object_path: Specifies the OBS storage path where the package is located.
               For example, `https://{bucket_name}.obs.{region}.myhuaweicloud.com/dli/packages/object_file.py`.
               Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[str] owner: Specifies the name of the package owner. The owner must be IAM user.
        :param pulumi.Input[str] region: Specifies the region in which to upload packages.
               If omitted, the provider-level region will be used.
               Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[str] status: Status of a package group to be uploaded.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Specifies the key/value pairs to associate with the package.
        :param pulumi.Input[str] type: Specifies the package type.
               + **jar**: `.jar` or jar related files.
               + **pyFile**: `.py` or python related files.
               + **file**: Other user files.
               + **modelFile**: User AI model files.
        :param pulumi.Input[str] updated_at: The last time when the package configuration update has completed.
        """
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if group_name is not None:
            pulumi.set(__self__, "group_name", group_name)
        if is_async is not None:
            pulumi.set(__self__, "is_async", is_async)
        if object_name is not None:
            pulumi.set(__self__, "object_name", object_name)
        if object_path is not None:
            pulumi.set(__self__, "object_path", object_path)
        if owner is not None:
            pulumi.set(__self__, "owner", owner)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[str]]:
        """
        Time when a queue is created.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter(name="groupName")
    def group_name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the group name which the package belongs to.
        Changing this parameter will delete the current package and upload a new package.
        """
        return pulumi.get(self, "group_name")

    @group_name.setter
    def group_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "group_name", value)

    @property
    @pulumi.getter(name="isAsync")
    def is_async(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether to upload resource packages in asynchronous mode.
        The default value is **false**. Changing this parameter will delete the current package and upload a new package.
        """
        return pulumi.get(self, "is_async")

    @is_async.setter
    def is_async(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_async", value)

    @property
    @pulumi.getter(name="objectName")
    def object_name(self) -> Optional[pulumi.Input[str]]:
        """
        The package name.
        """
        return pulumi.get(self, "object_name")

    @object_name.setter
    def object_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "object_name", value)

    @property
    @pulumi.getter(name="objectPath")
    def object_path(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the OBS storage path where the package is located.
        For example, `https://{bucket_name}.obs.{region}.myhuaweicloud.com/dli/packages/object_file.py`.
        Changing this parameter will delete the current package and upload a new package.
        """
        return pulumi.get(self, "object_path")

    @object_path.setter
    def object_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "object_path", value)

    @property
    @pulumi.getter
    def owner(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the package owner. The owner must be IAM user.
        """
        return pulumi.get(self, "owner")

    @owner.setter
    def owner(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "owner", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to upload packages.
        If omitted, the provider-level region will be used.
        Changing this parameter will delete the current package and upload a new package.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Status of a package group to be uploaded.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Specifies the key/value pairs to associate with the package.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the package type.
        + **jar**: `.jar` or jar related files.
        + **pyFile**: `.py` or python related files.
        + **file**: Other user files.
        + **modelFile**: User AI model files.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[pulumi.Input[str]]:
        """
        The last time when the package configuration update has completed.
        """
        return pulumi.get(self, "updated_at")

    @updated_at.setter
    def updated_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "updated_at", value)


class Package(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 group_name: Optional[pulumi.Input[str]] = None,
                 is_async: Optional[pulumi.Input[bool]] = None,
                 object_path: Optional[pulumi.Input[str]] = None,
                 owner: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages DLI package resource within HuaweiCloud

        ## Example Usage
        ### Upload the specified python script as a resource package

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        group_name = config.require_object("groupName")
        access_domain_name = config.require_object("accessDomainName")
        queue = huaweicloud.dli.Package("queue",
            group_name=group_name,
            object_path=f"https://{access_domain_name}/dli/packages/object_file.py",
            type="pyFile")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] group_name: Specifies the group name which the package belongs to.
               Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[bool] is_async: Specifies whether to upload resource packages in asynchronous mode.
               The default value is **false**. Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[str] object_path: Specifies the OBS storage path where the package is located.
               For example, `https://{bucket_name}.obs.{region}.myhuaweicloud.com/dli/packages/object_file.py`.
               Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[str] owner: Specifies the name of the package owner. The owner must be IAM user.
        :param pulumi.Input[str] region: Specifies the region in which to upload packages.
               If omitted, the provider-level region will be used.
               Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Specifies the key/value pairs to associate with the package.
        :param pulumi.Input[str] type: Specifies the package type.
               + **jar**: `.jar` or jar related files.
               + **pyFile**: `.py` or python related files.
               + **file**: Other user files.
               + **modelFile**: User AI model files.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PackageArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages DLI package resource within HuaweiCloud

        ## Example Usage
        ### Upload the specified python script as a resource package

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        group_name = config.require_object("groupName")
        access_domain_name = config.require_object("accessDomainName")
        queue = huaweicloud.dli.Package("queue",
            group_name=group_name,
            object_path=f"https://{access_domain_name}/dli/packages/object_file.py",
            type="pyFile")
        ```

        :param str resource_name: The name of the resource.
        :param PackageArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PackageArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 group_name: Optional[pulumi.Input[str]] = None,
                 is_async: Optional[pulumi.Input[bool]] = None,
                 object_path: Optional[pulumi.Input[str]] = None,
                 owner: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PackageArgs.__new__(PackageArgs)

            __props__.__dict__["group_name"] = group_name
            __props__.__dict__["is_async"] = is_async
            if object_path is None and not opts.urn:
                raise TypeError("Missing required property 'object_path'")
            __props__.__dict__["object_path"] = object_path
            __props__.__dict__["owner"] = owner
            __props__.__dict__["region"] = region
            __props__.__dict__["tags"] = tags
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
            __props__.__dict__["created_at"] = None
            __props__.__dict__["object_name"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["updated_at"] = None
        super(Package, __self__).__init__(
            'huaweicloud:Dli/package:Package',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            created_at: Optional[pulumi.Input[str]] = None,
            group_name: Optional[pulumi.Input[str]] = None,
            is_async: Optional[pulumi.Input[bool]] = None,
            object_name: Optional[pulumi.Input[str]] = None,
            object_path: Optional[pulumi.Input[str]] = None,
            owner: Optional[pulumi.Input[str]] = None,
            region: Optional[pulumi.Input[str]] = None,
            status: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            type: Optional[pulumi.Input[str]] = None,
            updated_at: Optional[pulumi.Input[str]] = None) -> 'Package':
        """
        Get an existing Package resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] created_at: Time when a queue is created.
        :param pulumi.Input[str] group_name: Specifies the group name which the package belongs to.
               Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[bool] is_async: Specifies whether to upload resource packages in asynchronous mode.
               The default value is **false**. Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[str] object_name: The package name.
        :param pulumi.Input[str] object_path: Specifies the OBS storage path where the package is located.
               For example, `https://{bucket_name}.obs.{region}.myhuaweicloud.com/dli/packages/object_file.py`.
               Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[str] owner: Specifies the name of the package owner. The owner must be IAM user.
        :param pulumi.Input[str] region: Specifies the region in which to upload packages.
               If omitted, the provider-level region will be used.
               Changing this parameter will delete the current package and upload a new package.
        :param pulumi.Input[str] status: Status of a package group to be uploaded.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Specifies the key/value pairs to associate with the package.
        :param pulumi.Input[str] type: Specifies the package type.
               + **jar**: `.jar` or jar related files.
               + **pyFile**: `.py` or python related files.
               + **file**: Other user files.
               + **modelFile**: User AI model files.
        :param pulumi.Input[str] updated_at: The last time when the package configuration update has completed.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _PackageState.__new__(_PackageState)

        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["group_name"] = group_name
        __props__.__dict__["is_async"] = is_async
        __props__.__dict__["object_name"] = object_name
        __props__.__dict__["object_path"] = object_path
        __props__.__dict__["owner"] = owner
        __props__.__dict__["region"] = region
        __props__.__dict__["status"] = status
        __props__.__dict__["tags"] = tags
        __props__.__dict__["type"] = type
        __props__.__dict__["updated_at"] = updated_at
        return Package(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[str]:
        """
        Time when a queue is created.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="groupName")
    def group_name(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the group name which the package belongs to.
        Changing this parameter will delete the current package and upload a new package.
        """
        return pulumi.get(self, "group_name")

    @property
    @pulumi.getter(name="isAsync")
    def is_async(self) -> pulumi.Output[bool]:
        """
        Specifies whether to upload resource packages in asynchronous mode.
        The default value is **false**. Changing this parameter will delete the current package and upload a new package.
        """
        return pulumi.get(self, "is_async")

    @property
    @pulumi.getter(name="objectName")
    def object_name(self) -> pulumi.Output[str]:
        """
        The package name.
        """
        return pulumi.get(self, "object_name")

    @property
    @pulumi.getter(name="objectPath")
    def object_path(self) -> pulumi.Output[str]:
        """
        Specifies the OBS storage path where the package is located.
        For example, `https://{bucket_name}.obs.{region}.myhuaweicloud.com/dli/packages/object_file.py`.
        Changing this parameter will delete the current package and upload a new package.
        """
        return pulumi.get(self, "object_path")

    @property
    @pulumi.getter
    def owner(self) -> pulumi.Output[str]:
        """
        Specifies the name of the package owner. The owner must be IAM user.
        """
        return pulumi.get(self, "owner")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        Specifies the region in which to upload packages.
        If omitted, the provider-level region will be used.
        Changing this parameter will delete the current package and upload a new package.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        Status of a package group to be uploaded.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Specifies the key/value pairs to associate with the package.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        Specifies the package type.
        + **jar**: `.jar` or jar related files.
        + **pyFile**: `.py` or python related files.
        + **file**: Other user files.
        + **modelFile**: User AI model files.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> pulumi.Output[str]:
        """
        The last time when the package configuration update has completed.
        """
        return pulumi.get(self, "updated_at")

