# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ClusterElb',
    'ClusterEndpoint',
    'ClusterMaintainWindow',
    'ClusterPublicEndpoint',
    'ClusterPublicIp',
    'ClusterVolume',
    'GetFlaovrsFlavorResult',
    'GetFlaovrsFlavorElasticVolumeSpecResult',
]

@pulumi.output_type
class ClusterElb(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "privateEndpoint":
            suggest = "private_endpoint"
        elif key == "privateIp":
            suggest = "private_ip"
        elif key == "privateIpV6":
            suggest = "private_ip_v6"
        elif key == "publicIp":
            suggest = "public_ip"
        elif key == "vpcId":
            suggest = "vpc_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterElb. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterElb.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterElb.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 id: Optional[str] = None,
                 name: Optional[str] = None,
                 private_endpoint: Optional[str] = None,
                 private_ip: Optional[str] = None,
                 private_ip_v6: Optional[str] = None,
                 public_ip: Optional[str] = None,
                 vpc_id: Optional[str] = None):
        """
        :param str id: The ID of the ELB load balancer.
        :param str name: Cluster name, which must be unique and contains 4 to 64 characters, which
               consist of letters, digits, hyphens(-), or underscores(_) only and must start with a letter.
               Changing this creates a new cluster resource.
        :param str private_endpoint: The private endpoint of the ELB load balancer.
        :param str private_ip: The private IP address of the ELB load balancer.
        :param str private_ip_v6: The IPv6 address of the ELB load balancer.
        :param str public_ip: The information about public IP.
        :param str vpc_id: The VPC ID.
               Changing this parameter will create a new resource.
        """
        if id is not None:
            pulumi.set(__self__, "id", id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if private_endpoint is not None:
            pulumi.set(__self__, "private_endpoint", private_endpoint)
        if private_ip is not None:
            pulumi.set(__self__, "private_ip", private_ip)
        if private_ip_v6 is not None:
            pulumi.set(__self__, "private_ip_v6", private_ip_v6)
        if public_ip is not None:
            pulumi.set(__self__, "public_ip", public_ip)
        if vpc_id is not None:
            pulumi.set(__self__, "vpc_id", vpc_id)

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        The ID of the ELB load balancer.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Cluster name, which must be unique and contains 4 to 64 characters, which
        consist of letters, digits, hyphens(-), or underscores(_) only and must start with a letter.
        Changing this creates a new cluster resource.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="privateEndpoint")
    def private_endpoint(self) -> Optional[str]:
        """
        The private endpoint of the ELB load balancer.
        """
        return pulumi.get(self, "private_endpoint")

    @property
    @pulumi.getter(name="privateIp")
    def private_ip(self) -> Optional[str]:
        """
        The private IP address of the ELB load balancer.
        """
        return pulumi.get(self, "private_ip")

    @property
    @pulumi.getter(name="privateIpV6")
    def private_ip_v6(self) -> Optional[str]:
        """
        The IPv6 address of the ELB load balancer.
        """
        return pulumi.get(self, "private_ip_v6")

    @property
    @pulumi.getter(name="publicIp")
    def public_ip(self) -> Optional[str]:
        """
        The information about public IP.
        """
        return pulumi.get(self, "public_ip")

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[str]:
        """
        The VPC ID.
        Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "vpc_id")


@pulumi.output_type
class ClusterEndpoint(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "connectInfo":
            suggest = "connect_info"
        elif key == "jdbcUrl":
            suggest = "jdbc_url"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterEndpoint. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterEndpoint.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterEndpoint.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 connect_info: Optional[str] = None,
                 jdbc_url: Optional[str] = None):
        """
        :param str connect_info: Private network connection information.
        :param str jdbc_url: JDBC URL. Format: jdbc:postgresql://<public_connect_info>/<YOUR_DATABASE_NAME>
        """
        if connect_info is not None:
            pulumi.set(__self__, "connect_info", connect_info)
        if jdbc_url is not None:
            pulumi.set(__self__, "jdbc_url", jdbc_url)

    @property
    @pulumi.getter(name="connectInfo")
    def connect_info(self) -> Optional[str]:
        """
        Private network connection information.
        """
        return pulumi.get(self, "connect_info")

    @property
    @pulumi.getter(name="jdbcUrl")
    def jdbc_url(self) -> Optional[str]:
        """
        JDBC URL. Format: jdbc:postgresql://<public_connect_info>/<YOUR_DATABASE_NAME>
        """
        return pulumi.get(self, "jdbc_url")


@pulumi.output_type
class ClusterMaintainWindow(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "endTime":
            suggest = "end_time"
        elif key == "startTime":
            suggest = "start_time"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterMaintainWindow. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterMaintainWindow.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterMaintainWindow.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 day: Optional[str] = None,
                 end_time: Optional[str] = None,
                 start_time: Optional[str] = None):
        """
        :param str day: Maintenance time in each week in the unit of day.  
               The valid values are **Mon**, **Tue**, **Wed**, **Thu**, **Fri**,
               **Sat**, and **Sun**.
        :param str end_time: Maintenance end time in HH:mm format. The time zone is GMT+0.
        :param str start_time: Maintenance start time in HH:mm format. The time zone is GMT+0.
        """
        if day is not None:
            pulumi.set(__self__, "day", day)
        if end_time is not None:
            pulumi.set(__self__, "end_time", end_time)
        if start_time is not None:
            pulumi.set(__self__, "start_time", start_time)

    @property
    @pulumi.getter
    def day(self) -> Optional[str]:
        """
        Maintenance time in each week in the unit of day.  
        The valid values are **Mon**, **Tue**, **Wed**, **Thu**, **Fri**,
        **Sat**, and **Sun**.
        """
        return pulumi.get(self, "day")

    @property
    @pulumi.getter(name="endTime")
    def end_time(self) -> Optional[str]:
        """
        Maintenance end time in HH:mm format. The time zone is GMT+0.
        """
        return pulumi.get(self, "end_time")

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> Optional[str]:
        """
        Maintenance start time in HH:mm format. The time zone is GMT+0.
        """
        return pulumi.get(self, "start_time")


@pulumi.output_type
class ClusterPublicEndpoint(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "jdbcUrl":
            suggest = "jdbc_url"
        elif key == "publicConnectInfo":
            suggest = "public_connect_info"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterPublicEndpoint. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterPublicEndpoint.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterPublicEndpoint.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 jdbc_url: Optional[str] = None,
                 public_connect_info: Optional[str] = None):
        """
        :param str jdbc_url: JDBC URL. Format: jdbc:postgresql://<public_connect_info>/<YOUR_DATABASE_NAME>
        :param str public_connect_info: Public network connection information.
        """
        if jdbc_url is not None:
            pulumi.set(__self__, "jdbc_url", jdbc_url)
        if public_connect_info is not None:
            pulumi.set(__self__, "public_connect_info", public_connect_info)

    @property
    @pulumi.getter(name="jdbcUrl")
    def jdbc_url(self) -> Optional[str]:
        """
        JDBC URL. Format: jdbc:postgresql://<public_connect_info>/<YOUR_DATABASE_NAME>
        """
        return pulumi.get(self, "jdbc_url")

    @property
    @pulumi.getter(name="publicConnectInfo")
    def public_connect_info(self) -> Optional[str]:
        """
        Public network connection information.
        """
        return pulumi.get(self, "public_connect_info")


@pulumi.output_type
class ClusterPublicIp(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "eipId":
            suggest = "eip_id"
        elif key == "publicBindType":
            suggest = "public_bind_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ClusterPublicIp. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ClusterPublicIp.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ClusterPublicIp.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 eip_id: Optional[str] = None,
                 public_bind_type: Optional[str] = None):
        """
        :param str eip_id: The EIP ID.
        :param str public_bind_type: The bind type of public IP.  
               The valid value are **auto_assign**, **not_use**, and **bind_existing**. Defaults to **not_use**.
        """
        if eip_id is not None:
            pulumi.set(__self__, "eip_id", eip_id)
        if public_bind_type is not None:
            pulumi.set(__self__, "public_bind_type", public_bind_type)

    @property
    @pulumi.getter(name="eipId")
    def eip_id(self) -> Optional[str]:
        """
        The EIP ID.
        """
        return pulumi.get(self, "eip_id")

    @property
    @pulumi.getter(name="publicBindType")
    def public_bind_type(self) -> Optional[str]:
        """
        The bind type of public IP.  
        The valid value are **auto_assign**, **not_use**, and **bind_existing**. Defaults to **not_use**.
        """
        return pulumi.get(self, "public_bind_type")


@pulumi.output_type
class ClusterVolume(dict):
    def __init__(__self__, *,
                 capacity: Optional[str] = None,
                 type: Optional[str] = None):
        """
        :param str capacity: The capacity size, in GB.
        :param str type: The volume type. Value options are as follows:
               + **SSD**: Ultra-high I/O. The solid-state drive (SSD) is used.
               + **SAS**: High I/O. The SAS disk is used.
               + **SATA**: Common I/O. The SATA disk is used.
        """
        if capacity is not None:
            pulumi.set(__self__, "capacity", capacity)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def capacity(self) -> Optional[str]:
        """
        The capacity size, in GB.
        """
        return pulumi.get(self, "capacity")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        The volume type. Value options are as follows:
        + **SSD**: Ultra-high I/O. The solid-state drive (SSD) is used.
        + **SAS**: High I/O. The SAS disk is used.
        + **SATA**: Common I/O. The SATA disk is used.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class GetFlaovrsFlavorResult(dict):
    def __init__(__self__, *,
                 availability_zones: Sequence[str],
                 datastore_type: str,
                 datastore_version: str,
                 elastic_volume_specs: Sequence['outputs.GetFlaovrsFlavorElasticVolumeSpecResult'],
                 flavor_id: str,
                 memory: int,
                 size: int,
                 vcpus: int,
                 volumetype: str):
        """
        :param Sequence[str] availability_zones: The list of availability zones.
        :param str datastore_type: The type of datastore.  
               The options are as follows:
               - **dws**: OLAP, elastic scaling, unlimited scaling of compute and storage capacity.
               - **hybrid**: a single data warehouse used for transaction and analytics workloads,
               in single-node or cluster mode.
               - **stream**: built-in time series operators; up to 40:1 compression ratio; applicable to IoT services.
        :param str datastore_version: The version of datastore.
        :param Sequence['GetFlaovrsFlavorElasticVolumeSpecArgs'] elastic_volume_specs: The ElasticVolumeSpec structure is documented below.
        :param str flavor_id: The name of the dws node flavor.  
               It is referenced by `node_type` in `_dws.get_flaovrs`.
        :param int memory: The ram of the dws node flavor in GB.
        :param int size: The default disk size in GB.
        :param int vcpus: The vcpus of the dws node flavor.
        :param str volumetype: Disk type.  
               The options are as follows:
               - **LOCAL_DISK**:common I/O disk.
               - **SSD**: ultra-high I/O disk.
        """
        pulumi.set(__self__, "availability_zones", availability_zones)
        pulumi.set(__self__, "datastore_type", datastore_type)
        pulumi.set(__self__, "datastore_version", datastore_version)
        pulumi.set(__self__, "elastic_volume_specs", elastic_volume_specs)
        pulumi.set(__self__, "flavor_id", flavor_id)
        pulumi.set(__self__, "memory", memory)
        pulumi.set(__self__, "size", size)
        pulumi.set(__self__, "vcpus", vcpus)
        pulumi.set(__self__, "volumetype", volumetype)

    @property
    @pulumi.getter(name="availabilityZones")
    def availability_zones(self) -> Sequence[str]:
        """
        The list of availability zones.
        """
        return pulumi.get(self, "availability_zones")

    @property
    @pulumi.getter(name="datastoreType")
    def datastore_type(self) -> str:
        """
        The type of datastore.  
        The options are as follows:
        - **dws**: OLAP, elastic scaling, unlimited scaling of compute and storage capacity.
        - **hybrid**: a single data warehouse used for transaction and analytics workloads,
        in single-node or cluster mode.
        - **stream**: built-in time series operators; up to 40:1 compression ratio; applicable to IoT services.
        """
        return pulumi.get(self, "datastore_type")

    @property
    @pulumi.getter(name="datastoreVersion")
    def datastore_version(self) -> str:
        """
        The version of datastore.
        """
        return pulumi.get(self, "datastore_version")

    @property
    @pulumi.getter(name="elasticVolumeSpecs")
    def elastic_volume_specs(self) -> Sequence['outputs.GetFlaovrsFlavorElasticVolumeSpecResult']:
        """
        The ElasticVolumeSpec structure is documented below.
        """
        return pulumi.get(self, "elastic_volume_specs")

    @property
    @pulumi.getter(name="flavorId")
    def flavor_id(self) -> str:
        """
        The name of the dws node flavor.  
        It is referenced by `node_type` in `_dws.get_flaovrs`.
        """
        return pulumi.get(self, "flavor_id")

    @property
    @pulumi.getter
    def memory(self) -> int:
        """
        The ram of the dws node flavor in GB.
        """
        return pulumi.get(self, "memory")

    @property
    @pulumi.getter
    def size(self) -> int:
        """
        The default disk size in GB.
        """
        return pulumi.get(self, "size")

    @property
    @pulumi.getter
    def vcpus(self) -> int:
        """
        The vcpus of the dws node flavor.
        """
        return pulumi.get(self, "vcpus")

    @property
    @pulumi.getter
    def volumetype(self) -> str:
        """
        Disk type.  
        The options are as follows:
        - **LOCAL_DISK**:common I/O disk.
        - **SSD**: ultra-high I/O disk.
        """
        return pulumi.get(self, "volumetype")


@pulumi.output_type
class GetFlaovrsFlavorElasticVolumeSpecResult(dict):
    def __init__(__self__, *,
                 max_size: int,
                 min_size: int,
                 step: int):
        """
        :param int max_size: Maximum disk size.
        :param int min_size: Minimum disk size.
        :param int step: Disk size increment step.
        """
        pulumi.set(__self__, "max_size", max_size)
        pulumi.set(__self__, "min_size", min_size)
        pulumi.set(__self__, "step", step)

    @property
    @pulumi.getter(name="maxSize")
    def max_size(self) -> int:
        """
        Maximum disk size.
        """
        return pulumi.get(self, "max_size")

    @property
    @pulumi.getter(name="minSize")
    def min_size(self) -> int:
        """
        Minimum disk size.
        """
        return pulumi.get(self, "min_size")

    @property
    @pulumi.getter
    def step(self) -> int:
        """
        Disk size increment step.
        """
        return pulumi.get(self, "step")


