# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetServergroupsResult',
    'AwaitableGetServergroupsResult',
    'get_servergroups',
    'get_servergroups_output',
]

@pulumi.output_type
class GetServergroupsResult:
    """
    A collection of values returned by getServergroups.
    """
    def __init__(__self__, id=None, name=None, region=None, servergroups=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if servergroups and not isinstance(servergroups, list):
            raise TypeError("Expected argument 'servergroups' to be a list")
        pulumi.set(__self__, "servergroups", servergroups)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The server group name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def region(self) -> Optional[str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def servergroups(self) -> Sequence['outputs.GetServergroupsServergroupResult']:
        """
        List of ECS server groups details. The object structure of each server group is documented below.
        """
        return pulumi.get(self, "servergroups")


class AwaitableGetServergroupsResult(GetServergroupsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetServergroupsResult(
            id=self.id,
            name=self.name,
            region=self.region,
            servergroups=self.servergroups)


def get_servergroups(name: Optional[str] = None,
                     region: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetServergroupsResult:
    """
    Use this data source to get the list of the compute server groups.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    name = config.require_object("name")
    test = huaweicloud.Ecs.get_servergroups(name=name)
    ```


    :param str name: Specifies the server group name.
    :param str region: Specifies the region in which to obtain the server groups.
           If omitted, the provider-level region will be used.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Ecs/getServergroups:getServergroups', __args__, opts=opts, typ=GetServergroupsResult).value

    return AwaitableGetServergroupsResult(
        id=__ret__.id,
        name=__ret__.name,
        region=__ret__.region,
        servergroups=__ret__.servergroups)


@_utilities.lift_output_func(get_servergroups)
def get_servergroups_output(name: Optional[pulumi.Input[Optional[str]]] = None,
                            region: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetServergroupsResult]:
    """
    Use this data source to get the list of the compute server groups.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    name = config.require_object("name")
    test = huaweicloud.Ecs.get_servergroups(name=name)
    ```


    :param str name: Specifies the server group name.
    :param str region: Specifies the region in which to obtain the server groups.
           If omitted, the provider-level region will be used.
    """
    ...
