# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['InstanceArgs', 'Instance']

@pulumi.input_type
class InstanceArgs:
    def __init__(__self__, *,
                 networks: pulumi.Input[Sequence[pulumi.Input['InstanceNetworkArgs']]],
                 admin_pass: Optional[pulumi.Input[str]] = None,
                 agency_name: Optional[pulumi.Input[str]] = None,
                 agent_list: Optional[pulumi.Input[str]] = None,
                 auto_pay: Optional[pulumi.Input[str]] = None,
                 auto_renew: Optional[pulumi.Input[str]] = None,
                 auto_terminate_time: Optional[pulumi.Input[str]] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 bandwidth: Optional[pulumi.Input['InstanceBandwidthArgs']] = None,
                 charging_mode: Optional[pulumi.Input[str]] = None,
                 data_disks: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceDataDiskArgs']]]] = None,
                 delete_disks_on_termination: Optional[pulumi.Input[bool]] = None,
                 delete_eip_on_termination: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 eip_id: Optional[pulumi.Input[str]] = None,
                 eip_type: Optional[pulumi.Input[str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[str]] = None,
                 flavor_id: Optional[pulumi.Input[str]] = None,
                 flavor_name: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image_id: Optional[pulumi.Input[str]] = None,
                 image_name: Optional[pulumi.Input[str]] = None,
                 key_pair: Optional[pulumi.Input[str]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 period_unit: Optional[pulumi.Input[str]] = None,
                 power_action: Optional[pulumi.Input[str]] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 scheduler_hints: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceSchedulerHintArgs']]]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 spot_duration: Optional[pulumi.Input[int]] = None,
                 spot_duration_count: Optional[pulumi.Input[int]] = None,
                 spot_maximum_price: Optional[pulumi.Input[str]] = None,
                 stop_before_destroy: Optional[pulumi.Input[bool]] = None,
                 system_disk_dss_pool_id: Optional[pulumi.Input[str]] = None,
                 system_disk_iops: Optional[pulumi.Input[int]] = None,
                 system_disk_kms_key_id: Optional[pulumi.Input[str]] = None,
                 system_disk_size: Optional[pulumi.Input[int]] = None,
                 system_disk_throughput: Optional[pulumi.Input[int]] = None,
                 system_disk_type: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 user_data: Optional[pulumi.Input[str]] = None,
                 user_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Instance resource.
        :param pulumi.Input[Sequence[pulumi.Input['InstanceNetworkArgs']]] networks: Specifies an array of one or more networks to attach to the instance. The
               network object structure is documented below. Changing this creates a new instance.
        :param pulumi.Input[str] admin_pass: Specifies the administrative password to assign to the instance.
        :param pulumi.Input[str] agency_name: Specifies the IAM agency name which is created on IAM to provide
               temporary credentials for ECS to access cloud services.
        :param pulumi.Input[str] agent_list: Specifies the agent list in comma-separated string.
               Available agents are:
               + `ces`: enable cloud eye monitoring.
               + `hss`: enable host security basic.
               + `hss,hss-ent`: enable host security enterprise edition.
        :param pulumi.Input[str] auto_renew: Specifies whether auto renew is enabled.
               Valid values are *true* and *false*. Defaults to *false*.
        :param pulumi.Input[str] auto_terminate_time: Specifies the auto terminate time.
               The value is in the format of "yyyy-MM-ddTHH:mm:ssZ" in UTC+0 and complies with ISO8601.
               If the value of second (ss) is not "00", the system automatically sets to the current value of minute (mm).
               The auto terminate time must be at least half an hour later than the current time.
               The auto terminate time cannot be three years later than the current time.
               For example, set the value to "2024-09-25T12:05:00Z".
        :param pulumi.Input[str] availability_zone: Specifies the availability zone in which to create the instance.
               Please following [reference](https://developer.huaweicloud.com/intl/en-us/endpoint/?ECS)
               for the values. Changing this creates a new instance.
        :param pulumi.Input['InstanceBandwidthArgs'] bandwidth: Specifies the bandwidth of an EIP that will be automatically assigned to the instance.
               The object structure is documented below. Changing this creates a new instance.
        :param pulumi.Input[str] charging_mode: Specifies the charging mode of the instance. Valid values are *prePaid*,
               *postPaid* and *spot*, defaults to *postPaid*. Changing this creates a new instance.
        :param pulumi.Input[Sequence[pulumi.Input['InstanceDataDiskArgs']]] data_disks: Specifies an array of one or more data disks to attach to the instance.
               The data_disks object structure is documented below. Changing this creates a new instance.
        :param pulumi.Input[bool] delete_disks_on_termination: Specifies whether to delete the data disks when the instance is terminated.
               Defaults to *false*. This parameter is valid if `charging_mode` is set to *postPaid*, and all data disks will be deleted
               in *prePaid* charging mode.
        :param pulumi.Input[bool] delete_eip_on_termination: Specifies whether the EIP is released when the instance is terminated.
               Defaults to *true*.
        :param pulumi.Input[str] description: Specifies the description of the instance. The description consists of 0 to 85
               characters, and can't contain '<' or '>'.
        :param pulumi.Input[str] eip_id: Specifies the ID of an *existing* EIP assigned to the instance.
               This parameter and `eip_type`, `bandwidth` are alternative. Changing this creates a new instance.
        :param pulumi.Input[str] eip_type: Specifies the type of an EIP that will be automatically assigned to the instance.
               Available values are *5_bgp* (dynamic BGP) and *5_sbgp* (static BGP). Changing this creates a new instance.
        :param pulumi.Input[str] enterprise_project_id: Specifies a unique id in UUID format of enterprise project.
        :param pulumi.Input[str] flavor_id: Specifies the flavor ID of the instance to be created.
        :param pulumi.Input[str] flavor_name: The flavor name of the instance.
        :param pulumi.Input[str] hostname: The hostname of the instance.
        :param pulumi.Input[str] image_id: Required if `image_name` is empty. Specifies the image ID of the desired
               image for the instance. Changing this creates a new instance.
        :param pulumi.Input[str] image_name: Required if `image_id` is empty. Specifies the name of the desired image
               for the instance. Changing this creates a new instance.
        :param pulumi.Input[str] key_pair: Specifies the SSH keypair name used for logging in to the instance.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] metadata: Specifies the user-defined metadata key-value pair.
        :param pulumi.Input[str] name: Specifies a unique name for the instance. The name consists of 1 to 64 characters,
               including letters, digits, underscores (_), hyphens (-), and periods (.).
        :param pulumi.Input[int] period: Specifies the charging period of the instance.
               If `period_unit` is set to *month* , the value ranges from 1 to 9. If `period_unit` is set to *year*, the value
               ranges from 1 to 3. This parameter is mandatory if `charging_mode` is set to *prePaid*. Changing this creates a
               new resource.
        :param pulumi.Input[str] period_unit: Specifies the charging period unit of the instance.
               Valid values are *month* and *year*. This parameter is mandatory if `charging_mode` is set to *prePaid*.
               Changing this creates a new instance.
        :param pulumi.Input[str] power_action: Specifies the power action to be done for the instance.
               The valid values are *ON*, *OFF*, *REBOOT*, *FORCE-OFF* and *FORCE-REBOOT*.
        :param pulumi.Input[str] private_key: Specifies the the private key of the keypair in use. This parameter is mandatory
               when replacing or unbinding a keypair and the instance is in **Running** state.
        :param pulumi.Input[str] region: Specifies the region in which to create the instance.
               If omitted, the provider-level region will be used. Changing this creates a new instance.
        :param pulumi.Input[Sequence[pulumi.Input['InstanceSchedulerHintArgs']]] scheduler_hints: Specifies the scheduler with hints on how the instance should be launched. The
               available hints are described below.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: Specifies an array of one or more security group IDs to associate with the
               instance.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups: An array of one or more security groups to associate with the instance.
        :param pulumi.Input[int] spot_duration: Specifies the service duration of the spot ECS in hours.  
               The valid value is range from `1` to `6`.
               This parameter takes effect only when `charging_mode` is set to *spot*.
               Changing this creates a new instance.
        :param pulumi.Input[int] spot_duration_count: Specifies the number of time periods in the service duration.
               This parameter takes effect only when `charging_mode` is set to *spot* and the default value is 1.
               Changing this creates a new instance.
        :param pulumi.Input[str] spot_maximum_price: Specifies the highest price per hour you accept for a spot ECS.
               This parameter takes effect only when `charging_mode` is set to *spot*. If the price is not specified,
               the pay-per-use price is used by default. Changing this creates a new instance.
        :param pulumi.Input[bool] stop_before_destroy: Specifies whether to try stop instance gracefully before destroying it, thus giving
               chance for guest OS daemons to stop correctly. If instance doesn't stop within timeout, it will be destroyed anyway.
        :param pulumi.Input[str] system_disk_dss_pool_id: Specifies the system disk DSS pool ID. This field is used
               only for dedicated storage. Changing this parameter will create a new resource.
        :param pulumi.Input[int] system_disk_iops: Specifies the IOPS(Input/Output Operations Per Second) for the disk.
               The field is valid and required when `system_disk_type` is set to **GPSSD2** or **ESSD2**.
        :param pulumi.Input[str] system_disk_kms_key_id: Specifies the ID of a KMS key used to encrypt the system disk.
               Changing this creates a new instance.
        :param pulumi.Input[int] system_disk_size: Specifies the system disk size in GB, The value range is 1 to 1024.
               Shrinking the disk is not supported.
        :param pulumi.Input[int] system_disk_throughput: Specifies the throughput for the disk. The Unit is MiB/s.
               The field is valid and required when `system_disk_type` is set to **GPSSD2**.
        :param pulumi.Input[str] system_disk_type: Specifies the system disk type of the instance. Defaults to `GPSSD`.
               Changing this creates a new instance.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Specifies the key/value pairs to associate with the instance.
        :param pulumi.Input[str] user_data: Specifies the user data to be injected to the instance during the creation. Text
               and text files can be injected. The content of `user_data` can be plaint text or encoded with base64.
        :param pulumi.Input[str] user_id: Specifies a user ID, required when using key_pair in prePaid charging mode.
               Changing this creates a new instance.
        """
        pulumi.set(__self__, "networks", networks)
        if admin_pass is not None:
            pulumi.set(__self__, "admin_pass", admin_pass)
        if agency_name is not None:
            pulumi.set(__self__, "agency_name", agency_name)
        if agent_list is not None:
            pulumi.set(__self__, "agent_list", agent_list)
        if auto_pay is not None:
            warnings.warn("""Deprecated""", DeprecationWarning)
            pulumi.log.warn("""auto_pay is deprecated: Deprecated""")
        if auto_pay is not None:
            pulumi.set(__self__, "auto_pay", auto_pay)
        if auto_renew is not None:
            pulumi.set(__self__, "auto_renew", auto_renew)
        if auto_terminate_time is not None:
            pulumi.set(__self__, "auto_terminate_time", auto_terminate_time)
        if availability_zone is not None:
            pulumi.set(__self__, "availability_zone", availability_zone)
        if bandwidth is not None:
            pulumi.set(__self__, "bandwidth", bandwidth)
        if charging_mode is not None:
            pulumi.set(__self__, "charging_mode", charging_mode)
        if data_disks is not None:
            pulumi.set(__self__, "data_disks", data_disks)
        if delete_disks_on_termination is not None:
            pulumi.set(__self__, "delete_disks_on_termination", delete_disks_on_termination)
        if delete_eip_on_termination is not None:
            pulumi.set(__self__, "delete_eip_on_termination", delete_eip_on_termination)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if eip_id is not None:
            pulumi.set(__self__, "eip_id", eip_id)
        if eip_type is not None:
            pulumi.set(__self__, "eip_type", eip_type)
        if enterprise_project_id is not None:
            pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if flavor_id is not None:
            pulumi.set(__self__, "flavor_id", flavor_id)
        if flavor_name is not None:
            pulumi.set(__self__, "flavor_name", flavor_name)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if image_id is not None:
            pulumi.set(__self__, "image_id", image_id)
        if image_name is not None:
            pulumi.set(__self__, "image_name", image_name)
        if key_pair is not None:
            pulumi.set(__self__, "key_pair", key_pair)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if period is not None:
            pulumi.set(__self__, "period", period)
        if period_unit is not None:
            pulumi.set(__self__, "period_unit", period_unit)
        if power_action is not None:
            pulumi.set(__self__, "power_action", power_action)
        if private_key is not None:
            pulumi.set(__self__, "private_key", private_key)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if scheduler_hints is not None:
            pulumi.set(__self__, "scheduler_hints", scheduler_hints)
        if security_group_ids is not None:
            pulumi.set(__self__, "security_group_ids", security_group_ids)
        if security_groups is not None:
            pulumi.set(__self__, "security_groups", security_groups)
        if spot_duration is not None:
            pulumi.set(__self__, "spot_duration", spot_duration)
        if spot_duration_count is not None:
            pulumi.set(__self__, "spot_duration_count", spot_duration_count)
        if spot_maximum_price is not None:
            pulumi.set(__self__, "spot_maximum_price", spot_maximum_price)
        if stop_before_destroy is not None:
            pulumi.set(__self__, "stop_before_destroy", stop_before_destroy)
        if system_disk_dss_pool_id is not None:
            pulumi.set(__self__, "system_disk_dss_pool_id", system_disk_dss_pool_id)
        if system_disk_iops is not None:
            pulumi.set(__self__, "system_disk_iops", system_disk_iops)
        if system_disk_kms_key_id is not None:
            pulumi.set(__self__, "system_disk_kms_key_id", system_disk_kms_key_id)
        if system_disk_size is not None:
            pulumi.set(__self__, "system_disk_size", system_disk_size)
        if system_disk_throughput is not None:
            pulumi.set(__self__, "system_disk_throughput", system_disk_throughput)
        if system_disk_type is not None:
            pulumi.set(__self__, "system_disk_type", system_disk_type)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if user_data is not None:
            pulumi.set(__self__, "user_data", user_data)
        if user_id is not None:
            pulumi.set(__self__, "user_id", user_id)

    @property
    @pulumi.getter
    def networks(self) -> pulumi.Input[Sequence[pulumi.Input['InstanceNetworkArgs']]]:
        """
        Specifies an array of one or more networks to attach to the instance. The
        network object structure is documented below. Changing this creates a new instance.
        """
        return pulumi.get(self, "networks")

    @networks.setter
    def networks(self, value: pulumi.Input[Sequence[pulumi.Input['InstanceNetworkArgs']]]):
        pulumi.set(self, "networks", value)

    @property
    @pulumi.getter(name="adminPass")
    def admin_pass(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the administrative password to assign to the instance.
        """
        return pulumi.get(self, "admin_pass")

    @admin_pass.setter
    def admin_pass(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "admin_pass", value)

    @property
    @pulumi.getter(name="agencyName")
    def agency_name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the IAM agency name which is created on IAM to provide
        temporary credentials for ECS to access cloud services.
        """
        return pulumi.get(self, "agency_name")

    @agency_name.setter
    def agency_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "agency_name", value)

    @property
    @pulumi.getter(name="agentList")
    def agent_list(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the agent list in comma-separated string.
        Available agents are:
        + `ces`: enable cloud eye monitoring.
        + `hss`: enable host security basic.
        + `hss,hss-ent`: enable host security enterprise edition.
        """
        return pulumi.get(self, "agent_list")

    @agent_list.setter
    def agent_list(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "agent_list", value)

    @property
    @pulumi.getter(name="autoPay")
    def auto_pay(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "auto_pay")

    @auto_pay.setter
    def auto_pay(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "auto_pay", value)

    @property
    @pulumi.getter(name="autoRenew")
    def auto_renew(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies whether auto renew is enabled.
        Valid values are *true* and *false*. Defaults to *false*.
        """
        return pulumi.get(self, "auto_renew")

    @auto_renew.setter
    def auto_renew(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "auto_renew", value)

    @property
    @pulumi.getter(name="autoTerminateTime")
    def auto_terminate_time(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the auto terminate time.
        The value is in the format of "yyyy-MM-ddTHH:mm:ssZ" in UTC+0 and complies with ISO8601.
        If the value of second (ss) is not "00", the system automatically sets to the current value of minute (mm).
        The auto terminate time must be at least half an hour later than the current time.
        The auto terminate time cannot be three years later than the current time.
        For example, set the value to "2024-09-25T12:05:00Z".
        """
        return pulumi.get(self, "auto_terminate_time")

    @auto_terminate_time.setter
    def auto_terminate_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "auto_terminate_time", value)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the availability zone in which to create the instance.
        Please following [reference](https://developer.huaweicloud.com/intl/en-us/endpoint/?ECS)
        for the values. Changing this creates a new instance.
        """
        return pulumi.get(self, "availability_zone")

    @availability_zone.setter
    def availability_zone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_zone", value)

    @property
    @pulumi.getter
    def bandwidth(self) -> Optional[pulumi.Input['InstanceBandwidthArgs']]:
        """
        Specifies the bandwidth of an EIP that will be automatically assigned to the instance.
        The object structure is documented below. Changing this creates a new instance.
        """
        return pulumi.get(self, "bandwidth")

    @bandwidth.setter
    def bandwidth(self, value: Optional[pulumi.Input['InstanceBandwidthArgs']]):
        pulumi.set(self, "bandwidth", value)

    @property
    @pulumi.getter(name="chargingMode")
    def charging_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the charging mode of the instance. Valid values are *prePaid*,
        *postPaid* and *spot*, defaults to *postPaid*. Changing this creates a new instance.
        """
        return pulumi.get(self, "charging_mode")

    @charging_mode.setter
    def charging_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "charging_mode", value)

    @property
    @pulumi.getter(name="dataDisks")
    def data_disks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InstanceDataDiskArgs']]]]:
        """
        Specifies an array of one or more data disks to attach to the instance.
        The data_disks object structure is documented below. Changing this creates a new instance.
        """
        return pulumi.get(self, "data_disks")

    @data_disks.setter
    def data_disks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceDataDiskArgs']]]]):
        pulumi.set(self, "data_disks", value)

    @property
    @pulumi.getter(name="deleteDisksOnTermination")
    def delete_disks_on_termination(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether to delete the data disks when the instance is terminated.
        Defaults to *false*. This parameter is valid if `charging_mode` is set to *postPaid*, and all data disks will be deleted
        in *prePaid* charging mode.
        """
        return pulumi.get(self, "delete_disks_on_termination")

    @delete_disks_on_termination.setter
    def delete_disks_on_termination(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "delete_disks_on_termination", value)

    @property
    @pulumi.getter(name="deleteEipOnTermination")
    def delete_eip_on_termination(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether the EIP is released when the instance is terminated.
        Defaults to *true*.
        """
        return pulumi.get(self, "delete_eip_on_termination")

    @delete_eip_on_termination.setter
    def delete_eip_on_termination(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "delete_eip_on_termination", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the description of the instance. The description consists of 0 to 85
        characters, and can't contain '<' or '>'.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="eipId")
    def eip_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the ID of an *existing* EIP assigned to the instance.
        This parameter and `eip_type`, `bandwidth` are alternative. Changing this creates a new instance.
        """
        return pulumi.get(self, "eip_id")

    @eip_id.setter
    def eip_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "eip_id", value)

    @property
    @pulumi.getter(name="eipType")
    def eip_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the type of an EIP that will be automatically assigned to the instance.
        Available values are *5_bgp* (dynamic BGP) and *5_sbgp* (static BGP). Changing this creates a new instance.
        """
        return pulumi.get(self, "eip_type")

    @eip_type.setter
    def eip_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "eip_type", value)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies a unique id in UUID format of enterprise project.
        """
        return pulumi.get(self, "enterprise_project_id")

    @enterprise_project_id.setter
    def enterprise_project_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enterprise_project_id", value)

    @property
    @pulumi.getter(name="flavorId")
    def flavor_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the flavor ID of the instance to be created.
        """
        return pulumi.get(self, "flavor_id")

    @flavor_id.setter
    def flavor_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "flavor_id", value)

    @property
    @pulumi.getter(name="flavorName")
    def flavor_name(self) -> Optional[pulumi.Input[str]]:
        """
        The flavor name of the instance.
        """
        return pulumi.get(self, "flavor_name")

    @flavor_name.setter
    def flavor_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "flavor_name", value)

    @property
    @pulumi.getter
    def hostname(self) -> Optional[pulumi.Input[str]]:
        """
        The hostname of the instance.
        """
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter(name="imageId")
    def image_id(self) -> Optional[pulumi.Input[str]]:
        """
        Required if `image_name` is empty. Specifies the image ID of the desired
        image for the instance. Changing this creates a new instance.
        """
        return pulumi.get(self, "image_id")

    @image_id.setter
    def image_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_id", value)

    @property
    @pulumi.getter(name="imageName")
    def image_name(self) -> Optional[pulumi.Input[str]]:
        """
        Required if `image_id` is empty. Specifies the name of the desired image
        for the instance. Changing this creates a new instance.
        """
        return pulumi.get(self, "image_name")

    @image_name.setter
    def image_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_name", value)

    @property
    @pulumi.getter(name="keyPair")
    def key_pair(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the SSH keypair name used for logging in to the instance.
        """
        return pulumi.get(self, "key_pair")

    @key_pair.setter
    def key_pair(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "key_pair", value)

    @property
    @pulumi.getter
    def metadata(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Specifies the user-defined metadata key-value pair.
        """
        return pulumi.get(self, "metadata")

    @metadata.setter
    def metadata(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "metadata", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies a unique name for the instance. The name consists of 1 to 64 characters,
        including letters, digits, underscores (_), hyphens (-), and periods (.).
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def period(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the charging period of the instance.
        If `period_unit` is set to *month* , the value ranges from 1 to 9. If `period_unit` is set to *year*, the value
        ranges from 1 to 3. This parameter is mandatory if `charging_mode` is set to *prePaid*. Changing this creates a
        new resource.
        """
        return pulumi.get(self, "period")

    @period.setter
    def period(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "period", value)

    @property
    @pulumi.getter(name="periodUnit")
    def period_unit(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the charging period unit of the instance.
        Valid values are *month* and *year*. This parameter is mandatory if `charging_mode` is set to *prePaid*.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "period_unit")

    @period_unit.setter
    def period_unit(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "period_unit", value)

    @property
    @pulumi.getter(name="powerAction")
    def power_action(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the power action to be done for the instance.
        The valid values are *ON*, *OFF*, *REBOOT*, *FORCE-OFF* and *FORCE-REBOOT*.
        """
        return pulumi.get(self, "power_action")

    @power_action.setter
    def power_action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "power_action", value)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the the private key of the keypair in use. This parameter is mandatory
        when replacing or unbinding a keypair and the instance is in **Running** state.
        """
        return pulumi.get(self, "private_key")

    @private_key.setter
    def private_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "private_key", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to create the instance.
        If omitted, the provider-level region will be used. Changing this creates a new instance.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="schedulerHints")
    def scheduler_hints(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InstanceSchedulerHintArgs']]]]:
        """
        Specifies the scheduler with hints on how the instance should be launched. The
        available hints are described below.
        """
        return pulumi.get(self, "scheduler_hints")

    @scheduler_hints.setter
    def scheduler_hints(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceSchedulerHintArgs']]]]):
        pulumi.set(self, "scheduler_hints", value)

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Specifies an array of one or more security group IDs to associate with the
        instance.
        """
        return pulumi.get(self, "security_group_ids")

    @security_group_ids.setter
    def security_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_group_ids", value)

    @property
    @pulumi.getter(name="securityGroups")
    def security_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        An array of one or more security groups to associate with the instance.
        """
        return pulumi.get(self, "security_groups")

    @security_groups.setter
    def security_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_groups", value)

    @property
    @pulumi.getter(name="spotDuration")
    def spot_duration(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the service duration of the spot ECS in hours.  
        The valid value is range from `1` to `6`.
        This parameter takes effect only when `charging_mode` is set to *spot*.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "spot_duration")

    @spot_duration.setter
    def spot_duration(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "spot_duration", value)

    @property
    @pulumi.getter(name="spotDurationCount")
    def spot_duration_count(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the number of time periods in the service duration.
        This parameter takes effect only when `charging_mode` is set to *spot* and the default value is 1.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "spot_duration_count")

    @spot_duration_count.setter
    def spot_duration_count(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "spot_duration_count", value)

    @property
    @pulumi.getter(name="spotMaximumPrice")
    def spot_maximum_price(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the highest price per hour you accept for a spot ECS.
        This parameter takes effect only when `charging_mode` is set to *spot*. If the price is not specified,
        the pay-per-use price is used by default. Changing this creates a new instance.
        """
        return pulumi.get(self, "spot_maximum_price")

    @spot_maximum_price.setter
    def spot_maximum_price(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "spot_maximum_price", value)

    @property
    @pulumi.getter(name="stopBeforeDestroy")
    def stop_before_destroy(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether to try stop instance gracefully before destroying it, thus giving
        chance for guest OS daemons to stop correctly. If instance doesn't stop within timeout, it will be destroyed anyway.
        """
        return pulumi.get(self, "stop_before_destroy")

    @stop_before_destroy.setter
    def stop_before_destroy(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "stop_before_destroy", value)

    @property
    @pulumi.getter(name="systemDiskDssPoolId")
    def system_disk_dss_pool_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the system disk DSS pool ID. This field is used
        only for dedicated storage. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "system_disk_dss_pool_id")

    @system_disk_dss_pool_id.setter
    def system_disk_dss_pool_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "system_disk_dss_pool_id", value)

    @property
    @pulumi.getter(name="systemDiskIops")
    def system_disk_iops(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the IOPS(Input/Output Operations Per Second) for the disk.
        The field is valid and required when `system_disk_type` is set to **GPSSD2** or **ESSD2**.
        """
        return pulumi.get(self, "system_disk_iops")

    @system_disk_iops.setter
    def system_disk_iops(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "system_disk_iops", value)

    @property
    @pulumi.getter(name="systemDiskKmsKeyId")
    def system_disk_kms_key_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the ID of a KMS key used to encrypt the system disk.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "system_disk_kms_key_id")

    @system_disk_kms_key_id.setter
    def system_disk_kms_key_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "system_disk_kms_key_id", value)

    @property
    @pulumi.getter(name="systemDiskSize")
    def system_disk_size(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the system disk size in GB, The value range is 1 to 1024.
        Shrinking the disk is not supported.
        """
        return pulumi.get(self, "system_disk_size")

    @system_disk_size.setter
    def system_disk_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "system_disk_size", value)

    @property
    @pulumi.getter(name="systemDiskThroughput")
    def system_disk_throughput(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the throughput for the disk. The Unit is MiB/s.
        The field is valid and required when `system_disk_type` is set to **GPSSD2**.
        """
        return pulumi.get(self, "system_disk_throughput")

    @system_disk_throughput.setter
    def system_disk_throughput(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "system_disk_throughput", value)

    @property
    @pulumi.getter(name="systemDiskType")
    def system_disk_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the system disk type of the instance. Defaults to `GPSSD`.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "system_disk_type")

    @system_disk_type.setter
    def system_disk_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "system_disk_type", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Specifies the key/value pairs to associate with the instance.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="userData")
    def user_data(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the user data to be injected to the instance during the creation. Text
        and text files can be injected. The content of `user_data` can be plaint text or encoded with base64.
        """
        return pulumi.get(self, "user_data")

    @user_data.setter
    def user_data(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_data", value)

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies a user ID, required when using key_pair in prePaid charging mode.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "user_id")

    @user_id.setter
    def user_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_id", value)


@pulumi.input_type
class _InstanceState:
    def __init__(__self__, *,
                 access_ip_v4: Optional[pulumi.Input[str]] = None,
                 access_ip_v6: Optional[pulumi.Input[str]] = None,
                 admin_pass: Optional[pulumi.Input[str]] = None,
                 agency_name: Optional[pulumi.Input[str]] = None,
                 agent_list: Optional[pulumi.Input[str]] = None,
                 auto_pay: Optional[pulumi.Input[str]] = None,
                 auto_renew: Optional[pulumi.Input[str]] = None,
                 auto_terminate_time: Optional[pulumi.Input[str]] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 bandwidth: Optional[pulumi.Input['InstanceBandwidthArgs']] = None,
                 charging_mode: Optional[pulumi.Input[str]] = None,
                 created_at: Optional[pulumi.Input[str]] = None,
                 data_disks: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceDataDiskArgs']]]] = None,
                 delete_disks_on_termination: Optional[pulumi.Input[bool]] = None,
                 delete_eip_on_termination: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 eip_id: Optional[pulumi.Input[str]] = None,
                 eip_type: Optional[pulumi.Input[str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[str]] = None,
                 expired_time: Optional[pulumi.Input[str]] = None,
                 flavor_id: Optional[pulumi.Input[str]] = None,
                 flavor_name: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image_id: Optional[pulumi.Input[str]] = None,
                 image_name: Optional[pulumi.Input[str]] = None,
                 key_pair: Optional[pulumi.Input[str]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 networks: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceNetworkArgs']]]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 period_unit: Optional[pulumi.Input[str]] = None,
                 power_action: Optional[pulumi.Input[str]] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 public_ip: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 scheduler_hints: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceSchedulerHintArgs']]]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 spot_duration: Optional[pulumi.Input[int]] = None,
                 spot_duration_count: Optional[pulumi.Input[int]] = None,
                 spot_maximum_price: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 stop_before_destroy: Optional[pulumi.Input[bool]] = None,
                 system_disk_dss_pool_id: Optional[pulumi.Input[str]] = None,
                 system_disk_id: Optional[pulumi.Input[str]] = None,
                 system_disk_iops: Optional[pulumi.Input[int]] = None,
                 system_disk_kms_key_id: Optional[pulumi.Input[str]] = None,
                 system_disk_size: Optional[pulumi.Input[int]] = None,
                 system_disk_throughput: Optional[pulumi.Input[int]] = None,
                 system_disk_type: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 updated_at: Optional[pulumi.Input[str]] = None,
                 user_data: Optional[pulumi.Input[str]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 volume_attacheds: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceVolumeAttachedArgs']]]] = None):
        """
        Input properties used for looking up and filtering Instance resources.
        :param pulumi.Input[str] access_ip_v4: The first detected Fixed IPv4 address or the Floating IP.
        :param pulumi.Input[str] access_ip_v6: The first detected Fixed IPv6 address.
        :param pulumi.Input[str] admin_pass: Specifies the administrative password to assign to the instance.
        :param pulumi.Input[str] agency_name: Specifies the IAM agency name which is created on IAM to provide
               temporary credentials for ECS to access cloud services.
        :param pulumi.Input[str] agent_list: Specifies the agent list in comma-separated string.
               Available agents are:
               + `ces`: enable cloud eye monitoring.
               + `hss`: enable host security basic.
               + `hss,hss-ent`: enable host security enterprise edition.
        :param pulumi.Input[str] auto_renew: Specifies whether auto renew is enabled.
               Valid values are *true* and *false*. Defaults to *false*.
        :param pulumi.Input[str] auto_terminate_time: Specifies the auto terminate time.
               The value is in the format of "yyyy-MM-ddTHH:mm:ssZ" in UTC+0 and complies with ISO8601.
               If the value of second (ss) is not "00", the system automatically sets to the current value of minute (mm).
               The auto terminate time must be at least half an hour later than the current time.
               The auto terminate time cannot be three years later than the current time.
               For example, set the value to "2024-09-25T12:05:00Z".
        :param pulumi.Input[str] availability_zone: Specifies the availability zone in which to create the instance.
               Please following [reference](https://developer.huaweicloud.com/intl/en-us/endpoint/?ECS)
               for the values. Changing this creates a new instance.
        :param pulumi.Input['InstanceBandwidthArgs'] bandwidth: Specifies the bandwidth of an EIP that will be automatically assigned to the instance.
               The object structure is documented below. Changing this creates a new instance.
        :param pulumi.Input[str] charging_mode: Specifies the charging mode of the instance. Valid values are *prePaid*,
               *postPaid* and *spot*, defaults to *postPaid*. Changing this creates a new instance.
        :param pulumi.Input[str] created_at: The creation time, in UTC format.
        :param pulumi.Input[Sequence[pulumi.Input['InstanceDataDiskArgs']]] data_disks: Specifies an array of one or more data disks to attach to the instance.
               The data_disks object structure is documented below. Changing this creates a new instance.
        :param pulumi.Input[bool] delete_disks_on_termination: Specifies whether to delete the data disks when the instance is terminated.
               Defaults to *false*. This parameter is valid if `charging_mode` is set to *postPaid*, and all data disks will be deleted
               in *prePaid* charging mode.
        :param pulumi.Input[bool] delete_eip_on_termination: Specifies whether the EIP is released when the instance is terminated.
               Defaults to *true*.
        :param pulumi.Input[str] description: Specifies the description of the instance. The description consists of 0 to 85
               characters, and can't contain '<' or '>'.
        :param pulumi.Input[str] eip_id: Specifies the ID of an *existing* EIP assigned to the instance.
               This parameter and `eip_type`, `bandwidth` are alternative. Changing this creates a new instance.
        :param pulumi.Input[str] eip_type: Specifies the type of an EIP that will be automatically assigned to the instance.
               Available values are *5_bgp* (dynamic BGP) and *5_sbgp* (static BGP). Changing this creates a new instance.
        :param pulumi.Input[str] enterprise_project_id: Specifies a unique id in UUID format of enterprise project.
        :param pulumi.Input[str] expired_time: The expired time of prePaid instance, in UTC format.
        :param pulumi.Input[str] flavor_id: Specifies the flavor ID of the instance to be created.
        :param pulumi.Input[str] flavor_name: The flavor name of the instance.
        :param pulumi.Input[str] hostname: The hostname of the instance.
        :param pulumi.Input[str] image_id: Required if `image_name` is empty. Specifies the image ID of the desired
               image for the instance. Changing this creates a new instance.
        :param pulumi.Input[str] image_name: Required if `image_id` is empty. Specifies the name of the desired image
               for the instance. Changing this creates a new instance.
        :param pulumi.Input[str] key_pair: Specifies the SSH keypair name used for logging in to the instance.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] metadata: Specifies the user-defined metadata key-value pair.
        :param pulumi.Input[str] name: Specifies a unique name for the instance. The name consists of 1 to 64 characters,
               including letters, digits, underscores (_), hyphens (-), and periods (.).
        :param pulumi.Input[Sequence[pulumi.Input['InstanceNetworkArgs']]] networks: Specifies an array of one or more networks to attach to the instance. The
               network object structure is documented below. Changing this creates a new instance.
        :param pulumi.Input[int] period: Specifies the charging period of the instance.
               If `period_unit` is set to *month* , the value ranges from 1 to 9. If `period_unit` is set to *year*, the value
               ranges from 1 to 3. This parameter is mandatory if `charging_mode` is set to *prePaid*. Changing this creates a
               new resource.
        :param pulumi.Input[str] period_unit: Specifies the charging period unit of the instance.
               Valid values are *month* and *year*. This parameter is mandatory if `charging_mode` is set to *prePaid*.
               Changing this creates a new instance.
        :param pulumi.Input[str] power_action: Specifies the power action to be done for the instance.
               The valid values are *ON*, *OFF*, *REBOOT*, *FORCE-OFF* and *FORCE-REBOOT*.
        :param pulumi.Input[str] private_key: Specifies the the private key of the keypair in use. This parameter is mandatory
               when replacing or unbinding a keypair and the instance is in **Running** state.
        :param pulumi.Input[str] public_ip: The EIP address that is associated to the instance.
        :param pulumi.Input[str] region: Specifies the region in which to create the instance.
               If omitted, the provider-level region will be used. Changing this creates a new instance.
        :param pulumi.Input[Sequence[pulumi.Input['InstanceSchedulerHintArgs']]] scheduler_hints: Specifies the scheduler with hints on how the instance should be launched. The
               available hints are described below.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: Specifies an array of one or more security group IDs to associate with the
               instance.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups: An array of one or more security groups to associate with the instance.
        :param pulumi.Input[int] spot_duration: Specifies the service duration of the spot ECS in hours.  
               The valid value is range from `1` to `6`.
               This parameter takes effect only when `charging_mode` is set to *spot*.
               Changing this creates a new instance.
        :param pulumi.Input[int] spot_duration_count: Specifies the number of time periods in the service duration.
               This parameter takes effect only when `charging_mode` is set to *spot* and the default value is 1.
               Changing this creates a new instance.
        :param pulumi.Input[str] spot_maximum_price: Specifies the highest price per hour you accept for a spot ECS.
               This parameter takes effect only when `charging_mode` is set to *spot*. If the price is not specified,
               the pay-per-use price is used by default. Changing this creates a new instance.
        :param pulumi.Input[str] status: The status of the instance.
        :param pulumi.Input[bool] stop_before_destroy: Specifies whether to try stop instance gracefully before destroying it, thus giving
               chance for guest OS daemons to stop correctly. If instance doesn't stop within timeout, it will be destroyed anyway.
        :param pulumi.Input[str] system_disk_dss_pool_id: Specifies the system disk DSS pool ID. This field is used
               only for dedicated storage. Changing this parameter will create a new resource.
        :param pulumi.Input[str] system_disk_id: The system disk volume ID.
        :param pulumi.Input[int] system_disk_iops: Specifies the IOPS(Input/Output Operations Per Second) for the disk.
               The field is valid and required when `system_disk_type` is set to **GPSSD2** or **ESSD2**.
        :param pulumi.Input[str] system_disk_kms_key_id: Specifies the ID of a KMS key used to encrypt the system disk.
               Changing this creates a new instance.
        :param pulumi.Input[int] system_disk_size: Specifies the system disk size in GB, The value range is 1 to 1024.
               Shrinking the disk is not supported.
        :param pulumi.Input[int] system_disk_throughput: Specifies the throughput for the disk. The Unit is MiB/s.
               The field is valid and required when `system_disk_type` is set to **GPSSD2**.
        :param pulumi.Input[str] system_disk_type: Specifies the system disk type of the instance. Defaults to `GPSSD`.
               Changing this creates a new instance.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Specifies the key/value pairs to associate with the instance.
        :param pulumi.Input[str] updated_at: The last update time, in UTC format.
        :param pulumi.Input[str] user_data: Specifies the user data to be injected to the instance during the creation. Text
               and text files can be injected. The content of `user_data` can be plaint text or encoded with base64.
        :param pulumi.Input[str] user_id: Specifies a user ID, required when using key_pair in prePaid charging mode.
               Changing this creates a new instance.
        :param pulumi.Input[Sequence[pulumi.Input['InstanceVolumeAttachedArgs']]] volume_attacheds: An array of one or more disks to attach to the instance.
               The volume attached object structure is documented below.
        """
        if access_ip_v4 is not None:
            pulumi.set(__self__, "access_ip_v4", access_ip_v4)
        if access_ip_v6 is not None:
            pulumi.set(__self__, "access_ip_v6", access_ip_v6)
        if admin_pass is not None:
            pulumi.set(__self__, "admin_pass", admin_pass)
        if agency_name is not None:
            pulumi.set(__self__, "agency_name", agency_name)
        if agent_list is not None:
            pulumi.set(__self__, "agent_list", agent_list)
        if auto_pay is not None:
            warnings.warn("""Deprecated""", DeprecationWarning)
            pulumi.log.warn("""auto_pay is deprecated: Deprecated""")
        if auto_pay is not None:
            pulumi.set(__self__, "auto_pay", auto_pay)
        if auto_renew is not None:
            pulumi.set(__self__, "auto_renew", auto_renew)
        if auto_terminate_time is not None:
            pulumi.set(__self__, "auto_terminate_time", auto_terminate_time)
        if availability_zone is not None:
            pulumi.set(__self__, "availability_zone", availability_zone)
        if bandwidth is not None:
            pulumi.set(__self__, "bandwidth", bandwidth)
        if charging_mode is not None:
            pulumi.set(__self__, "charging_mode", charging_mode)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if data_disks is not None:
            pulumi.set(__self__, "data_disks", data_disks)
        if delete_disks_on_termination is not None:
            pulumi.set(__self__, "delete_disks_on_termination", delete_disks_on_termination)
        if delete_eip_on_termination is not None:
            pulumi.set(__self__, "delete_eip_on_termination", delete_eip_on_termination)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if eip_id is not None:
            pulumi.set(__self__, "eip_id", eip_id)
        if eip_type is not None:
            pulumi.set(__self__, "eip_type", eip_type)
        if enterprise_project_id is not None:
            pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if expired_time is not None:
            pulumi.set(__self__, "expired_time", expired_time)
        if flavor_id is not None:
            pulumi.set(__self__, "flavor_id", flavor_id)
        if flavor_name is not None:
            pulumi.set(__self__, "flavor_name", flavor_name)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if image_id is not None:
            pulumi.set(__self__, "image_id", image_id)
        if image_name is not None:
            pulumi.set(__self__, "image_name", image_name)
        if key_pair is not None:
            pulumi.set(__self__, "key_pair", key_pair)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if networks is not None:
            pulumi.set(__self__, "networks", networks)
        if period is not None:
            pulumi.set(__self__, "period", period)
        if period_unit is not None:
            pulumi.set(__self__, "period_unit", period_unit)
        if power_action is not None:
            pulumi.set(__self__, "power_action", power_action)
        if private_key is not None:
            pulumi.set(__self__, "private_key", private_key)
        if public_ip is not None:
            pulumi.set(__self__, "public_ip", public_ip)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if scheduler_hints is not None:
            pulumi.set(__self__, "scheduler_hints", scheduler_hints)
        if security_group_ids is not None:
            pulumi.set(__self__, "security_group_ids", security_group_ids)
        if security_groups is not None:
            pulumi.set(__self__, "security_groups", security_groups)
        if spot_duration is not None:
            pulumi.set(__self__, "spot_duration", spot_duration)
        if spot_duration_count is not None:
            pulumi.set(__self__, "spot_duration_count", spot_duration_count)
        if spot_maximum_price is not None:
            pulumi.set(__self__, "spot_maximum_price", spot_maximum_price)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if stop_before_destroy is not None:
            pulumi.set(__self__, "stop_before_destroy", stop_before_destroy)
        if system_disk_dss_pool_id is not None:
            pulumi.set(__self__, "system_disk_dss_pool_id", system_disk_dss_pool_id)
        if system_disk_id is not None:
            pulumi.set(__self__, "system_disk_id", system_disk_id)
        if system_disk_iops is not None:
            pulumi.set(__self__, "system_disk_iops", system_disk_iops)
        if system_disk_kms_key_id is not None:
            pulumi.set(__self__, "system_disk_kms_key_id", system_disk_kms_key_id)
        if system_disk_size is not None:
            pulumi.set(__self__, "system_disk_size", system_disk_size)
        if system_disk_throughput is not None:
            pulumi.set(__self__, "system_disk_throughput", system_disk_throughput)
        if system_disk_type is not None:
            pulumi.set(__self__, "system_disk_type", system_disk_type)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)
        if user_data is not None:
            pulumi.set(__self__, "user_data", user_data)
        if user_id is not None:
            pulumi.set(__self__, "user_id", user_id)
        if volume_attacheds is not None:
            pulumi.set(__self__, "volume_attacheds", volume_attacheds)

    @property
    @pulumi.getter(name="accessIpV4")
    def access_ip_v4(self) -> Optional[pulumi.Input[str]]:
        """
        The first detected Fixed IPv4 address or the Floating IP.
        """
        return pulumi.get(self, "access_ip_v4")

    @access_ip_v4.setter
    def access_ip_v4(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "access_ip_v4", value)

    @property
    @pulumi.getter(name="accessIpV6")
    def access_ip_v6(self) -> Optional[pulumi.Input[str]]:
        """
        The first detected Fixed IPv6 address.
        """
        return pulumi.get(self, "access_ip_v6")

    @access_ip_v6.setter
    def access_ip_v6(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "access_ip_v6", value)

    @property
    @pulumi.getter(name="adminPass")
    def admin_pass(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the administrative password to assign to the instance.
        """
        return pulumi.get(self, "admin_pass")

    @admin_pass.setter
    def admin_pass(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "admin_pass", value)

    @property
    @pulumi.getter(name="agencyName")
    def agency_name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the IAM agency name which is created on IAM to provide
        temporary credentials for ECS to access cloud services.
        """
        return pulumi.get(self, "agency_name")

    @agency_name.setter
    def agency_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "agency_name", value)

    @property
    @pulumi.getter(name="agentList")
    def agent_list(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the agent list in comma-separated string.
        Available agents are:
        + `ces`: enable cloud eye monitoring.
        + `hss`: enable host security basic.
        + `hss,hss-ent`: enable host security enterprise edition.
        """
        return pulumi.get(self, "agent_list")

    @agent_list.setter
    def agent_list(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "agent_list", value)

    @property
    @pulumi.getter(name="autoPay")
    def auto_pay(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "auto_pay")

    @auto_pay.setter
    def auto_pay(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "auto_pay", value)

    @property
    @pulumi.getter(name="autoRenew")
    def auto_renew(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies whether auto renew is enabled.
        Valid values are *true* and *false*. Defaults to *false*.
        """
        return pulumi.get(self, "auto_renew")

    @auto_renew.setter
    def auto_renew(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "auto_renew", value)

    @property
    @pulumi.getter(name="autoTerminateTime")
    def auto_terminate_time(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the auto terminate time.
        The value is in the format of "yyyy-MM-ddTHH:mm:ssZ" in UTC+0 and complies with ISO8601.
        If the value of second (ss) is not "00", the system automatically sets to the current value of minute (mm).
        The auto terminate time must be at least half an hour later than the current time.
        The auto terminate time cannot be three years later than the current time.
        For example, set the value to "2024-09-25T12:05:00Z".
        """
        return pulumi.get(self, "auto_terminate_time")

    @auto_terminate_time.setter
    def auto_terminate_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "auto_terminate_time", value)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the availability zone in which to create the instance.
        Please following [reference](https://developer.huaweicloud.com/intl/en-us/endpoint/?ECS)
        for the values. Changing this creates a new instance.
        """
        return pulumi.get(self, "availability_zone")

    @availability_zone.setter
    def availability_zone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_zone", value)

    @property
    @pulumi.getter
    def bandwidth(self) -> Optional[pulumi.Input['InstanceBandwidthArgs']]:
        """
        Specifies the bandwidth of an EIP that will be automatically assigned to the instance.
        The object structure is documented below. Changing this creates a new instance.
        """
        return pulumi.get(self, "bandwidth")

    @bandwidth.setter
    def bandwidth(self, value: Optional[pulumi.Input['InstanceBandwidthArgs']]):
        pulumi.set(self, "bandwidth", value)

    @property
    @pulumi.getter(name="chargingMode")
    def charging_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the charging mode of the instance. Valid values are *prePaid*,
        *postPaid* and *spot*, defaults to *postPaid*. Changing this creates a new instance.
        """
        return pulumi.get(self, "charging_mode")

    @charging_mode.setter
    def charging_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "charging_mode", value)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[str]]:
        """
        The creation time, in UTC format.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter(name="dataDisks")
    def data_disks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InstanceDataDiskArgs']]]]:
        """
        Specifies an array of one or more data disks to attach to the instance.
        The data_disks object structure is documented below. Changing this creates a new instance.
        """
        return pulumi.get(self, "data_disks")

    @data_disks.setter
    def data_disks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceDataDiskArgs']]]]):
        pulumi.set(self, "data_disks", value)

    @property
    @pulumi.getter(name="deleteDisksOnTermination")
    def delete_disks_on_termination(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether to delete the data disks when the instance is terminated.
        Defaults to *false*. This parameter is valid if `charging_mode` is set to *postPaid*, and all data disks will be deleted
        in *prePaid* charging mode.
        """
        return pulumi.get(self, "delete_disks_on_termination")

    @delete_disks_on_termination.setter
    def delete_disks_on_termination(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "delete_disks_on_termination", value)

    @property
    @pulumi.getter(name="deleteEipOnTermination")
    def delete_eip_on_termination(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether the EIP is released when the instance is terminated.
        Defaults to *true*.
        """
        return pulumi.get(self, "delete_eip_on_termination")

    @delete_eip_on_termination.setter
    def delete_eip_on_termination(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "delete_eip_on_termination", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the description of the instance. The description consists of 0 to 85
        characters, and can't contain '<' or '>'.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="eipId")
    def eip_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the ID of an *existing* EIP assigned to the instance.
        This parameter and `eip_type`, `bandwidth` are alternative. Changing this creates a new instance.
        """
        return pulumi.get(self, "eip_id")

    @eip_id.setter
    def eip_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "eip_id", value)

    @property
    @pulumi.getter(name="eipType")
    def eip_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the type of an EIP that will be automatically assigned to the instance.
        Available values are *5_bgp* (dynamic BGP) and *5_sbgp* (static BGP). Changing this creates a new instance.
        """
        return pulumi.get(self, "eip_type")

    @eip_type.setter
    def eip_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "eip_type", value)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies a unique id in UUID format of enterprise project.
        """
        return pulumi.get(self, "enterprise_project_id")

    @enterprise_project_id.setter
    def enterprise_project_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enterprise_project_id", value)

    @property
    @pulumi.getter(name="expiredTime")
    def expired_time(self) -> Optional[pulumi.Input[str]]:
        """
        The expired time of prePaid instance, in UTC format.
        """
        return pulumi.get(self, "expired_time")

    @expired_time.setter
    def expired_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "expired_time", value)

    @property
    @pulumi.getter(name="flavorId")
    def flavor_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the flavor ID of the instance to be created.
        """
        return pulumi.get(self, "flavor_id")

    @flavor_id.setter
    def flavor_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "flavor_id", value)

    @property
    @pulumi.getter(name="flavorName")
    def flavor_name(self) -> Optional[pulumi.Input[str]]:
        """
        The flavor name of the instance.
        """
        return pulumi.get(self, "flavor_name")

    @flavor_name.setter
    def flavor_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "flavor_name", value)

    @property
    @pulumi.getter
    def hostname(self) -> Optional[pulumi.Input[str]]:
        """
        The hostname of the instance.
        """
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter(name="imageId")
    def image_id(self) -> Optional[pulumi.Input[str]]:
        """
        Required if `image_name` is empty. Specifies the image ID of the desired
        image for the instance. Changing this creates a new instance.
        """
        return pulumi.get(self, "image_id")

    @image_id.setter
    def image_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_id", value)

    @property
    @pulumi.getter(name="imageName")
    def image_name(self) -> Optional[pulumi.Input[str]]:
        """
        Required if `image_id` is empty. Specifies the name of the desired image
        for the instance. Changing this creates a new instance.
        """
        return pulumi.get(self, "image_name")

    @image_name.setter
    def image_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_name", value)

    @property
    @pulumi.getter(name="keyPair")
    def key_pair(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the SSH keypair name used for logging in to the instance.
        """
        return pulumi.get(self, "key_pair")

    @key_pair.setter
    def key_pair(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "key_pair", value)

    @property
    @pulumi.getter
    def metadata(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Specifies the user-defined metadata key-value pair.
        """
        return pulumi.get(self, "metadata")

    @metadata.setter
    def metadata(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "metadata", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies a unique name for the instance. The name consists of 1 to 64 characters,
        including letters, digits, underscores (_), hyphens (-), and periods (.).
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def networks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InstanceNetworkArgs']]]]:
        """
        Specifies an array of one or more networks to attach to the instance. The
        network object structure is documented below. Changing this creates a new instance.
        """
        return pulumi.get(self, "networks")

    @networks.setter
    def networks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceNetworkArgs']]]]):
        pulumi.set(self, "networks", value)

    @property
    @pulumi.getter
    def period(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the charging period of the instance.
        If `period_unit` is set to *month* , the value ranges from 1 to 9. If `period_unit` is set to *year*, the value
        ranges from 1 to 3. This parameter is mandatory if `charging_mode` is set to *prePaid*. Changing this creates a
        new resource.
        """
        return pulumi.get(self, "period")

    @period.setter
    def period(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "period", value)

    @property
    @pulumi.getter(name="periodUnit")
    def period_unit(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the charging period unit of the instance.
        Valid values are *month* and *year*. This parameter is mandatory if `charging_mode` is set to *prePaid*.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "period_unit")

    @period_unit.setter
    def period_unit(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "period_unit", value)

    @property
    @pulumi.getter(name="powerAction")
    def power_action(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the power action to be done for the instance.
        The valid values are *ON*, *OFF*, *REBOOT*, *FORCE-OFF* and *FORCE-REBOOT*.
        """
        return pulumi.get(self, "power_action")

    @power_action.setter
    def power_action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "power_action", value)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the the private key of the keypair in use. This parameter is mandatory
        when replacing or unbinding a keypair and the instance is in **Running** state.
        """
        return pulumi.get(self, "private_key")

    @private_key.setter
    def private_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "private_key", value)

    @property
    @pulumi.getter(name="publicIp")
    def public_ip(self) -> Optional[pulumi.Input[str]]:
        """
        The EIP address that is associated to the instance.
        """
        return pulumi.get(self, "public_ip")

    @public_ip.setter
    def public_ip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "public_ip", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to create the instance.
        If omitted, the provider-level region will be used. Changing this creates a new instance.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="schedulerHints")
    def scheduler_hints(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InstanceSchedulerHintArgs']]]]:
        """
        Specifies the scheduler with hints on how the instance should be launched. The
        available hints are described below.
        """
        return pulumi.get(self, "scheduler_hints")

    @scheduler_hints.setter
    def scheduler_hints(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceSchedulerHintArgs']]]]):
        pulumi.set(self, "scheduler_hints", value)

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Specifies an array of one or more security group IDs to associate with the
        instance.
        """
        return pulumi.get(self, "security_group_ids")

    @security_group_ids.setter
    def security_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_group_ids", value)

    @property
    @pulumi.getter(name="securityGroups")
    def security_groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        An array of one or more security groups to associate with the instance.
        """
        return pulumi.get(self, "security_groups")

    @security_groups.setter
    def security_groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_groups", value)

    @property
    @pulumi.getter(name="spotDuration")
    def spot_duration(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the service duration of the spot ECS in hours.  
        The valid value is range from `1` to `6`.
        This parameter takes effect only when `charging_mode` is set to *spot*.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "spot_duration")

    @spot_duration.setter
    def spot_duration(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "spot_duration", value)

    @property
    @pulumi.getter(name="spotDurationCount")
    def spot_duration_count(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the number of time periods in the service duration.
        This parameter takes effect only when `charging_mode` is set to *spot* and the default value is 1.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "spot_duration_count")

    @spot_duration_count.setter
    def spot_duration_count(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "spot_duration_count", value)

    @property
    @pulumi.getter(name="spotMaximumPrice")
    def spot_maximum_price(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the highest price per hour you accept for a spot ECS.
        This parameter takes effect only when `charging_mode` is set to *spot*. If the price is not specified,
        the pay-per-use price is used by default. Changing this creates a new instance.
        """
        return pulumi.get(self, "spot_maximum_price")

    @spot_maximum_price.setter
    def spot_maximum_price(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "spot_maximum_price", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        The status of the instance.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter(name="stopBeforeDestroy")
    def stop_before_destroy(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether to try stop instance gracefully before destroying it, thus giving
        chance for guest OS daemons to stop correctly. If instance doesn't stop within timeout, it will be destroyed anyway.
        """
        return pulumi.get(self, "stop_before_destroy")

    @stop_before_destroy.setter
    def stop_before_destroy(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "stop_before_destroy", value)

    @property
    @pulumi.getter(name="systemDiskDssPoolId")
    def system_disk_dss_pool_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the system disk DSS pool ID. This field is used
        only for dedicated storage. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "system_disk_dss_pool_id")

    @system_disk_dss_pool_id.setter
    def system_disk_dss_pool_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "system_disk_dss_pool_id", value)

    @property
    @pulumi.getter(name="systemDiskId")
    def system_disk_id(self) -> Optional[pulumi.Input[str]]:
        """
        The system disk volume ID.
        """
        return pulumi.get(self, "system_disk_id")

    @system_disk_id.setter
    def system_disk_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "system_disk_id", value)

    @property
    @pulumi.getter(name="systemDiskIops")
    def system_disk_iops(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the IOPS(Input/Output Operations Per Second) for the disk.
        The field is valid and required when `system_disk_type` is set to **GPSSD2** or **ESSD2**.
        """
        return pulumi.get(self, "system_disk_iops")

    @system_disk_iops.setter
    def system_disk_iops(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "system_disk_iops", value)

    @property
    @pulumi.getter(name="systemDiskKmsKeyId")
    def system_disk_kms_key_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the ID of a KMS key used to encrypt the system disk.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "system_disk_kms_key_id")

    @system_disk_kms_key_id.setter
    def system_disk_kms_key_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "system_disk_kms_key_id", value)

    @property
    @pulumi.getter(name="systemDiskSize")
    def system_disk_size(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the system disk size in GB, The value range is 1 to 1024.
        Shrinking the disk is not supported.
        """
        return pulumi.get(self, "system_disk_size")

    @system_disk_size.setter
    def system_disk_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "system_disk_size", value)

    @property
    @pulumi.getter(name="systemDiskThroughput")
    def system_disk_throughput(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the throughput for the disk. The Unit is MiB/s.
        The field is valid and required when `system_disk_type` is set to **GPSSD2**.
        """
        return pulumi.get(self, "system_disk_throughput")

    @system_disk_throughput.setter
    def system_disk_throughput(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "system_disk_throughput", value)

    @property
    @pulumi.getter(name="systemDiskType")
    def system_disk_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the system disk type of the instance. Defaults to `GPSSD`.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "system_disk_type")

    @system_disk_type.setter
    def system_disk_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "system_disk_type", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Specifies the key/value pairs to associate with the instance.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[pulumi.Input[str]]:
        """
        The last update time, in UTC format.
        """
        return pulumi.get(self, "updated_at")

    @updated_at.setter
    def updated_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "updated_at", value)

    @property
    @pulumi.getter(name="userData")
    def user_data(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the user data to be injected to the instance during the creation. Text
        and text files can be injected. The content of `user_data` can be plaint text or encoded with base64.
        """
        return pulumi.get(self, "user_data")

    @user_data.setter
    def user_data(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_data", value)

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies a user ID, required when using key_pair in prePaid charging mode.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "user_id")

    @user_id.setter
    def user_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_id", value)

    @property
    @pulumi.getter(name="volumeAttacheds")
    def volume_attacheds(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InstanceVolumeAttachedArgs']]]]:
        """
        An array of one or more disks to attach to the instance.
        The volume attached object structure is documented below.
        """
        return pulumi.get(self, "volume_attacheds")

    @volume_attacheds.setter
    def volume_attacheds(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InstanceVolumeAttachedArgs']]]]):
        pulumi.set(self, "volume_attacheds", value)


class Instance(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 admin_pass: Optional[pulumi.Input[str]] = None,
                 agency_name: Optional[pulumi.Input[str]] = None,
                 agent_list: Optional[pulumi.Input[str]] = None,
                 auto_pay: Optional[pulumi.Input[str]] = None,
                 auto_renew: Optional[pulumi.Input[str]] = None,
                 auto_terminate_time: Optional[pulumi.Input[str]] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 bandwidth: Optional[pulumi.Input[pulumi.InputType['InstanceBandwidthArgs']]] = None,
                 charging_mode: Optional[pulumi.Input[str]] = None,
                 data_disks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceDataDiskArgs']]]]] = None,
                 delete_disks_on_termination: Optional[pulumi.Input[bool]] = None,
                 delete_eip_on_termination: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 eip_id: Optional[pulumi.Input[str]] = None,
                 eip_type: Optional[pulumi.Input[str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[str]] = None,
                 flavor_id: Optional[pulumi.Input[str]] = None,
                 flavor_name: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image_id: Optional[pulumi.Input[str]] = None,
                 image_name: Optional[pulumi.Input[str]] = None,
                 key_pair: Optional[pulumi.Input[str]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 networks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceNetworkArgs']]]]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 period_unit: Optional[pulumi.Input[str]] = None,
                 power_action: Optional[pulumi.Input[str]] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 scheduler_hints: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceSchedulerHintArgs']]]]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 spot_duration: Optional[pulumi.Input[int]] = None,
                 spot_duration_count: Optional[pulumi.Input[int]] = None,
                 spot_maximum_price: Optional[pulumi.Input[str]] = None,
                 stop_before_destroy: Optional[pulumi.Input[bool]] = None,
                 system_disk_dss_pool_id: Optional[pulumi.Input[str]] = None,
                 system_disk_iops: Optional[pulumi.Input[int]] = None,
                 system_disk_kms_key_id: Optional[pulumi.Input[str]] = None,
                 system_disk_size: Optional[pulumi.Input[int]] = None,
                 system_disk_throughput: Optional[pulumi.Input[int]] = None,
                 system_disk_type: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 user_data: Optional[pulumi.Input[str]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages an ECS VM instance resource within HuaweiCloud.

        ## Example Usage
        ### Basic Instance

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        secgroup_id = config.require_object("secgroupId")
        myaz = huaweicloud.get_availability_zones()
        myflavor = huaweicloud.Ecs.get_flavors(availability_zone=myaz.names[0],
            performance_type="normal",
            cpu_core_count=2,
            memory_size=4)
        mynet = huaweicloud.Vpc.get_subnet(name="subnet-default")
        myimage = huaweicloud.Ims.get_image(name="Ubuntu 18.04 server 64bit",
            most_recent=True)
        basic = huaweicloud.ecs.Instance("basic",
            image_id=myimage.id,
            flavor_id=myflavor.ids[0],
            security_group_ids=[secgroup_id],
            availability_zone=myaz.names[0],
            networks=[huaweicloud.ecs.InstanceNetworkArgs(
                uuid=mynet.id,
            )])
        ```
        ### Instance With Associated Eip

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        secgroup_id = config.require_object("secgroupId")
        myinstance = huaweicloud.ecs.Instance("myinstance",
            image_id="ad091b52-742f-469e-8f3c-fd81cadf0743",
            flavor_id="s6.small.1",
            key_pair="my_key_pair_name",
            security_group_ids=[secgroup_id],
            availability_zone="cn-north-4a",
            networks=[huaweicloud.ecs.InstanceNetworkArgs(
                uuid="55534eaa-533a-419d-9b40-ec427ea7195a",
            )])
        myeip = huaweicloud.vpc.Eip("myeip",
            publicip=huaweicloud.vpc.EipPublicipArgs(
                type="5_bgp",
            ),
            bandwidth=huaweicloud.vpc.EipBandwidthArgs(
                name="test",
                size=8,
                share_type="PER",
                charge_mode="traffic",
            ))
        associated = huaweicloud.ecs.EipAssociate("associated",
            public_ip=myeip.address,
            instance_id=myinstance.id)
        ```
        ### Instance With Attached Volume

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        secgroup_id = config.require_object("secgroupId")
        myvolume = huaweicloud.evs.Volume("myvolume",
            availability_zone="cn-north-4a",
            volume_type="SAS",
            size=10)
        myinstance = huaweicloud.ecs.Instance("myinstance",
            image_id="ad091b52-742f-469e-8f3c-fd81cadf0743",
            flavor_id="s6.small.1",
            key_pair="my_key_pair_name",
            security_group_ids=[secgroup_id],
            availability_zone="cn-north-4a",
            networks=[huaweicloud.ecs.InstanceNetworkArgs(
                uuid="55534eaa-533a-419d-9b40-ec427ea7195a",
            )])
        attached = huaweicloud.ecs.VolumeAttach("attached",
            instance_id=myinstance.id,
            volume_id=myvolume.id)
        ```
        ### Instance With Multiple Data Disks

        It's possible to specify multiple `data_disks` entries to create an instance with multiple data disks, but we can't
        ensure the volume attached order. So it's recommended to use `Instance With Attached Volume` above.

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        secgroup_id = config.require_object("secgroupId")
        multi_disk = huaweicloud.ecs.Instance("multi-disk",
            image_id="ad091b52-742f-469e-8f3c-fd81cadf0743",
            flavor_id="s6.small.1",
            key_pair="my_key_pair_name",
            security_group_ids=[secgroup_id],
            availability_zone="cn-north-4a",
            system_disk_type="SAS",
            system_disk_size=40,
            data_disks=[
                huaweicloud.ecs.InstanceDataDiskArgs(
                    type="SAS",
                    size=10,
                ),
                huaweicloud.ecs.InstanceDataDiskArgs(
                    type="SAS",
                    size=20,
                ),
            ],
            delete_disks_on_termination=True,
            networks=[huaweicloud.ecs.InstanceNetworkArgs(
                uuid="55534eaa-533a-419d-9b40-ec427ea7195a",
            )])
        ```
        ### Instance With Multiple Networks

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        secgroup_id = config.require_object("secgroupId")
        multi_net = huaweicloud.ecs.Instance("multi-net",
            image_id="ad091b52-742f-469e-8f3c-fd81cadf0743",
            flavor_id="s6.small.1",
            key_pair="my_key_pair_name",
            security_group_ids=[secgroup_id],
            availability_zone="cn-north-4a",
            networks=[
                huaweicloud.ecs.InstanceNetworkArgs(
                    uuid="55534eaa-533a-419d-9b40-ec427ea7195a",
                ),
                huaweicloud.ecs.InstanceNetworkArgs(
                    uuid="3c4a0d74-24b9-46cf-9d7f-8b7a4dc2f65c",
                ),
            ])
        ```
        ### Instance with User Data (cloud-init)

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        secgroup_id = config.require_object("secgroupId")
        myinstance = huaweicloud.ecs.Instance("myinstance",
            image_id="ad091b52-742f-469e-8f3c-fd81cadf0743",
            flavor_id="s6.small.1",
            key_pair="my_key_pair_name",
            security_group_ids=[secgroup_id],
            availability_zone="az",
            user_data=\"\"\"#cloud-config
        hostname: instance_1.example.com
        fqdn: instance_1.example.com\"\"\",
            networks=[huaweicloud.ecs.InstanceNetworkArgs(
                uuid="55534eaa-533a-419d-9b40-ec427ea7195a",
            )])
        ```

        ## Import

        Instances can be imported by their `id`. For example,

        ```sh
         $ pulumi import huaweicloud:Ecs/instance:Instance my_instance b11b407c-e604-4e8d-8bc4-92398320b847
        ```

         Note that the imported state may not be identical to your resource definition, due to some attributes missing from the API response, security or some other reason. The missing attributes include`admin_pass`, `user_data`, `metadata`, `data_disks`, `scheduler_hints`, `stop_before_destroy`, `delete_disks_on_termination`, `delete_eip_on_termination`, `network/access_network`, `bandwidth`, `eip_type`, `power_action` and arguments for pre-paid and spot price. It is generally recommended running `terraform plan` after importing an instance. You can then decide if changes should be applied to the instance, or the resource definition should be updated to align with the instance. Also you can ignore changes as below. hcl resource "huaweicloud_compute_instance" "myinstance" {

         ...

         lifecycle {

         ignore_changes = [

         user_data, data_disks,

         ]

         } }

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] admin_pass: Specifies the administrative password to assign to the instance.
        :param pulumi.Input[str] agency_name: Specifies the IAM agency name which is created on IAM to provide
               temporary credentials for ECS to access cloud services.
        :param pulumi.Input[str] agent_list: Specifies the agent list in comma-separated string.
               Available agents are:
               + `ces`: enable cloud eye monitoring.
               + `hss`: enable host security basic.
               + `hss,hss-ent`: enable host security enterprise edition.
        :param pulumi.Input[str] auto_renew: Specifies whether auto renew is enabled.
               Valid values are *true* and *false*. Defaults to *false*.
        :param pulumi.Input[str] auto_terminate_time: Specifies the auto terminate time.
               The value is in the format of "yyyy-MM-ddTHH:mm:ssZ" in UTC+0 and complies with ISO8601.
               If the value of second (ss) is not "00", the system automatically sets to the current value of minute (mm).
               The auto terminate time must be at least half an hour later than the current time.
               The auto terminate time cannot be three years later than the current time.
               For example, set the value to "2024-09-25T12:05:00Z".
        :param pulumi.Input[str] availability_zone: Specifies the availability zone in which to create the instance.
               Please following [reference](https://developer.huaweicloud.com/intl/en-us/endpoint/?ECS)
               for the values. Changing this creates a new instance.
        :param pulumi.Input[pulumi.InputType['InstanceBandwidthArgs']] bandwidth: Specifies the bandwidth of an EIP that will be automatically assigned to the instance.
               The object structure is documented below. Changing this creates a new instance.
        :param pulumi.Input[str] charging_mode: Specifies the charging mode of the instance. Valid values are *prePaid*,
               *postPaid* and *spot*, defaults to *postPaid*. Changing this creates a new instance.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceDataDiskArgs']]]] data_disks: Specifies an array of one or more data disks to attach to the instance.
               The data_disks object structure is documented below. Changing this creates a new instance.
        :param pulumi.Input[bool] delete_disks_on_termination: Specifies whether to delete the data disks when the instance is terminated.
               Defaults to *false*. This parameter is valid if `charging_mode` is set to *postPaid*, and all data disks will be deleted
               in *prePaid* charging mode.
        :param pulumi.Input[bool] delete_eip_on_termination: Specifies whether the EIP is released when the instance is terminated.
               Defaults to *true*.
        :param pulumi.Input[str] description: Specifies the description of the instance. The description consists of 0 to 85
               characters, and can't contain '<' or '>'.
        :param pulumi.Input[str] eip_id: Specifies the ID of an *existing* EIP assigned to the instance.
               This parameter and `eip_type`, `bandwidth` are alternative. Changing this creates a new instance.
        :param pulumi.Input[str] eip_type: Specifies the type of an EIP that will be automatically assigned to the instance.
               Available values are *5_bgp* (dynamic BGP) and *5_sbgp* (static BGP). Changing this creates a new instance.
        :param pulumi.Input[str] enterprise_project_id: Specifies a unique id in UUID format of enterprise project.
        :param pulumi.Input[str] flavor_id: Specifies the flavor ID of the instance to be created.
        :param pulumi.Input[str] flavor_name: The flavor name of the instance.
        :param pulumi.Input[str] hostname: The hostname of the instance.
        :param pulumi.Input[str] image_id: Required if `image_name` is empty. Specifies the image ID of the desired
               image for the instance. Changing this creates a new instance.
        :param pulumi.Input[str] image_name: Required if `image_id` is empty. Specifies the name of the desired image
               for the instance. Changing this creates a new instance.
        :param pulumi.Input[str] key_pair: Specifies the SSH keypair name used for logging in to the instance.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] metadata: Specifies the user-defined metadata key-value pair.
        :param pulumi.Input[str] name: Specifies a unique name for the instance. The name consists of 1 to 64 characters,
               including letters, digits, underscores (_), hyphens (-), and periods (.).
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceNetworkArgs']]]] networks: Specifies an array of one or more networks to attach to the instance. The
               network object structure is documented below. Changing this creates a new instance.
        :param pulumi.Input[int] period: Specifies the charging period of the instance.
               If `period_unit` is set to *month* , the value ranges from 1 to 9. If `period_unit` is set to *year*, the value
               ranges from 1 to 3. This parameter is mandatory if `charging_mode` is set to *prePaid*. Changing this creates a
               new resource.
        :param pulumi.Input[str] period_unit: Specifies the charging period unit of the instance.
               Valid values are *month* and *year*. This parameter is mandatory if `charging_mode` is set to *prePaid*.
               Changing this creates a new instance.
        :param pulumi.Input[str] power_action: Specifies the power action to be done for the instance.
               The valid values are *ON*, *OFF*, *REBOOT*, *FORCE-OFF* and *FORCE-REBOOT*.
        :param pulumi.Input[str] private_key: Specifies the the private key of the keypair in use. This parameter is mandatory
               when replacing or unbinding a keypair and the instance is in **Running** state.
        :param pulumi.Input[str] region: Specifies the region in which to create the instance.
               If omitted, the provider-level region will be used. Changing this creates a new instance.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceSchedulerHintArgs']]]] scheduler_hints: Specifies the scheduler with hints on how the instance should be launched. The
               available hints are described below.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: Specifies an array of one or more security group IDs to associate with the
               instance.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups: An array of one or more security groups to associate with the instance.
        :param pulumi.Input[int] spot_duration: Specifies the service duration of the spot ECS in hours.  
               The valid value is range from `1` to `6`.
               This parameter takes effect only when `charging_mode` is set to *spot*.
               Changing this creates a new instance.
        :param pulumi.Input[int] spot_duration_count: Specifies the number of time periods in the service duration.
               This parameter takes effect only when `charging_mode` is set to *spot* and the default value is 1.
               Changing this creates a new instance.
        :param pulumi.Input[str] spot_maximum_price: Specifies the highest price per hour you accept for a spot ECS.
               This parameter takes effect only when `charging_mode` is set to *spot*. If the price is not specified,
               the pay-per-use price is used by default. Changing this creates a new instance.
        :param pulumi.Input[bool] stop_before_destroy: Specifies whether to try stop instance gracefully before destroying it, thus giving
               chance for guest OS daemons to stop correctly. If instance doesn't stop within timeout, it will be destroyed anyway.
        :param pulumi.Input[str] system_disk_dss_pool_id: Specifies the system disk DSS pool ID. This field is used
               only for dedicated storage. Changing this parameter will create a new resource.
        :param pulumi.Input[int] system_disk_iops: Specifies the IOPS(Input/Output Operations Per Second) for the disk.
               The field is valid and required when `system_disk_type` is set to **GPSSD2** or **ESSD2**.
        :param pulumi.Input[str] system_disk_kms_key_id: Specifies the ID of a KMS key used to encrypt the system disk.
               Changing this creates a new instance.
        :param pulumi.Input[int] system_disk_size: Specifies the system disk size in GB, The value range is 1 to 1024.
               Shrinking the disk is not supported.
        :param pulumi.Input[int] system_disk_throughput: Specifies the throughput for the disk. The Unit is MiB/s.
               The field is valid and required when `system_disk_type` is set to **GPSSD2**.
        :param pulumi.Input[str] system_disk_type: Specifies the system disk type of the instance. Defaults to `GPSSD`.
               Changing this creates a new instance.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Specifies the key/value pairs to associate with the instance.
        :param pulumi.Input[str] user_data: Specifies the user data to be injected to the instance during the creation. Text
               and text files can be injected. The content of `user_data` can be plaint text or encoded with base64.
        :param pulumi.Input[str] user_id: Specifies a user ID, required when using key_pair in prePaid charging mode.
               Changing this creates a new instance.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InstanceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages an ECS VM instance resource within HuaweiCloud.

        ## Example Usage
        ### Basic Instance

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        secgroup_id = config.require_object("secgroupId")
        myaz = huaweicloud.get_availability_zones()
        myflavor = huaweicloud.Ecs.get_flavors(availability_zone=myaz.names[0],
            performance_type="normal",
            cpu_core_count=2,
            memory_size=4)
        mynet = huaweicloud.Vpc.get_subnet(name="subnet-default")
        myimage = huaweicloud.Ims.get_image(name="Ubuntu 18.04 server 64bit",
            most_recent=True)
        basic = huaweicloud.ecs.Instance("basic",
            image_id=myimage.id,
            flavor_id=myflavor.ids[0],
            security_group_ids=[secgroup_id],
            availability_zone=myaz.names[0],
            networks=[huaweicloud.ecs.InstanceNetworkArgs(
                uuid=mynet.id,
            )])
        ```
        ### Instance With Associated Eip

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        secgroup_id = config.require_object("secgroupId")
        myinstance = huaweicloud.ecs.Instance("myinstance",
            image_id="ad091b52-742f-469e-8f3c-fd81cadf0743",
            flavor_id="s6.small.1",
            key_pair="my_key_pair_name",
            security_group_ids=[secgroup_id],
            availability_zone="cn-north-4a",
            networks=[huaweicloud.ecs.InstanceNetworkArgs(
                uuid="55534eaa-533a-419d-9b40-ec427ea7195a",
            )])
        myeip = huaweicloud.vpc.Eip("myeip",
            publicip=huaweicloud.vpc.EipPublicipArgs(
                type="5_bgp",
            ),
            bandwidth=huaweicloud.vpc.EipBandwidthArgs(
                name="test",
                size=8,
                share_type="PER",
                charge_mode="traffic",
            ))
        associated = huaweicloud.ecs.EipAssociate("associated",
            public_ip=myeip.address,
            instance_id=myinstance.id)
        ```
        ### Instance With Attached Volume

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        secgroup_id = config.require_object("secgroupId")
        myvolume = huaweicloud.evs.Volume("myvolume",
            availability_zone="cn-north-4a",
            volume_type="SAS",
            size=10)
        myinstance = huaweicloud.ecs.Instance("myinstance",
            image_id="ad091b52-742f-469e-8f3c-fd81cadf0743",
            flavor_id="s6.small.1",
            key_pair="my_key_pair_name",
            security_group_ids=[secgroup_id],
            availability_zone="cn-north-4a",
            networks=[huaweicloud.ecs.InstanceNetworkArgs(
                uuid="55534eaa-533a-419d-9b40-ec427ea7195a",
            )])
        attached = huaweicloud.ecs.VolumeAttach("attached",
            instance_id=myinstance.id,
            volume_id=myvolume.id)
        ```
        ### Instance With Multiple Data Disks

        It's possible to specify multiple `data_disks` entries to create an instance with multiple data disks, but we can't
        ensure the volume attached order. So it's recommended to use `Instance With Attached Volume` above.

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        secgroup_id = config.require_object("secgroupId")
        multi_disk = huaweicloud.ecs.Instance("multi-disk",
            image_id="ad091b52-742f-469e-8f3c-fd81cadf0743",
            flavor_id="s6.small.1",
            key_pair="my_key_pair_name",
            security_group_ids=[secgroup_id],
            availability_zone="cn-north-4a",
            system_disk_type="SAS",
            system_disk_size=40,
            data_disks=[
                huaweicloud.ecs.InstanceDataDiskArgs(
                    type="SAS",
                    size=10,
                ),
                huaweicloud.ecs.InstanceDataDiskArgs(
                    type="SAS",
                    size=20,
                ),
            ],
            delete_disks_on_termination=True,
            networks=[huaweicloud.ecs.InstanceNetworkArgs(
                uuid="55534eaa-533a-419d-9b40-ec427ea7195a",
            )])
        ```
        ### Instance With Multiple Networks

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        secgroup_id = config.require_object("secgroupId")
        multi_net = huaweicloud.ecs.Instance("multi-net",
            image_id="ad091b52-742f-469e-8f3c-fd81cadf0743",
            flavor_id="s6.small.1",
            key_pair="my_key_pair_name",
            security_group_ids=[secgroup_id],
            availability_zone="cn-north-4a",
            networks=[
                huaweicloud.ecs.InstanceNetworkArgs(
                    uuid="55534eaa-533a-419d-9b40-ec427ea7195a",
                ),
                huaweicloud.ecs.InstanceNetworkArgs(
                    uuid="3c4a0d74-24b9-46cf-9d7f-8b7a4dc2f65c",
                ),
            ])
        ```
        ### Instance with User Data (cloud-init)

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        secgroup_id = config.require_object("secgroupId")
        myinstance = huaweicloud.ecs.Instance("myinstance",
            image_id="ad091b52-742f-469e-8f3c-fd81cadf0743",
            flavor_id="s6.small.1",
            key_pair="my_key_pair_name",
            security_group_ids=[secgroup_id],
            availability_zone="az",
            user_data=\"\"\"#cloud-config
        hostname: instance_1.example.com
        fqdn: instance_1.example.com\"\"\",
            networks=[huaweicloud.ecs.InstanceNetworkArgs(
                uuid="55534eaa-533a-419d-9b40-ec427ea7195a",
            )])
        ```

        ## Import

        Instances can be imported by their `id`. For example,

        ```sh
         $ pulumi import huaweicloud:Ecs/instance:Instance my_instance b11b407c-e604-4e8d-8bc4-92398320b847
        ```

         Note that the imported state may not be identical to your resource definition, due to some attributes missing from the API response, security or some other reason. The missing attributes include`admin_pass`, `user_data`, `metadata`, `data_disks`, `scheduler_hints`, `stop_before_destroy`, `delete_disks_on_termination`, `delete_eip_on_termination`, `network/access_network`, `bandwidth`, `eip_type`, `power_action` and arguments for pre-paid and spot price. It is generally recommended running `terraform plan` after importing an instance. You can then decide if changes should be applied to the instance, or the resource definition should be updated to align with the instance. Also you can ignore changes as below. hcl resource "huaweicloud_compute_instance" "myinstance" {

         ...

         lifecycle {

         ignore_changes = [

         user_data, data_disks,

         ]

         } }

        :param str resource_name: The name of the resource.
        :param InstanceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InstanceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 admin_pass: Optional[pulumi.Input[str]] = None,
                 agency_name: Optional[pulumi.Input[str]] = None,
                 agent_list: Optional[pulumi.Input[str]] = None,
                 auto_pay: Optional[pulumi.Input[str]] = None,
                 auto_renew: Optional[pulumi.Input[str]] = None,
                 auto_terminate_time: Optional[pulumi.Input[str]] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 bandwidth: Optional[pulumi.Input[pulumi.InputType['InstanceBandwidthArgs']]] = None,
                 charging_mode: Optional[pulumi.Input[str]] = None,
                 data_disks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceDataDiskArgs']]]]] = None,
                 delete_disks_on_termination: Optional[pulumi.Input[bool]] = None,
                 delete_eip_on_termination: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 eip_id: Optional[pulumi.Input[str]] = None,
                 eip_type: Optional[pulumi.Input[str]] = None,
                 enterprise_project_id: Optional[pulumi.Input[str]] = None,
                 flavor_id: Optional[pulumi.Input[str]] = None,
                 flavor_name: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image_id: Optional[pulumi.Input[str]] = None,
                 image_name: Optional[pulumi.Input[str]] = None,
                 key_pair: Optional[pulumi.Input[str]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 networks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceNetworkArgs']]]]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 period_unit: Optional[pulumi.Input[str]] = None,
                 power_action: Optional[pulumi.Input[str]] = None,
                 private_key: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 scheduler_hints: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceSchedulerHintArgs']]]]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 spot_duration: Optional[pulumi.Input[int]] = None,
                 spot_duration_count: Optional[pulumi.Input[int]] = None,
                 spot_maximum_price: Optional[pulumi.Input[str]] = None,
                 stop_before_destroy: Optional[pulumi.Input[bool]] = None,
                 system_disk_dss_pool_id: Optional[pulumi.Input[str]] = None,
                 system_disk_iops: Optional[pulumi.Input[int]] = None,
                 system_disk_kms_key_id: Optional[pulumi.Input[str]] = None,
                 system_disk_size: Optional[pulumi.Input[int]] = None,
                 system_disk_throughput: Optional[pulumi.Input[int]] = None,
                 system_disk_type: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 user_data: Optional[pulumi.Input[str]] = None,
                 user_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InstanceArgs.__new__(InstanceArgs)

            __props__.__dict__["admin_pass"] = admin_pass
            __props__.__dict__["agency_name"] = agency_name
            __props__.__dict__["agent_list"] = agent_list
            if auto_pay is not None and not opts.urn:
                warnings.warn("""Deprecated""", DeprecationWarning)
                pulumi.log.warn("""auto_pay is deprecated: Deprecated""")
            __props__.__dict__["auto_pay"] = auto_pay
            __props__.__dict__["auto_renew"] = auto_renew
            __props__.__dict__["auto_terminate_time"] = auto_terminate_time
            __props__.__dict__["availability_zone"] = availability_zone
            __props__.__dict__["bandwidth"] = bandwidth
            __props__.__dict__["charging_mode"] = charging_mode
            __props__.__dict__["data_disks"] = data_disks
            __props__.__dict__["delete_disks_on_termination"] = delete_disks_on_termination
            __props__.__dict__["delete_eip_on_termination"] = delete_eip_on_termination
            __props__.__dict__["description"] = description
            __props__.__dict__["eip_id"] = eip_id
            __props__.__dict__["eip_type"] = eip_type
            __props__.__dict__["enterprise_project_id"] = enterprise_project_id
            __props__.__dict__["flavor_id"] = flavor_id
            __props__.__dict__["flavor_name"] = flavor_name
            __props__.__dict__["hostname"] = hostname
            __props__.__dict__["image_id"] = image_id
            __props__.__dict__["image_name"] = image_name
            __props__.__dict__["key_pair"] = key_pair
            __props__.__dict__["metadata"] = metadata
            __props__.__dict__["name"] = name
            if networks is None and not opts.urn:
                raise TypeError("Missing required property 'networks'")
            __props__.__dict__["networks"] = networks
            __props__.__dict__["period"] = period
            __props__.__dict__["period_unit"] = period_unit
            __props__.__dict__["power_action"] = power_action
            __props__.__dict__["private_key"] = private_key
            __props__.__dict__["region"] = region
            __props__.__dict__["scheduler_hints"] = scheduler_hints
            __props__.__dict__["security_group_ids"] = security_group_ids
            __props__.__dict__["security_groups"] = security_groups
            __props__.__dict__["spot_duration"] = spot_duration
            __props__.__dict__["spot_duration_count"] = spot_duration_count
            __props__.__dict__["spot_maximum_price"] = spot_maximum_price
            __props__.__dict__["stop_before_destroy"] = stop_before_destroy
            __props__.__dict__["system_disk_dss_pool_id"] = system_disk_dss_pool_id
            __props__.__dict__["system_disk_iops"] = system_disk_iops
            __props__.__dict__["system_disk_kms_key_id"] = system_disk_kms_key_id
            __props__.__dict__["system_disk_size"] = system_disk_size
            __props__.__dict__["system_disk_throughput"] = system_disk_throughput
            __props__.__dict__["system_disk_type"] = system_disk_type
            __props__.__dict__["tags"] = tags
            __props__.__dict__["user_data"] = user_data
            __props__.__dict__["user_id"] = user_id
            __props__.__dict__["access_ip_v4"] = None
            __props__.__dict__["access_ip_v6"] = None
            __props__.__dict__["created_at"] = None
            __props__.__dict__["expired_time"] = None
            __props__.__dict__["public_ip"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["system_disk_id"] = None
            __props__.__dict__["updated_at"] = None
            __props__.__dict__["volume_attacheds"] = None
        super(Instance, __self__).__init__(
            'huaweicloud:Ecs/instance:Instance',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            access_ip_v4: Optional[pulumi.Input[str]] = None,
            access_ip_v6: Optional[pulumi.Input[str]] = None,
            admin_pass: Optional[pulumi.Input[str]] = None,
            agency_name: Optional[pulumi.Input[str]] = None,
            agent_list: Optional[pulumi.Input[str]] = None,
            auto_pay: Optional[pulumi.Input[str]] = None,
            auto_renew: Optional[pulumi.Input[str]] = None,
            auto_terminate_time: Optional[pulumi.Input[str]] = None,
            availability_zone: Optional[pulumi.Input[str]] = None,
            bandwidth: Optional[pulumi.Input[pulumi.InputType['InstanceBandwidthArgs']]] = None,
            charging_mode: Optional[pulumi.Input[str]] = None,
            created_at: Optional[pulumi.Input[str]] = None,
            data_disks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceDataDiskArgs']]]]] = None,
            delete_disks_on_termination: Optional[pulumi.Input[bool]] = None,
            delete_eip_on_termination: Optional[pulumi.Input[bool]] = None,
            description: Optional[pulumi.Input[str]] = None,
            eip_id: Optional[pulumi.Input[str]] = None,
            eip_type: Optional[pulumi.Input[str]] = None,
            enterprise_project_id: Optional[pulumi.Input[str]] = None,
            expired_time: Optional[pulumi.Input[str]] = None,
            flavor_id: Optional[pulumi.Input[str]] = None,
            flavor_name: Optional[pulumi.Input[str]] = None,
            hostname: Optional[pulumi.Input[str]] = None,
            image_id: Optional[pulumi.Input[str]] = None,
            image_name: Optional[pulumi.Input[str]] = None,
            key_pair: Optional[pulumi.Input[str]] = None,
            metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            networks: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceNetworkArgs']]]]] = None,
            period: Optional[pulumi.Input[int]] = None,
            period_unit: Optional[pulumi.Input[str]] = None,
            power_action: Optional[pulumi.Input[str]] = None,
            private_key: Optional[pulumi.Input[str]] = None,
            public_ip: Optional[pulumi.Input[str]] = None,
            region: Optional[pulumi.Input[str]] = None,
            scheduler_hints: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceSchedulerHintArgs']]]]] = None,
            security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            security_groups: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            spot_duration: Optional[pulumi.Input[int]] = None,
            spot_duration_count: Optional[pulumi.Input[int]] = None,
            spot_maximum_price: Optional[pulumi.Input[str]] = None,
            status: Optional[pulumi.Input[str]] = None,
            stop_before_destroy: Optional[pulumi.Input[bool]] = None,
            system_disk_dss_pool_id: Optional[pulumi.Input[str]] = None,
            system_disk_id: Optional[pulumi.Input[str]] = None,
            system_disk_iops: Optional[pulumi.Input[int]] = None,
            system_disk_kms_key_id: Optional[pulumi.Input[str]] = None,
            system_disk_size: Optional[pulumi.Input[int]] = None,
            system_disk_throughput: Optional[pulumi.Input[int]] = None,
            system_disk_type: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            updated_at: Optional[pulumi.Input[str]] = None,
            user_data: Optional[pulumi.Input[str]] = None,
            user_id: Optional[pulumi.Input[str]] = None,
            volume_attacheds: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceVolumeAttachedArgs']]]]] = None) -> 'Instance':
        """
        Get an existing Instance resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] access_ip_v4: The first detected Fixed IPv4 address or the Floating IP.
        :param pulumi.Input[str] access_ip_v6: The first detected Fixed IPv6 address.
        :param pulumi.Input[str] admin_pass: Specifies the administrative password to assign to the instance.
        :param pulumi.Input[str] agency_name: Specifies the IAM agency name which is created on IAM to provide
               temporary credentials for ECS to access cloud services.
        :param pulumi.Input[str] agent_list: Specifies the agent list in comma-separated string.
               Available agents are:
               + `ces`: enable cloud eye monitoring.
               + `hss`: enable host security basic.
               + `hss,hss-ent`: enable host security enterprise edition.
        :param pulumi.Input[str] auto_renew: Specifies whether auto renew is enabled.
               Valid values are *true* and *false*. Defaults to *false*.
        :param pulumi.Input[str] auto_terminate_time: Specifies the auto terminate time.
               The value is in the format of "yyyy-MM-ddTHH:mm:ssZ" in UTC+0 and complies with ISO8601.
               If the value of second (ss) is not "00", the system automatically sets to the current value of minute (mm).
               The auto terminate time must be at least half an hour later than the current time.
               The auto terminate time cannot be three years later than the current time.
               For example, set the value to "2024-09-25T12:05:00Z".
        :param pulumi.Input[str] availability_zone: Specifies the availability zone in which to create the instance.
               Please following [reference](https://developer.huaweicloud.com/intl/en-us/endpoint/?ECS)
               for the values. Changing this creates a new instance.
        :param pulumi.Input[pulumi.InputType['InstanceBandwidthArgs']] bandwidth: Specifies the bandwidth of an EIP that will be automatically assigned to the instance.
               The object structure is documented below. Changing this creates a new instance.
        :param pulumi.Input[str] charging_mode: Specifies the charging mode of the instance. Valid values are *prePaid*,
               *postPaid* and *spot*, defaults to *postPaid*. Changing this creates a new instance.
        :param pulumi.Input[str] created_at: The creation time, in UTC format.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceDataDiskArgs']]]] data_disks: Specifies an array of one or more data disks to attach to the instance.
               The data_disks object structure is documented below. Changing this creates a new instance.
        :param pulumi.Input[bool] delete_disks_on_termination: Specifies whether to delete the data disks when the instance is terminated.
               Defaults to *false*. This parameter is valid if `charging_mode` is set to *postPaid*, and all data disks will be deleted
               in *prePaid* charging mode.
        :param pulumi.Input[bool] delete_eip_on_termination: Specifies whether the EIP is released when the instance is terminated.
               Defaults to *true*.
        :param pulumi.Input[str] description: Specifies the description of the instance. The description consists of 0 to 85
               characters, and can't contain '<' or '>'.
        :param pulumi.Input[str] eip_id: Specifies the ID of an *existing* EIP assigned to the instance.
               This parameter and `eip_type`, `bandwidth` are alternative. Changing this creates a new instance.
        :param pulumi.Input[str] eip_type: Specifies the type of an EIP that will be automatically assigned to the instance.
               Available values are *5_bgp* (dynamic BGP) and *5_sbgp* (static BGP). Changing this creates a new instance.
        :param pulumi.Input[str] enterprise_project_id: Specifies a unique id in UUID format of enterprise project.
        :param pulumi.Input[str] expired_time: The expired time of prePaid instance, in UTC format.
        :param pulumi.Input[str] flavor_id: Specifies the flavor ID of the instance to be created.
        :param pulumi.Input[str] flavor_name: The flavor name of the instance.
        :param pulumi.Input[str] hostname: The hostname of the instance.
        :param pulumi.Input[str] image_id: Required if `image_name` is empty. Specifies the image ID of the desired
               image for the instance. Changing this creates a new instance.
        :param pulumi.Input[str] image_name: Required if `image_id` is empty. Specifies the name of the desired image
               for the instance. Changing this creates a new instance.
        :param pulumi.Input[str] key_pair: Specifies the SSH keypair name used for logging in to the instance.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] metadata: Specifies the user-defined metadata key-value pair.
        :param pulumi.Input[str] name: Specifies a unique name for the instance. The name consists of 1 to 64 characters,
               including letters, digits, underscores (_), hyphens (-), and periods (.).
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceNetworkArgs']]]] networks: Specifies an array of one or more networks to attach to the instance. The
               network object structure is documented below. Changing this creates a new instance.
        :param pulumi.Input[int] period: Specifies the charging period of the instance.
               If `period_unit` is set to *month* , the value ranges from 1 to 9. If `period_unit` is set to *year*, the value
               ranges from 1 to 3. This parameter is mandatory if `charging_mode` is set to *prePaid*. Changing this creates a
               new resource.
        :param pulumi.Input[str] period_unit: Specifies the charging period unit of the instance.
               Valid values are *month* and *year*. This parameter is mandatory if `charging_mode` is set to *prePaid*.
               Changing this creates a new instance.
        :param pulumi.Input[str] power_action: Specifies the power action to be done for the instance.
               The valid values are *ON*, *OFF*, *REBOOT*, *FORCE-OFF* and *FORCE-REBOOT*.
        :param pulumi.Input[str] private_key: Specifies the the private key of the keypair in use. This parameter is mandatory
               when replacing or unbinding a keypair and the instance is in **Running** state.
        :param pulumi.Input[str] public_ip: The EIP address that is associated to the instance.
        :param pulumi.Input[str] region: Specifies the region in which to create the instance.
               If omitted, the provider-level region will be used. Changing this creates a new instance.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceSchedulerHintArgs']]]] scheduler_hints: Specifies the scheduler with hints on how the instance should be launched. The
               available hints are described below.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: Specifies an array of one or more security group IDs to associate with the
               instance.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups: An array of one or more security groups to associate with the instance.
        :param pulumi.Input[int] spot_duration: Specifies the service duration of the spot ECS in hours.  
               The valid value is range from `1` to `6`.
               This parameter takes effect only when `charging_mode` is set to *spot*.
               Changing this creates a new instance.
        :param pulumi.Input[int] spot_duration_count: Specifies the number of time periods in the service duration.
               This parameter takes effect only when `charging_mode` is set to *spot* and the default value is 1.
               Changing this creates a new instance.
        :param pulumi.Input[str] spot_maximum_price: Specifies the highest price per hour you accept for a spot ECS.
               This parameter takes effect only when `charging_mode` is set to *spot*. If the price is not specified,
               the pay-per-use price is used by default. Changing this creates a new instance.
        :param pulumi.Input[str] status: The status of the instance.
        :param pulumi.Input[bool] stop_before_destroy: Specifies whether to try stop instance gracefully before destroying it, thus giving
               chance for guest OS daemons to stop correctly. If instance doesn't stop within timeout, it will be destroyed anyway.
        :param pulumi.Input[str] system_disk_dss_pool_id: Specifies the system disk DSS pool ID. This field is used
               only for dedicated storage. Changing this parameter will create a new resource.
        :param pulumi.Input[str] system_disk_id: The system disk volume ID.
        :param pulumi.Input[int] system_disk_iops: Specifies the IOPS(Input/Output Operations Per Second) for the disk.
               The field is valid and required when `system_disk_type` is set to **GPSSD2** or **ESSD2**.
        :param pulumi.Input[str] system_disk_kms_key_id: Specifies the ID of a KMS key used to encrypt the system disk.
               Changing this creates a new instance.
        :param pulumi.Input[int] system_disk_size: Specifies the system disk size in GB, The value range is 1 to 1024.
               Shrinking the disk is not supported.
        :param pulumi.Input[int] system_disk_throughput: Specifies the throughput for the disk. The Unit is MiB/s.
               The field is valid and required when `system_disk_type` is set to **GPSSD2**.
        :param pulumi.Input[str] system_disk_type: Specifies the system disk type of the instance. Defaults to `GPSSD`.
               Changing this creates a new instance.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] tags: Specifies the key/value pairs to associate with the instance.
        :param pulumi.Input[str] updated_at: The last update time, in UTC format.
        :param pulumi.Input[str] user_data: Specifies the user data to be injected to the instance during the creation. Text
               and text files can be injected. The content of `user_data` can be plaint text or encoded with base64.
        :param pulumi.Input[str] user_id: Specifies a user ID, required when using key_pair in prePaid charging mode.
               Changing this creates a new instance.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['InstanceVolumeAttachedArgs']]]] volume_attacheds: An array of one or more disks to attach to the instance.
               The volume attached object structure is documented below.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InstanceState.__new__(_InstanceState)

        __props__.__dict__["access_ip_v4"] = access_ip_v4
        __props__.__dict__["access_ip_v6"] = access_ip_v6
        __props__.__dict__["admin_pass"] = admin_pass
        __props__.__dict__["agency_name"] = agency_name
        __props__.__dict__["agent_list"] = agent_list
        __props__.__dict__["auto_pay"] = auto_pay
        __props__.__dict__["auto_renew"] = auto_renew
        __props__.__dict__["auto_terminate_time"] = auto_terminate_time
        __props__.__dict__["availability_zone"] = availability_zone
        __props__.__dict__["bandwidth"] = bandwidth
        __props__.__dict__["charging_mode"] = charging_mode
        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["data_disks"] = data_disks
        __props__.__dict__["delete_disks_on_termination"] = delete_disks_on_termination
        __props__.__dict__["delete_eip_on_termination"] = delete_eip_on_termination
        __props__.__dict__["description"] = description
        __props__.__dict__["eip_id"] = eip_id
        __props__.__dict__["eip_type"] = eip_type
        __props__.__dict__["enterprise_project_id"] = enterprise_project_id
        __props__.__dict__["expired_time"] = expired_time
        __props__.__dict__["flavor_id"] = flavor_id
        __props__.__dict__["flavor_name"] = flavor_name
        __props__.__dict__["hostname"] = hostname
        __props__.__dict__["image_id"] = image_id
        __props__.__dict__["image_name"] = image_name
        __props__.__dict__["key_pair"] = key_pair
        __props__.__dict__["metadata"] = metadata
        __props__.__dict__["name"] = name
        __props__.__dict__["networks"] = networks
        __props__.__dict__["period"] = period
        __props__.__dict__["period_unit"] = period_unit
        __props__.__dict__["power_action"] = power_action
        __props__.__dict__["private_key"] = private_key
        __props__.__dict__["public_ip"] = public_ip
        __props__.__dict__["region"] = region
        __props__.__dict__["scheduler_hints"] = scheduler_hints
        __props__.__dict__["security_group_ids"] = security_group_ids
        __props__.__dict__["security_groups"] = security_groups
        __props__.__dict__["spot_duration"] = spot_duration
        __props__.__dict__["spot_duration_count"] = spot_duration_count
        __props__.__dict__["spot_maximum_price"] = spot_maximum_price
        __props__.__dict__["status"] = status
        __props__.__dict__["stop_before_destroy"] = stop_before_destroy
        __props__.__dict__["system_disk_dss_pool_id"] = system_disk_dss_pool_id
        __props__.__dict__["system_disk_id"] = system_disk_id
        __props__.__dict__["system_disk_iops"] = system_disk_iops
        __props__.__dict__["system_disk_kms_key_id"] = system_disk_kms_key_id
        __props__.__dict__["system_disk_size"] = system_disk_size
        __props__.__dict__["system_disk_throughput"] = system_disk_throughput
        __props__.__dict__["system_disk_type"] = system_disk_type
        __props__.__dict__["tags"] = tags
        __props__.__dict__["updated_at"] = updated_at
        __props__.__dict__["user_data"] = user_data
        __props__.__dict__["user_id"] = user_id
        __props__.__dict__["volume_attacheds"] = volume_attacheds
        return Instance(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accessIpV4")
    def access_ip_v4(self) -> pulumi.Output[str]:
        """
        The first detected Fixed IPv4 address or the Floating IP.
        """
        return pulumi.get(self, "access_ip_v4")

    @property
    @pulumi.getter(name="accessIpV6")
    def access_ip_v6(self) -> pulumi.Output[str]:
        """
        The first detected Fixed IPv6 address.
        """
        return pulumi.get(self, "access_ip_v6")

    @property
    @pulumi.getter(name="adminPass")
    def admin_pass(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the administrative password to assign to the instance.
        """
        return pulumi.get(self, "admin_pass")

    @property
    @pulumi.getter(name="agencyName")
    def agency_name(self) -> pulumi.Output[str]:
        """
        Specifies the IAM agency name which is created on IAM to provide
        temporary credentials for ECS to access cloud services.
        """
        return pulumi.get(self, "agency_name")

    @property
    @pulumi.getter(name="agentList")
    def agent_list(self) -> pulumi.Output[str]:
        """
        Specifies the agent list in comma-separated string.
        Available agents are:
        + `ces`: enable cloud eye monitoring.
        + `hss`: enable host security basic.
        + `hss,hss-ent`: enable host security enterprise edition.
        """
        return pulumi.get(self, "agent_list")

    @property
    @pulumi.getter(name="autoPay")
    def auto_pay(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "auto_pay")

    @property
    @pulumi.getter(name="autoRenew")
    def auto_renew(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies whether auto renew is enabled.
        Valid values are *true* and *false*. Defaults to *false*.
        """
        return pulumi.get(self, "auto_renew")

    @property
    @pulumi.getter(name="autoTerminateTime")
    def auto_terminate_time(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the auto terminate time.
        The value is in the format of "yyyy-MM-ddTHH:mm:ssZ" in UTC+0 and complies with ISO8601.
        If the value of second (ss) is not "00", the system automatically sets to the current value of minute (mm).
        The auto terminate time must be at least half an hour later than the current time.
        The auto terminate time cannot be three years later than the current time.
        For example, set the value to "2024-09-25T12:05:00Z".
        """
        return pulumi.get(self, "auto_terminate_time")

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> pulumi.Output[str]:
        """
        Specifies the availability zone in which to create the instance.
        Please following [reference](https://developer.huaweicloud.com/intl/en-us/endpoint/?ECS)
        for the values. Changing this creates a new instance.
        """
        return pulumi.get(self, "availability_zone")

    @property
    @pulumi.getter
    def bandwidth(self) -> pulumi.Output[Optional['outputs.InstanceBandwidth']]:
        """
        Specifies the bandwidth of an EIP that will be automatically assigned to the instance.
        The object structure is documented below. Changing this creates a new instance.
        """
        return pulumi.get(self, "bandwidth")

    @property
    @pulumi.getter(name="chargingMode")
    def charging_mode(self) -> pulumi.Output[str]:
        """
        Specifies the charging mode of the instance. Valid values are *prePaid*,
        *postPaid* and *spot*, defaults to *postPaid*. Changing this creates a new instance.
        """
        return pulumi.get(self, "charging_mode")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[str]:
        """
        The creation time, in UTC format.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter(name="dataDisks")
    def data_disks(self) -> pulumi.Output[Optional[Sequence['outputs.InstanceDataDisk']]]:
        """
        Specifies an array of one or more data disks to attach to the instance.
        The data_disks object structure is documented below. Changing this creates a new instance.
        """
        return pulumi.get(self, "data_disks")

    @property
    @pulumi.getter(name="deleteDisksOnTermination")
    def delete_disks_on_termination(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether to delete the data disks when the instance is terminated.
        Defaults to *false*. This parameter is valid if `charging_mode` is set to *postPaid*, and all data disks will be deleted
        in *prePaid* charging mode.
        """
        return pulumi.get(self, "delete_disks_on_termination")

    @property
    @pulumi.getter(name="deleteEipOnTermination")
    def delete_eip_on_termination(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether the EIP is released when the instance is terminated.
        Defaults to *true*.
        """
        return pulumi.get(self, "delete_eip_on_termination")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[str]:
        """
        Specifies the description of the instance. The description consists of 0 to 85
        characters, and can't contain '<' or '>'.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="eipId")
    def eip_id(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the ID of an *existing* EIP assigned to the instance.
        This parameter and `eip_type`, `bandwidth` are alternative. Changing this creates a new instance.
        """
        return pulumi.get(self, "eip_id")

    @property
    @pulumi.getter(name="eipType")
    def eip_type(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the type of an EIP that will be automatically assigned to the instance.
        Available values are *5_bgp* (dynamic BGP) and *5_sbgp* (static BGP). Changing this creates a new instance.
        """
        return pulumi.get(self, "eip_type")

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> pulumi.Output[str]:
        """
        Specifies a unique id in UUID format of enterprise project.
        """
        return pulumi.get(self, "enterprise_project_id")

    @property
    @pulumi.getter(name="expiredTime")
    def expired_time(self) -> pulumi.Output[str]:
        """
        The expired time of prePaid instance, in UTC format.
        """
        return pulumi.get(self, "expired_time")

    @property
    @pulumi.getter(name="flavorId")
    def flavor_id(self) -> pulumi.Output[str]:
        """
        Specifies the flavor ID of the instance to be created.
        """
        return pulumi.get(self, "flavor_id")

    @property
    @pulumi.getter(name="flavorName")
    def flavor_name(self) -> pulumi.Output[str]:
        """
        The flavor name of the instance.
        """
        return pulumi.get(self, "flavor_name")

    @property
    @pulumi.getter
    def hostname(self) -> pulumi.Output[str]:
        """
        The hostname of the instance.
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter(name="imageId")
    def image_id(self) -> pulumi.Output[str]:
        """
        Required if `image_name` is empty. Specifies the image ID of the desired
        image for the instance. Changing this creates a new instance.
        """
        return pulumi.get(self, "image_id")

    @property
    @pulumi.getter(name="imageName")
    def image_name(self) -> pulumi.Output[str]:
        """
        Required if `image_id` is empty. Specifies the name of the desired image
        for the instance. Changing this creates a new instance.
        """
        return pulumi.get(self, "image_name")

    @property
    @pulumi.getter(name="keyPair")
    def key_pair(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the SSH keypair name used for logging in to the instance.
        """
        return pulumi.get(self, "key_pair")

    @property
    @pulumi.getter
    def metadata(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Specifies the user-defined metadata key-value pair.
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Specifies a unique name for the instance. The name consists of 1 to 64 characters,
        including letters, digits, underscores (_), hyphens (-), and periods (.).
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def networks(self) -> pulumi.Output[Sequence['outputs.InstanceNetwork']]:
        """
        Specifies an array of one or more networks to attach to the instance. The
        network object structure is documented below. Changing this creates a new instance.
        """
        return pulumi.get(self, "networks")

    @property
    @pulumi.getter
    def period(self) -> pulumi.Output[Optional[int]]:
        """
        Specifies the charging period of the instance.
        If `period_unit` is set to *month* , the value ranges from 1 to 9. If `period_unit` is set to *year*, the value
        ranges from 1 to 3. This parameter is mandatory if `charging_mode` is set to *prePaid*. Changing this creates a
        new resource.
        """
        return pulumi.get(self, "period")

    @property
    @pulumi.getter(name="periodUnit")
    def period_unit(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the charging period unit of the instance.
        Valid values are *month* and *year*. This parameter is mandatory if `charging_mode` is set to *prePaid*.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "period_unit")

    @property
    @pulumi.getter(name="powerAction")
    def power_action(self) -> pulumi.Output[str]:
        """
        Specifies the power action to be done for the instance.
        The valid values are *ON*, *OFF*, *REBOOT*, *FORCE-OFF* and *FORCE-REBOOT*.
        """
        return pulumi.get(self, "power_action")

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the the private key of the keypair in use. This parameter is mandatory
        when replacing or unbinding a keypair and the instance is in **Running** state.
        """
        return pulumi.get(self, "private_key")

    @property
    @pulumi.getter(name="publicIp")
    def public_ip(self) -> pulumi.Output[str]:
        """
        The EIP address that is associated to the instance.
        """
        return pulumi.get(self, "public_ip")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        Specifies the region in which to create the instance.
        If omitted, the provider-level region will be used. Changing this creates a new instance.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="schedulerHints")
    def scheduler_hints(self) -> pulumi.Output[Sequence['outputs.InstanceSchedulerHint']]:
        """
        Specifies the scheduler with hints on how the instance should be launched. The
        available hints are described below.
        """
        return pulumi.get(self, "scheduler_hints")

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> pulumi.Output[Sequence[str]]:
        """
        Specifies an array of one or more security group IDs to associate with the
        instance.
        """
        return pulumi.get(self, "security_group_ids")

    @property
    @pulumi.getter(name="securityGroups")
    def security_groups(self) -> pulumi.Output[Sequence[str]]:
        """
        An array of one or more security groups to associate with the instance.
        """
        return pulumi.get(self, "security_groups")

    @property
    @pulumi.getter(name="spotDuration")
    def spot_duration(self) -> pulumi.Output[Optional[int]]:
        """
        Specifies the service duration of the spot ECS in hours.  
        The valid value is range from `1` to `6`.
        This parameter takes effect only when `charging_mode` is set to *spot*.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "spot_duration")

    @property
    @pulumi.getter(name="spotDurationCount")
    def spot_duration_count(self) -> pulumi.Output[int]:
        """
        Specifies the number of time periods in the service duration.
        This parameter takes effect only when `charging_mode` is set to *spot* and the default value is 1.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "spot_duration_count")

    @property
    @pulumi.getter(name="spotMaximumPrice")
    def spot_maximum_price(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the highest price per hour you accept for a spot ECS.
        This parameter takes effect only when `charging_mode` is set to *spot*. If the price is not specified,
        the pay-per-use price is used by default. Changing this creates a new instance.
        """
        return pulumi.get(self, "spot_maximum_price")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        The status of the instance.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="stopBeforeDestroy")
    def stop_before_destroy(self) -> pulumi.Output[Optional[bool]]:
        """
        Specifies whether to try stop instance gracefully before destroying it, thus giving
        chance for guest OS daemons to stop correctly. If instance doesn't stop within timeout, it will be destroyed anyway.
        """
        return pulumi.get(self, "stop_before_destroy")

    @property
    @pulumi.getter(name="systemDiskDssPoolId")
    def system_disk_dss_pool_id(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the system disk DSS pool ID. This field is used
        only for dedicated storage. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "system_disk_dss_pool_id")

    @property
    @pulumi.getter(name="systemDiskId")
    def system_disk_id(self) -> pulumi.Output[str]:
        """
        The system disk volume ID.
        """
        return pulumi.get(self, "system_disk_id")

    @property
    @pulumi.getter(name="systemDiskIops")
    def system_disk_iops(self) -> pulumi.Output[int]:
        """
        Specifies the IOPS(Input/Output Operations Per Second) for the disk.
        The field is valid and required when `system_disk_type` is set to **GPSSD2** or **ESSD2**.
        """
        return pulumi.get(self, "system_disk_iops")

    @property
    @pulumi.getter(name="systemDiskKmsKeyId")
    def system_disk_kms_key_id(self) -> pulumi.Output[str]:
        """
        Specifies the ID of a KMS key used to encrypt the system disk.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "system_disk_kms_key_id")

    @property
    @pulumi.getter(name="systemDiskSize")
    def system_disk_size(self) -> pulumi.Output[int]:
        """
        Specifies the system disk size in GB, The value range is 1 to 1024.
        Shrinking the disk is not supported.
        """
        return pulumi.get(self, "system_disk_size")

    @property
    @pulumi.getter(name="systemDiskThroughput")
    def system_disk_throughput(self) -> pulumi.Output[int]:
        """
        Specifies the throughput for the disk. The Unit is MiB/s.
        The field is valid and required when `system_disk_type` is set to **GPSSD2**.
        """
        return pulumi.get(self, "system_disk_throughput")

    @property
    @pulumi.getter(name="systemDiskType")
    def system_disk_type(self) -> pulumi.Output[str]:
        """
        Specifies the system disk type of the instance. Defaults to `GPSSD`.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "system_disk_type")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Specifies the key/value pairs to associate with the instance.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> pulumi.Output[str]:
        """
        The last update time, in UTC format.
        """
        return pulumi.get(self, "updated_at")

    @property
    @pulumi.getter(name="userData")
    def user_data(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the user data to be injected to the instance during the creation. Text
        and text files can be injected. The content of `user_data` can be plaint text or encoded with base64.
        """
        return pulumi.get(self, "user_data")

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies a user ID, required when using key_pair in prePaid charging mode.
        Changing this creates a new instance.
        """
        return pulumi.get(self, "user_id")

    @property
    @pulumi.getter(name="volumeAttacheds")
    def volume_attacheds(self) -> pulumi.Output[Sequence['outputs.InstanceVolumeAttached']]:
        """
        An array of one or more disks to attach to the instance.
        The volume attached object structure is documented below.
        """
        return pulumi.get(self, "volume_attacheds")

