# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetProjectResult',
    'AwaitableGetProjectResult',
    'get_project',
    'get_project_output',
]

@pulumi.output_type
class GetProjectResult:
    """
    A collection of values returned by getProject.
    """
    def __init__(__self__, created_at=None, description=None, id=None, name=None, status=None, updated_at=None):
        if created_at and not isinstance(created_at, str):
            raise TypeError("Expected argument 'created_at' to be a str")
        pulumi.set(__self__, "created_at", created_at)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if status and not isinstance(status, int):
            raise TypeError("Expected argument 'status' to be a int")
        pulumi.set(__self__, "status", status)
        if updated_at and not isinstance(updated_at, str):
            raise TypeError("Expected argument 'updated_at' to be a str")
        pulumi.set(__self__, "updated_at", updated_at)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> str:
        """
        Specifies the time (UTC) when the enterprise project was created. Example: 2018-05-18T06:49:06Z
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Provides supplementary information about the enterprise project.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def status(self) -> int:
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> str:
        """
        Specifies the time (UTC) when the enterprise project was modified. Example: 2018-05-28T02:21:36Z
        """
        return pulumi.get(self, "updated_at")


class AwaitableGetProjectResult(GetProjectResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProjectResult(
            created_at=self.created_at,
            description=self.description,
            id=self.id,
            name=self.name,
            status=self.status,
            updated_at=self.updated_at)


def get_project(id: Optional[str] = None,
                name: Optional[str] = None,
                status: Optional[int] = None,
                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetProjectResult:
    """
    Use this data source to get an enterprise project from HuaweiCloud

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Eps.get_project(name="test")
    ```
    ## Resources Supported Currently

    <!-- markdownlint-disable MD033 -->
    Service Name | Resource Name
    ---- | ---
    AOM | huaweicloud_aom_cmdb_application
    APIG | DedicatedApig.Instance
    AS  | As.Group
    BCS | Bcs.Instance
    BMS | Bms.Instance
    CBR | Cbr.Vault
    CC  | huaweicloud_cc_bandwidth_package<br>huaweicloud_cc_connection<br>huaweicloud_central_network
    CCE | Cce.Cluster
    CCI | Cci.Namespace
    CCM | huaweicloud_ccm_private_certificate<br>huaweicloud_ccm_private_ca
    CDM | Cdm.Cluster
    CDN | Cdn.Domain
    CES | huaweicloud_ces_alarmrule<br>huaweicloud_ces_resource_group
    CodeArts | huaweicloud_codearts_project
    CPH | huaweicloud_cph_server
    CSE | huaweicloud_cse__microservice_engine
    CSS | Css.Cluster
    DataArts | DataArtsStudio.StudioInstance
    DBSS | huaweicloud_dbss_instance
    DC  | huaweicloud_dc_virtual_gateway<br>huaweicloud_dc_virtual_interface
    DCS | Dcs.Instance
    DDM | huaweicloud_ddm_instance
    DDS | Dds.Instance
    DEW | Dew.Key
    DIS | Dis.Stream
    DLI | huaweicloud_dli_database<br>huaweicloud_dli_queue
    DMS | huaweicloud_dms_kafka_instance<br>huaweicloud_dms_rabbitmq_instance<br>huaweicloud_dms_rocketmq_instance
    DNS | huaweicloud_dns_ptrrecord<br>huaweicloud_dns_zone
    DRS | Drs.Job
    DWS | Dws.Cluster
    ECS | Ecs.Instance
    EG  | huaweicloud_eg_custom_event_channel
    EIP | huaweicloud_vpc_eip<br>huaweicloud_vpc_bandwidth
    ELB | huaweicloud_elb_loadbalancer<br>huaweicloud_elb_certificate<br>huaweicloud_elb_ipgroup<br>huaweicloud_elb_security_policy
    ER  | Er.Instance
    EVS | Evs.Volume
    FGS | FunctionGraph.Function
    GA  | huaweicloud_ga_accelerator
    GaussDB | huaweicloud_gaussdb_cassandra_instance<br>huaweicloud_gaussdb_influx_instance<br>huaweicloud_gaussdb_mongo_instance<br>huaweicloud_gaussdb_mysql_instance<br>huaweicloud_gaussdb_opengauss_instance<br>huaweicloud_gaussdb_redis_instance
    GES | huaweicloud_ges_graph
    HSS | huaweicloud_hss_host_group
    IAM | huaweicloud_identity_group_role_assignment<br>huaweicloud_identity_user_role_assignment
    IMS | huaweicloud_images_image<br>huaweicloud_images_image_copy
    LB  | huaweicloud_lb_certificate<br>huaweicloud_lb_loadbalancer
    LTS | huaweicloud_lts_stream<br>huaweicloud_lts_waf_access<br>huaweicloud_lts_search_criteria
    ModelArts | huaweicloud_modelarts_workspace
    MRS | Mrs.cluster
    NAT | huaweicloud_nat_gateway<br>huaweicloud_nat_private_gateway<br>huaweicloud_nat_private_transit_ip
    OBS | Obs.Bucket
    RDS | huaweicloud_rds_instance<br>huaweicloud_rds_read_replica_instance
    ServicesTage | huaweicloud_servicestage_application<br>huaweicloud_servicestage_environment
    SFS | huaweicloud_sfs_file_system<br>huaweicloud_sfs_turbo
    SMN | Smn.Topic
    VPC | huaweicloud_vpc<br>huaweicloud_networking_secgroup<br>huaweicloud_vpc_address_group
    VPN | huaweicloud_vpn_gateway
    WAF | huaweicloud_waf_address_group<br>huaweicloud_waf_certificate<br>huaweicloud_waf_cloud_instance<br>huaweicloud_waf_dedicated_domain<br>huaweicloud_waf_dedicated_instance<br>huaweicloud_waf_domain<br>huaweicloud_waf_policy<br>huaweicloud_waf_reference_table<br> huaweicloud_waf_rule_anti_crawler<br>huaweicloud_waf_rule_blacklist<br>huaweicloud_waf_rule_cc_protection<br>huaweicloud_waf_rule_data_masking<br>huaweicloud_waf_rule_geolocation_access_control<br>huaweicloud_waf_rule_global_protection_whitelist<br>huaweicloud_waf_rule_information_leakage_prevention<br>huaweicloud_waf_rule_known_attack_source<br>huaweicloud_waf_rule_precise_protection<br>huaweicloud_waf_rule_web_tamper_protection
    WorkSpace | huaweicloud_workspace_desktop<br>
    <!-- markdownlint-enable MD033 -->


    :param str id: Specifies the ID of an enterprise project. The value 0 indicates enterprise project default.
    :param str name: Specifies the enterprise project name. Fuzzy search is supported.
    :param int status: Specifies the status of an enterprise project.
           + 1 indicates Enabled.
           + 2 indicates Disabled.
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['name'] = name
    __args__['status'] = status
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Eps/getProject:getProject', __args__, opts=opts, typ=GetProjectResult).value

    return AwaitableGetProjectResult(
        created_at=__ret__.created_at,
        description=__ret__.description,
        id=__ret__.id,
        name=__ret__.name,
        status=__ret__.status,
        updated_at=__ret__.updated_at)


@_utilities.lift_output_func(get_project)
def get_project_output(id: Optional[pulumi.Input[Optional[str]]] = None,
                       name: Optional[pulumi.Input[Optional[str]]] = None,
                       status: Optional[pulumi.Input[Optional[int]]] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetProjectResult]:
    """
    Use this data source to get an enterprise project from HuaweiCloud

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Eps.get_project(name="test")
    ```
    ## Resources Supported Currently

    <!-- markdownlint-disable MD033 -->
    Service Name | Resource Name
    ---- | ---
    AOM | huaweicloud_aom_cmdb_application
    APIG | DedicatedApig.Instance
    AS  | As.Group
    BCS | Bcs.Instance
    BMS | Bms.Instance
    CBR | Cbr.Vault
    CC  | huaweicloud_cc_bandwidth_package<br>huaweicloud_cc_connection<br>huaweicloud_central_network
    CCE | Cce.Cluster
    CCI | Cci.Namespace
    CCM | huaweicloud_ccm_private_certificate<br>huaweicloud_ccm_private_ca
    CDM | Cdm.Cluster
    CDN | Cdn.Domain
    CES | huaweicloud_ces_alarmrule<br>huaweicloud_ces_resource_group
    CodeArts | huaweicloud_codearts_project
    CPH | huaweicloud_cph_server
    CSE | huaweicloud_cse__microservice_engine
    CSS | Css.Cluster
    DataArts | DataArtsStudio.StudioInstance
    DBSS | huaweicloud_dbss_instance
    DC  | huaweicloud_dc_virtual_gateway<br>huaweicloud_dc_virtual_interface
    DCS | Dcs.Instance
    DDM | huaweicloud_ddm_instance
    DDS | Dds.Instance
    DEW | Dew.Key
    DIS | Dis.Stream
    DLI | huaweicloud_dli_database<br>huaweicloud_dli_queue
    DMS | huaweicloud_dms_kafka_instance<br>huaweicloud_dms_rabbitmq_instance<br>huaweicloud_dms_rocketmq_instance
    DNS | huaweicloud_dns_ptrrecord<br>huaweicloud_dns_zone
    DRS | Drs.Job
    DWS | Dws.Cluster
    ECS | Ecs.Instance
    EG  | huaweicloud_eg_custom_event_channel
    EIP | huaweicloud_vpc_eip<br>huaweicloud_vpc_bandwidth
    ELB | huaweicloud_elb_loadbalancer<br>huaweicloud_elb_certificate<br>huaweicloud_elb_ipgroup<br>huaweicloud_elb_security_policy
    ER  | Er.Instance
    EVS | Evs.Volume
    FGS | FunctionGraph.Function
    GA  | huaweicloud_ga_accelerator
    GaussDB | huaweicloud_gaussdb_cassandra_instance<br>huaweicloud_gaussdb_influx_instance<br>huaweicloud_gaussdb_mongo_instance<br>huaweicloud_gaussdb_mysql_instance<br>huaweicloud_gaussdb_opengauss_instance<br>huaweicloud_gaussdb_redis_instance
    GES | huaweicloud_ges_graph
    HSS | huaweicloud_hss_host_group
    IAM | huaweicloud_identity_group_role_assignment<br>huaweicloud_identity_user_role_assignment
    IMS | huaweicloud_images_image<br>huaweicloud_images_image_copy
    LB  | huaweicloud_lb_certificate<br>huaweicloud_lb_loadbalancer
    LTS | huaweicloud_lts_stream<br>huaweicloud_lts_waf_access<br>huaweicloud_lts_search_criteria
    ModelArts | huaweicloud_modelarts_workspace
    MRS | Mrs.cluster
    NAT | huaweicloud_nat_gateway<br>huaweicloud_nat_private_gateway<br>huaweicloud_nat_private_transit_ip
    OBS | Obs.Bucket
    RDS | huaweicloud_rds_instance<br>huaweicloud_rds_read_replica_instance
    ServicesTage | huaweicloud_servicestage_application<br>huaweicloud_servicestage_environment
    SFS | huaweicloud_sfs_file_system<br>huaweicloud_sfs_turbo
    SMN | Smn.Topic
    VPC | huaweicloud_vpc<br>huaweicloud_networking_secgroup<br>huaweicloud_vpc_address_group
    VPN | huaweicloud_vpn_gateway
    WAF | huaweicloud_waf_address_group<br>huaweicloud_waf_certificate<br>huaweicloud_waf_cloud_instance<br>huaweicloud_waf_dedicated_domain<br>huaweicloud_waf_dedicated_instance<br>huaweicloud_waf_domain<br>huaweicloud_waf_policy<br>huaweicloud_waf_reference_table<br> huaweicloud_waf_rule_anti_crawler<br>huaweicloud_waf_rule_blacklist<br>huaweicloud_waf_rule_cc_protection<br>huaweicloud_waf_rule_data_masking<br>huaweicloud_waf_rule_geolocation_access_control<br>huaweicloud_waf_rule_global_protection_whitelist<br>huaweicloud_waf_rule_information_leakage_prevention<br>huaweicloud_waf_rule_known_attack_source<br>huaweicloud_waf_rule_precise_protection<br>huaweicloud_waf_rule_web_tamper_protection
    WorkSpace | huaweicloud_workspace_desktop<br>
    <!-- markdownlint-enable MD033 -->


    :param str id: Specifies the ID of an enterprise project. The value 0 indicates enterprise project default.
    :param str name: Specifies the enterprise project name. Fuzzy search is supported.
    :param int status: Specifies the status of an enterprise project.
           + 1 indicates Enabled.
           + 2 indicates Disabled.
    """
    ...
