# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetAvailableRoutesResult',
    'AwaitableGetAvailableRoutesResult',
    'get_available_routes',
    'get_available_routes_output',
]

@pulumi.output_type
class GetAvailableRoutesResult:
    """
    A collection of values returned by getAvailableRoutes.
    """
    def __init__(__self__, destination=None, id=None, region=None, resource_type=None, route_table_id=None, routes=None):
        if destination and not isinstance(destination, str):
            raise TypeError("Expected argument 'destination' to be a str")
        pulumi.set(__self__, "destination", destination)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if resource_type and not isinstance(resource_type, str):
            raise TypeError("Expected argument 'resource_type' to be a str")
        pulumi.set(__self__, "resource_type", resource_type)
        if route_table_id and not isinstance(route_table_id, str):
            raise TypeError("Expected argument 'route_table_id' to be a str")
        pulumi.set(__self__, "route_table_id", route_table_id)
        if routes and not isinstance(routes, list):
            raise TypeError("Expected argument 'routes' to be a list")
        pulumi.set(__self__, "routes", routes)

    @property
    @pulumi.getter
    def destination(self) -> Optional[str]:
        """
        The destination address of the route.
        """
        return pulumi.get(self, "destination")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> Optional[str]:
        """
        The attachment type.
        """
        return pulumi.get(self, "resource_type")

    @property
    @pulumi.getter(name="routeTableId")
    def route_table_id(self) -> str:
        return pulumi.get(self, "route_table_id")

    @property
    @pulumi.getter
    def routes(self) -> Sequence['outputs.GetAvailableRoutesRouteResult']:
        """
        All available routes that match the filter parameters.
        """
        return pulumi.get(self, "routes")


class AwaitableGetAvailableRoutesResult(GetAvailableRoutesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAvailableRoutesResult(
            destination=self.destination,
            id=self.id,
            region=self.region,
            resource_type=self.resource_type,
            route_table_id=self.route_table_id,
            routes=self.routes)


def get_available_routes(destination: Optional[str] = None,
                         region: Optional[str] = None,
                         resource_type: Optional[str] = None,
                         route_table_id: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAvailableRoutesResult:
    """
    Using this data source to query the list of available routes within HuaweiCloud.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    route_table_id = config.require_object("routeTableId")
    test = huaweicloud.Er.get_available_routes(route_table_id=route_table_id)
    ```


    :param str destination: The destination address of the routes to be queried.
    :param str region: Specifies the region in which to query the available routes.
           If omitted, the provider-level region will be used.
    :param str resource_type: The attachment type.
           The valid values are as follows:
           + **vpc**: VPC attachment.
           + **vpn**: VPN gateway attachment.
           + **vgw**: virtual gateway attachment.
           + **peering**: peering connection attachment.
           + **ecn**: ECN attachment.
           + **cfw**: CFW instance attachment.
    :param str route_table_id: The route table ID to which the available routes belong.
    """
    __args__ = dict()
    __args__['destination'] = destination
    __args__['region'] = region
    __args__['resourceType'] = resource_type
    __args__['routeTableId'] = route_table_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Er/getAvailableRoutes:getAvailableRoutes', __args__, opts=opts, typ=GetAvailableRoutesResult).value

    return AwaitableGetAvailableRoutesResult(
        destination=__ret__.destination,
        id=__ret__.id,
        region=__ret__.region,
        resource_type=__ret__.resource_type,
        route_table_id=__ret__.route_table_id,
        routes=__ret__.routes)


@_utilities.lift_output_func(get_available_routes)
def get_available_routes_output(destination: Optional[pulumi.Input[Optional[str]]] = None,
                                region: Optional[pulumi.Input[Optional[str]]] = None,
                                resource_type: Optional[pulumi.Input[Optional[str]]] = None,
                                route_table_id: Optional[pulumi.Input[str]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAvailableRoutesResult]:
    """
    Using this data source to query the list of available routes within HuaweiCloud.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    route_table_id = config.require_object("routeTableId")
    test = huaweicloud.Er.get_available_routes(route_table_id=route_table_id)
    ```


    :param str destination: The destination address of the routes to be queried.
    :param str region: Specifies the region in which to query the available routes.
           If omitted, the provider-level region will be used.
    :param str resource_type: The attachment type.
           The valid values are as follows:
           + **vpc**: VPC attachment.
           + **vpn**: VPN gateway attachment.
           + **vgw**: virtual gateway attachment.
           + **peering**: peering connection attachment.
           + **ecn**: ECN attachment.
           + **cfw**: CFW instance attachment.
    :param str route_table_id: The route table ID to which the available routes belong.
    """
    ...
