# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetFlowLogsResult',
    'AwaitableGetFlowLogsResult',
    'get_flow_logs',
    'get_flow_logs_output',
]

@pulumi.output_type
class GetFlowLogsResult:
    """
    A collection of values returned by getFlowLogs.
    """
    def __init__(__self__, enabled=None, flow_log_id=None, flow_logs=None, id=None, instance_id=None, log_group_id=None, log_stream_id=None, name=None, region=None, resource_id=None, resource_type=None, status=None):
        if enabled and not isinstance(enabled, str):
            raise TypeError("Expected argument 'enabled' to be a str")
        pulumi.set(__self__, "enabled", enabled)
        if flow_log_id and not isinstance(flow_log_id, str):
            raise TypeError("Expected argument 'flow_log_id' to be a str")
        pulumi.set(__self__, "flow_log_id", flow_log_id)
        if flow_logs and not isinstance(flow_logs, list):
            raise TypeError("Expected argument 'flow_logs' to be a list")
        pulumi.set(__self__, "flow_logs", flow_logs)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if log_group_id and not isinstance(log_group_id, str):
            raise TypeError("Expected argument 'log_group_id' to be a str")
        pulumi.set(__self__, "log_group_id", log_group_id)
        if log_stream_id and not isinstance(log_stream_id, str):
            raise TypeError("Expected argument 'log_stream_id' to be a str")
        pulumi.set(__self__, "log_stream_id", log_stream_id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if resource_id and not isinstance(resource_id, str):
            raise TypeError("Expected argument 'resource_id' to be a str")
        pulumi.set(__self__, "resource_id", resource_id)
        if resource_type and not isinstance(resource_type, str):
            raise TypeError("Expected argument 'resource_type' to be a str")
        pulumi.set(__self__, "resource_type", resource_type)
        if status and not isinstance(status, str):
            raise TypeError("Expected argument 'status' to be a str")
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[str]:
        """
        The switch of the flow log.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="flowLogId")
    def flow_log_id(self) -> Optional[str]:
        return pulumi.get(self, "flow_log_id")

    @property
    @pulumi.getter(name="flowLogs")
    def flow_logs(self) -> Sequence['outputs.GetFlowLogsFlowLogResult']:
        """
        The list ot the flow logs.
        The flow_logs structure is documented below.
        """
        return pulumi.get(self, "flow_logs")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="logGroupId")
    def log_group_id(self) -> Optional[str]:
        """
        The ID of the log group to which the flow log belongs.
        """
        return pulumi.get(self, "log_group_id")

    @property
    @pulumi.getter(name="logStreamId")
    def log_stream_id(self) -> Optional[str]:
        """
        The ID of the log stream to which the flow log belongs.
        """
        return pulumi.get(self, "log_stream_id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The name of the flow log.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def region(self) -> Optional[str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> Optional[str]:
        """
        The ID of the attachment to which the flow log belongs.
        """
        return pulumi.get(self, "resource_id")

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> Optional[str]:
        """
        The type of the flow log.
        """
        return pulumi.get(self, "resource_type")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        The status of the flow log.
        """
        return pulumi.get(self, "status")


class AwaitableGetFlowLogsResult(GetFlowLogsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFlowLogsResult(
            enabled=self.enabled,
            flow_log_id=self.flow_log_id,
            flow_logs=self.flow_logs,
            id=self.id,
            instance_id=self.instance_id,
            log_group_id=self.log_group_id,
            log_stream_id=self.log_stream_id,
            name=self.name,
            region=self.region,
            resource_id=self.resource_id,
            resource_type=self.resource_type,
            status=self.status)


def get_flow_logs(enabled: Optional[str] = None,
                  flow_log_id: Optional[str] = None,
                  instance_id: Optional[str] = None,
                  log_group_id: Optional[str] = None,
                  log_stream_id: Optional[str] = None,
                  name: Optional[str] = None,
                  region: Optional[str] = None,
                  resource_id: Optional[str] = None,
                  resource_type: Optional[str] = None,
                  status: Optional[str] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFlowLogsResult:
    """
    Use this data source to get the list of flow logs.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    instance_id = config.require_object("instanceId")
    resource_id = config.require_object("resourceId")
    test = huaweicloud.Er.get_flow_logs(instance_id=instance_id,
        resource_id=resource_id)
    ```


    :param str enabled: Specifies the switch status of the flow log.
           The value can be **true** and **false**.
    :param str flow_log_id: Specifies the ID of the flow log.
    :param str instance_id: Specifies the ID of the ER instance to which the flow logs belong.
    :param str log_group_id: Specifies the ID of the log group to which the flow logs belong.
    :param str log_stream_id: Specifies the ID of the log stream to which the flow logs belong.
    :param str name: Specifies the name of the flow log.
    :param str region: Specifies the region where the flow logs are located.
           If omitted, the provider-level region will be used.
    :param str resource_id: Specifies the ID of the attachment to which the flow logs belong.
    :param str resource_type: Specifies the type of the flow logs.
           The valid values are as follows:
           + **attachment**: The flow logs type are attachment.
    :param str status: Specifies the status of the flow logs.
    """
    __args__ = dict()
    __args__['enabled'] = enabled
    __args__['flowLogId'] = flow_log_id
    __args__['instanceId'] = instance_id
    __args__['logGroupId'] = log_group_id
    __args__['logStreamId'] = log_stream_id
    __args__['name'] = name
    __args__['region'] = region
    __args__['resourceId'] = resource_id
    __args__['resourceType'] = resource_type
    __args__['status'] = status
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Er/getFlowLogs:getFlowLogs', __args__, opts=opts, typ=GetFlowLogsResult).value

    return AwaitableGetFlowLogsResult(
        enabled=__ret__.enabled,
        flow_log_id=__ret__.flow_log_id,
        flow_logs=__ret__.flow_logs,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        log_group_id=__ret__.log_group_id,
        log_stream_id=__ret__.log_stream_id,
        name=__ret__.name,
        region=__ret__.region,
        resource_id=__ret__.resource_id,
        resource_type=__ret__.resource_type,
        status=__ret__.status)


@_utilities.lift_output_func(get_flow_logs)
def get_flow_logs_output(enabled: Optional[pulumi.Input[Optional[str]]] = None,
                         flow_log_id: Optional[pulumi.Input[Optional[str]]] = None,
                         instance_id: Optional[pulumi.Input[str]] = None,
                         log_group_id: Optional[pulumi.Input[Optional[str]]] = None,
                         log_stream_id: Optional[pulumi.Input[Optional[str]]] = None,
                         name: Optional[pulumi.Input[Optional[str]]] = None,
                         region: Optional[pulumi.Input[Optional[str]]] = None,
                         resource_id: Optional[pulumi.Input[Optional[str]]] = None,
                         resource_type: Optional[pulumi.Input[Optional[str]]] = None,
                         status: Optional[pulumi.Input[Optional[str]]] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetFlowLogsResult]:
    """
    Use this data source to get the list of flow logs.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    instance_id = config.require_object("instanceId")
    resource_id = config.require_object("resourceId")
    test = huaweicloud.Er.get_flow_logs(instance_id=instance_id,
        resource_id=resource_id)
    ```


    :param str enabled: Specifies the switch status of the flow log.
           The value can be **true** and **false**.
    :param str flow_log_id: Specifies the ID of the flow log.
    :param str instance_id: Specifies the ID of the ER instance to which the flow logs belong.
    :param str log_group_id: Specifies the ID of the log group to which the flow logs belong.
    :param str log_stream_id: Specifies the ID of the log stream to which the flow logs belong.
    :param str name: Specifies the name of the flow log.
    :param str region: Specifies the region where the flow logs are located.
           If omitted, the provider-level region will be used.
    :param str resource_id: Specifies the ID of the attachment to which the flow logs belong.
    :param str resource_type: Specifies the type of the flow logs.
           The valid values are as follows:
           + **attachment**: The flow logs type are attachment.
    :param str status: Specifies the status of the flow logs.
    """
    ...
