# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetInstancesResult',
    'AwaitableGetInstancesResult',
    'get_instances',
    'get_instances_output',
]

@pulumi.output_type
class GetInstancesResult:
    """
    A collection of values returned by getInstances.
    """
    def __init__(__self__, enterprise_project_id=None, id=None, instance_id=None, instances=None, name=None, owned_by_self=None, region=None, status=None, tags=None):
        if enterprise_project_id and not isinstance(enterprise_project_id, str):
            raise TypeError("Expected argument 'enterprise_project_id' to be a str")
        pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if instances and not isinstance(instances, list):
            raise TypeError("Expected argument 'instances' to be a list")
        pulumi.set(__self__, "instances", instances)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if owned_by_self and not isinstance(owned_by_self, bool):
            raise TypeError("Expected argument 'owned_by_self' to be a bool")
        pulumi.set(__self__, "owned_by_self", owned_by_self)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if status and not isinstance(status, str):
            raise TypeError("Expected argument 'status' to be a str")
        pulumi.set(__self__, "status", status)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[str]:
        """
        The ID of enterprise project to which the ER instance belongs.
        """
        return pulumi.get(self, "enterprise_project_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[str]:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def instances(self) -> Sequence['outputs.GetInstancesInstanceResult']:
        """
        All instances that match the filter parameters.  
        The object structure is documented below.
        """
        return pulumi.get(self, "instances")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The name of the ER instance.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="ownedBySelf")
    def owned_by_self(self) -> Optional[bool]:
        return pulumi.get(self, "owned_by_self")

    @property
    @pulumi.getter
    def region(self) -> Optional[str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        The current status of the ER instance.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, str]]:
        """
        The key/value pairs to associate with the ER instance.
        """
        return pulumi.get(self, "tags")


class AwaitableGetInstancesResult(GetInstancesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInstancesResult(
            enterprise_project_id=self.enterprise_project_id,
            id=self.id,
            instance_id=self.instance_id,
            instances=self.instances,
            name=self.name,
            owned_by_self=self.owned_by_self,
            region=self.region,
            status=self.status,
            tags=self.tags)


def get_instances(enterprise_project_id: Optional[str] = None,
                  instance_id: Optional[str] = None,
                  name: Optional[str] = None,
                  owned_by_self: Optional[bool] = None,
                  region: Optional[str] = None,
                  status: Optional[str] = None,
                  tags: Optional[Mapping[str, str]] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInstancesResult:
    """
    Use this data source to filter ER instances within HuaweiCloud.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Er.get_instances(tags={
        "foo": "bar",
    })
    ```


    :param str enterprise_project_id: Specifies the enterprise project ID of the ER instances to be queried.
    :param str instance_id: Specifies the ID used to query specified ER instance.
    :param str name: Specifies the name used to filter the ER instances.
           The valid length is limited from `1` to `64`, only Chinese and English letters, digits, underscores (_) and
           hyphens (-) are allowed.
    :param bool owned_by_self: Specifies whether resources belong to the current renant.
    :param str region: Specifies the region where the ER instances are located.  
           If omitted, the provider-level region will be used.
    :param str status: Specifies the status used to filter the ER instances.
    :param Mapping[str, str] tags: Specifies the key/value pairs used to filter the ER instances.
    """
    __args__ = dict()
    __args__['enterpriseProjectId'] = enterprise_project_id
    __args__['instanceId'] = instance_id
    __args__['name'] = name
    __args__['ownedBySelf'] = owned_by_self
    __args__['region'] = region
    __args__['status'] = status
    __args__['tags'] = tags
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Er/getInstances:getInstances', __args__, opts=opts, typ=GetInstancesResult).value

    return AwaitableGetInstancesResult(
        enterprise_project_id=__ret__.enterprise_project_id,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        instances=__ret__.instances,
        name=__ret__.name,
        owned_by_self=__ret__.owned_by_self,
        region=__ret__.region,
        status=__ret__.status,
        tags=__ret__.tags)


@_utilities.lift_output_func(get_instances)
def get_instances_output(enterprise_project_id: Optional[pulumi.Input[Optional[str]]] = None,
                         instance_id: Optional[pulumi.Input[Optional[str]]] = None,
                         name: Optional[pulumi.Input[Optional[str]]] = None,
                         owned_by_self: Optional[pulumi.Input[Optional[bool]]] = None,
                         region: Optional[pulumi.Input[Optional[str]]] = None,
                         status: Optional[pulumi.Input[Optional[str]]] = None,
                         tags: Optional[pulumi.Input[Optional[Mapping[str, str]]]] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetInstancesResult]:
    """
    Use this data source to filter ER instances within HuaweiCloud.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Er.get_instances(tags={
        "foo": "bar",
    })
    ```


    :param str enterprise_project_id: Specifies the enterprise project ID of the ER instances to be queried.
    :param str instance_id: Specifies the ID used to query specified ER instance.
    :param str name: Specifies the name used to filter the ER instances.
           The valid length is limited from `1` to `64`, only Chinese and English letters, digits, underscores (_) and
           hyphens (-) are allowed.
    :param bool owned_by_self: Specifies whether resources belong to the current renant.
    :param str region: Specifies the region where the ER instances are located.  
           If omitted, the provider-level region will be used.
    :param str status: Specifies the status used to filter the ER instances.
    :param Mapping[str, str] tags: Specifies the key/value pairs used to filter the ER instances.
    """
    ...
