# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetPropagationsResult',
    'AwaitableGetPropagationsResult',
    'get_propagations',
    'get_propagations_output',
]

@pulumi.output_type
class GetPropagationsResult:
    """
    A collection of values returned by getPropagations.
    """
    def __init__(__self__, attachment_id=None, attachment_type=None, id=None, instance_id=None, propagations=None, region=None, route_table_id=None, status=None):
        if attachment_id and not isinstance(attachment_id, str):
            raise TypeError("Expected argument 'attachment_id' to be a str")
        pulumi.set(__self__, "attachment_id", attachment_id)
        if attachment_type and not isinstance(attachment_type, str):
            raise TypeError("Expected argument 'attachment_type' to be a str")
        pulumi.set(__self__, "attachment_type", attachment_type)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if propagations and not isinstance(propagations, list):
            raise TypeError("Expected argument 'propagations' to be a list")
        pulumi.set(__self__, "propagations", propagations)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if route_table_id and not isinstance(route_table_id, str):
            raise TypeError("Expected argument 'route_table_id' to be a str")
        pulumi.set(__self__, "route_table_id", route_table_id)
        if status and not isinstance(status, str):
            raise TypeError("Expected argument 'status' to be a str")
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="attachmentId")
    def attachment_id(self) -> Optional[str]:
        """
        The attachment ID corresponding to the propagation.
        """
        return pulumi.get(self, "attachment_id")

    @property
    @pulumi.getter(name="attachmentType")
    def attachment_type(self) -> Optional[str]:
        """
        The attachment type corresponding to the propagation.
        """
        return pulumi.get(self, "attachment_type")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        """
        The ER instance ID to which the propagation belongs.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def propagations(self) -> Sequence['outputs.GetPropagationsPropagationResult']:
        """
        All propagations that match the filter parameters.
        The propagations structure is documented below.
        """
        return pulumi.get(self, "propagations")

    @property
    @pulumi.getter
    def region(self) -> Optional[str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="routeTableId")
    def route_table_id(self) -> str:
        """
        The route table ID of corresponding to the propagation.
        """
        return pulumi.get(self, "route_table_id")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        The current status of the propagation.
        """
        return pulumi.get(self, "status")


class AwaitableGetPropagationsResult(GetPropagationsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPropagationsResult(
            attachment_id=self.attachment_id,
            attachment_type=self.attachment_type,
            id=self.id,
            instance_id=self.instance_id,
            propagations=self.propagations,
            region=self.region,
            route_table_id=self.route_table_id,
            status=self.status)


def get_propagations(attachment_id: Optional[str] = None,
                     attachment_type: Optional[str] = None,
                     instance_id: Optional[str] = None,
                     region: Optional[str] = None,
                     route_table_id: Optional[str] = None,
                     status: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPropagationsResult:
    """
    Use this data source to get the list of propagations.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    instance_id = config.require_object("instanceId")
    route_table_id = config.require_object("routeTableId")
    attachment_id = config.require_object("attachmentId")
    test = huaweicloud.Er.get_propagations(instance_id=instance_id,
        route_table_id=route_table_id,
        attachment_id=attachment_id)
    ```


    :param str attachment_id: Specifies the attachment ID to which the propagation belongs.
    :param str attachment_type: Specifies the attachment type of corresponding to the propagation.  
           The valid values are as follows:
           + **vpc**: Virtual private cloud.
           + **vpn**: VPN gateway.
           + **vgw**: Virtual gateway of cloud private line.
           + **peering**: Peering connection, through the cloud connection (CC) to load ERs in different regions to create a
           peering connection.
           + **enc**: Enterprise connect network in EC.
           + **cfw**: VPC border firewall.
    :param str instance_id: Specifies the ER instance ID to which the propagation belongs.
    :param str region: Specifies the region in which to query the data source.
           If omitted, the provider-level region will be used.
    :param str route_table_id: Specifies the route table ID to which the propagation belongs.
    :param str status: Specifies the status of the propagation. Default value is `available`.
           The valid values are as follows:
           + **available**
           + **failed**
    """
    __args__ = dict()
    __args__['attachmentId'] = attachment_id
    __args__['attachmentType'] = attachment_type
    __args__['instanceId'] = instance_id
    __args__['region'] = region
    __args__['routeTableId'] = route_table_id
    __args__['status'] = status
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Er/getPropagations:getPropagations', __args__, opts=opts, typ=GetPropagationsResult).value

    return AwaitableGetPropagationsResult(
        attachment_id=__ret__.attachment_id,
        attachment_type=__ret__.attachment_type,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        propagations=__ret__.propagations,
        region=__ret__.region,
        route_table_id=__ret__.route_table_id,
        status=__ret__.status)


@_utilities.lift_output_func(get_propagations)
def get_propagations_output(attachment_id: Optional[pulumi.Input[Optional[str]]] = None,
                            attachment_type: Optional[pulumi.Input[Optional[str]]] = None,
                            instance_id: Optional[pulumi.Input[str]] = None,
                            region: Optional[pulumi.Input[Optional[str]]] = None,
                            route_table_id: Optional[pulumi.Input[str]] = None,
                            status: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPropagationsResult]:
    """
    Use this data source to get the list of propagations.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    instance_id = config.require_object("instanceId")
    route_table_id = config.require_object("routeTableId")
    attachment_id = config.require_object("attachmentId")
    test = huaweicloud.Er.get_propagations(instance_id=instance_id,
        route_table_id=route_table_id,
        attachment_id=attachment_id)
    ```


    :param str attachment_id: Specifies the attachment ID to which the propagation belongs.
    :param str attachment_type: Specifies the attachment type of corresponding to the propagation.  
           The valid values are as follows:
           + **vpc**: Virtual private cloud.
           + **vpn**: VPN gateway.
           + **vgw**: Virtual gateway of cloud private line.
           + **peering**: Peering connection, through the cloud connection (CC) to load ERs in different regions to create a
           peering connection.
           + **enc**: Enterprise connect network in EC.
           + **cfw**: VPC border firewall.
    :param str instance_id: Specifies the ER instance ID to which the propagation belongs.
    :param str region: Specifies the region in which to query the data source.
           If omitted, the provider-level region will be used.
    :param str route_table_id: Specifies the route table ID to which the propagation belongs.
    :param str status: Specifies the status of the propagation. Default value is `available`.
           The valid values are as follows:
           + **available**
           + **failed**
    """
    ...
