# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetResourceTagsResult',
    'AwaitableGetResourceTagsResult',
    'get_resource_tags',
    'get_resource_tags_output',
]

@pulumi.output_type
class GetResourceTagsResult:
    """
    A collection of values returned by getResourceTags.
    """
    def __init__(__self__, id=None, region=None, resource_id=None, resource_type=None, tags=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if resource_id and not isinstance(resource_id, str):
            raise TypeError("Expected argument 'resource_id' to be a str")
        pulumi.set(__self__, "resource_id", resource_id)
        if resource_type and not isinstance(resource_type, str):
            raise TypeError("Expected argument 'resource_type' to be a str")
        pulumi.set(__self__, "resource_type", resource_type)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> str:
        return pulumi.get(self, "resource_id")

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> str:
        return pulumi.get(self, "resource_type")

    @property
    @pulumi.getter
    def tags(self) -> Mapping[str, str]:
        """
        The tags of a specified resource.
        """
        return pulumi.get(self, "tags")


class AwaitableGetResourceTagsResult(GetResourceTagsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetResourceTagsResult(
            id=self.id,
            region=self.region,
            resource_id=self.resource_id,
            resource_type=self.resource_type,
            tags=self.tags)


def get_resource_tags(region: Optional[str] = None,
                      resource_id: Optional[str] = None,
                      resource_type: Optional[str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetResourceTagsResult:
    """
    Use this data source to query the tag list of a specifies resource within HuaweiCloud.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    instance_id = config.require_object("instanceId")
    test = huaweicloud.Er.get_resource_tags(resource_type="instance",
        resource_id=instance_id)
    ```


    :param str region: Specifies the region in which to query the resource tags.  
           If omitted, the provider-level region will be used.
    :param str resource_id: Specifies the resource ID to which the tags belong that to be queried.
    :param str resource_type: Specifies the resource type to which the tags belong that to be queried.  
           The valid values are as follows:
           + **instance**: enterprise router instance.
           + **route-table**: route table.
           + **vpc-attachment**: VPC connection.
           + **vgw-attachment**: virtual gateway connection.
           + **peering-attachment**: peering connection.
           + **vpn-attachment**: VPN gateway connection.
           + **ecn-attachment**: enterprise network connection.
           + **cfw-attachment**: cloud firewall connection.
    """
    __args__ = dict()
    __args__['region'] = region
    __args__['resourceId'] = resource_id
    __args__['resourceType'] = resource_type
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Er/getResourceTags:getResourceTags', __args__, opts=opts, typ=GetResourceTagsResult).value

    return AwaitableGetResourceTagsResult(
        id=__ret__.id,
        region=__ret__.region,
        resource_id=__ret__.resource_id,
        resource_type=__ret__.resource_type,
        tags=__ret__.tags)


@_utilities.lift_output_func(get_resource_tags)
def get_resource_tags_output(region: Optional[pulumi.Input[Optional[str]]] = None,
                             resource_id: Optional[pulumi.Input[str]] = None,
                             resource_type: Optional[pulumi.Input[str]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetResourceTagsResult]:
    """
    Use this data source to query the tag list of a specifies resource within HuaweiCloud.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    instance_id = config.require_object("instanceId")
    test = huaweicloud.Er.get_resource_tags(resource_type="instance",
        resource_id=instance_id)
    ```


    :param str region: Specifies the region in which to query the resource tags.  
           If omitted, the provider-level region will be used.
    :param str resource_id: Specifies the resource ID to which the tags belong that to be queried.
    :param str resource_type: Specifies the resource type to which the tags belong that to be queried.  
           The valid values are as follows:
           + **instance**: enterprise router instance.
           + **route-table**: route table.
           + **vpc-attachment**: VPC connection.
           + **vgw-attachment**: virtual gateway connection.
           + **peering-attachment**: peering connection.
           + **vpn-attachment**: VPN gateway connection.
           + **ecn-attachment**: enterprise network connection.
           + **cfw-attachment**: cloud firewall connection.
    """
    ...
