# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'VolumeAttachment',
    'VolumeIopsAttribute',
    'VolumeLink',
    'VolumeThroughputAttribute',
    'GetVolumesVolumeResult',
    'GetVolumesVolumeAttachmentResult',
    'GetVolumesVolumeIopsAttributeResult',
    'GetVolumesVolumeLinkResult',
    'GetVolumesVolumeThroughputAttributeResult',
]

@pulumi.output_type
class VolumeAttachment(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "attachedAt":
            suggest = "attached_at"
        elif key == "attachedVolumeId":
            suggest = "attached_volume_id"
        elif key == "hostName":
            suggest = "host_name"
        elif key == "instanceId":
            suggest = "instance_id"
        elif key == "volumeId":
            suggest = "volume_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VolumeAttachment. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VolumeAttachment.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VolumeAttachment.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 attached_at: Optional[str] = None,
                 attached_volume_id: Optional[str] = None,
                 device: Optional[str] = None,
                 host_name: Optional[str] = None,
                 id: Optional[str] = None,
                 instance_id: Optional[str] = None,
                 volume_id: Optional[str] = None):
        """
        :param str attached_at: The time when the disk was attached.
        :param str attached_volume_id: The ID of the attached disk.
        :param str device: The device name.
        :param str host_name: The name of the physical host housing the cloud server to which the disk is attached.
        :param str id: The ID of the attachment information.
        :param str instance_id: The ID of the server to which the disk is attached.
        :param str volume_id: The disk ID.
        """
        if attached_at is not None:
            pulumi.set(__self__, "attached_at", attached_at)
        if attached_volume_id is not None:
            pulumi.set(__self__, "attached_volume_id", attached_volume_id)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if host_name is not None:
            pulumi.set(__self__, "host_name", host_name)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if volume_id is not None:
            pulumi.set(__self__, "volume_id", volume_id)

    @property
    @pulumi.getter(name="attachedAt")
    def attached_at(self) -> Optional[str]:
        """
        The time when the disk was attached.
        """
        return pulumi.get(self, "attached_at")

    @property
    @pulumi.getter(name="attachedVolumeId")
    def attached_volume_id(self) -> Optional[str]:
        """
        The ID of the attached disk.
        """
        return pulumi.get(self, "attached_volume_id")

    @property
    @pulumi.getter
    def device(self) -> Optional[str]:
        """
        The device name.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter(name="hostName")
    def host_name(self) -> Optional[str]:
        """
        The name of the physical host housing the cloud server to which the disk is attached.
        """
        return pulumi.get(self, "host_name")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        The ID of the attachment information.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[str]:
        """
        The ID of the server to which the disk is attached.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="volumeId")
    def volume_id(self) -> Optional[str]:
        """
        The disk ID.
        """
        return pulumi.get(self, "volume_id")


@pulumi.output_type
class VolumeIopsAttribute(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "totalVal":
            suggest = "total_val"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VolumeIopsAttribute. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VolumeIopsAttribute.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VolumeIopsAttribute.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 frozened: Optional[bool] = None,
                 id: Optional[str] = None,
                 total_val: Optional[int] = None):
        """
        :param bool frozened: The frozen tag.
        :param str id: The ID of the attachment information.
        :param int total_val: The throughput.
        """
        if frozened is not None:
            pulumi.set(__self__, "frozened", frozened)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if total_val is not None:
            pulumi.set(__self__, "total_val", total_val)

    @property
    @pulumi.getter
    def frozened(self) -> Optional[bool]:
        """
        The frozen tag.
        """
        return pulumi.get(self, "frozened")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        The ID of the attachment information.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="totalVal")
    def total_val(self) -> Optional[int]:
        """
        The throughput.
        """
        return pulumi.get(self, "total_val")


@pulumi.output_type
class VolumeLink(dict):
    def __init__(__self__, *,
                 href: Optional[str] = None,
                 rel: Optional[str] = None):
        """
        :param str href: The corresponding shortcut link.
        :param str rel: The shortcut link marker name.
        """
        if href is not None:
            pulumi.set(__self__, "href", href)
        if rel is not None:
            pulumi.set(__self__, "rel", rel)

    @property
    @pulumi.getter
    def href(self) -> Optional[str]:
        """
        The corresponding shortcut link.
        """
        return pulumi.get(self, "href")

    @property
    @pulumi.getter
    def rel(self) -> Optional[str]:
        """
        The shortcut link marker name.
        """
        return pulumi.get(self, "rel")


@pulumi.output_type
class VolumeThroughputAttribute(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "totalVal":
            suggest = "total_val"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VolumeThroughputAttribute. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VolumeThroughputAttribute.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VolumeThroughputAttribute.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 frozened: Optional[bool] = None,
                 id: Optional[str] = None,
                 total_val: Optional[int] = None):
        """
        :param bool frozened: The frozen tag.
        :param str id: The ID of the attachment information.
        :param int total_val: The throughput.
        """
        if frozened is not None:
            pulumi.set(__self__, "frozened", frozened)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if total_val is not None:
            pulumi.set(__self__, "total_val", total_val)

    @property
    @pulumi.getter
    def frozened(self) -> Optional[bool]:
        """
        The frozen tag.
        """
        return pulumi.get(self, "frozened")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        The ID of the attachment information.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="totalVal")
    def total_val(self) -> Optional[int]:
        """
        The throughput.
        """
        return pulumi.get(self, "total_val")


@pulumi.output_type
class GetVolumesVolumeResult(dict):
    def __init__(__self__, *,
                 attachments: Sequence['outputs.GetVolumesVolumeAttachmentResult'],
                 availability_zone: str,
                 bootable: bool,
                 create_at: str,
                 dedicated_storage_id: str,
                 dedicated_storage_name: str,
                 description: str,
                 enterprise_project_id: str,
                 id: str,
                 iops: int,
                 iops_attributes: Sequence['outputs.GetVolumesVolumeIopsAttributeResult'],
                 links: Sequence['outputs.GetVolumesVolumeLinkResult'],
                 metadata: Mapping[str, str],
                 name: str,
                 serial_number: str,
                 service_type: str,
                 shareable: bool,
                 size: int,
                 snapshot_id: str,
                 status: str,
                 tags: Mapping[str, str],
                 throughput: int,
                 throughput_attributes: Sequence['outputs.GetVolumesVolumeThroughputAttributeResult'],
                 update_at: str,
                 volume_image_metadata: Mapping[str, str],
                 volume_type: str,
                 wwn: str):
        """
        :param Sequence['GetVolumesVolumeAttachmentArgs'] attachments: The disk attachment information. Structure is documented below.
        :param str availability_zone: Specifies the availability zone for the disks.
        :param bool bootable: Whether the disk is bootable.
        :param str create_at: The time when the disk was created.
        :param str dedicated_storage_id: Specifies the dedicated storage pool ID. All disks in the dedicated storage
               pool can be filtered by exact match.
        :param str dedicated_storage_name: Specifies the dedicated storage pool name. All disks in the dedicated
               storage pool can be filtered by fuzzy match.
        :param str description: The disk description.
        :param str enterprise_project_id: Specifies the enterprise project ID for filtering.
        :param str id: The ID of the attached resource in UUID format.
        :param int iops: the IOPS(Input/Output Operations Per Second) of the volume. Only valid when `volume_type` is **GPSSD2** or
               **ESSD2**.
        :param Sequence['GetVolumesVolumeIopsAttributeArgs'] iops_attributes: The disk IOPS information. This attribute appears only for a general purpose SSD V2 or an extreme
               SSD V2 disk. The iops_attribute structure is documented below.
        :param Sequence['GetVolumesVolumeLinkArgs'] links: The disk URI. The links structure is documented below.
        :param Mapping[str, str] metadata: Specifies the disk metadata.
               Please pay attention to escape special characters before use. Please refer to the usage of example.
        :param str name: Specifies the name for the disks. This field will undergo a fuzzy matching query, the
               query result is for all disks whose names contain this value.
        :param str serial_number: The disk serial number. This field is returned only for non-HyperMetro SCSI disks and is used for
               disk mapping in the VM.
        :param str service_type: Specifies the service type. Supported services are **EVS**, **DSS**, and **DESS**.
        :param bool shareable: Specifies whether the disk is shareable.
        :param int size: The disk size, in GB.
        :param str snapshot_id: The snapshot ID. This attribute has a value if the disk is created from a snapshot.
        :param str status: Specifies the disk status. The valid values are as following:
               + **FREEZED**
               + **BIND_ERROR**
               + **BINDING**
               + **PENDING_DELETE**
               + **PENDING_CREATE**
               + **NOTIFYING**
               + **NOTIFY_DELETE**
               + **PENDING_UPDATE**
               + **DOWN**
               + **ACTIVE**
               + **ELB**
               + **ERROR**
               + **VPN**
        :param Mapping[str, str] tags: Specifies the included key/value pairs which associated with the desired disk.
        :param int throughput: The throughput of the system disk. Only valid when `volume_type` is **GPSSD2**.
        :param Sequence['GetVolumesVolumeThroughputAttributeArgs'] throughput_attributes: The disk throughput information. This attribute appears only for a general purpose SSD V2 disk.
               The throughput_attribute structure is documented below.
        :param str update_at: The time when the disk was updated.
        :param Mapping[str, str] volume_image_metadata: The metadata of the disk image.
        :param str volume_type: The disk type. Valid values are as follows:
               + **SAS**: High I/O type.
               + **SSD**: Ultra-high I/O type.
               + **GPSSD**: General purpose SSD type.
               + **ESSD**: Extreme SSD type.
               + **GPSSD2**: General purpose SSD V2 type.
               + **ESSD2**: Extreme SSD V2 type.
        :param str wwn: The unique identifier used when attaching the disk.
        """
        pulumi.set(__self__, "attachments", attachments)
        pulumi.set(__self__, "availability_zone", availability_zone)
        pulumi.set(__self__, "bootable", bootable)
        pulumi.set(__self__, "create_at", create_at)
        pulumi.set(__self__, "dedicated_storage_id", dedicated_storage_id)
        pulumi.set(__self__, "dedicated_storage_name", dedicated_storage_name)
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "iops", iops)
        pulumi.set(__self__, "iops_attributes", iops_attributes)
        pulumi.set(__self__, "links", links)
        pulumi.set(__self__, "metadata", metadata)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "serial_number", serial_number)
        pulumi.set(__self__, "service_type", service_type)
        pulumi.set(__self__, "shareable", shareable)
        pulumi.set(__self__, "size", size)
        pulumi.set(__self__, "snapshot_id", snapshot_id)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "tags", tags)
        pulumi.set(__self__, "throughput", throughput)
        pulumi.set(__self__, "throughput_attributes", throughput_attributes)
        pulumi.set(__self__, "update_at", update_at)
        pulumi.set(__self__, "volume_image_metadata", volume_image_metadata)
        pulumi.set(__self__, "volume_type", volume_type)
        pulumi.set(__self__, "wwn", wwn)

    @property
    @pulumi.getter
    def attachments(self) -> Sequence['outputs.GetVolumesVolumeAttachmentResult']:
        """
        The disk attachment information. Structure is documented below.
        """
        return pulumi.get(self, "attachments")

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> str:
        """
        Specifies the availability zone for the disks.
        """
        return pulumi.get(self, "availability_zone")

    @property
    @pulumi.getter
    def bootable(self) -> bool:
        """
        Whether the disk is bootable.
        """
        return pulumi.get(self, "bootable")

    @property
    @pulumi.getter(name="createAt")
    def create_at(self) -> str:
        """
        The time when the disk was created.
        """
        return pulumi.get(self, "create_at")

    @property
    @pulumi.getter(name="dedicatedStorageId")
    def dedicated_storage_id(self) -> str:
        """
        Specifies the dedicated storage pool ID. All disks in the dedicated storage
        pool can be filtered by exact match.
        """
        return pulumi.get(self, "dedicated_storage_id")

    @property
    @pulumi.getter(name="dedicatedStorageName")
    def dedicated_storage_name(self) -> str:
        """
        Specifies the dedicated storage pool name. All disks in the dedicated
        storage pool can be filtered by fuzzy match.
        """
        return pulumi.get(self, "dedicated_storage_name")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The disk description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> str:
        """
        Specifies the enterprise project ID for filtering.
        """
        return pulumi.get(self, "enterprise_project_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the attached resource in UUID format.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def iops(self) -> int:
        """
        the IOPS(Input/Output Operations Per Second) of the volume. Only valid when `volume_type` is **GPSSD2** or
        **ESSD2**.
        """
        return pulumi.get(self, "iops")

    @property
    @pulumi.getter(name="iopsAttributes")
    def iops_attributes(self) -> Sequence['outputs.GetVolumesVolumeIopsAttributeResult']:
        """
        The disk IOPS information. This attribute appears only for a general purpose SSD V2 or an extreme
        SSD V2 disk. The iops_attribute structure is documented below.
        """
        return pulumi.get(self, "iops_attributes")

    @property
    @pulumi.getter
    def links(self) -> Sequence['outputs.GetVolumesVolumeLinkResult']:
        """
        The disk URI. The links structure is documented below.
        """
        return pulumi.get(self, "links")

    @property
    @pulumi.getter
    def metadata(self) -> Mapping[str, str]:
        """
        Specifies the disk metadata.
        Please pay attention to escape special characters before use. Please refer to the usage of example.
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Specifies the name for the disks. This field will undergo a fuzzy matching query, the
        query result is for all disks whose names contain this value.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="serialNumber")
    def serial_number(self) -> str:
        """
        The disk serial number. This field is returned only for non-HyperMetro SCSI disks and is used for
        disk mapping in the VM.
        """
        return pulumi.get(self, "serial_number")

    @property
    @pulumi.getter(name="serviceType")
    def service_type(self) -> str:
        """
        Specifies the service type. Supported services are **EVS**, **DSS**, and **DESS**.
        """
        return pulumi.get(self, "service_type")

    @property
    @pulumi.getter
    def shareable(self) -> bool:
        """
        Specifies whether the disk is shareable.
        """
        return pulumi.get(self, "shareable")

    @property
    @pulumi.getter
    def size(self) -> int:
        """
        The disk size, in GB.
        """
        return pulumi.get(self, "size")

    @property
    @pulumi.getter(name="snapshotId")
    def snapshot_id(self) -> str:
        """
        The snapshot ID. This attribute has a value if the disk is created from a snapshot.
        """
        return pulumi.get(self, "snapshot_id")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        Specifies the disk status. The valid values are as following:
        + **FREEZED**
        + **BIND_ERROR**
        + **BINDING**
        + **PENDING_DELETE**
        + **PENDING_CREATE**
        + **NOTIFYING**
        + **NOTIFY_DELETE**
        + **PENDING_UPDATE**
        + **DOWN**
        + **ACTIVE**
        + **ELB**
        + **ERROR**
        + **VPN**
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def tags(self) -> Mapping[str, str]:
        """
        Specifies the included key/value pairs which associated with the desired disk.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def throughput(self) -> int:
        """
        The throughput of the system disk. Only valid when `volume_type` is **GPSSD2**.
        """
        return pulumi.get(self, "throughput")

    @property
    @pulumi.getter(name="throughputAttributes")
    def throughput_attributes(self) -> Sequence['outputs.GetVolumesVolumeThroughputAttributeResult']:
        """
        The disk throughput information. This attribute appears only for a general purpose SSD V2 disk.
        The throughput_attribute structure is documented below.
        """
        return pulumi.get(self, "throughput_attributes")

    @property
    @pulumi.getter(name="updateAt")
    def update_at(self) -> str:
        """
        The time when the disk was updated.
        """
        return pulumi.get(self, "update_at")

    @property
    @pulumi.getter(name="volumeImageMetadata")
    def volume_image_metadata(self) -> Mapping[str, str]:
        """
        The metadata of the disk image.
        """
        return pulumi.get(self, "volume_image_metadata")

    @property
    @pulumi.getter(name="volumeType")
    def volume_type(self) -> str:
        """
        The disk type. Valid values are as follows:
        + **SAS**: High I/O type.
        + **SSD**: Ultra-high I/O type.
        + **GPSSD**: General purpose SSD type.
        + **ESSD**: Extreme SSD type.
        + **GPSSD2**: General purpose SSD V2 type.
        + **ESSD2**: Extreme SSD V2 type.
        """
        return pulumi.get(self, "volume_type")

    @property
    @pulumi.getter
    def wwn(self) -> str:
        """
        The unique identifier used when attaching the disk.
        """
        return pulumi.get(self, "wwn")


@pulumi.output_type
class GetVolumesVolumeAttachmentResult(dict):
    def __init__(__self__, *,
                 attached_at: str,
                 attached_mode: str,
                 attached_volume_id: str,
                 device_name: str,
                 host_name: str,
                 id: str,
                 server_id: str,
                 volume_id: str):
        """
        :param str attached_at: The time when the disk was attached.
        :param str attached_mode: The ID of the attachment information.
        :param str attached_volume_id: The ID of the attached disk.
        :param str device_name: The device name to which the disk is attached.
        :param str host_name: The name of the physical host housing the cloud server to which the disk is attached.
        :param str id: The ID of the attached resource in UUID format.
        :param str server_id: Specifies the server ID to which the disks are attached.
        :param str volume_id: Specifies the ID for the disk.
        """
        pulumi.set(__self__, "attached_at", attached_at)
        pulumi.set(__self__, "attached_mode", attached_mode)
        pulumi.set(__self__, "attached_volume_id", attached_volume_id)
        pulumi.set(__self__, "device_name", device_name)
        pulumi.set(__self__, "host_name", host_name)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "server_id", server_id)
        pulumi.set(__self__, "volume_id", volume_id)

    @property
    @pulumi.getter(name="attachedAt")
    def attached_at(self) -> str:
        """
        The time when the disk was attached.
        """
        return pulumi.get(self, "attached_at")

    @property
    @pulumi.getter(name="attachedMode")
    def attached_mode(self) -> str:
        """
        The ID of the attachment information.
        """
        return pulumi.get(self, "attached_mode")

    @property
    @pulumi.getter(name="attachedVolumeId")
    def attached_volume_id(self) -> str:
        """
        The ID of the attached disk.
        """
        return pulumi.get(self, "attached_volume_id")

    @property
    @pulumi.getter(name="deviceName")
    def device_name(self) -> str:
        """
        The device name to which the disk is attached.
        """
        return pulumi.get(self, "device_name")

    @property
    @pulumi.getter(name="hostName")
    def host_name(self) -> str:
        """
        The name of the physical host housing the cloud server to which the disk is attached.
        """
        return pulumi.get(self, "host_name")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the attached resource in UUID format.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="serverId")
    def server_id(self) -> str:
        """
        Specifies the server ID to which the disks are attached.
        """
        return pulumi.get(self, "server_id")

    @property
    @pulumi.getter(name="volumeId")
    def volume_id(self) -> str:
        """
        Specifies the ID for the disk.
        """
        return pulumi.get(self, "volume_id")


@pulumi.output_type
class GetVolumesVolumeIopsAttributeResult(dict):
    def __init__(__self__, *,
                 frozened: bool,
                 id: str,
                 total_val: int):
        """
        :param bool frozened: The frozen tag.
        :param str id: The ID of the attached resource in UUID format.
        :param int total_val: The IOPS.
        """
        pulumi.set(__self__, "frozened", frozened)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "total_val", total_val)

    @property
    @pulumi.getter
    def frozened(self) -> bool:
        """
        The frozen tag.
        """
        return pulumi.get(self, "frozened")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the attached resource in UUID format.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="totalVal")
    def total_val(self) -> int:
        """
        The IOPS.
        """
        return pulumi.get(self, "total_val")


@pulumi.output_type
class GetVolumesVolumeLinkResult(dict):
    def __init__(__self__, *,
                 href: str,
                 rel: str):
        """
        :param str href: The corresponding shortcut link.
        :param str rel: The shortcut link marker name.
        """
        pulumi.set(__self__, "href", href)
        pulumi.set(__self__, "rel", rel)

    @property
    @pulumi.getter
    def href(self) -> str:
        """
        The corresponding shortcut link.
        """
        return pulumi.get(self, "href")

    @property
    @pulumi.getter
    def rel(self) -> str:
        """
        The shortcut link marker name.
        """
        return pulumi.get(self, "rel")


@pulumi.output_type
class GetVolumesVolumeThroughputAttributeResult(dict):
    def __init__(__self__, *,
                 frozened: bool,
                 id: str,
                 total_val: int):
        """
        :param bool frozened: The frozen tag.
        :param str id: The ID of the attached resource in UUID format.
        :param int total_val: The IOPS.
        """
        pulumi.set(__self__, "frozened", frozened)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "total_val", total_val)

    @property
    @pulumi.getter
    def frozened(self) -> bool:
        """
        The frozen tag.
        """
        return pulumi.get(self, "frozened")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the attached resource in UUID format.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="totalVal")
    def total_val(self) -> int:
        """
        The IOPS.
        """
        return pulumi.get(self, "total_val")


