# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetProvidersResult',
    'AwaitableGetProvidersResult',
    'get_providers',
    'get_providers_output',
]

@pulumi.output_type
class GetProvidersResult:
    """
    A collection of values returned by getProviders.
    """
    def __init__(__self__, id=None, identity_providers=None, name=None, sso_type=None, status=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if identity_providers and not isinstance(identity_providers, list):
            raise TypeError("Expected argument 'identity_providers' to be a list")
        pulumi.set(__self__, "identity_providers", identity_providers)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if sso_type and not isinstance(sso_type, str):
            raise TypeError("Expected argument 'sso_type' to be a str")
        pulumi.set(__self__, "sso_type", sso_type)
        if status and not isinstance(status, str):
            raise TypeError("Expected argument 'status' to be a str")
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="identityProviders")
    def identity_providers(self) -> Sequence['outputs.GetProvidersIdentityProviderResult']:
        """
        The list of identity providers.
        """
        return pulumi.get(self, "identity_providers")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="ssoType")
    def sso_type(self) -> Optional[str]:
        """
        The single sign-on type of the identity provider.
        """
        return pulumi.get(self, "sso_type")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        The enabled status for the identity provider.
        """
        return pulumi.get(self, "status")


class AwaitableGetProvidersResult(GetProvidersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProvidersResult(
            id=self.id,
            identity_providers=self.identity_providers,
            name=self.name,
            sso_type=self.sso_type,
            status=self.status)


def get_providers(name: Optional[str] = None,
                  sso_type: Optional[str] = None,
                  status: Optional[str] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetProvidersResult:
    """
    Use this data source to get the list of IAM identity providers.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    provider_name = config.require_object("providerName")
    test = huaweicloud.Iam.get_providers(name=provider_name)
    ```


    :param str name: Specifies the name of the identity provider.
    :param str sso_type: Specifies the single sign-on type of the identity provider.
    :param str status: Specifies the status of the identity provider. The value can be **true** or **false**
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['ssoType'] = sso_type
    __args__['status'] = status
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Iam/getProviders:getProviders', __args__, opts=opts, typ=GetProvidersResult).value

    return AwaitableGetProvidersResult(
        id=__ret__.id,
        identity_providers=__ret__.identity_providers,
        name=__ret__.name,
        sso_type=__ret__.sso_type,
        status=__ret__.status)


@_utilities.lift_output_func(get_providers)
def get_providers_output(name: Optional[pulumi.Input[Optional[str]]] = None,
                         sso_type: Optional[pulumi.Input[Optional[str]]] = None,
                         status: Optional[pulumi.Input[Optional[str]]] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetProvidersResult]:
    """
    Use this data source to get the list of IAM identity providers.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    provider_name = config.require_object("providerName")
    test = huaweicloud.Iam.get_providers(name=provider_name)
    ```


    :param str name: Specifies the name of the identity provider.
    :param str sso_type: Specifies the single sign-on type of the identity provider.
    :param str status: Specifies the status of the identity provider. The value can be **true** or **false**
    """
    ...
