# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ProtectionPolicyArgs', 'ProtectionPolicy']

@pulumi.input_type
class ProtectionPolicyArgs:
    def __init__(__self__, *,
                 protection_enabled: pulumi.Input[bool],
                 self_management: Optional[pulumi.Input['ProtectionPolicySelfManagementArgs']] = None,
                 verification_email: Optional[pulumi.Input[str]] = None,
                 verification_mobile: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ProtectionPolicy resource.
        :param pulumi.Input[bool] protection_enabled: Specifies whether to enable operation protection.
        :param pulumi.Input['ProtectionPolicySelfManagementArgs'] self_management: Specifies the attributes IAM users can modify.
               The object structure is documented below.
        :param pulumi.Input[str] verification_email: Specifies the email address used for verification. An example value is `example@email.com`.
        :param pulumi.Input[str] verification_mobile: Specifies the mobile number used for verification. An example value is *0086-123456789*.
        """
        pulumi.set(__self__, "protection_enabled", protection_enabled)
        if self_management is not None:
            pulumi.set(__self__, "self_management", self_management)
        if verification_email is not None:
            pulumi.set(__self__, "verification_email", verification_email)
        if verification_mobile is not None:
            pulumi.set(__self__, "verification_mobile", verification_mobile)

    @property
    @pulumi.getter(name="protectionEnabled")
    def protection_enabled(self) -> pulumi.Input[bool]:
        """
        Specifies whether to enable operation protection.
        """
        return pulumi.get(self, "protection_enabled")

    @protection_enabled.setter
    def protection_enabled(self, value: pulumi.Input[bool]):
        pulumi.set(self, "protection_enabled", value)

    @property
    @pulumi.getter(name="selfManagement")
    def self_management(self) -> Optional[pulumi.Input['ProtectionPolicySelfManagementArgs']]:
        """
        Specifies the attributes IAM users can modify.
        The object structure is documented below.
        """
        return pulumi.get(self, "self_management")

    @self_management.setter
    def self_management(self, value: Optional[pulumi.Input['ProtectionPolicySelfManagementArgs']]):
        pulumi.set(self, "self_management", value)

    @property
    @pulumi.getter(name="verificationEmail")
    def verification_email(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the email address used for verification. An example value is `example@email.com`.
        """
        return pulumi.get(self, "verification_email")

    @verification_email.setter
    def verification_email(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "verification_email", value)

    @property
    @pulumi.getter(name="verificationMobile")
    def verification_mobile(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the mobile number used for verification. An example value is *0086-123456789*.
        """
        return pulumi.get(self, "verification_mobile")

    @verification_mobile.setter
    def verification_mobile(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "verification_mobile", value)


@pulumi.input_type
class _ProtectionPolicyState:
    def __init__(__self__, *,
                 protection_enabled: Optional[pulumi.Input[bool]] = None,
                 self_management: Optional[pulumi.Input['ProtectionPolicySelfManagementArgs']] = None,
                 self_verification: Optional[pulumi.Input[bool]] = None,
                 verification_email: Optional[pulumi.Input[str]] = None,
                 verification_mobile: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ProtectionPolicy resources.
        :param pulumi.Input[bool] protection_enabled: Specifies whether to enable operation protection.
        :param pulumi.Input['ProtectionPolicySelfManagementArgs'] self_management: Specifies the attributes IAM users can modify.
               The object structure is documented below.
        :param pulumi.Input[bool] self_verification: Indicates whether the IAM users perform verification by themselves.
        :param pulumi.Input[str] verification_email: Specifies the email address used for verification. An example value is `example@email.com`.
        :param pulumi.Input[str] verification_mobile: Specifies the mobile number used for verification. An example value is *0086-123456789*.
        """
        if protection_enabled is not None:
            pulumi.set(__self__, "protection_enabled", protection_enabled)
        if self_management is not None:
            pulumi.set(__self__, "self_management", self_management)
        if self_verification is not None:
            pulumi.set(__self__, "self_verification", self_verification)
        if verification_email is not None:
            pulumi.set(__self__, "verification_email", verification_email)
        if verification_mobile is not None:
            pulumi.set(__self__, "verification_mobile", verification_mobile)

    @property
    @pulumi.getter(name="protectionEnabled")
    def protection_enabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether to enable operation protection.
        """
        return pulumi.get(self, "protection_enabled")

    @protection_enabled.setter
    def protection_enabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "protection_enabled", value)

    @property
    @pulumi.getter(name="selfManagement")
    def self_management(self) -> Optional[pulumi.Input['ProtectionPolicySelfManagementArgs']]:
        """
        Specifies the attributes IAM users can modify.
        The object structure is documented below.
        """
        return pulumi.get(self, "self_management")

    @self_management.setter
    def self_management(self, value: Optional[pulumi.Input['ProtectionPolicySelfManagementArgs']]):
        pulumi.set(self, "self_management", value)

    @property
    @pulumi.getter(name="selfVerification")
    def self_verification(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether the IAM users perform verification by themselves.
        """
        return pulumi.get(self, "self_verification")

    @self_verification.setter
    def self_verification(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "self_verification", value)

    @property
    @pulumi.getter(name="verificationEmail")
    def verification_email(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the email address used for verification. An example value is `example@email.com`.
        """
        return pulumi.get(self, "verification_email")

    @verification_email.setter
    def verification_email(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "verification_email", value)

    @property
    @pulumi.getter(name="verificationMobile")
    def verification_mobile(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the mobile number used for verification. An example value is *0086-123456789*.
        """
        return pulumi.get(self, "verification_mobile")

    @verification_mobile.setter
    def verification_mobile(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "verification_mobile", value)


class ProtectionPolicy(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 protection_enabled: Optional[pulumi.Input[bool]] = None,
                 self_management: Optional[pulumi.Input[pulumi.InputType['ProtectionPolicySelfManagementArgs']]] = None,
                 verification_email: Optional[pulumi.Input[str]] = None,
                 verification_mobile: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## Example Usage
        ### Self-Verification

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        test = huaweicloud.iam.ProtectionPolicy("test",
            protection_enabled=True,
            self_management=huaweicloud.iam.ProtectionPolicySelfManagementArgs(
                access_key=True,
                email=False,
                mobile=False,
                password=True,
            ))
        ```
        ### Verification by another person

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        verification = huaweicloud.iam.ProtectionPolicy("verification",
            protection_enabled=True,
            verification_email="example@email.com")
        ```

        ## Import

        Identity protection policy can be imported using the account ID or domain ID, e.g. bash

        ```sh
         $ pulumi import huaweicloud:Iam/protectionPolicy:ProtectionPolicy example <your account ID>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] protection_enabled: Specifies whether to enable operation protection.
        :param pulumi.Input[pulumi.InputType['ProtectionPolicySelfManagementArgs']] self_management: Specifies the attributes IAM users can modify.
               The object structure is documented below.
        :param pulumi.Input[str] verification_email: Specifies the email address used for verification. An example value is `example@email.com`.
        :param pulumi.Input[str] verification_mobile: Specifies the mobile number used for verification. An example value is *0086-123456789*.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ProtectionPolicyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage
        ### Self-Verification

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        test = huaweicloud.iam.ProtectionPolicy("test",
            protection_enabled=True,
            self_management=huaweicloud.iam.ProtectionPolicySelfManagementArgs(
                access_key=True,
                email=False,
                mobile=False,
                password=True,
            ))
        ```
        ### Verification by another person

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        verification = huaweicloud.iam.ProtectionPolicy("verification",
            protection_enabled=True,
            verification_email="example@email.com")
        ```

        ## Import

        Identity protection policy can be imported using the account ID or domain ID, e.g. bash

        ```sh
         $ pulumi import huaweicloud:Iam/protectionPolicy:ProtectionPolicy example <your account ID>
        ```

        :param str resource_name: The name of the resource.
        :param ProtectionPolicyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProtectionPolicyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 protection_enabled: Optional[pulumi.Input[bool]] = None,
                 self_management: Optional[pulumi.Input[pulumi.InputType['ProtectionPolicySelfManagementArgs']]] = None,
                 verification_email: Optional[pulumi.Input[str]] = None,
                 verification_mobile: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProtectionPolicyArgs.__new__(ProtectionPolicyArgs)

            if protection_enabled is None and not opts.urn:
                raise TypeError("Missing required property 'protection_enabled'")
            __props__.__dict__["protection_enabled"] = protection_enabled
            __props__.__dict__["self_management"] = self_management
            __props__.__dict__["verification_email"] = verification_email
            __props__.__dict__["verification_mobile"] = verification_mobile
            __props__.__dict__["self_verification"] = None
        super(ProtectionPolicy, __self__).__init__(
            'huaweicloud:Iam/protectionPolicy:ProtectionPolicy',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            protection_enabled: Optional[pulumi.Input[bool]] = None,
            self_management: Optional[pulumi.Input[pulumi.InputType['ProtectionPolicySelfManagementArgs']]] = None,
            self_verification: Optional[pulumi.Input[bool]] = None,
            verification_email: Optional[pulumi.Input[str]] = None,
            verification_mobile: Optional[pulumi.Input[str]] = None) -> 'ProtectionPolicy':
        """
        Get an existing ProtectionPolicy resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] protection_enabled: Specifies whether to enable operation protection.
        :param pulumi.Input[pulumi.InputType['ProtectionPolicySelfManagementArgs']] self_management: Specifies the attributes IAM users can modify.
               The object structure is documented below.
        :param pulumi.Input[bool] self_verification: Indicates whether the IAM users perform verification by themselves.
        :param pulumi.Input[str] verification_email: Specifies the email address used for verification. An example value is `example@email.com`.
        :param pulumi.Input[str] verification_mobile: Specifies the mobile number used for verification. An example value is *0086-123456789*.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ProtectionPolicyState.__new__(_ProtectionPolicyState)

        __props__.__dict__["protection_enabled"] = protection_enabled
        __props__.__dict__["self_management"] = self_management
        __props__.__dict__["self_verification"] = self_verification
        __props__.__dict__["verification_email"] = verification_email
        __props__.__dict__["verification_mobile"] = verification_mobile
        return ProtectionPolicy(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="protectionEnabled")
    def protection_enabled(self) -> pulumi.Output[bool]:
        """
        Specifies whether to enable operation protection.
        """
        return pulumi.get(self, "protection_enabled")

    @property
    @pulumi.getter(name="selfManagement")
    def self_management(self) -> pulumi.Output['outputs.ProtectionPolicySelfManagement']:
        """
        Specifies the attributes IAM users can modify.
        The object structure is documented below.
        """
        return pulumi.get(self, "self_management")

    @property
    @pulumi.getter(name="selfVerification")
    def self_verification(self) -> pulumi.Output[bool]:
        """
        Indicates whether the IAM users perform verification by themselves.
        """
        return pulumi.get(self, "self_verification")

    @property
    @pulumi.getter(name="verificationEmail")
    def verification_email(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the email address used for verification. An example value is `example@email.com`.
        """
        return pulumi.get(self, "verification_email")

    @property
    @pulumi.getter(name="verificationMobile")
    def verification_mobile(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the mobile number used for verification. An example value is *0086-123456789*.
        """
        return pulumi.get(self, "verification_mobile")

