# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetOsVersionsResult',
    'AwaitableGetOsVersionsResult',
    'get_os_versions',
    'get_os_versions_output',
]

@pulumi.output_type
class GetOsVersionsResult:
    """
    A collection of values returned by getOsVersions.
    """
    def __init__(__self__, id=None, os_versions=None, region=None, tag=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if os_versions and not isinstance(os_versions, list):
            raise TypeError("Expected argument 'os_versions' to be a list")
        pulumi.set(__self__, "os_versions", os_versions)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if tag and not isinstance(tag, str):
            raise TypeError("Expected argument 'tag' to be a str")
        pulumi.set(__self__, "tag", tag)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="osVersions")
    def os_versions(self) -> Sequence['outputs.GetOsVersionsOsVersionResult']:
        """
        The OS version details.
        """
        return pulumi.get(self, "os_versions")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def tag(self) -> Optional[str]:
        return pulumi.get(self, "tag")


class AwaitableGetOsVersionsResult(GetOsVersionsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOsVersionsResult(
            id=self.id,
            os_versions=self.os_versions,
            region=self.region,
            tag=self.tag)


def get_os_versions(region: Optional[str] = None,
                    tag: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOsVersionsResult:
    """
    Use this data source to get the list of OS versions supported by IMS image within HuaweiCloud.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Ims.get_os_versions()
    ```


    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    :param str tag: Specifies the label value for the OS versions.
           Multiple tags separated by commas, e.g. **bms,uefi**.
           The valid values are as follows:
           + **bms**: OS versions that supports BMS image type.
           + **uefi**: OS versions that supports UEFI boot mode.
           + **arm**: OS versions based on ARM architecture.
           + **x86**: OS versions based on x86 architecture.
    """
    __args__ = dict()
    __args__['region'] = region
    __args__['tag'] = tag
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Ims/getOsVersions:getOsVersions', __args__, opts=opts, typ=GetOsVersionsResult).value

    return AwaitableGetOsVersionsResult(
        id=__ret__.id,
        os_versions=__ret__.os_versions,
        region=__ret__.region,
        tag=__ret__.tag)


@_utilities.lift_output_func(get_os_versions)
def get_os_versions_output(region: Optional[pulumi.Input[Optional[str]]] = None,
                           tag: Optional[pulumi.Input[Optional[str]]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetOsVersionsResult]:
    """
    Use this data source to get the list of OS versions supported by IMS image within HuaweiCloud.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Ims.get_os_versions()
    ```


    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    :param str tag: Specifies the label value for the OS versions.
           Multiple tags separated by commas, e.g. **bms,uefi**.
           The valid values are as follows:
           + **bms**: OS versions that supports BMS image type.
           + **uefi**: OS versions that supports UEFI boot mode.
           + **arm**: OS versions based on ARM architecture.
           + **x86**: OS versions based on x86 architecture.
    """
    ...
