# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'ClusterAnalysisCoreNodesArgs',
    'ClusterAnalysisTaskNodesArgs',
    'ClusterBootstrapScriptArgs',
    'ClusterComponentConfigArgs',
    'ClusterComponentConfigConfigArgs',
    'ClusterCustomNodeArgs',
    'ClusterExternalDatasourceArgs',
    'ClusterMasterNodesArgs',
    'ClusterSmnNotifyArgs',
    'ClusterStreamingCoreNodesArgs',
    'ClusterStreamingTaskNodesArgs',
]

@pulumi.input_type
class ClusterAnalysisCoreNodesArgs:
    def __init__(__self__, *,
                 data_volume_count: pulumi.Input[int],
                 flavor: pulumi.Input[str],
                 node_number: pulumi.Input[int],
                 root_volume_size: pulumi.Input[int],
                 root_volume_type: pulumi.Input[str],
                 assigned_roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 data_volume_size: Optional[pulumi.Input[int]] = None,
                 data_volume_type: Optional[pulumi.Input[str]] = None,
                 host_ips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        :param pulumi.Input[int] data_volume_count: Specifies the data disk number of the nodes.  
               The valid value is `1`.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[str] flavor: Specifies the instance specifications for each nodes in node group.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[int] node_number: Specifies the number of nodes for the node group.  
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[int] root_volume_size: Specifies the system disk size of the nodes. Changing this will create
               a new MapReduce cluster resource.
        :param pulumi.Input[str] root_volume_type: Specifies the system disk flavor of the nodes. Changing this will
               create a new MapReduce cluster resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] assigned_roles: Specifies the roles deployed in a node group.This argument is mandatory
               when the cluster type is **CUSTOM**. Each character string represents a role expression.
        :param pulumi.Input[int] data_volume_size: Specifies the data disk size of the nodes,in GB. The value range is 10
               to 32768. Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce
               cluster resource.
        :param pulumi.Input[str] data_volume_type: Specifies the data disk flavor of the nodes.
               Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce cluster resource.
               The following disk types are supported:
               + **SATA**: common I/O disk.
               + **SAS**: high I/O disk.
               + **SSD**: ultra-high I/O disk.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_ips: The host list of this nodes group in the cluster.
               * `bootstrap_scripts/start_time` - The execution time of one bootstrap action script, in RFC-3339 format.
               * `bootstrap_scripts/state` - The status of one bootstrap action script.
               The valid value are **PENDING**, **IN_PROGRESS**, **SUCCESS**, and **FAILURE**.
        """
        pulumi.set(__self__, "data_volume_count", data_volume_count)
        pulumi.set(__self__, "flavor", flavor)
        pulumi.set(__self__, "node_number", node_number)
        pulumi.set(__self__, "root_volume_size", root_volume_size)
        pulumi.set(__self__, "root_volume_type", root_volume_type)
        if assigned_roles is not None:
            pulumi.set(__self__, "assigned_roles", assigned_roles)
        if data_volume_size is not None:
            pulumi.set(__self__, "data_volume_size", data_volume_size)
        if data_volume_type is not None:
            pulumi.set(__self__, "data_volume_type", data_volume_type)
        if host_ips is not None:
            pulumi.set(__self__, "host_ips", host_ips)

    @property
    @pulumi.getter(name="dataVolumeCount")
    def data_volume_count(self) -> pulumi.Input[int]:
        """
        Specifies the data disk number of the nodes.  
        The valid value is `1`.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "data_volume_count")

    @data_volume_count.setter
    def data_volume_count(self, value: pulumi.Input[int]):
        pulumi.set(self, "data_volume_count", value)

    @property
    @pulumi.getter
    def flavor(self) -> pulumi.Input[str]:
        """
        Specifies the instance specifications for each nodes in node group.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "flavor")

    @flavor.setter
    def flavor(self, value: pulumi.Input[str]):
        pulumi.set(self, "flavor", value)

    @property
    @pulumi.getter(name="nodeNumber")
    def node_number(self) -> pulumi.Input[int]:
        """
        Specifies the number of nodes for the node group.  
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "node_number")

    @node_number.setter
    def node_number(self, value: pulumi.Input[int]):
        pulumi.set(self, "node_number", value)

    @property
    @pulumi.getter(name="rootVolumeSize")
    def root_volume_size(self) -> pulumi.Input[int]:
        """
        Specifies the system disk size of the nodes. Changing this will create
        a new MapReduce cluster resource.
        """
        return pulumi.get(self, "root_volume_size")

    @root_volume_size.setter
    def root_volume_size(self, value: pulumi.Input[int]):
        pulumi.set(self, "root_volume_size", value)

    @property
    @pulumi.getter(name="rootVolumeType")
    def root_volume_type(self) -> pulumi.Input[str]:
        """
        Specifies the system disk flavor of the nodes. Changing this will
        create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "root_volume_type")

    @root_volume_type.setter
    def root_volume_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "root_volume_type", value)

    @property
    @pulumi.getter(name="assignedRoles")
    def assigned_roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Specifies the roles deployed in a node group.This argument is mandatory
        when the cluster type is **CUSTOM**. Each character string represents a role expression.
        """
        return pulumi.get(self, "assigned_roles")

    @assigned_roles.setter
    def assigned_roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "assigned_roles", value)

    @property
    @pulumi.getter(name="dataVolumeSize")
    def data_volume_size(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the data disk size of the nodes,in GB. The value range is 10
        to 32768. Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce
        cluster resource.
        """
        return pulumi.get(self, "data_volume_size")

    @data_volume_size.setter
    def data_volume_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "data_volume_size", value)

    @property
    @pulumi.getter(name="dataVolumeType")
    def data_volume_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the data disk flavor of the nodes.
        Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce cluster resource.
        The following disk types are supported:
        + **SATA**: common I/O disk.
        + **SAS**: high I/O disk.
        + **SSD**: ultra-high I/O disk.
        """
        return pulumi.get(self, "data_volume_type")

    @data_volume_type.setter
    def data_volume_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "data_volume_type", value)

    @property
    @pulumi.getter(name="hostIps")
    def host_ips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The host list of this nodes group in the cluster.
        * `bootstrap_scripts/start_time` - The execution time of one bootstrap action script, in RFC-3339 format.
        * `bootstrap_scripts/state` - The status of one bootstrap action script.
        The valid value are **PENDING**, **IN_PROGRESS**, **SUCCESS**, and **FAILURE**.
        """
        return pulumi.get(self, "host_ips")

    @host_ips.setter
    def host_ips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_ips", value)


@pulumi.input_type
class ClusterAnalysisTaskNodesArgs:
    def __init__(__self__, *,
                 data_volume_count: pulumi.Input[int],
                 flavor: pulumi.Input[str],
                 node_number: pulumi.Input[int],
                 root_volume_size: pulumi.Input[int],
                 root_volume_type: pulumi.Input[str],
                 assigned_roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 data_volume_size: Optional[pulumi.Input[int]] = None,
                 data_volume_type: Optional[pulumi.Input[str]] = None,
                 host_ips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        :param pulumi.Input[int] data_volume_count: Specifies the data disk number of the nodes.  
               The valid value is `1`.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[str] flavor: Specifies the instance specifications for each nodes in node group.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[int] node_number: Specifies the number of nodes for the node group.  
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[int] root_volume_size: Specifies the system disk size of the nodes. Changing this will create
               a new MapReduce cluster resource.
        :param pulumi.Input[str] root_volume_type: Specifies the system disk flavor of the nodes. Changing this will
               create a new MapReduce cluster resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] assigned_roles: Specifies the roles deployed in a node group.This argument is mandatory
               when the cluster type is **CUSTOM**. Each character string represents a role expression.
        :param pulumi.Input[int] data_volume_size: Specifies the data disk size of the nodes,in GB. The value range is 10
               to 32768. Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce
               cluster resource.
        :param pulumi.Input[str] data_volume_type: Specifies the data disk flavor of the nodes.
               Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce cluster resource.
               The following disk types are supported:
               + **SATA**: common I/O disk.
               + **SAS**: high I/O disk.
               + **SSD**: ultra-high I/O disk.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_ips: The host list of this nodes group in the cluster.
               * `bootstrap_scripts/start_time` - The execution time of one bootstrap action script, in RFC-3339 format.
               * `bootstrap_scripts/state` - The status of one bootstrap action script.
               The valid value are **PENDING**, **IN_PROGRESS**, **SUCCESS**, and **FAILURE**.
        """
        pulumi.set(__self__, "data_volume_count", data_volume_count)
        pulumi.set(__self__, "flavor", flavor)
        pulumi.set(__self__, "node_number", node_number)
        pulumi.set(__self__, "root_volume_size", root_volume_size)
        pulumi.set(__self__, "root_volume_type", root_volume_type)
        if assigned_roles is not None:
            pulumi.set(__self__, "assigned_roles", assigned_roles)
        if data_volume_size is not None:
            pulumi.set(__self__, "data_volume_size", data_volume_size)
        if data_volume_type is not None:
            pulumi.set(__self__, "data_volume_type", data_volume_type)
        if host_ips is not None:
            pulumi.set(__self__, "host_ips", host_ips)

    @property
    @pulumi.getter(name="dataVolumeCount")
    def data_volume_count(self) -> pulumi.Input[int]:
        """
        Specifies the data disk number of the nodes.  
        The valid value is `1`.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "data_volume_count")

    @data_volume_count.setter
    def data_volume_count(self, value: pulumi.Input[int]):
        pulumi.set(self, "data_volume_count", value)

    @property
    @pulumi.getter
    def flavor(self) -> pulumi.Input[str]:
        """
        Specifies the instance specifications for each nodes in node group.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "flavor")

    @flavor.setter
    def flavor(self, value: pulumi.Input[str]):
        pulumi.set(self, "flavor", value)

    @property
    @pulumi.getter(name="nodeNumber")
    def node_number(self) -> pulumi.Input[int]:
        """
        Specifies the number of nodes for the node group.  
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "node_number")

    @node_number.setter
    def node_number(self, value: pulumi.Input[int]):
        pulumi.set(self, "node_number", value)

    @property
    @pulumi.getter(name="rootVolumeSize")
    def root_volume_size(self) -> pulumi.Input[int]:
        """
        Specifies the system disk size of the nodes. Changing this will create
        a new MapReduce cluster resource.
        """
        return pulumi.get(self, "root_volume_size")

    @root_volume_size.setter
    def root_volume_size(self, value: pulumi.Input[int]):
        pulumi.set(self, "root_volume_size", value)

    @property
    @pulumi.getter(name="rootVolumeType")
    def root_volume_type(self) -> pulumi.Input[str]:
        """
        Specifies the system disk flavor of the nodes. Changing this will
        create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "root_volume_type")

    @root_volume_type.setter
    def root_volume_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "root_volume_type", value)

    @property
    @pulumi.getter(name="assignedRoles")
    def assigned_roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Specifies the roles deployed in a node group.This argument is mandatory
        when the cluster type is **CUSTOM**. Each character string represents a role expression.
        """
        return pulumi.get(self, "assigned_roles")

    @assigned_roles.setter
    def assigned_roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "assigned_roles", value)

    @property
    @pulumi.getter(name="dataVolumeSize")
    def data_volume_size(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the data disk size of the nodes,in GB. The value range is 10
        to 32768. Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce
        cluster resource.
        """
        return pulumi.get(self, "data_volume_size")

    @data_volume_size.setter
    def data_volume_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "data_volume_size", value)

    @property
    @pulumi.getter(name="dataVolumeType")
    def data_volume_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the data disk flavor of the nodes.
        Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce cluster resource.
        The following disk types are supported:
        + **SATA**: common I/O disk.
        + **SAS**: high I/O disk.
        + **SSD**: ultra-high I/O disk.
        """
        return pulumi.get(self, "data_volume_type")

    @data_volume_type.setter
    def data_volume_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "data_volume_type", value)

    @property
    @pulumi.getter(name="hostIps")
    def host_ips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The host list of this nodes group in the cluster.
        * `bootstrap_scripts/start_time` - The execution time of one bootstrap action script, in RFC-3339 format.
        * `bootstrap_scripts/state` - The status of one bootstrap action script.
        The valid value are **PENDING**, **IN_PROGRESS**, **SUCCESS**, and **FAILURE**.
        """
        return pulumi.get(self, "host_ips")

    @host_ips.setter
    def host_ips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_ips", value)


@pulumi.input_type
class ClusterBootstrapScriptArgs:
    def __init__(__self__, *,
                 fail_action: pulumi.Input[str],
                 name: pulumi.Input[str],
                 nodes: pulumi.Input[Sequence[pulumi.Input[str]]],
                 uri: pulumi.Input[str],
                 active_master: Optional[pulumi.Input[bool]] = None,
                 before_component_start: Optional[pulumi.Input[bool]] = None,
                 execute_need_sudo_root: Optional[pulumi.Input[bool]] = None,
                 parameters: Optional[pulumi.Input[str]] = None,
                 start_time: Optional[pulumi.Input[str]] = None,
                 state: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] fail_action: Specifies the action after the bootstrap action script fails to be executed.
               The options are as follows:
               + **continue**: Continue to execute subsequent scripts.
               + **errorout**: Stop the action.
        :param pulumi.Input[str] name: Specifies the name of a bootstrap action script.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] nodes: Specifies names of the node group where the bootstrap action script is executed.
        :param pulumi.Input[str] uri: Specifies the path of a bootstrap action script.
               Set this parameter to an OBS bucket path or a local VM path.
               + **OBS bucket path**: The path of an OBS file system starts with *s3a://* or *obs://* and end with *.sh*.
               + **Local VM path**: The script path must start with a slash (/) and end with *.sh*.
        :param pulumi.Input[bool] active_master: Specifies whether the bootstrap action script runs only on active master nodes.
               The default value is **false**, indicating that the bootstrap action script can run on all master nodes.
        :param pulumi.Input[bool] before_component_start: Specifies whether the bootstrap action script is executed
               before component start.
               The options are as follows:
               + **false**: After component start. The default value is **false**.
               + **true**: Before component start.
        :param pulumi.Input[bool] execute_need_sudo_root: Specifies whether the bootstrap action script involves root user
               operations.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[str] parameters: Specifies bootstrap action script parameters.
        """
        pulumi.set(__self__, "fail_action", fail_action)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "nodes", nodes)
        pulumi.set(__self__, "uri", uri)
        if active_master is not None:
            pulumi.set(__self__, "active_master", active_master)
        if before_component_start is not None:
            pulumi.set(__self__, "before_component_start", before_component_start)
        if execute_need_sudo_root is not None:
            pulumi.set(__self__, "execute_need_sudo_root", execute_need_sudo_root)
        if parameters is not None:
            pulumi.set(__self__, "parameters", parameters)
        if start_time is not None:
            pulumi.set(__self__, "start_time", start_time)
        if state is not None:
            pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="failAction")
    def fail_action(self) -> pulumi.Input[str]:
        """
        Specifies the action after the bootstrap action script fails to be executed.
        The options are as follows:
        + **continue**: Continue to execute subsequent scripts.
        + **errorout**: Stop the action.
        """
        return pulumi.get(self, "fail_action")

    @fail_action.setter
    def fail_action(self, value: pulumi.Input[str]):
        pulumi.set(self, "fail_action", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        Specifies the name of a bootstrap action script.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def nodes(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Specifies names of the node group where the bootstrap action script is executed.
        """
        return pulumi.get(self, "nodes")

    @nodes.setter
    def nodes(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "nodes", value)

    @property
    @pulumi.getter
    def uri(self) -> pulumi.Input[str]:
        """
        Specifies the path of a bootstrap action script.
        Set this parameter to an OBS bucket path or a local VM path.
        + **OBS bucket path**: The path of an OBS file system starts with *s3a://* or *obs://* and end with *.sh*.
        + **Local VM path**: The script path must start with a slash (/) and end with *.sh*.
        """
        return pulumi.get(self, "uri")

    @uri.setter
    def uri(self, value: pulumi.Input[str]):
        pulumi.set(self, "uri", value)

    @property
    @pulumi.getter(name="activeMaster")
    def active_master(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether the bootstrap action script runs only on active master nodes.
        The default value is **false**, indicating that the bootstrap action script can run on all master nodes.
        """
        return pulumi.get(self, "active_master")

    @active_master.setter
    def active_master(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "active_master", value)

    @property
    @pulumi.getter(name="beforeComponentStart")
    def before_component_start(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether the bootstrap action script is executed
        before component start.
        The options are as follows:
        + **false**: After component start. The default value is **false**.
        + **true**: Before component start.
        """
        return pulumi.get(self, "before_component_start")

    @before_component_start.setter
    def before_component_start(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "before_component_start", value)

    @property
    @pulumi.getter(name="executeNeedSudoRoot")
    def execute_need_sudo_root(self) -> Optional[pulumi.Input[bool]]:
        """
        Specifies whether the bootstrap action script involves root user
        operations.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "execute_need_sudo_root")

    @execute_need_sudo_root.setter
    def execute_need_sudo_root(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "execute_need_sudo_root", value)

    @property
    @pulumi.getter
    def parameters(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies bootstrap action script parameters.
        """
        return pulumi.get(self, "parameters")

    @parameters.setter
    def parameters(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "parameters", value)

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "start_time")

    @start_time.setter
    def start_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "start_time", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "state", value)


@pulumi.input_type
class ClusterComponentConfigArgs:
    def __init__(__self__, *,
                 configs: pulumi.Input[Sequence[pulumi.Input['ClusterComponentConfigConfigArgs']]],
                 name: pulumi.Input[str]):
        """
        :param pulumi.Input[Sequence[pulumi.Input['ClusterComponentConfigConfigArgs']]] configs: Specifies the configuration of component installed.
               The object structure is documented below.
        :param pulumi.Input[str] name: Specifies the name of a bootstrap action script.
               Changing this will create a new MapReduce cluster resource.
        """
        pulumi.set(__self__, "configs", configs)
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def configs(self) -> pulumi.Input[Sequence[pulumi.Input['ClusterComponentConfigConfigArgs']]]:
        """
        Specifies the configuration of component installed.
        The object structure is documented below.
        """
        return pulumi.get(self, "configs")

    @configs.setter
    def configs(self, value: pulumi.Input[Sequence[pulumi.Input['ClusterComponentConfigConfigArgs']]]):
        pulumi.set(self, "configs", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        """
        Specifies the name of a bootstrap action script.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class ClusterComponentConfigConfigArgs:
    def __init__(__self__, *,
                 config_file_name: pulumi.Input[str],
                 key: pulumi.Input[str],
                 value: pulumi.Input[str]):
        """
        :param pulumi.Input[str] config_file_name: Specifies the configuration file name of component installed.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[str] key: Specifies the configuration item key of component installed.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[str] value: Specifies the configuration item value of component installed.
               Changing this will create a new MapReduce cluster resource.
        """
        pulumi.set(__self__, "config_file_name", config_file_name)
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="configFileName")
    def config_file_name(self) -> pulumi.Input[str]:
        """
        Specifies the configuration file name of component installed.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "config_file_name")

    @config_file_name.setter
    def config_file_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "config_file_name", value)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Input[str]:
        """
        Specifies the configuration item key of component installed.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: pulumi.Input[str]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[str]:
        """
        Specifies the configuration item value of component installed.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[str]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class ClusterCustomNodeArgs:
    def __init__(__self__, *,
                 data_volume_count: pulumi.Input[int],
                 flavor: pulumi.Input[str],
                 group_name: pulumi.Input[str],
                 node_number: pulumi.Input[int],
                 root_volume_size: pulumi.Input[int],
                 root_volume_type: pulumi.Input[str],
                 assigned_roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 data_volume_size: Optional[pulumi.Input[int]] = None,
                 data_volume_type: Optional[pulumi.Input[str]] = None,
                 host_ips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        :param pulumi.Input[int] data_volume_count: Specifies the data disk number of the nodes.  
               The valid value is `1`.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[str] flavor: Specifies the instance specifications for each nodes in node group.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[str] group_name: Specifies the name of nodes for the node group.  
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[int] node_number: Specifies the number of nodes for the node group.  
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[int] root_volume_size: Specifies the system disk size of the nodes. Changing this will create
               a new MapReduce cluster resource.
        :param pulumi.Input[str] root_volume_type: Specifies the system disk flavor of the nodes. Changing this will
               create a new MapReduce cluster resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] assigned_roles: Specifies the roles deployed in a node group.This argument is mandatory
               when the cluster type is **CUSTOM**. Each character string represents a role expression.
        :param pulumi.Input[int] data_volume_size: Specifies the data disk size of the nodes,in GB. The value range is 10
               to 32768. Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce
               cluster resource.
        :param pulumi.Input[str] data_volume_type: Specifies the data disk flavor of the nodes.
               Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce cluster resource.
               The following disk types are supported:
               + **SATA**: common I/O disk.
               + **SAS**: high I/O disk.
               + **SSD**: ultra-high I/O disk.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_ips: The host list of this nodes group in the cluster.
               * `bootstrap_scripts/start_time` - The execution time of one bootstrap action script, in RFC-3339 format.
               * `bootstrap_scripts/state` - The status of one bootstrap action script.
               The valid value are **PENDING**, **IN_PROGRESS**, **SUCCESS**, and **FAILURE**.
        """
        pulumi.set(__self__, "data_volume_count", data_volume_count)
        pulumi.set(__self__, "flavor", flavor)
        pulumi.set(__self__, "group_name", group_name)
        pulumi.set(__self__, "node_number", node_number)
        pulumi.set(__self__, "root_volume_size", root_volume_size)
        pulumi.set(__self__, "root_volume_type", root_volume_type)
        if assigned_roles is not None:
            pulumi.set(__self__, "assigned_roles", assigned_roles)
        if data_volume_size is not None:
            pulumi.set(__self__, "data_volume_size", data_volume_size)
        if data_volume_type is not None:
            pulumi.set(__self__, "data_volume_type", data_volume_type)
        if host_ips is not None:
            pulumi.set(__self__, "host_ips", host_ips)

    @property
    @pulumi.getter(name="dataVolumeCount")
    def data_volume_count(self) -> pulumi.Input[int]:
        """
        Specifies the data disk number of the nodes.  
        The valid value is `1`.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "data_volume_count")

    @data_volume_count.setter
    def data_volume_count(self, value: pulumi.Input[int]):
        pulumi.set(self, "data_volume_count", value)

    @property
    @pulumi.getter
    def flavor(self) -> pulumi.Input[str]:
        """
        Specifies the instance specifications for each nodes in node group.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "flavor")

    @flavor.setter
    def flavor(self, value: pulumi.Input[str]):
        pulumi.set(self, "flavor", value)

    @property
    @pulumi.getter(name="groupName")
    def group_name(self) -> pulumi.Input[str]:
        """
        Specifies the name of nodes for the node group.  
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "group_name")

    @group_name.setter
    def group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "group_name", value)

    @property
    @pulumi.getter(name="nodeNumber")
    def node_number(self) -> pulumi.Input[int]:
        """
        Specifies the number of nodes for the node group.  
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "node_number")

    @node_number.setter
    def node_number(self, value: pulumi.Input[int]):
        pulumi.set(self, "node_number", value)

    @property
    @pulumi.getter(name="rootVolumeSize")
    def root_volume_size(self) -> pulumi.Input[int]:
        """
        Specifies the system disk size of the nodes. Changing this will create
        a new MapReduce cluster resource.
        """
        return pulumi.get(self, "root_volume_size")

    @root_volume_size.setter
    def root_volume_size(self, value: pulumi.Input[int]):
        pulumi.set(self, "root_volume_size", value)

    @property
    @pulumi.getter(name="rootVolumeType")
    def root_volume_type(self) -> pulumi.Input[str]:
        """
        Specifies the system disk flavor of the nodes. Changing this will
        create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "root_volume_type")

    @root_volume_type.setter
    def root_volume_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "root_volume_type", value)

    @property
    @pulumi.getter(name="assignedRoles")
    def assigned_roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Specifies the roles deployed in a node group.This argument is mandatory
        when the cluster type is **CUSTOM**. Each character string represents a role expression.
        """
        return pulumi.get(self, "assigned_roles")

    @assigned_roles.setter
    def assigned_roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "assigned_roles", value)

    @property
    @pulumi.getter(name="dataVolumeSize")
    def data_volume_size(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the data disk size of the nodes,in GB. The value range is 10
        to 32768. Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce
        cluster resource.
        """
        return pulumi.get(self, "data_volume_size")

    @data_volume_size.setter
    def data_volume_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "data_volume_size", value)

    @property
    @pulumi.getter(name="dataVolumeType")
    def data_volume_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the data disk flavor of the nodes.
        Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce cluster resource.
        The following disk types are supported:
        + **SATA**: common I/O disk.
        + **SAS**: high I/O disk.
        + **SSD**: ultra-high I/O disk.
        """
        return pulumi.get(self, "data_volume_type")

    @data_volume_type.setter
    def data_volume_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "data_volume_type", value)

    @property
    @pulumi.getter(name="hostIps")
    def host_ips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The host list of this nodes group in the cluster.
        * `bootstrap_scripts/start_time` - The execution time of one bootstrap action script, in RFC-3339 format.
        * `bootstrap_scripts/state` - The status of one bootstrap action script.
        The valid value are **PENDING**, **IN_PROGRESS**, **SUCCESS**, and **FAILURE**.
        """
        return pulumi.get(self, "host_ips")

    @host_ips.setter
    def host_ips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_ips", value)


@pulumi.input_type
class ClusterExternalDatasourceArgs:
    def __init__(__self__, *,
                 component_name: pulumi.Input[str],
                 role_type: pulumi.Input[str],
                 source_type: pulumi.Input[str],
                 data_connection_id: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] component_name: Specifies the component name. The valid values are `Hive` and `Ranger`.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[str] role_type: Specifies the component role type.
               The options are as follows:
               + **hive_metastore**: Hive Metastore role.
               + **ranger_data**: Ranger role.
        :param pulumi.Input[str] source_type: Specifies the data connection type.
               The options are as follows:
               + **LOCAL_DB**: Local metadata.
               + **RDS_POSTGRES**: RDS PostgreSQL database.
               + **RDS_MYSQL**: RDS MySQL database.
               + **gaussdb-mysql**: GaussDB(for MySQL).
        :param pulumi.Input[str] data_connection_id: Specifies the data connection ID.
               This parameter is mandatory if `source_type` is not **LOCAL_DB**.
               Changing this will create a new MapReduce cluster resource.
        """
        pulumi.set(__self__, "component_name", component_name)
        pulumi.set(__self__, "role_type", role_type)
        pulumi.set(__self__, "source_type", source_type)
        if data_connection_id is not None:
            pulumi.set(__self__, "data_connection_id", data_connection_id)

    @property
    @pulumi.getter(name="componentName")
    def component_name(self) -> pulumi.Input[str]:
        """
        Specifies the component name. The valid values are `Hive` and `Ranger`.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "component_name")

    @component_name.setter
    def component_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "component_name", value)

    @property
    @pulumi.getter(name="roleType")
    def role_type(self) -> pulumi.Input[str]:
        """
        Specifies the component role type.
        The options are as follows:
        + **hive_metastore**: Hive Metastore role.
        + **ranger_data**: Ranger role.
        """
        return pulumi.get(self, "role_type")

    @role_type.setter
    def role_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "role_type", value)

    @property
    @pulumi.getter(name="sourceType")
    def source_type(self) -> pulumi.Input[str]:
        """
        Specifies the data connection type.
        The options are as follows:
        + **LOCAL_DB**: Local metadata.
        + **RDS_POSTGRES**: RDS PostgreSQL database.
        + **RDS_MYSQL**: RDS MySQL database.
        + **gaussdb-mysql**: GaussDB(for MySQL).
        """
        return pulumi.get(self, "source_type")

    @source_type.setter
    def source_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "source_type", value)

    @property
    @pulumi.getter(name="dataConnectionId")
    def data_connection_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the data connection ID.
        This parameter is mandatory if `source_type` is not **LOCAL_DB**.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "data_connection_id")

    @data_connection_id.setter
    def data_connection_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "data_connection_id", value)


@pulumi.input_type
class ClusterMasterNodesArgs:
    def __init__(__self__, *,
                 data_volume_count: pulumi.Input[int],
                 flavor: pulumi.Input[str],
                 node_number: pulumi.Input[int],
                 root_volume_size: pulumi.Input[int],
                 root_volume_type: pulumi.Input[str],
                 assigned_roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 data_volume_size: Optional[pulumi.Input[int]] = None,
                 data_volume_type: Optional[pulumi.Input[str]] = None,
                 host_ips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        :param pulumi.Input[int] data_volume_count: Specifies the data disk number of the nodes.  
               The valid value is `1`.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[str] flavor: Specifies the instance specifications for each nodes in node group.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[int] node_number: Specifies the number of nodes for the node group.  
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[int] root_volume_size: Specifies the system disk size of the nodes. Changing this will create
               a new MapReduce cluster resource.
        :param pulumi.Input[str] root_volume_type: Specifies the system disk flavor of the nodes. Changing this will
               create a new MapReduce cluster resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] assigned_roles: Specifies the roles deployed in a node group.This argument is mandatory
               when the cluster type is **CUSTOM**. Each character string represents a role expression.
        :param pulumi.Input[int] data_volume_size: Specifies the data disk size of the nodes,in GB. The value range is 10
               to 32768. Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce
               cluster resource.
        :param pulumi.Input[str] data_volume_type: Specifies the data disk flavor of the nodes.
               Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce cluster resource.
               The following disk types are supported:
               + **SATA**: common I/O disk.
               + **SAS**: high I/O disk.
               + **SSD**: ultra-high I/O disk.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_ips: The host list of this nodes group in the cluster.
               * `bootstrap_scripts/start_time` - The execution time of one bootstrap action script, in RFC-3339 format.
               * `bootstrap_scripts/state` - The status of one bootstrap action script.
               The valid value are **PENDING**, **IN_PROGRESS**, **SUCCESS**, and **FAILURE**.
        """
        pulumi.set(__self__, "data_volume_count", data_volume_count)
        pulumi.set(__self__, "flavor", flavor)
        pulumi.set(__self__, "node_number", node_number)
        pulumi.set(__self__, "root_volume_size", root_volume_size)
        pulumi.set(__self__, "root_volume_type", root_volume_type)
        if assigned_roles is not None:
            pulumi.set(__self__, "assigned_roles", assigned_roles)
        if data_volume_size is not None:
            pulumi.set(__self__, "data_volume_size", data_volume_size)
        if data_volume_type is not None:
            pulumi.set(__self__, "data_volume_type", data_volume_type)
        if host_ips is not None:
            pulumi.set(__self__, "host_ips", host_ips)

    @property
    @pulumi.getter(name="dataVolumeCount")
    def data_volume_count(self) -> pulumi.Input[int]:
        """
        Specifies the data disk number of the nodes.  
        The valid value is `1`.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "data_volume_count")

    @data_volume_count.setter
    def data_volume_count(self, value: pulumi.Input[int]):
        pulumi.set(self, "data_volume_count", value)

    @property
    @pulumi.getter
    def flavor(self) -> pulumi.Input[str]:
        """
        Specifies the instance specifications for each nodes in node group.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "flavor")

    @flavor.setter
    def flavor(self, value: pulumi.Input[str]):
        pulumi.set(self, "flavor", value)

    @property
    @pulumi.getter(name="nodeNumber")
    def node_number(self) -> pulumi.Input[int]:
        """
        Specifies the number of nodes for the node group.  
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "node_number")

    @node_number.setter
    def node_number(self, value: pulumi.Input[int]):
        pulumi.set(self, "node_number", value)

    @property
    @pulumi.getter(name="rootVolumeSize")
    def root_volume_size(self) -> pulumi.Input[int]:
        """
        Specifies the system disk size of the nodes. Changing this will create
        a new MapReduce cluster resource.
        """
        return pulumi.get(self, "root_volume_size")

    @root_volume_size.setter
    def root_volume_size(self, value: pulumi.Input[int]):
        pulumi.set(self, "root_volume_size", value)

    @property
    @pulumi.getter(name="rootVolumeType")
    def root_volume_type(self) -> pulumi.Input[str]:
        """
        Specifies the system disk flavor of the nodes. Changing this will
        create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "root_volume_type")

    @root_volume_type.setter
    def root_volume_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "root_volume_type", value)

    @property
    @pulumi.getter(name="assignedRoles")
    def assigned_roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Specifies the roles deployed in a node group.This argument is mandatory
        when the cluster type is **CUSTOM**. Each character string represents a role expression.
        """
        return pulumi.get(self, "assigned_roles")

    @assigned_roles.setter
    def assigned_roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "assigned_roles", value)

    @property
    @pulumi.getter(name="dataVolumeSize")
    def data_volume_size(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the data disk size of the nodes,in GB. The value range is 10
        to 32768. Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce
        cluster resource.
        """
        return pulumi.get(self, "data_volume_size")

    @data_volume_size.setter
    def data_volume_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "data_volume_size", value)

    @property
    @pulumi.getter(name="dataVolumeType")
    def data_volume_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the data disk flavor of the nodes.
        Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce cluster resource.
        The following disk types are supported:
        + **SATA**: common I/O disk.
        + **SAS**: high I/O disk.
        + **SSD**: ultra-high I/O disk.
        """
        return pulumi.get(self, "data_volume_type")

    @data_volume_type.setter
    def data_volume_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "data_volume_type", value)

    @property
    @pulumi.getter(name="hostIps")
    def host_ips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The host list of this nodes group in the cluster.
        * `bootstrap_scripts/start_time` - The execution time of one bootstrap action script, in RFC-3339 format.
        * `bootstrap_scripts/state` - The status of one bootstrap action script.
        The valid value are **PENDING**, **IN_PROGRESS**, **SUCCESS**, and **FAILURE**.
        """
        return pulumi.get(self, "host_ips")

    @host_ips.setter
    def host_ips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_ips", value)


@pulumi.input_type
class ClusterSmnNotifyArgs:
    def __init__(__self__, *,
                 subscription_name: pulumi.Input[str],
                 topic_urn: pulumi.Input[str]):
        """
        :param pulumi.Input[str] subscription_name: Specifies the subscription rule name.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[str] topic_urn: Specifies the Uniform Resource Name (URN) of the topic.
               Changing this will create a new MapReduce cluster resource.
        """
        pulumi.set(__self__, "subscription_name", subscription_name)
        pulumi.set(__self__, "topic_urn", topic_urn)

    @property
    @pulumi.getter(name="subscriptionName")
    def subscription_name(self) -> pulumi.Input[str]:
        """
        Specifies the subscription rule name.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "subscription_name")

    @subscription_name.setter
    def subscription_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "subscription_name", value)

    @property
    @pulumi.getter(name="topicUrn")
    def topic_urn(self) -> pulumi.Input[str]:
        """
        Specifies the Uniform Resource Name (URN) of the topic.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "topic_urn")

    @topic_urn.setter
    def topic_urn(self, value: pulumi.Input[str]):
        pulumi.set(self, "topic_urn", value)


@pulumi.input_type
class ClusterStreamingCoreNodesArgs:
    def __init__(__self__, *,
                 data_volume_count: pulumi.Input[int],
                 flavor: pulumi.Input[str],
                 node_number: pulumi.Input[int],
                 root_volume_size: pulumi.Input[int],
                 root_volume_type: pulumi.Input[str],
                 assigned_roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 data_volume_size: Optional[pulumi.Input[int]] = None,
                 data_volume_type: Optional[pulumi.Input[str]] = None,
                 host_ips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        :param pulumi.Input[int] data_volume_count: Specifies the data disk number of the nodes.  
               The valid value is `1`.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[str] flavor: Specifies the instance specifications for each nodes in node group.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[int] node_number: Specifies the number of nodes for the node group.  
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[int] root_volume_size: Specifies the system disk size of the nodes. Changing this will create
               a new MapReduce cluster resource.
        :param pulumi.Input[str] root_volume_type: Specifies the system disk flavor of the nodes. Changing this will
               create a new MapReduce cluster resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] assigned_roles: Specifies the roles deployed in a node group.This argument is mandatory
               when the cluster type is **CUSTOM**. Each character string represents a role expression.
        :param pulumi.Input[int] data_volume_size: Specifies the data disk size of the nodes,in GB. The value range is 10
               to 32768. Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce
               cluster resource.
        :param pulumi.Input[str] data_volume_type: Specifies the data disk flavor of the nodes.
               Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce cluster resource.
               The following disk types are supported:
               + **SATA**: common I/O disk.
               + **SAS**: high I/O disk.
               + **SSD**: ultra-high I/O disk.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_ips: The host list of this nodes group in the cluster.
               * `bootstrap_scripts/start_time` - The execution time of one bootstrap action script, in RFC-3339 format.
               * `bootstrap_scripts/state` - The status of one bootstrap action script.
               The valid value are **PENDING**, **IN_PROGRESS**, **SUCCESS**, and **FAILURE**.
        """
        pulumi.set(__self__, "data_volume_count", data_volume_count)
        pulumi.set(__self__, "flavor", flavor)
        pulumi.set(__self__, "node_number", node_number)
        pulumi.set(__self__, "root_volume_size", root_volume_size)
        pulumi.set(__self__, "root_volume_type", root_volume_type)
        if assigned_roles is not None:
            pulumi.set(__self__, "assigned_roles", assigned_roles)
        if data_volume_size is not None:
            pulumi.set(__self__, "data_volume_size", data_volume_size)
        if data_volume_type is not None:
            pulumi.set(__self__, "data_volume_type", data_volume_type)
        if host_ips is not None:
            pulumi.set(__self__, "host_ips", host_ips)

    @property
    @pulumi.getter(name="dataVolumeCount")
    def data_volume_count(self) -> pulumi.Input[int]:
        """
        Specifies the data disk number of the nodes.  
        The valid value is `1`.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "data_volume_count")

    @data_volume_count.setter
    def data_volume_count(self, value: pulumi.Input[int]):
        pulumi.set(self, "data_volume_count", value)

    @property
    @pulumi.getter
    def flavor(self) -> pulumi.Input[str]:
        """
        Specifies the instance specifications for each nodes in node group.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "flavor")

    @flavor.setter
    def flavor(self, value: pulumi.Input[str]):
        pulumi.set(self, "flavor", value)

    @property
    @pulumi.getter(name="nodeNumber")
    def node_number(self) -> pulumi.Input[int]:
        """
        Specifies the number of nodes for the node group.  
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "node_number")

    @node_number.setter
    def node_number(self, value: pulumi.Input[int]):
        pulumi.set(self, "node_number", value)

    @property
    @pulumi.getter(name="rootVolumeSize")
    def root_volume_size(self) -> pulumi.Input[int]:
        """
        Specifies the system disk size of the nodes. Changing this will create
        a new MapReduce cluster resource.
        """
        return pulumi.get(self, "root_volume_size")

    @root_volume_size.setter
    def root_volume_size(self, value: pulumi.Input[int]):
        pulumi.set(self, "root_volume_size", value)

    @property
    @pulumi.getter(name="rootVolumeType")
    def root_volume_type(self) -> pulumi.Input[str]:
        """
        Specifies the system disk flavor of the nodes. Changing this will
        create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "root_volume_type")

    @root_volume_type.setter
    def root_volume_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "root_volume_type", value)

    @property
    @pulumi.getter(name="assignedRoles")
    def assigned_roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Specifies the roles deployed in a node group.This argument is mandatory
        when the cluster type is **CUSTOM**. Each character string represents a role expression.
        """
        return pulumi.get(self, "assigned_roles")

    @assigned_roles.setter
    def assigned_roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "assigned_roles", value)

    @property
    @pulumi.getter(name="dataVolumeSize")
    def data_volume_size(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the data disk size of the nodes,in GB. The value range is 10
        to 32768. Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce
        cluster resource.
        """
        return pulumi.get(self, "data_volume_size")

    @data_volume_size.setter
    def data_volume_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "data_volume_size", value)

    @property
    @pulumi.getter(name="dataVolumeType")
    def data_volume_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the data disk flavor of the nodes.
        Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce cluster resource.
        The following disk types are supported:
        + **SATA**: common I/O disk.
        + **SAS**: high I/O disk.
        + **SSD**: ultra-high I/O disk.
        """
        return pulumi.get(self, "data_volume_type")

    @data_volume_type.setter
    def data_volume_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "data_volume_type", value)

    @property
    @pulumi.getter(name="hostIps")
    def host_ips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The host list of this nodes group in the cluster.
        * `bootstrap_scripts/start_time` - The execution time of one bootstrap action script, in RFC-3339 format.
        * `bootstrap_scripts/state` - The status of one bootstrap action script.
        The valid value are **PENDING**, **IN_PROGRESS**, **SUCCESS**, and **FAILURE**.
        """
        return pulumi.get(self, "host_ips")

    @host_ips.setter
    def host_ips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_ips", value)


@pulumi.input_type
class ClusterStreamingTaskNodesArgs:
    def __init__(__self__, *,
                 data_volume_count: pulumi.Input[int],
                 flavor: pulumi.Input[str],
                 node_number: pulumi.Input[int],
                 root_volume_size: pulumi.Input[int],
                 root_volume_type: pulumi.Input[str],
                 assigned_roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 data_volume_size: Optional[pulumi.Input[int]] = None,
                 data_volume_type: Optional[pulumi.Input[str]] = None,
                 host_ips: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        :param pulumi.Input[int] data_volume_count: Specifies the data disk number of the nodes.  
               The valid value is `1`.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[str] flavor: Specifies the instance specifications for each nodes in node group.
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[int] node_number: Specifies the number of nodes for the node group.  
               Changing this will create a new MapReduce cluster resource.
        :param pulumi.Input[int] root_volume_size: Specifies the system disk size of the nodes. Changing this will create
               a new MapReduce cluster resource.
        :param pulumi.Input[str] root_volume_type: Specifies the system disk flavor of the nodes. Changing this will
               create a new MapReduce cluster resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] assigned_roles: Specifies the roles deployed in a node group.This argument is mandatory
               when the cluster type is **CUSTOM**. Each character string represents a role expression.
        :param pulumi.Input[int] data_volume_size: Specifies the data disk size of the nodes,in GB. The value range is 10
               to 32768. Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce
               cluster resource.
        :param pulumi.Input[str] data_volume_type: Specifies the data disk flavor of the nodes.
               Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce cluster resource.
               The following disk types are supported:
               + **SATA**: common I/O disk.
               + **SAS**: high I/O disk.
               + **SSD**: ultra-high I/O disk.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_ips: The host list of this nodes group in the cluster.
               * `bootstrap_scripts/start_time` - The execution time of one bootstrap action script, in RFC-3339 format.
               * `bootstrap_scripts/state` - The status of one bootstrap action script.
               The valid value are **PENDING**, **IN_PROGRESS**, **SUCCESS**, and **FAILURE**.
        """
        pulumi.set(__self__, "data_volume_count", data_volume_count)
        pulumi.set(__self__, "flavor", flavor)
        pulumi.set(__self__, "node_number", node_number)
        pulumi.set(__self__, "root_volume_size", root_volume_size)
        pulumi.set(__self__, "root_volume_type", root_volume_type)
        if assigned_roles is not None:
            pulumi.set(__self__, "assigned_roles", assigned_roles)
        if data_volume_size is not None:
            pulumi.set(__self__, "data_volume_size", data_volume_size)
        if data_volume_type is not None:
            pulumi.set(__self__, "data_volume_type", data_volume_type)
        if host_ips is not None:
            pulumi.set(__self__, "host_ips", host_ips)

    @property
    @pulumi.getter(name="dataVolumeCount")
    def data_volume_count(self) -> pulumi.Input[int]:
        """
        Specifies the data disk number of the nodes.  
        The valid value is `1`.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "data_volume_count")

    @data_volume_count.setter
    def data_volume_count(self, value: pulumi.Input[int]):
        pulumi.set(self, "data_volume_count", value)

    @property
    @pulumi.getter
    def flavor(self) -> pulumi.Input[str]:
        """
        Specifies the instance specifications for each nodes in node group.
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "flavor")

    @flavor.setter
    def flavor(self, value: pulumi.Input[str]):
        pulumi.set(self, "flavor", value)

    @property
    @pulumi.getter(name="nodeNumber")
    def node_number(self) -> pulumi.Input[int]:
        """
        Specifies the number of nodes for the node group.  
        Changing this will create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "node_number")

    @node_number.setter
    def node_number(self, value: pulumi.Input[int]):
        pulumi.set(self, "node_number", value)

    @property
    @pulumi.getter(name="rootVolumeSize")
    def root_volume_size(self) -> pulumi.Input[int]:
        """
        Specifies the system disk size of the nodes. Changing this will create
        a new MapReduce cluster resource.
        """
        return pulumi.get(self, "root_volume_size")

    @root_volume_size.setter
    def root_volume_size(self, value: pulumi.Input[int]):
        pulumi.set(self, "root_volume_size", value)

    @property
    @pulumi.getter(name="rootVolumeType")
    def root_volume_type(self) -> pulumi.Input[str]:
        """
        Specifies the system disk flavor of the nodes. Changing this will
        create a new MapReduce cluster resource.
        """
        return pulumi.get(self, "root_volume_type")

    @root_volume_type.setter
    def root_volume_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "root_volume_type", value)

    @property
    @pulumi.getter(name="assignedRoles")
    def assigned_roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Specifies the roles deployed in a node group.This argument is mandatory
        when the cluster type is **CUSTOM**. Each character string represents a role expression.
        """
        return pulumi.get(self, "assigned_roles")

    @assigned_roles.setter
    def assigned_roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "assigned_roles", value)

    @property
    @pulumi.getter(name="dataVolumeSize")
    def data_volume_size(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the data disk size of the nodes,in GB. The value range is 10
        to 32768. Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce
        cluster resource.
        """
        return pulumi.get(self, "data_volume_size")

    @data_volume_size.setter
    def data_volume_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "data_volume_size", value)

    @property
    @pulumi.getter(name="dataVolumeType")
    def data_volume_type(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the data disk flavor of the nodes.
        Required if `data_volume_count` is greater than zero. Changing this will create a new MapReduce cluster resource.
        The following disk types are supported:
        + **SATA**: common I/O disk.
        + **SAS**: high I/O disk.
        + **SSD**: ultra-high I/O disk.
        """
        return pulumi.get(self, "data_volume_type")

    @data_volume_type.setter
    def data_volume_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "data_volume_type", value)

    @property
    @pulumi.getter(name="hostIps")
    def host_ips(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The host list of this nodes group in the cluster.
        * `bootstrap_scripts/start_time` - The execution time of one bootstrap action script, in RFC-3339 format.
        * `bootstrap_scripts/state` - The status of one bootstrap action script.
        The valid value are **PENDING**, **IN_PROGRESS**, **SUCCESS**, and **FAILURE**.
        """
        return pulumi.get(self, "host_ips")

    @host_ips.setter
    def host_ips(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_ips", value)


