# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GatewaySessionConf',
]

@pulumi.output_type
class GatewaySessionConf(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "icmpSessionExpireTime":
            suggest = "icmp_session_expire_time"
        elif key == "tcpSessionExpireTime":
            suggest = "tcp_session_expire_time"
        elif key == "tcpTimeWaitTime":
            suggest = "tcp_time_wait_time"
        elif key == "udpSessionExpireTime":
            suggest = "udp_session_expire_time"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in GatewaySessionConf. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        GatewaySessionConf.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        GatewaySessionConf.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 icmp_session_expire_time: Optional[int] = None,
                 tcp_session_expire_time: Optional[int] = None,
                 tcp_time_wait_time: Optional[int] = None,
                 udp_session_expire_time: Optional[int] = None):
        """
        :param int icmp_session_expire_time: Specifies the ICMP session expiration time, in seconds.
               The valid value from `10` to `7,200`, default value is `10`.
        :param int tcp_session_expire_time: Specifies the TCP session expiration time, in seconds.
               The valid value from `40` to `7,200`, default value is `900`.
        :param int tcp_time_wait_time: Specifies the duration of TIME_WAIT state when TCP connection is closed,
               in seconds. The valid value from `0` to `1,800`, default value is `5`.
        :param int udp_session_expire_time: Specifies the UDP session expiration time, in seconds.
               The valid value from `40` to `7,200`, default value is `300`.
        """
        if icmp_session_expire_time is not None:
            pulumi.set(__self__, "icmp_session_expire_time", icmp_session_expire_time)
        if tcp_session_expire_time is not None:
            pulumi.set(__self__, "tcp_session_expire_time", tcp_session_expire_time)
        if tcp_time_wait_time is not None:
            pulumi.set(__self__, "tcp_time_wait_time", tcp_time_wait_time)
        if udp_session_expire_time is not None:
            pulumi.set(__self__, "udp_session_expire_time", udp_session_expire_time)

    @property
    @pulumi.getter(name="icmpSessionExpireTime")
    def icmp_session_expire_time(self) -> Optional[int]:
        """
        Specifies the ICMP session expiration time, in seconds.
        The valid value from `10` to `7,200`, default value is `10`.
        """
        return pulumi.get(self, "icmp_session_expire_time")

    @property
    @pulumi.getter(name="tcpSessionExpireTime")
    def tcp_session_expire_time(self) -> Optional[int]:
        """
        Specifies the TCP session expiration time, in seconds.
        The valid value from `40` to `7,200`, default value is `900`.
        """
        return pulumi.get(self, "tcp_session_expire_time")

    @property
    @pulumi.getter(name="tcpTimeWaitTime")
    def tcp_time_wait_time(self) -> Optional[int]:
        """
        Specifies the duration of TIME_WAIT state when TCP connection is closed,
        in seconds. The valid value from `0` to `1,800`, default value is `5`.
        """
        return pulumi.get(self, "tcp_time_wait_time")

    @property
    @pulumi.getter(name="udpSessionExpireTime")
    def udp_session_expire_time(self) -> Optional[int]:
        """
        Specifies the UDP session expiration time, in seconds.
        The valid value from `40` to `7,200`, default value is `300`.
        """
        return pulumi.get(self, "udp_session_expire_time")


