# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetBackupFilesResult',
    'AwaitableGetBackupFilesResult',
    'get_backup_files',
    'get_backup_files_output',
]

@pulumi.output_type
class GetBackupFilesResult:
    """
    A collection of values returned by getBackupFiles.
    """
    def __init__(__self__, backup_id=None, bucket=None, files=None, id=None, region=None):
        if backup_id and not isinstance(backup_id, str):
            raise TypeError("Expected argument 'backup_id' to be a str")
        pulumi.set(__self__, "backup_id", backup_id)
        if bucket and not isinstance(bucket, str):
            raise TypeError("Expected argument 'bucket' to be a str")
        pulumi.set(__self__, "bucket", bucket)
        if files and not isinstance(files, list):
            raise TypeError("Expected argument 'files' to be a list")
        pulumi.set(__self__, "files", files)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="backupId")
    def backup_id(self) -> str:
        return pulumi.get(self, "backup_id")

    @property
    @pulumi.getter
    def bucket(self) -> str:
        """
        Indicates the name of the bucket where the file is located.
        """
        return pulumi.get(self, "bucket")

    @property
    @pulumi.getter
    def files(self) -> Sequence['outputs.GetBackupFilesFileResult']:
        """
        Indicates the list of backup files.
        """
        return pulumi.get(self, "files")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")


class AwaitableGetBackupFilesResult(GetBackupFilesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBackupFilesResult(
            backup_id=self.backup_id,
            bucket=self.bucket,
            files=self.files,
            id=self.id,
            region=self.region)


def get_backup_files(backup_id: Optional[str] = None,
                     region: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBackupFilesResult:
    """
    Use this data source to get the link for downloading a backup file.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Rds.get_backup_files(backup_id=var["backup_id"])
    ```


    :param str backup_id: Specifies the backup ID.
    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    """
    __args__ = dict()
    __args__['backupId'] = backup_id
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Rds/getBackupFiles:getBackupFiles', __args__, opts=opts, typ=GetBackupFilesResult).value

    return AwaitableGetBackupFilesResult(
        backup_id=__ret__.backup_id,
        bucket=__ret__.bucket,
        files=__ret__.files,
        id=__ret__.id,
        region=__ret__.region)


@_utilities.lift_output_func(get_backup_files)
def get_backup_files_output(backup_id: Optional[pulumi.Input[str]] = None,
                            region: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetBackupFilesResult]:
    """
    Use this data source to get the link for downloading a backup file.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Rds.get_backup_files(backup_id=var["backup_id"])
    ```


    :param str backup_id: Specifies the backup ID.
    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    """
    ...
