# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetMysqlAccountsResult',
    'AwaitableGetMysqlAccountsResult',
    'get_mysql_accounts',
    'get_mysql_accounts_output',
]

@pulumi.output_type
class GetMysqlAccountsResult:
    """
    A collection of values returned by getMysqlAccounts.
    """
    def __init__(__self__, host=None, id=None, instance_id=None, name=None, region=None, users=None):
        if host and not isinstance(host, str):
            raise TypeError("Expected argument 'host' to be a str")
        pulumi.set(__self__, "host", host)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if users and not isinstance(users, list):
            raise TypeError("Expected argument 'users' to be a list")
        pulumi.set(__self__, "users", users)

    @property
    @pulumi.getter
    def host(self) -> Optional[str]:
        return pulumi.get(self, "host")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Indicates the username of the DB account.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def users(self) -> Sequence['outputs.GetMysqlAccountsUserResult']:
        """
        Indicates the list of users.
        The users structure is documented below.
        """
        return pulumi.get(self, "users")


class AwaitableGetMysqlAccountsResult(GetMysqlAccountsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetMysqlAccountsResult(
            host=self.host,
            id=self.id,
            instance_id=self.instance_id,
            name=self.name,
            region=self.region,
            users=self.users)


def get_mysql_accounts(host: Optional[str] = None,
                       instance_id: Optional[str] = None,
                       name: Optional[str] = None,
                       region: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetMysqlAccountsResult:
    """
    Use this data source to get the list of RDS MySQL accounts.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Rds.get_mysql_accounts(instance_id=var["instance_id"],
        name="test",
        host="10.10.10.10")
    ```


    :param str host: Specifies the IP address that is allowed to access your DB instance.
    :param str instance_id: Specifies the ID of the RDS instance.
    :param str name: Specifies the username of the DB account.
    :param str region: Specifies the region in which to query the data source.
           If omitted, the provider-level region will be used.
    """
    __args__ = dict()
    __args__['host'] = host
    __args__['instanceId'] = instance_id
    __args__['name'] = name
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Rds/getMysqlAccounts:getMysqlAccounts', __args__, opts=opts, typ=GetMysqlAccountsResult).value

    return AwaitableGetMysqlAccountsResult(
        host=__ret__.host,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        name=__ret__.name,
        region=__ret__.region,
        users=__ret__.users)


@_utilities.lift_output_func(get_mysql_accounts)
def get_mysql_accounts_output(host: Optional[pulumi.Input[Optional[str]]] = None,
                              instance_id: Optional[pulumi.Input[str]] = None,
                              name: Optional[pulumi.Input[Optional[str]]] = None,
                              region: Optional[pulumi.Input[Optional[str]]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetMysqlAccountsResult]:
    """
    Use this data source to get the list of RDS MySQL accounts.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Rds.get_mysql_accounts(instance_id=var["instance_id"],
        name="test",
        host="10.10.10.10")
    ```


    :param str host: Specifies the IP address that is allowed to access your DB instance.
    :param str instance_id: Specifies the ID of the RDS instance.
    :param str name: Specifies the username of the DB account.
    :param str region: Specifies the region in which to query the data source.
           If omitted, the provider-level region will be used.
    """
    ...
