# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetPgAccountsResult',
    'AwaitableGetPgAccountsResult',
    'get_pg_accounts',
    'get_pg_accounts_output',
]

@pulumi.output_type
class GetPgAccountsResult:
    """
    A collection of values returned by getPgAccounts.
    """
    def __init__(__self__, id=None, instance_id=None, region=None, user_name=None, users=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if user_name and not isinstance(user_name, str):
            raise TypeError("Expected argument 'user_name' to be a str")
        pulumi.set(__self__, "user_name", user_name)
        if users and not isinstance(users, list):
            raise TypeError("Expected argument 'users' to be a list")
        pulumi.set(__self__, "users", users)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="userName")
    def user_name(self) -> Optional[str]:
        return pulumi.get(self, "user_name")

    @property
    @pulumi.getter
    def users(self) -> Sequence['outputs.GetPgAccountsUserResult']:
        """
        Indicates the user list.
        The users structure is documented below.
        """
        return pulumi.get(self, "users")


class AwaitableGetPgAccountsResult(GetPgAccountsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPgAccountsResult(
            id=self.id,
            instance_id=self.instance_id,
            region=self.region,
            user_name=self.user_name,
            users=self.users)


def get_pg_accounts(instance_id: Optional[str] = None,
                    region: Optional[str] = None,
                    user_name: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPgAccountsResult:
    """
    Use this data source to get the list of RDS PostgreSQL accounts.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    instance_id = config.require_object("instanceId")
    test = huaweicloud.Rds.get_pg_accounts(instance_id=instance_id)
    ```


    :param str instance_id: Specifies the PostgreSQL instance ID.
    :param str region: Specifies the region in which to query the data source.
           If omitted, the provider-level region will be used.
    :param str user_name: Specifies the username of the DB account.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['region'] = region
    __args__['userName'] = user_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Rds/getPgAccounts:getPgAccounts', __args__, opts=opts, typ=GetPgAccountsResult).value

    return AwaitableGetPgAccountsResult(
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        region=__ret__.region,
        user_name=__ret__.user_name,
        users=__ret__.users)


@_utilities.lift_output_func(get_pg_accounts)
def get_pg_accounts_output(instance_id: Optional[pulumi.Input[str]] = None,
                           region: Optional[pulumi.Input[Optional[str]]] = None,
                           user_name: Optional[pulumi.Input[Optional[str]]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPgAccountsResult]:
    """
    Use this data source to get the list of RDS PostgreSQL accounts.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    instance_id = config.require_object("instanceId")
    test = huaweicloud.Rds.get_pg_accounts(instance_id=instance_id)
    ```


    :param str instance_id: Specifies the PostgreSQL instance ID.
    :param str region: Specifies the region in which to query the data source.
           If omitted, the provider-level region will be used.
    :param str user_name: Specifies the username of the DB account.
    """
    ...
