# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetPgPluginsResult',
    'AwaitableGetPgPluginsResult',
    'get_pg_plugins',
    'get_pg_plugins_output',
]

@pulumi.output_type
class GetPgPluginsResult:
    """
    A collection of values returned by getPgPlugins.
    """
    def __init__(__self__, created=None, database_name=None, id=None, instance_id=None, name=None, plugins=None, region=None, version=None):
        if created and not isinstance(created, bool):
            raise TypeError("Expected argument 'created' to be a bool")
        pulumi.set(__self__, "created", created)
        if database_name and not isinstance(database_name, str):
            raise TypeError("Expected argument 'database_name' to be a str")
        pulumi.set(__self__, "database_name", database_name)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if plugins and not isinstance(plugins, list):
            raise TypeError("Expected argument 'plugins' to be a list")
        pulumi.set(__self__, "plugins", plugins)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if version and not isinstance(version, str):
            raise TypeError("Expected argument 'version' to be a str")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def created(self) -> Optional[bool]:
        """
        Indicates whether the plugin has been created.
        """
        return pulumi.get(self, "created")

    @property
    @pulumi.getter(name="databaseName")
    def database_name(self) -> str:
        return pulumi.get(self, "database_name")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Indicates the plugin name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def plugins(self) -> Sequence['outputs.GetPgPluginsPluginResult']:
        """
        Indicates the plugin list.
        The plugins structure is documented below.
        """
        return pulumi.get(self, "plugins")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def version(self) -> Optional[str]:
        """
        Indicates the plugin version.
        """
        return pulumi.get(self, "version")


class AwaitableGetPgPluginsResult(GetPgPluginsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPgPluginsResult(
            created=self.created,
            database_name=self.database_name,
            id=self.id,
            instance_id=self.instance_id,
            name=self.name,
            plugins=self.plugins,
            region=self.region,
            version=self.version)


def get_pg_plugins(created: Optional[bool] = None,
                   database_name: Optional[str] = None,
                   instance_id: Optional[str] = None,
                   name: Optional[str] = None,
                   region: Optional[str] = None,
                   version: Optional[str] = None,
                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPgPluginsResult:
    """
    Use this data source to get the list of RDS PostgreSQL plugins.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    instance_id = config.require_object("instanceId")
    database_name = config.require_object("databaseName")
    plugins = huaweicloud.Rds.get_pg_plugins(instance_id=instance_id,
        database_name=database_name)
    ```


    :param bool created: Specifies whether the plugin has been created. Defaults to: **false**.
    :param str database_name: Specifies the database name of a PostgreSQL instance.
    :param str instance_id: Specifies the ID of a PostgreSQL instance.
    :param str name: Specifies the plugin name.
    :param str region: Specifies the region in which to query the data source.
           If omitted, the provider-level region will be used.
    :param str version: Specifies the plugin version.
    """
    __args__ = dict()
    __args__['created'] = created
    __args__['databaseName'] = database_name
    __args__['instanceId'] = instance_id
    __args__['name'] = name
    __args__['region'] = region
    __args__['version'] = version
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Rds/getPgPlugins:getPgPlugins', __args__, opts=opts, typ=GetPgPluginsResult).value

    return AwaitableGetPgPluginsResult(
        created=__ret__.created,
        database_name=__ret__.database_name,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        name=__ret__.name,
        plugins=__ret__.plugins,
        region=__ret__.region,
        version=__ret__.version)


@_utilities.lift_output_func(get_pg_plugins)
def get_pg_plugins_output(created: Optional[pulumi.Input[Optional[bool]]] = None,
                          database_name: Optional[pulumi.Input[str]] = None,
                          instance_id: Optional[pulumi.Input[str]] = None,
                          name: Optional[pulumi.Input[Optional[str]]] = None,
                          region: Optional[pulumi.Input[Optional[str]]] = None,
                          version: Optional[pulumi.Input[Optional[str]]] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPgPluginsResult]:
    """
    Use this data source to get the list of RDS PostgreSQL plugins.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    instance_id = config.require_object("instanceId")
    database_name = config.require_object("databaseName")
    plugins = huaweicloud.Rds.get_pg_plugins(instance_id=instance_id,
        database_name=database_name)
    ```


    :param bool created: Specifies whether the plugin has been created. Defaults to: **false**.
    :param str database_name: Specifies the database name of a PostgreSQL instance.
    :param str instance_id: Specifies the ID of a PostgreSQL instance.
    :param str name: Specifies the plugin name.
    :param str region: Specifies the region in which to query the data source.
           If omitted, the provider-level region will be used.
    :param str version: Specifies the plugin version.
    """
    ...
