# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetPgRolesResult',
    'AwaitableGetPgRolesResult',
    'get_pg_roles',
    'get_pg_roles_output',
]

@pulumi.output_type
class GetPgRolesResult:
    """
    A collection of values returned by getPgRoles.
    """
    def __init__(__self__, account=None, id=None, instance_id=None, region=None, roles=None):
        if account and not isinstance(account, str):
            raise TypeError("Expected argument 'account' to be a str")
        pulumi.set(__self__, "account", account)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if roles and not isinstance(roles, list):
            raise TypeError("Expected argument 'roles' to be a list")
        pulumi.set(__self__, "roles", roles)

    @property
    @pulumi.getter
    def account(self) -> Optional[str]:
        return pulumi.get(self, "account")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def roles(self) -> Sequence[str]:
        """
        Indicates the list of roles.
        """
        return pulumi.get(self, "roles")


class AwaitableGetPgRolesResult(GetPgRolesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPgRolesResult(
            account=self.account,
            id=self.id,
            instance_id=self.instance_id,
            region=self.region,
            roles=self.roles)


def get_pg_roles(account: Optional[str] = None,
                 instance_id: Optional[str] = None,
                 region: Optional[str] = None,
                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPgRolesResult:
    """
    Use this data source to get the list of RDS instance roles.


    :param str account: Specifies the username of the account.
           The list of authorized roles for this account when there is a value.
    :param str instance_id: Specifies the ID of Instance.
    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    """
    __args__ = dict()
    __args__['account'] = account
    __args__['instanceId'] = instance_id
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Rds/getPgRoles:getPgRoles', __args__, opts=opts, typ=GetPgRolesResult).value

    return AwaitableGetPgRolesResult(
        account=__ret__.account,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        region=__ret__.region,
        roles=__ret__.roles)


@_utilities.lift_output_func(get_pg_roles)
def get_pg_roles_output(account: Optional[pulumi.Input[Optional[str]]] = None,
                        instance_id: Optional[pulumi.Input[str]] = None,
                        region: Optional[pulumi.Input[Optional[str]]] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPgRolesResult]:
    """
    Use this data source to get the list of RDS instance roles.


    :param str account: Specifies the username of the account.
           The list of authorized roles for this account when there is a value.
    :param str instance_id: Specifies the ID of Instance.
    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    """
    ...
