# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetSqlAuditOperationsResult',
    'AwaitableGetSqlAuditOperationsResult',
    'get_sql_audit_operations',
    'get_sql_audit_operations_output',
]

@pulumi.output_type
class GetSqlAuditOperationsResult:
    """
    A collection of values returned by getSqlAuditOperations.
    """
    def __init__(__self__, id=None, instance_id=None, operation_types=None, operations=None, region=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if operation_types and not isinstance(operation_types, list):
            raise TypeError("Expected argument 'operation_types' to be a list")
        pulumi.set(__self__, "operation_types", operation_types)
        if operations and not isinstance(operations, list):
            raise TypeError("Expected argument 'operations' to be a list")
        pulumi.set(__self__, "operations", operations)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="operationTypes")
    def operation_types(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "operation_types")

    @property
    @pulumi.getter
    def operations(self) -> Sequence['outputs.GetSqlAuditOperationsOperationResult']:
        """
        Indicates the list of audit operations.
        """
        return pulumi.get(self, "operations")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")


class AwaitableGetSqlAuditOperationsResult(GetSqlAuditOperationsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSqlAuditOperationsResult(
            id=self.id,
            instance_id=self.instance_id,
            operation_types=self.operation_types,
            operations=self.operations,
            region=self.region)


def get_sql_audit_operations(instance_id: Optional[str] = None,
                             operation_types: Optional[Sequence[str]] = None,
                             region: Optional[str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSqlAuditOperationsResult:
    """
    Use this data source to get the list of RDS SQL audit operations.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    instance_id = config.require_object("instanceId")
    test = huaweicloud.Rds.get_sql_audit_operations(instance_id=instance_id)
    ```


    :param str instance_id: Specifies the ID of the RDS instance.
    :param Sequence[str] operation_types: Specifies the list of the operation type. Value options: **DDL**, **DCL**,
           **DML**, **OTHER**.
    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['operationTypes'] = operation_types
    __args__['region'] = region
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Rds/getSqlAuditOperations:getSqlAuditOperations', __args__, opts=opts, typ=GetSqlAuditOperationsResult).value

    return AwaitableGetSqlAuditOperationsResult(
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        operation_types=__ret__.operation_types,
        operations=__ret__.operations,
        region=__ret__.region)


@_utilities.lift_output_func(get_sql_audit_operations)
def get_sql_audit_operations_output(instance_id: Optional[pulumi.Input[str]] = None,
                                    operation_types: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                    region: Optional[pulumi.Input[Optional[str]]] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetSqlAuditOperationsResult]:
    """
    Use this data source to get the list of RDS SQL audit operations.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    instance_id = config.require_object("instanceId")
    test = huaweicloud.Rds.get_sql_audit_operations(instance_id=instance_id)
    ```


    :param str instance_id: Specifies the ID of the RDS instance.
    :param Sequence[str] operation_types: Specifies the list of the operation type. Value options: **DDL**, **DCL**,
           **DML**, **OTHER**.
    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    """
    ...
