# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetSqlserverDatabasesResult',
    'AwaitableGetSqlserverDatabasesResult',
    'get_sqlserver_databases',
    'get_sqlserver_databases_output',
]

@pulumi.output_type
class GetSqlserverDatabasesResult:
    """
    A collection of values returned by getSqlserverDatabases.
    """
    def __init__(__self__, character_set=None, databases=None, id=None, instance_id=None, name=None, region=None, state=None):
        if character_set and not isinstance(character_set, str):
            raise TypeError("Expected argument 'character_set' to be a str")
        pulumi.set(__self__, "character_set", character_set)
        if databases and not isinstance(databases, list):
            raise TypeError("Expected argument 'databases' to be a list")
        pulumi.set(__self__, "databases", databases)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="characterSet")
    def character_set(self) -> Optional[str]:
        """
        Indicates the character set used by the database.
        """
        return pulumi.get(self, "character_set")

    @property
    @pulumi.getter
    def databases(self) -> Sequence['outputs.GetSqlserverDatabasesDatabaseResult']:
        """
        The list of databases.
        The databases structure is documented below.
        """
        return pulumi.get(self, "databases")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Indicates the database name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def state(self) -> Optional[str]:
        """
        Indicates the database status.
        """
        return pulumi.get(self, "state")


class AwaitableGetSqlserverDatabasesResult(GetSqlserverDatabasesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSqlserverDatabasesResult(
            character_set=self.character_set,
            databases=self.databases,
            id=self.id,
            instance_id=self.instance_id,
            name=self.name,
            region=self.region,
            state=self.state)


def get_sqlserver_databases(character_set: Optional[str] = None,
                            instance_id: Optional[str] = None,
                            name: Optional[str] = None,
                            region: Optional[str] = None,
                            state: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSqlserverDatabasesResult:
    """
    Use this data source to get the list of RDS SQLServer databases.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Rds.get_sqlserver_databases(instance_id=var["instance_id"],
        name="test")
    ```


    :param str character_set: Specifies the character set used by the database.
    :param str instance_id: Specifies the ID of the RDS SQLServer instance.
    :param str name: Specifies the database name.
    :param str region: Specifies the region in which to query the data source.
           If omitted, the provider-level region will be used.
    :param str state: Specifies the database status.
    """
    __args__ = dict()
    __args__['characterSet'] = character_set
    __args__['instanceId'] = instance_id
    __args__['name'] = name
    __args__['region'] = region
    __args__['state'] = state
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Rds/getSqlserverDatabases:getSqlserverDatabases', __args__, opts=opts, typ=GetSqlserverDatabasesResult).value

    return AwaitableGetSqlserverDatabasesResult(
        character_set=__ret__.character_set,
        databases=__ret__.databases,
        id=__ret__.id,
        instance_id=__ret__.instance_id,
        name=__ret__.name,
        region=__ret__.region,
        state=__ret__.state)


@_utilities.lift_output_func(get_sqlserver_databases)
def get_sqlserver_databases_output(character_set: Optional[pulumi.Input[Optional[str]]] = None,
                                   instance_id: Optional[pulumi.Input[str]] = None,
                                   name: Optional[pulumi.Input[Optional[str]]] = None,
                                   region: Optional[pulumi.Input[Optional[str]]] = None,
                                   state: Optional[pulumi.Input[Optional[str]]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetSqlserverDatabasesResult]:
    """
    Use this data source to get the list of RDS SQLServer databases.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Rds.get_sqlserver_databases(instance_id=var["instance_id"],
        name="test")
    ```


    :param str character_set: Specifies the character set used by the database.
    :param str instance_id: Specifies the ID of the RDS SQLServer instance.
    :param str name: Specifies the database name.
    :param str region: Specifies the region in which to query the data source.
           If omitted, the provider-level region will be used.
    :param str state: Specifies the database status.
    """
    ...
