# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['PgPluginParameterArgs', 'PgPluginParameter']

@pulumi.input_type
class PgPluginParameterArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 values: pulumi.Input[Sequence[pulumi.Input[str]]],
                 name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a PgPluginParameter resource.
        :param pulumi.Input[str] instance_id: Specifies the ID of RDS instance.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] values: Specifies the list of plugin parameter values.
        :param pulumi.Input[str] name: Specifies the name of the plugin parameter.
        :param pulumi.Input[str] region: The region in which to create the rds PostgreSQL plugin parameter resource.
               If omitted, the provider-level region will be used. Changing this will creates a new resource.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "values", values)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Specifies the ID of RDS instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def values(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Specifies the list of plugin parameter values.
        """
        return pulumi.get(self, "values")

    @values.setter
    def values(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "values", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the plugin parameter.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        The region in which to create the rds PostgreSQL plugin parameter resource.
        If omitted, the provider-level region will be used. Changing this will creates a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)


@pulumi.input_type
class _PgPluginParameterState:
    def __init__(__self__, *,
                 default_values: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 restart_required: Optional[pulumi.Input[bool]] = None,
                 values: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering PgPluginParameter resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] default_values: Indicates the default values of the plugin parameter.
        :param pulumi.Input[str] instance_id: Specifies the ID of RDS instance.
        :param pulumi.Input[str] name: Specifies the name of the plugin parameter.
        :param pulumi.Input[str] region: The region in which to create the rds PostgreSQL plugin parameter resource.
               If omitted, the provider-level region will be used. Changing this will creates a new resource.
        :param pulumi.Input[bool] restart_required: Indicates whether a reboot is required.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] values: Specifies the list of plugin parameter values.
        """
        if default_values is not None:
            pulumi.set(__self__, "default_values", default_values)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if restart_required is not None:
            pulumi.set(__self__, "restart_required", restart_required)
        if values is not None:
            pulumi.set(__self__, "values", values)

    @property
    @pulumi.getter(name="defaultValues")
    def default_values(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Indicates the default values of the plugin parameter.
        """
        return pulumi.get(self, "default_values")

    @default_values.setter
    def default_values(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "default_values", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the ID of RDS instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the plugin parameter.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        The region in which to create the rds PostgreSQL plugin parameter resource.
        If omitted, the provider-level region will be used. Changing this will creates a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="restartRequired")
    def restart_required(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether a reboot is required.
        """
        return pulumi.get(self, "restart_required")

    @restart_required.setter
    def restart_required(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "restart_required", value)

    @property
    @pulumi.getter
    def values(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Specifies the list of plugin parameter values.
        """
        return pulumi.get(self, "values")

    @values.setter
    def values(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "values", value)


class PgPluginParameter(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 values: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Manage an RDS PostgreSQL plugin parameter resource within HuaweiCloud.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        instance_id = config.require_object("instanceId")
        test = huaweicloud.rds.PgPluginParameter("test",
            instance_id=instance_id,
            values=["pg_stat_kcache"])
        ```

        ## Import

        The SQL limit can be imported using the `instance_id` and `name`, separated by a slash, e.g. bash

        ```sh
         $ pulumi import huaweicloud:Rds/pgPluginParameter:PgPluginParameter test <instance_id>/<name>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Specifies the ID of RDS instance.
        :param pulumi.Input[str] name: Specifies the name of the plugin parameter.
        :param pulumi.Input[str] region: The region in which to create the rds PostgreSQL plugin parameter resource.
               If omitted, the provider-level region will be used. Changing this will creates a new resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] values: Specifies the list of plugin parameter values.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PgPluginParameterArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manage an RDS PostgreSQL plugin parameter resource within HuaweiCloud.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        instance_id = config.require_object("instanceId")
        test = huaweicloud.rds.PgPluginParameter("test",
            instance_id=instance_id,
            values=["pg_stat_kcache"])
        ```

        ## Import

        The SQL limit can be imported using the `instance_id` and `name`, separated by a slash, e.g. bash

        ```sh
         $ pulumi import huaweicloud:Rds/pgPluginParameter:PgPluginParameter test <instance_id>/<name>
        ```

        :param str resource_name: The name of the resource.
        :param PgPluginParameterArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PgPluginParameterArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 values: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PgPluginParameterArgs.__new__(PgPluginParameterArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            __props__.__dict__["name"] = name
            __props__.__dict__["region"] = region
            if values is None and not opts.urn:
                raise TypeError("Missing required property 'values'")
            __props__.__dict__["values"] = values
            __props__.__dict__["default_values"] = None
            __props__.__dict__["restart_required"] = None
        super(PgPluginParameter, __self__).__init__(
            'huaweicloud:Rds/pgPluginParameter:PgPluginParameter',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            default_values: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            region: Optional[pulumi.Input[str]] = None,
            restart_required: Optional[pulumi.Input[bool]] = None,
            values: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'PgPluginParameter':
        """
        Get an existing PgPluginParameter resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] default_values: Indicates the default values of the plugin parameter.
        :param pulumi.Input[str] instance_id: Specifies the ID of RDS instance.
        :param pulumi.Input[str] name: Specifies the name of the plugin parameter.
        :param pulumi.Input[str] region: The region in which to create the rds PostgreSQL plugin parameter resource.
               If omitted, the provider-level region will be used. Changing this will creates a new resource.
        :param pulumi.Input[bool] restart_required: Indicates whether a reboot is required.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] values: Specifies the list of plugin parameter values.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _PgPluginParameterState.__new__(_PgPluginParameterState)

        __props__.__dict__["default_values"] = default_values
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["name"] = name
        __props__.__dict__["region"] = region
        __props__.__dict__["restart_required"] = restart_required
        __props__.__dict__["values"] = values
        return PgPluginParameter(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="defaultValues")
    def default_values(self) -> pulumi.Output[Sequence[str]]:
        """
        Indicates the default values of the plugin parameter.
        """
        return pulumi.get(self, "default_values")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Specifies the ID of RDS instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Specifies the name of the plugin parameter.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        The region in which to create the rds PostgreSQL plugin parameter resource.
        If omitted, the provider-level region will be used. Changing this will creates a new resource.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="restartRequired")
    def restart_required(self) -> pulumi.Output[bool]:
        """
        Indicates whether a reboot is required.
        """
        return pulumi.get(self, "restart_required")

    @property
    @pulumi.getter
    def values(self) -> pulumi.Output[Sequence[str]]:
        """
        Specifies the list of plugin parameter values.
        """
        return pulumi.get(self, "values")

