# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['SqlserverAccountArgs', 'SqlserverAccount']

@pulumi.input_type
class SqlserverAccountArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 password: pulumi.Input[str],
                 name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a SqlserverAccount resource.
        :param pulumi.Input[str] instance_id: Specifies the ID of the RDS SQLServer instance.
        :param pulumi.Input[str] password: Specifies the password of the DB account. It consists of 8 to 128 characters and
               contains at least three types of the following characters: uppercase letters, lowercase letters, digits, and special
               characters.
        :param pulumi.Input[str] name: Specifies the username of the DB account. The username consists of 1 to 128
               characters and must be different from system usernames. System users include **rdsadmin**, **rdsuser**, **rdsbackup**,
               and **rdsmirror**.
        :param pulumi.Input[str] region: Specifies the region in which to create the resource.
               If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "password", password)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Specifies the ID of the RDS SQLServer instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def password(self) -> pulumi.Input[str]:
        """
        Specifies the password of the DB account. It consists of 8 to 128 characters and
        contains at least three types of the following characters: uppercase letters, lowercase letters, digits, and special
        characters.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: pulumi.Input[str]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the username of the DB account. The username consists of 1 to 128
        characters and must be different from system usernames. System users include **rdsadmin**, **rdsuser**, **rdsbackup**,
        and **rdsmirror**.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to create the resource.
        If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)


@pulumi.input_type
class _SqlserverAccountState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 state: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering SqlserverAccount resources.
        :param pulumi.Input[str] instance_id: Specifies the ID of the RDS SQLServer instance.
        :param pulumi.Input[str] name: Specifies the username of the DB account. The username consists of 1 to 128
               characters and must be different from system usernames. System users include **rdsadmin**, **rdsuser**, **rdsbackup**,
               and **rdsmirror**.
        :param pulumi.Input[str] password: Specifies the password of the DB account. It consists of 8 to 128 characters and
               contains at least three types of the following characters: uppercase letters, lowercase letters, digits, and special
               characters.
        :param pulumi.Input[str] region: Specifies the region in which to create the resource.
               If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        :param pulumi.Input[str] state: Indicates the DB user status. Its value can be any of the following:
               + **unavailable**: The database user is unavailable.
               + **available**: The database user is available.
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if password is not None:
            pulumi.set(__self__, "password", password)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if state is not None:
            pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the ID of the RDS SQLServer instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the username of the DB account. The username consists of 1 to 128
        characters and must be different from system usernames. System users include **rdsadmin**, **rdsuser**, **rdsbackup**,
        and **rdsmirror**.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the password of the DB account. It consists of 8 to 128 characters and
        contains at least three types of the following characters: uppercase letters, lowercase letters, digits, and special
        characters.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "password", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to create the resource.
        If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the DB user status. Its value can be any of the following:
        + **unavailable**: The database user is unavailable.
        + **available**: The database user is available.
        """
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "state", value)


class SqlserverAccount(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages RDS SQLServer account resource within HuaweiCloud.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        instance_id = config.require_object("instanceId")
        test = huaweicloud.rds.SqlserverAccount("test",
            instance_id=instance_id,
            password="Test@12345678")
        ```

        ## Import

        The RDS sqlserver account can be imported using the `instance_id` and `name` separated by a slash, e.g. bash

        ```sh
         $ pulumi import huaweicloud:Rds/sqlserverAccount:SqlserverAccount test <instance_id>/<name>
        ```

         Note that the imported state may not be identical to your resource definition, due to some attributes missing from the API response, security or some other reason. The missing attributes include`password`. It is generally recommended running `terraform plan` after importing a RDS SQLServer account. You can then decide if changes should be applied to the RDS SQLServer account, or the resource definition should be updated to align with the RDS SQLServer account. Also you can ignore changes as below. hcl resource "huaweicloud_rds_sqlserver_account" "test" {

         ...

         lifecycle {

         ignore_changes = [

         password,

         ]

         } }

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Specifies the ID of the RDS SQLServer instance.
        :param pulumi.Input[str] name: Specifies the username of the DB account. The username consists of 1 to 128
               characters and must be different from system usernames. System users include **rdsadmin**, **rdsuser**, **rdsbackup**,
               and **rdsmirror**.
        :param pulumi.Input[str] password: Specifies the password of the DB account. It consists of 8 to 128 characters and
               contains at least three types of the following characters: uppercase letters, lowercase letters, digits, and special
               characters.
        :param pulumi.Input[str] region: Specifies the region in which to create the resource.
               If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SqlserverAccountArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages RDS SQLServer account resource within HuaweiCloud.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        instance_id = config.require_object("instanceId")
        test = huaweicloud.rds.SqlserverAccount("test",
            instance_id=instance_id,
            password="Test@12345678")
        ```

        ## Import

        The RDS sqlserver account can be imported using the `instance_id` and `name` separated by a slash, e.g. bash

        ```sh
         $ pulumi import huaweicloud:Rds/sqlserverAccount:SqlserverAccount test <instance_id>/<name>
        ```

         Note that the imported state may not be identical to your resource definition, due to some attributes missing from the API response, security or some other reason. The missing attributes include`password`. It is generally recommended running `terraform plan` after importing a RDS SQLServer account. You can then decide if changes should be applied to the RDS SQLServer account, or the resource definition should be updated to align with the RDS SQLServer account. Also you can ignore changes as below. hcl resource "huaweicloud_rds_sqlserver_account" "test" {

         ...

         lifecycle {

         ignore_changes = [

         password,

         ]

         } }

        :param str resource_name: The name of the resource.
        :param SqlserverAccountArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SqlserverAccountArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SqlserverAccountArgs.__new__(SqlserverAccountArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            __props__.__dict__["name"] = name
            if password is None and not opts.urn:
                raise TypeError("Missing required property 'password'")
            __props__.__dict__["password"] = password
            __props__.__dict__["region"] = region
            __props__.__dict__["state"] = None
        super(SqlserverAccount, __self__).__init__(
            'huaweicloud:Rds/sqlserverAccount:SqlserverAccount',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            password: Optional[pulumi.Input[str]] = None,
            region: Optional[pulumi.Input[str]] = None,
            state: Optional[pulumi.Input[str]] = None) -> 'SqlserverAccount':
        """
        Get an existing SqlserverAccount resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Specifies the ID of the RDS SQLServer instance.
        :param pulumi.Input[str] name: Specifies the username of the DB account. The username consists of 1 to 128
               characters and must be different from system usernames. System users include **rdsadmin**, **rdsuser**, **rdsbackup**,
               and **rdsmirror**.
        :param pulumi.Input[str] password: Specifies the password of the DB account. It consists of 8 to 128 characters and
               contains at least three types of the following characters: uppercase letters, lowercase letters, digits, and special
               characters.
        :param pulumi.Input[str] region: Specifies the region in which to create the resource.
               If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        :param pulumi.Input[str] state: Indicates the DB user status. Its value can be any of the following:
               + **unavailable**: The database user is unavailable.
               + **available**: The database user is available.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SqlserverAccountState.__new__(_SqlserverAccountState)

        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["name"] = name
        __props__.__dict__["password"] = password
        __props__.__dict__["region"] = region
        __props__.__dict__["state"] = state
        return SqlserverAccount(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Specifies the ID of the RDS SQLServer instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Specifies the username of the DB account. The username consists of 1 to 128
        characters and must be different from system usernames. System users include **rdsadmin**, **rdsuser**, **rdsbackup**,
        and **rdsmirror**.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def password(self) -> pulumi.Output[str]:
        """
        Specifies the password of the DB account. It consists of 8 to 128 characters and
        contains at least three types of the following characters: uppercase letters, lowercase letters, digits, and special
        characters.
        """
        return pulumi.get(self, "password")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        Specifies the region in which to create the resource.
        If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def state(self) -> pulumi.Output[str]:
        """
        Indicates the DB user status. Its value can be any of the following:
        + **unavailable**: The database user is unavailable.
        + **available**: The database user is available.
        """
        return pulumi.get(self, "state")

