# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['SqlserverDatabaseCopyArgs', 'SqlserverDatabaseCopy']

@pulumi.input_type
class SqlserverDatabaseCopyArgs:
    def __init__(__self__, *,
                 db_name_source: pulumi.Input[str],
                 db_name_target: pulumi.Input[str],
                 instance_id: pulumi.Input[str],
                 procedure_name: pulumi.Input[str],
                 enable_force_new: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a SqlserverDatabaseCopy resource.
        :param pulumi.Input[str] db_name_source: Specifies the name of the source database.
        :param pulumi.Input[str] db_name_target: Specifies the name of the target database.
        :param pulumi.Input[str] instance_id: Specifies the ID of the RDS instance.
        :param pulumi.Input[str] procedure_name: Specifies the operation name. Value options: **copy_database**.
        :param pulumi.Input[str] region: Specifies the region in which to create the resource.
               If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        """
        pulumi.set(__self__, "db_name_source", db_name_source)
        pulumi.set(__self__, "db_name_target", db_name_target)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "procedure_name", procedure_name)
        if enable_force_new is not None:
            pulumi.set(__self__, "enable_force_new", enable_force_new)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="dbNameSource")
    def db_name_source(self) -> pulumi.Input[str]:
        """
        Specifies the name of the source database.
        """
        return pulumi.get(self, "db_name_source")

    @db_name_source.setter
    def db_name_source(self, value: pulumi.Input[str]):
        pulumi.set(self, "db_name_source", value)

    @property
    @pulumi.getter(name="dbNameTarget")
    def db_name_target(self) -> pulumi.Input[str]:
        """
        Specifies the name of the target database.
        """
        return pulumi.get(self, "db_name_target")

    @db_name_target.setter
    def db_name_target(self, value: pulumi.Input[str]):
        pulumi.set(self, "db_name_target", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Specifies the ID of the RDS instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="procedureName")
    def procedure_name(self) -> pulumi.Input[str]:
        """
        Specifies the operation name. Value options: **copy_database**.
        """
        return pulumi.get(self, "procedure_name")

    @procedure_name.setter
    def procedure_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "procedure_name", value)

    @property
    @pulumi.getter(name="enableForceNew")
    def enable_force_new(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "enable_force_new")

    @enable_force_new.setter
    def enable_force_new(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enable_force_new", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to create the resource.
        If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)


@pulumi.input_type
class _SqlserverDatabaseCopyState:
    def __init__(__self__, *,
                 db_name_source: Optional[pulumi.Input[str]] = None,
                 db_name_target: Optional[pulumi.Input[str]] = None,
                 enable_force_new: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 procedure_name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering SqlserverDatabaseCopy resources.
        :param pulumi.Input[str] db_name_source: Specifies the name of the source database.
        :param pulumi.Input[str] db_name_target: Specifies the name of the target database.
        :param pulumi.Input[str] instance_id: Specifies the ID of the RDS instance.
        :param pulumi.Input[str] procedure_name: Specifies the operation name. Value options: **copy_database**.
        :param pulumi.Input[str] region: Specifies the region in which to create the resource.
               If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        """
        if db_name_source is not None:
            pulumi.set(__self__, "db_name_source", db_name_source)
        if db_name_target is not None:
            pulumi.set(__self__, "db_name_target", db_name_target)
        if enable_force_new is not None:
            pulumi.set(__self__, "enable_force_new", enable_force_new)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if procedure_name is not None:
            pulumi.set(__self__, "procedure_name", procedure_name)
        if region is not None:
            pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="dbNameSource")
    def db_name_source(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the source database.
        """
        return pulumi.get(self, "db_name_source")

    @db_name_source.setter
    def db_name_source(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "db_name_source", value)

    @property
    @pulumi.getter(name="dbNameTarget")
    def db_name_target(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the name of the target database.
        """
        return pulumi.get(self, "db_name_target")

    @db_name_target.setter
    def db_name_target(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "db_name_target", value)

    @property
    @pulumi.getter(name="enableForceNew")
    def enable_force_new(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "enable_force_new")

    @enable_force_new.setter
    def enable_force_new(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "enable_force_new", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the ID of the RDS instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="procedureName")
    def procedure_name(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the operation name. Value options: **copy_database**.
        """
        return pulumi.get(self, "procedure_name")

    @procedure_name.setter
    def procedure_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "procedure_name", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to create the resource.
        If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)


class SqlserverDatabaseCopy(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_name_source: Optional[pulumi.Input[str]] = None,
                 db_name_target: Optional[pulumi.Input[str]] = None,
                 enable_force_new: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 procedure_name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages an RDS database copy resource within HuaweiCloud.

        > **NOTE:** Deleting RDS SQLServer database copy is not supported. If you destroy a resource of RDS SQLServer database
          copy, it is only removed from the state, but still remains in the cloud. And the instance doesn't return to the state
          before modifying.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        instance_id = config.require_object("instanceId")
        test = huaweicloud.rds.SqlserverDatabaseCopy("test",
            instance_id=instance_id,
            procedure_name="copy_database",
            db_name_source="test_db_source",
            db_name_target="test_db_target")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] db_name_source: Specifies the name of the source database.
        :param pulumi.Input[str] db_name_target: Specifies the name of the target database.
        :param pulumi.Input[str] instance_id: Specifies the ID of the RDS instance.
        :param pulumi.Input[str] procedure_name: Specifies the operation name. Value options: **copy_database**.
        :param pulumi.Input[str] region: Specifies the region in which to create the resource.
               If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SqlserverDatabaseCopyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages an RDS database copy resource within HuaweiCloud.

        > **NOTE:** Deleting RDS SQLServer database copy is not supported. If you destroy a resource of RDS SQLServer database
          copy, it is only removed from the state, but still remains in the cloud. And the instance doesn't return to the state
          before modifying.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        instance_id = config.require_object("instanceId")
        test = huaweicloud.rds.SqlserverDatabaseCopy("test",
            instance_id=instance_id,
            procedure_name="copy_database",
            db_name_source="test_db_source",
            db_name_target="test_db_target")
        ```

        :param str resource_name: The name of the resource.
        :param SqlserverDatabaseCopyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SqlserverDatabaseCopyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_name_source: Optional[pulumi.Input[str]] = None,
                 db_name_target: Optional[pulumi.Input[str]] = None,
                 enable_force_new: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 procedure_name: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SqlserverDatabaseCopyArgs.__new__(SqlserverDatabaseCopyArgs)

            if db_name_source is None and not opts.urn:
                raise TypeError("Missing required property 'db_name_source'")
            __props__.__dict__["db_name_source"] = db_name_source
            if db_name_target is None and not opts.urn:
                raise TypeError("Missing required property 'db_name_target'")
            __props__.__dict__["db_name_target"] = db_name_target
            __props__.__dict__["enable_force_new"] = enable_force_new
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if procedure_name is None and not opts.urn:
                raise TypeError("Missing required property 'procedure_name'")
            __props__.__dict__["procedure_name"] = procedure_name
            __props__.__dict__["region"] = region
        super(SqlserverDatabaseCopy, __self__).__init__(
            'huaweicloud:Rds/sqlserverDatabaseCopy:SqlserverDatabaseCopy',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            db_name_source: Optional[pulumi.Input[str]] = None,
            db_name_target: Optional[pulumi.Input[str]] = None,
            enable_force_new: Optional[pulumi.Input[str]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            procedure_name: Optional[pulumi.Input[str]] = None,
            region: Optional[pulumi.Input[str]] = None) -> 'SqlserverDatabaseCopy':
        """
        Get an existing SqlserverDatabaseCopy resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] db_name_source: Specifies the name of the source database.
        :param pulumi.Input[str] db_name_target: Specifies the name of the target database.
        :param pulumi.Input[str] instance_id: Specifies the ID of the RDS instance.
        :param pulumi.Input[str] procedure_name: Specifies the operation name. Value options: **copy_database**.
        :param pulumi.Input[str] region: Specifies the region in which to create the resource.
               If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SqlserverDatabaseCopyState.__new__(_SqlserverDatabaseCopyState)

        __props__.__dict__["db_name_source"] = db_name_source
        __props__.__dict__["db_name_target"] = db_name_target
        __props__.__dict__["enable_force_new"] = enable_force_new
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["procedure_name"] = procedure_name
        __props__.__dict__["region"] = region
        return SqlserverDatabaseCopy(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="dbNameSource")
    def db_name_source(self) -> pulumi.Output[str]:
        """
        Specifies the name of the source database.
        """
        return pulumi.get(self, "db_name_source")

    @property
    @pulumi.getter(name="dbNameTarget")
    def db_name_target(self) -> pulumi.Output[str]:
        """
        Specifies the name of the target database.
        """
        return pulumi.get(self, "db_name_target")

    @property
    @pulumi.getter(name="enableForceNew")
    def enable_force_new(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "enable_force_new")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Specifies the ID of the RDS instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="procedureName")
    def procedure_name(self) -> pulumi.Output[str]:
        """
        Specifies the operation name. Value options: **copy_database**.
        """
        return pulumi.get(self, "procedure_name")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        Specifies the region in which to create the resource.
        If omitted, the provider-level region will be used. Changing this parameter will create a new resource.
        """
        return pulumi.get(self, "region")

