# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['TagsArgs', 'Tags']

@pulumi.input_type
class TagsArgs:
    def __init__(__self__, *,
                 tags: pulumi.Input[Sequence[pulumi.Input['TagsTagArgs']]]):
        """
        The set of arguments for constructing a Tags resource.
        :param pulumi.Input[Sequence[pulumi.Input['TagsTagArgs']]] tags: Specifies an array of one or more predefined tags.
               The tags structure is documented below.
        """
        pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Input[Sequence[pulumi.Input['TagsTagArgs']]]:
        """
        Specifies an array of one or more predefined tags.
        The tags structure is documented below.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: pulumi.Input[Sequence[pulumi.Input['TagsTagArgs']]]):
        pulumi.set(self, "tags", value)


@pulumi.input_type
class _TagsState:
    def __init__(__self__, *,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input['TagsTagArgs']]]] = None):
        """
        Input properties used for looking up and filtering Tags resources.
        :param pulumi.Input[Sequence[pulumi.Input['TagsTagArgs']]] tags: Specifies an array of one or more predefined tags.
               The tags structure is documented below.
        """
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TagsTagArgs']]]]:
        """
        Specifies an array of one or more predefined tags.
        The tags structure is documented below.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TagsTagArgs']]]]):
        pulumi.set(self, "tags", value)


class Tags(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TagsTagArgs']]]]] = None,
                 __props__=None):
        """
        Manages TMS tags resource within HuaweiCloud.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        test = huaweicloud.tms.Tags("test", tags=[huaweicloud.tms.TagsTagArgs(
            key="foo",
            value="bar",
        )])
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TagsTagArgs']]]] tags: Specifies an array of one or more predefined tags.
               The tags structure is documented below.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TagsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages TMS tags resource within HuaweiCloud.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        test = huaweicloud.tms.Tags("test", tags=[huaweicloud.tms.TagsTagArgs(
            key="foo",
            value="bar",
        )])
        ```

        :param str resource_name: The name of the resource.
        :param TagsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TagsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TagsTagArgs']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TagsArgs.__new__(TagsArgs)

            if tags is None and not opts.urn:
                raise TypeError("Missing required property 'tags'")
            __props__.__dict__["tags"] = tags
        super(Tags, __self__).__init__(
            'huaweicloud:Tms/tags:Tags',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TagsTagArgs']]]]] = None) -> 'Tags':
        """
        Get an existing Tags resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['TagsTagArgs']]]] tags: Specifies an array of one or more predefined tags.
               The tags structure is documented below.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _TagsState.__new__(_TagsState)

        __props__.__dict__["tags"] = tags
        return Tags(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Sequence['outputs.TagsTag']]:
        """
        Specifies an array of one or more predefined tags.
        The tags structure is documented below.
        """
        return pulumi.get(self, "tags")

