# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetNetworkAclsResult',
    'AwaitableGetNetworkAclsResult',
    'get_network_acls',
    'get_network_acls_output',
]

@pulumi.output_type
class GetNetworkAclsResult:
    """
    A collection of values returned by getNetworkAcls.
    """
    def __init__(__self__, enabled=None, enterprise_project_id=None, id=None, name=None, network_acl_id=None, network_acls=None, region=None, status=None):
        if enabled and not isinstance(enabled, str):
            raise TypeError("Expected argument 'enabled' to be a str")
        pulumi.set(__self__, "enabled", enabled)
        if enterprise_project_id and not isinstance(enterprise_project_id, str):
            raise TypeError("Expected argument 'enterprise_project_id' to be a str")
        pulumi.set(__self__, "enterprise_project_id", enterprise_project_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if network_acl_id and not isinstance(network_acl_id, str):
            raise TypeError("Expected argument 'network_acl_id' to be a str")
        pulumi.set(__self__, "network_acl_id", network_acl_id)
        if network_acls and not isinstance(network_acls, list):
            raise TypeError("Expected argument 'network_acls' to be a list")
        pulumi.set(__self__, "network_acls", network_acls)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if status and not isinstance(status, str):
            raise TypeError("Expected argument 'status' to be a str")
        pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[str]:
        """
        Whether the network ACL is enabled.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="enterpriseProjectId")
    def enterprise_project_id(self) -> Optional[str]:
        """
        The enterprise project ID of the network ACL.
        """
        return pulumi.get(self, "enterprise_project_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The network ACL rule name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkAclId")
    def network_acl_id(self) -> Optional[str]:
        return pulumi.get(self, "network_acl_id")

    @property
    @pulumi.getter(name="networkAcls")
    def network_acls(self) -> Sequence['outputs.GetNetworkAclsNetworkAclResult']:
        """
        The list of VPC network ACLs.
        The network_acls structure is documented below.
        """
        return pulumi.get(self, "network_acls")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        The status of the ACL.
        """
        return pulumi.get(self, "status")


class AwaitableGetNetworkAclsResult(GetNetworkAclsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNetworkAclsResult(
            enabled=self.enabled,
            enterprise_project_id=self.enterprise_project_id,
            id=self.id,
            name=self.name,
            network_acl_id=self.network_acl_id,
            network_acls=self.network_acls,
            region=self.region,
            status=self.status)


def get_network_acls(enabled: Optional[str] = None,
                     enterprise_project_id: Optional[str] = None,
                     name: Optional[str] = None,
                     network_acl_id: Optional[str] = None,
                     region: Optional[str] = None,
                     status: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNetworkAclsResult:
    """
    Use this data source to get the list of VPC network ACLs.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    network_acl_name = config.require_object("networkAclName")
    enterprise_project_id = config.require_object("enterpriseProjectId")
    basic = huaweicloud.Vpc.get_network_acls(name=network_acl_name,
        enterprise_project_id=enterprise_project_id)
    ```


    :param str enabled: Specifies whether the network ACL is enabled. The value can be **true** or **false**.
    :param str enterprise_project_id: Specifies the enterprise project ID of the network ACL.
    :param str name: Specifies the network ACL name. The value can contain no more than 64 characters,
           including letters, digits, underscores (_), hyphens (-), and periods (.).
    :param str network_acl_id: Specifies the network ACL ID.
    :param str region: Specifies the region in which to obtain the network ACLs.
           If omitted, the provider-level region will be used.
    :param str status: Specifies the status of the network ACL.
    """
    __args__ = dict()
    __args__['enabled'] = enabled
    __args__['enterpriseProjectId'] = enterprise_project_id
    __args__['name'] = name
    __args__['networkAclId'] = network_acl_id
    __args__['region'] = region
    __args__['status'] = status
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Vpc/getNetworkAcls:getNetworkAcls', __args__, opts=opts, typ=GetNetworkAclsResult).value

    return AwaitableGetNetworkAclsResult(
        enabled=__ret__.enabled,
        enterprise_project_id=__ret__.enterprise_project_id,
        id=__ret__.id,
        name=__ret__.name,
        network_acl_id=__ret__.network_acl_id,
        network_acls=__ret__.network_acls,
        region=__ret__.region,
        status=__ret__.status)


@_utilities.lift_output_func(get_network_acls)
def get_network_acls_output(enabled: Optional[pulumi.Input[Optional[str]]] = None,
                            enterprise_project_id: Optional[pulumi.Input[Optional[str]]] = None,
                            name: Optional[pulumi.Input[Optional[str]]] = None,
                            network_acl_id: Optional[pulumi.Input[Optional[str]]] = None,
                            region: Optional[pulumi.Input[Optional[str]]] = None,
                            status: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetNetworkAclsResult]:
    """
    Use this data source to get the list of VPC network ACLs.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    network_acl_name = config.require_object("networkAclName")
    enterprise_project_id = config.require_object("enterpriseProjectId")
    basic = huaweicloud.Vpc.get_network_acls(name=network_acl_name,
        enterprise_project_id=enterprise_project_id)
    ```


    :param str enabled: Specifies whether the network ACL is enabled. The value can be **true** or **false**.
    :param str enterprise_project_id: Specifies the enterprise project ID of the network ACL.
    :param str name: Specifies the network ACL name. The value can contain no more than 64 characters,
           including letters, digits, underscores (_), hyphens (-), and periods (.).
    :param str network_acl_id: Specifies the network ACL ID.
    :param str region: Specifies the region in which to obtain the network ACLs.
           If omitted, the provider-level region will be used.
    :param str status: Specifies the status of the network ACL.
    """
    ...
