# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetRoutesResult',
    'AwaitableGetRoutesResult',
    'get_routes',
    'get_routes_output',
]

@pulumi.output_type
class GetRoutesResult:
    """
    A collection of values returned by getRoutes.
    """
    def __init__(__self__, destination=None, id=None, region=None, routes=None, type=None, vpc_id=None):
        if destination and not isinstance(destination, str):
            raise TypeError("Expected argument 'destination' to be a str")
        pulumi.set(__self__, "destination", destination)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if routes and not isinstance(routes, list):
            raise TypeError("Expected argument 'routes' to be a list")
        pulumi.set(__self__, "routes", routes)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)
        if vpc_id and not isinstance(vpc_id, str):
            raise TypeError("Expected argument 'vpc_id' to be a str")
        pulumi.set(__self__, "vpc_id", vpc_id)

    @property
    @pulumi.getter
    def destination(self) -> Optional[str]:
        """
        The route destination.
        """
        return pulumi.get(self, "destination")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter
    def routes(self) -> Sequence['outputs.GetRoutesRouteResult']:
        """
        The list of routes.
        """
        return pulumi.get(self, "routes")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        The route type.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[str]:
        """
        The ID of the VPC to which the route belongs.
        """
        return pulumi.get(self, "vpc_id")


class AwaitableGetRoutesResult(GetRoutesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRoutesResult(
            destination=self.destination,
            id=self.id,
            region=self.region,
            routes=self.routes,
            type=self.type,
            vpc_id=self.vpc_id)


def get_routes(destination: Optional[str] = None,
               region: Optional[str] = None,
               type: Optional[str] = None,
               vpc_id: Optional[str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRoutesResult:
    """
    Use this data source to get the list of VPC routes.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Vpc.get_routes(type="peering")
    ```


    :param str destination: Specifies the route destination.
    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    :param str type: Specifies the route type.
    :param str vpc_id: Specifies the ID of the VPC to which the route belongs.
    """
    __args__ = dict()
    __args__['destination'] = destination
    __args__['region'] = region
    __args__['type'] = type
    __args__['vpcId'] = vpc_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Vpc/getRoutes:getRoutes', __args__, opts=opts, typ=GetRoutesResult).value

    return AwaitableGetRoutesResult(
        destination=__ret__.destination,
        id=__ret__.id,
        region=__ret__.region,
        routes=__ret__.routes,
        type=__ret__.type,
        vpc_id=__ret__.vpc_id)


@_utilities.lift_output_func(get_routes)
def get_routes_output(destination: Optional[pulumi.Input[Optional[str]]] = None,
                      region: Optional[pulumi.Input[Optional[str]]] = None,
                      type: Optional[pulumi.Input[Optional[str]]] = None,
                      vpc_id: Optional[pulumi.Input[Optional[str]]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRoutesResult]:
    """
    Use this data source to get the list of VPC routes.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    test = huaweicloud.Vpc.get_routes(type="peering")
    ```


    :param str destination: Specifies the route destination.
    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    :param str type: Specifies the route type.
    :param str vpc_id: Specifies the ID of the VPC to which the route belongs.
    """
    ...
