# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetSubnetPrivateIpsResult',
    'AwaitableGetSubnetPrivateIpsResult',
    'get_subnet_private_ips',
    'get_subnet_private_ips_output',
]

@pulumi.output_type
class GetSubnetPrivateIpsResult:
    """
    A collection of values returned by getSubnetPrivateIps.
    """
    def __init__(__self__, id=None, private_ips=None, region=None, subnet_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if private_ips and not isinstance(private_ips, list):
            raise TypeError("Expected argument 'private_ips' to be a list")
        pulumi.set(__self__, "private_ips", private_ips)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if subnet_id and not isinstance(subnet_id, str):
            raise TypeError("Expected argument 'subnet_id' to be a str")
        pulumi.set(__self__, "subnet_id", subnet_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="privateIps")
    def private_ips(self) -> Sequence['outputs.GetSubnetPrivateIpsPrivateIpResult']:
        """
        The list of private IP addresses.
        """
        return pulumi.get(self, "private_ips")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> str:
        """
        The ID of the subnet from which IP addresses are assigned.
        """
        return pulumi.get(self, "subnet_id")


class AwaitableGetSubnetPrivateIpsResult(GetSubnetPrivateIpsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSubnetPrivateIpsResult(
            id=self.id,
            private_ips=self.private_ips,
            region=self.region,
            subnet_id=self.subnet_id)


def get_subnet_private_ips(region: Optional[str] = None,
                           subnet_id: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSubnetPrivateIpsResult:
    """
    Use this data source to get a list of private IPs within HuaweiCloud.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    subnet_id = config.require_object("subnetId")
    test = huaweicloud.Vpc.get_subnet_private_ips(subnet_id=subnet_id)
    ```


    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    :param str subnet_id: Specifies the ID of the subnet that the private IP address belongs to.
    """
    __args__ = dict()
    __args__['region'] = region
    __args__['subnetId'] = subnet_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('huaweicloud:Vpc/getSubnetPrivateIps:getSubnetPrivateIps', __args__, opts=opts, typ=GetSubnetPrivateIpsResult).value

    return AwaitableGetSubnetPrivateIpsResult(
        id=__ret__.id,
        private_ips=__ret__.private_ips,
        region=__ret__.region,
        subnet_id=__ret__.subnet_id)


@_utilities.lift_output_func(get_subnet_private_ips)
def get_subnet_private_ips_output(region: Optional[pulumi.Input[Optional[str]]] = None,
                                  subnet_id: Optional[pulumi.Input[str]] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetSubnetPrivateIpsResult]:
    """
    Use this data source to get a list of private IPs within HuaweiCloud.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_huaweicloud as huaweicloud

    config = pulumi.Config()
    subnet_id = config.require_object("subnetId")
    test = huaweicloud.Vpc.get_subnet_private_ips(subnet_id=subnet_id)
    ```


    :param str region: Specifies the region in which to query the resource.
           If omitted, the provider-level region will be used.
    :param str subnet_id: Specifies the ID of the subnet that the private IP address belongs to.
    """
    ...
