# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['TrafficMirrorFilterRuleArgs', 'TrafficMirrorFilterRule']

@pulumi.input_type
class TrafficMirrorFilterRuleArgs:
    def __init__(__self__, *,
                 action: pulumi.Input[str],
                 direction: pulumi.Input[str],
                 ethertype: pulumi.Input[str],
                 priority: pulumi.Input[int],
                 protocol: pulumi.Input[str],
                 traffic_mirror_filter_id: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 destination_cidr_block: Optional[pulumi.Input[str]] = None,
                 destination_port_range: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 source_cidr_block: Optional[pulumi.Input[str]] = None,
                 source_port_range: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a TrafficMirrorFilterRule resource.
        :param pulumi.Input[str] action: Specifies the policy of in the traffic mirror filter rule.
               Valid values are **accept** or **reject**.
        :param pulumi.Input[str] direction: Specifies the direction of the traffic mirror filter rule.
               Valid values are **ingress** or **egress**. Changing this creates a new resource.
        :param pulumi.Input[str] ethertype: Specifies the IP address protocol type of the traffic mirror filter rule.
               Valid values are **IPv4** or **IPv6**.
        :param pulumi.Input[int] priority: Specifies the priority number of the traffic mirror filter rule.
               Valid value ranges from `1` to `65,535`.
               The smaller the priority number, the higher the priority.
        :param pulumi.Input[str] protocol: Specifies the protocol of the traffic mirror filter rule.
               Valid value are **tcp**, **udp**, **icmp**, **icmpv6**, **all**.
        :param pulumi.Input[str] traffic_mirror_filter_id: Specifies an ID of the traffic mirror filter to which
               the rule belongs. Changing this creates a new resource.
        :param pulumi.Input[str] description: Specifies the description of the traffic mirror filter rule.
        :param pulumi.Input[str] destination_cidr_block: Specifies the destination IP address of the traffic traffic mirror filter
               rule.
        :param pulumi.Input[str] destination_port_range: Specifies the destination port number range of the traffic mirror filter
               rule. The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        :param pulumi.Input[str] region: Specifies the region in which to create the resource.
               If omitted, the provider-level region will be used.
               Changing this creates a new resource.
        :param pulumi.Input[str] source_cidr_block: Specifies the source IP address of the traffic traffic mirror filter rule.
        :param pulumi.Input[str] source_port_range: Specifies the source port number range of the traffic mirror filter rule.
               The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        """
        pulumi.set(__self__, "action", action)
        pulumi.set(__self__, "direction", direction)
        pulumi.set(__self__, "ethertype", ethertype)
        pulumi.set(__self__, "priority", priority)
        pulumi.set(__self__, "protocol", protocol)
        pulumi.set(__self__, "traffic_mirror_filter_id", traffic_mirror_filter_id)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if destination_cidr_block is not None:
            pulumi.set(__self__, "destination_cidr_block", destination_cidr_block)
        if destination_port_range is not None:
            pulumi.set(__self__, "destination_port_range", destination_port_range)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if source_cidr_block is not None:
            pulumi.set(__self__, "source_cidr_block", source_cidr_block)
        if source_port_range is not None:
            pulumi.set(__self__, "source_port_range", source_port_range)

    @property
    @pulumi.getter
    def action(self) -> pulumi.Input[str]:
        """
        Specifies the policy of in the traffic mirror filter rule.
        Valid values are **accept** or **reject**.
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: pulumi.Input[str]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter
    def direction(self) -> pulumi.Input[str]:
        """
        Specifies the direction of the traffic mirror filter rule.
        Valid values are **ingress** or **egress**. Changing this creates a new resource.
        """
        return pulumi.get(self, "direction")

    @direction.setter
    def direction(self, value: pulumi.Input[str]):
        pulumi.set(self, "direction", value)

    @property
    @pulumi.getter
    def ethertype(self) -> pulumi.Input[str]:
        """
        Specifies the IP address protocol type of the traffic mirror filter rule.
        Valid values are **IPv4** or **IPv6**.
        """
        return pulumi.get(self, "ethertype")

    @ethertype.setter
    def ethertype(self, value: pulumi.Input[str]):
        pulumi.set(self, "ethertype", value)

    @property
    @pulumi.getter
    def priority(self) -> pulumi.Input[int]:
        """
        Specifies the priority number of the traffic mirror filter rule.
        Valid value ranges from `1` to `65,535`.
        The smaller the priority number, the higher the priority.
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: pulumi.Input[int]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter
    def protocol(self) -> pulumi.Input[str]:
        """
        Specifies the protocol of the traffic mirror filter rule.
        Valid value are **tcp**, **udp**, **icmp**, **icmpv6**, **all**.
        """
        return pulumi.get(self, "protocol")

    @protocol.setter
    def protocol(self, value: pulumi.Input[str]):
        pulumi.set(self, "protocol", value)

    @property
    @pulumi.getter(name="trafficMirrorFilterId")
    def traffic_mirror_filter_id(self) -> pulumi.Input[str]:
        """
        Specifies an ID of the traffic mirror filter to which
        the rule belongs. Changing this creates a new resource.
        """
        return pulumi.get(self, "traffic_mirror_filter_id")

    @traffic_mirror_filter_id.setter
    def traffic_mirror_filter_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "traffic_mirror_filter_id", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the description of the traffic mirror filter rule.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="destinationCidrBlock")
    def destination_cidr_block(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the destination IP address of the traffic traffic mirror filter
        rule.
        """
        return pulumi.get(self, "destination_cidr_block")

    @destination_cidr_block.setter
    def destination_cidr_block(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "destination_cidr_block", value)

    @property
    @pulumi.getter(name="destinationPortRange")
    def destination_port_range(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the destination port number range of the traffic mirror filter
        rule. The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        """
        return pulumi.get(self, "destination_port_range")

    @destination_port_range.setter
    def destination_port_range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "destination_port_range", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to create the resource.
        If omitted, the provider-level region will be used.
        Changing this creates a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="sourceCidrBlock")
    def source_cidr_block(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the source IP address of the traffic traffic mirror filter rule.
        """
        return pulumi.get(self, "source_cidr_block")

    @source_cidr_block.setter
    def source_cidr_block(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source_cidr_block", value)

    @property
    @pulumi.getter(name="sourcePortRange")
    def source_port_range(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the source port number range of the traffic mirror filter rule.
        The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        """
        return pulumi.get(self, "source_port_range")

    @source_port_range.setter
    def source_port_range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source_port_range", value)


@pulumi.input_type
class _TrafficMirrorFilterRuleState:
    def __init__(__self__, *,
                 action: Optional[pulumi.Input[str]] = None,
                 created_at: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 destination_cidr_block: Optional[pulumi.Input[str]] = None,
                 destination_port_range: Optional[pulumi.Input[str]] = None,
                 direction: Optional[pulumi.Input[str]] = None,
                 ethertype: Optional[pulumi.Input[str]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 protocol: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 source_cidr_block: Optional[pulumi.Input[str]] = None,
                 source_port_range: Optional[pulumi.Input[str]] = None,
                 traffic_mirror_filter_id: Optional[pulumi.Input[str]] = None,
                 updated_at: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering TrafficMirrorFilterRule resources.
        :param pulumi.Input[str] action: Specifies the policy of in the traffic mirror filter rule.
               Valid values are **accept** or **reject**.
        :param pulumi.Input[str] created_at: The creation time of the traffic mirror filter rule.
        :param pulumi.Input[str] description: Specifies the description of the traffic mirror filter rule.
        :param pulumi.Input[str] destination_cidr_block: Specifies the destination IP address of the traffic traffic mirror filter
               rule.
        :param pulumi.Input[str] destination_port_range: Specifies the destination port number range of the traffic mirror filter
               rule. The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        :param pulumi.Input[str] direction: Specifies the direction of the traffic mirror filter rule.
               Valid values are **ingress** or **egress**. Changing this creates a new resource.
        :param pulumi.Input[str] ethertype: Specifies the IP address protocol type of the traffic mirror filter rule.
               Valid values are **IPv4** or **IPv6**.
        :param pulumi.Input[int] priority: Specifies the priority number of the traffic mirror filter rule.
               Valid value ranges from `1` to `65,535`.
               The smaller the priority number, the higher the priority.
        :param pulumi.Input[str] protocol: Specifies the protocol of the traffic mirror filter rule.
               Valid value are **tcp**, **udp**, **icmp**, **icmpv6**, **all**.
        :param pulumi.Input[str] region: Specifies the region in which to create the resource.
               If omitted, the provider-level region will be used.
               Changing this creates a new resource.
        :param pulumi.Input[str] source_cidr_block: Specifies the source IP address of the traffic traffic mirror filter rule.
        :param pulumi.Input[str] source_port_range: Specifies the source port number range of the traffic mirror filter rule.
               The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        :param pulumi.Input[str] traffic_mirror_filter_id: Specifies an ID of the traffic mirror filter to which
               the rule belongs. Changing this creates a new resource.
        :param pulumi.Input[str] updated_at: The latest update time of the traffic mirror filter rule.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if created_at is not None:
            pulumi.set(__self__, "created_at", created_at)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if destination_cidr_block is not None:
            pulumi.set(__self__, "destination_cidr_block", destination_cidr_block)
        if destination_port_range is not None:
            pulumi.set(__self__, "destination_port_range", destination_port_range)
        if direction is not None:
            pulumi.set(__self__, "direction", direction)
        if ethertype is not None:
            pulumi.set(__self__, "ethertype", ethertype)
        if priority is not None:
            pulumi.set(__self__, "priority", priority)
        if protocol is not None:
            pulumi.set(__self__, "protocol", protocol)
        if region is not None:
            pulumi.set(__self__, "region", region)
        if source_cidr_block is not None:
            pulumi.set(__self__, "source_cidr_block", source_cidr_block)
        if source_port_range is not None:
            pulumi.set(__self__, "source_port_range", source_port_range)
        if traffic_mirror_filter_id is not None:
            pulumi.set(__self__, "traffic_mirror_filter_id", traffic_mirror_filter_id)
        if updated_at is not None:
            pulumi.set(__self__, "updated_at", updated_at)

    @property
    @pulumi.getter
    def action(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the policy of in the traffic mirror filter rule.
        Valid values are **accept** or **reject**.
        """
        return pulumi.get(self, "action")

    @action.setter
    def action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action", value)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> Optional[pulumi.Input[str]]:
        """
        The creation time of the traffic mirror filter rule.
        """
        return pulumi.get(self, "created_at")

    @created_at.setter
    def created_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "created_at", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the description of the traffic mirror filter rule.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="destinationCidrBlock")
    def destination_cidr_block(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the destination IP address of the traffic traffic mirror filter
        rule.
        """
        return pulumi.get(self, "destination_cidr_block")

    @destination_cidr_block.setter
    def destination_cidr_block(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "destination_cidr_block", value)

    @property
    @pulumi.getter(name="destinationPortRange")
    def destination_port_range(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the destination port number range of the traffic mirror filter
        rule. The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        """
        return pulumi.get(self, "destination_port_range")

    @destination_port_range.setter
    def destination_port_range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "destination_port_range", value)

    @property
    @pulumi.getter
    def direction(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the direction of the traffic mirror filter rule.
        Valid values are **ingress** or **egress**. Changing this creates a new resource.
        """
        return pulumi.get(self, "direction")

    @direction.setter
    def direction(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "direction", value)

    @property
    @pulumi.getter
    def ethertype(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the IP address protocol type of the traffic mirror filter rule.
        Valid values are **IPv4** or **IPv6**.
        """
        return pulumi.get(self, "ethertype")

    @ethertype.setter
    def ethertype(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ethertype", value)

    @property
    @pulumi.getter
    def priority(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the priority number of the traffic mirror filter rule.
        Valid value ranges from `1` to `65,535`.
        The smaller the priority number, the higher the priority.
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter
    def protocol(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the protocol of the traffic mirror filter rule.
        Valid value are **tcp**, **udp**, **icmp**, **icmpv6**, **all**.
        """
        return pulumi.get(self, "protocol")

    @protocol.setter
    def protocol(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "protocol", value)

    @property
    @pulumi.getter
    def region(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the region in which to create the resource.
        If omitted, the provider-level region will be used.
        Changing this creates a new resource.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="sourceCidrBlock")
    def source_cidr_block(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the source IP address of the traffic traffic mirror filter rule.
        """
        return pulumi.get(self, "source_cidr_block")

    @source_cidr_block.setter
    def source_cidr_block(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source_cidr_block", value)

    @property
    @pulumi.getter(name="sourcePortRange")
    def source_port_range(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the source port number range of the traffic mirror filter rule.
        The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        """
        return pulumi.get(self, "source_port_range")

    @source_port_range.setter
    def source_port_range(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "source_port_range", value)

    @property
    @pulumi.getter(name="trafficMirrorFilterId")
    def traffic_mirror_filter_id(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies an ID of the traffic mirror filter to which
        the rule belongs. Changing this creates a new resource.
        """
        return pulumi.get(self, "traffic_mirror_filter_id")

    @traffic_mirror_filter_id.setter
    def traffic_mirror_filter_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "traffic_mirror_filter_id", value)

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> Optional[pulumi.Input[str]]:
        """
        The latest update time of the traffic mirror filter rule.
        """
        return pulumi.get(self, "updated_at")

    @updated_at.setter
    def updated_at(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "updated_at", value)


class TrafficMirrorFilterRule(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 destination_cidr_block: Optional[pulumi.Input[str]] = None,
                 destination_port_range: Optional[pulumi.Input[str]] = None,
                 direction: Optional[pulumi.Input[str]] = None,
                 ethertype: Optional[pulumi.Input[str]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 protocol: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 source_cidr_block: Optional[pulumi.Input[str]] = None,
                 source_port_range: Optional[pulumi.Input[str]] = None,
                 traffic_mirror_filter_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages a VPC traffic mirror filter rule resource within HuaweiCloud.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        traffic_mirror_filter_id = config.require_object("trafficMirrorFilterId")
        test = huaweicloud.vpc.TrafficMirrorFilterRule("test",
            traffic_mirror_filter_id=traffic_mirror_filter_id,
            direction="ingress",
            protocol="tcp",
            ethertype="IPv4",
            action="accept",
            priority=1,
            source_cidr_block="10.0.0.0/8",
            source_port_range="80-90",
            destination_cidr_block="192.168.1.0/24",
            destination_port_range="10-65535")
        ```

        ## Import

        The traffic mirror filter rule can be imported using `id`, e.g. bash

        ```sh
         $ pulumi import huaweicloud:Vpc/trafficMirrorFilterRule:TrafficMirrorFilterRule test <id>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: Specifies the policy of in the traffic mirror filter rule.
               Valid values are **accept** or **reject**.
        :param pulumi.Input[str] description: Specifies the description of the traffic mirror filter rule.
        :param pulumi.Input[str] destination_cidr_block: Specifies the destination IP address of the traffic traffic mirror filter
               rule.
        :param pulumi.Input[str] destination_port_range: Specifies the destination port number range of the traffic mirror filter
               rule. The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        :param pulumi.Input[str] direction: Specifies the direction of the traffic mirror filter rule.
               Valid values are **ingress** or **egress**. Changing this creates a new resource.
        :param pulumi.Input[str] ethertype: Specifies the IP address protocol type of the traffic mirror filter rule.
               Valid values are **IPv4** or **IPv6**.
        :param pulumi.Input[int] priority: Specifies the priority number of the traffic mirror filter rule.
               Valid value ranges from `1` to `65,535`.
               The smaller the priority number, the higher the priority.
        :param pulumi.Input[str] protocol: Specifies the protocol of the traffic mirror filter rule.
               Valid value are **tcp**, **udp**, **icmp**, **icmpv6**, **all**.
        :param pulumi.Input[str] region: Specifies the region in which to create the resource.
               If omitted, the provider-level region will be used.
               Changing this creates a new resource.
        :param pulumi.Input[str] source_cidr_block: Specifies the source IP address of the traffic traffic mirror filter rule.
        :param pulumi.Input[str] source_port_range: Specifies the source port number range of the traffic mirror filter rule.
               The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        :param pulumi.Input[str] traffic_mirror_filter_id: Specifies an ID of the traffic mirror filter to which
               the rule belongs. Changing this creates a new resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TrafficMirrorFilterRuleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages a VPC traffic mirror filter rule resource within HuaweiCloud.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_huaweicloud as huaweicloud

        config = pulumi.Config()
        traffic_mirror_filter_id = config.require_object("trafficMirrorFilterId")
        test = huaweicloud.vpc.TrafficMirrorFilterRule("test",
            traffic_mirror_filter_id=traffic_mirror_filter_id,
            direction="ingress",
            protocol="tcp",
            ethertype="IPv4",
            action="accept",
            priority=1,
            source_cidr_block="10.0.0.0/8",
            source_port_range="80-90",
            destination_cidr_block="192.168.1.0/24",
            destination_port_range="10-65535")
        ```

        ## Import

        The traffic mirror filter rule can be imported using `id`, e.g. bash

        ```sh
         $ pulumi import huaweicloud:Vpc/trafficMirrorFilterRule:TrafficMirrorFilterRule test <id>
        ```

        :param str resource_name: The name of the resource.
        :param TrafficMirrorFilterRuleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TrafficMirrorFilterRuleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 action: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 destination_cidr_block: Optional[pulumi.Input[str]] = None,
                 destination_port_range: Optional[pulumi.Input[str]] = None,
                 direction: Optional[pulumi.Input[str]] = None,
                 ethertype: Optional[pulumi.Input[str]] = None,
                 priority: Optional[pulumi.Input[int]] = None,
                 protocol: Optional[pulumi.Input[str]] = None,
                 region: Optional[pulumi.Input[str]] = None,
                 source_cidr_block: Optional[pulumi.Input[str]] = None,
                 source_port_range: Optional[pulumi.Input[str]] = None,
                 traffic_mirror_filter_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TrafficMirrorFilterRuleArgs.__new__(TrafficMirrorFilterRuleArgs)

            if action is None and not opts.urn:
                raise TypeError("Missing required property 'action'")
            __props__.__dict__["action"] = action
            __props__.__dict__["description"] = description
            __props__.__dict__["destination_cidr_block"] = destination_cidr_block
            __props__.__dict__["destination_port_range"] = destination_port_range
            if direction is None and not opts.urn:
                raise TypeError("Missing required property 'direction'")
            __props__.__dict__["direction"] = direction
            if ethertype is None and not opts.urn:
                raise TypeError("Missing required property 'ethertype'")
            __props__.__dict__["ethertype"] = ethertype
            if priority is None and not opts.urn:
                raise TypeError("Missing required property 'priority'")
            __props__.__dict__["priority"] = priority
            if protocol is None and not opts.urn:
                raise TypeError("Missing required property 'protocol'")
            __props__.__dict__["protocol"] = protocol
            __props__.__dict__["region"] = region
            __props__.__dict__["source_cidr_block"] = source_cidr_block
            __props__.__dict__["source_port_range"] = source_port_range
            if traffic_mirror_filter_id is None and not opts.urn:
                raise TypeError("Missing required property 'traffic_mirror_filter_id'")
            __props__.__dict__["traffic_mirror_filter_id"] = traffic_mirror_filter_id
            __props__.__dict__["created_at"] = None
            __props__.__dict__["updated_at"] = None
        super(TrafficMirrorFilterRule, __self__).__init__(
            'huaweicloud:Vpc/trafficMirrorFilterRule:TrafficMirrorFilterRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            action: Optional[pulumi.Input[str]] = None,
            created_at: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            destination_cidr_block: Optional[pulumi.Input[str]] = None,
            destination_port_range: Optional[pulumi.Input[str]] = None,
            direction: Optional[pulumi.Input[str]] = None,
            ethertype: Optional[pulumi.Input[str]] = None,
            priority: Optional[pulumi.Input[int]] = None,
            protocol: Optional[pulumi.Input[str]] = None,
            region: Optional[pulumi.Input[str]] = None,
            source_cidr_block: Optional[pulumi.Input[str]] = None,
            source_port_range: Optional[pulumi.Input[str]] = None,
            traffic_mirror_filter_id: Optional[pulumi.Input[str]] = None,
            updated_at: Optional[pulumi.Input[str]] = None) -> 'TrafficMirrorFilterRule':
        """
        Get an existing TrafficMirrorFilterRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] action: Specifies the policy of in the traffic mirror filter rule.
               Valid values are **accept** or **reject**.
        :param pulumi.Input[str] created_at: The creation time of the traffic mirror filter rule.
        :param pulumi.Input[str] description: Specifies the description of the traffic mirror filter rule.
        :param pulumi.Input[str] destination_cidr_block: Specifies the destination IP address of the traffic traffic mirror filter
               rule.
        :param pulumi.Input[str] destination_port_range: Specifies the destination port number range of the traffic mirror filter
               rule. The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        :param pulumi.Input[str] direction: Specifies the direction of the traffic mirror filter rule.
               Valid values are **ingress** or **egress**. Changing this creates a new resource.
        :param pulumi.Input[str] ethertype: Specifies the IP address protocol type of the traffic mirror filter rule.
               Valid values are **IPv4** or **IPv6**.
        :param pulumi.Input[int] priority: Specifies the priority number of the traffic mirror filter rule.
               Valid value ranges from `1` to `65,535`.
               The smaller the priority number, the higher the priority.
        :param pulumi.Input[str] protocol: Specifies the protocol of the traffic mirror filter rule.
               Valid value are **tcp**, **udp**, **icmp**, **icmpv6**, **all**.
        :param pulumi.Input[str] region: Specifies the region in which to create the resource.
               If omitted, the provider-level region will be used.
               Changing this creates a new resource.
        :param pulumi.Input[str] source_cidr_block: Specifies the source IP address of the traffic traffic mirror filter rule.
        :param pulumi.Input[str] source_port_range: Specifies the source port number range of the traffic mirror filter rule.
               The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        :param pulumi.Input[str] traffic_mirror_filter_id: Specifies an ID of the traffic mirror filter to which
               the rule belongs. Changing this creates a new resource.
        :param pulumi.Input[str] updated_at: The latest update time of the traffic mirror filter rule.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _TrafficMirrorFilterRuleState.__new__(_TrafficMirrorFilterRuleState)

        __props__.__dict__["action"] = action
        __props__.__dict__["created_at"] = created_at
        __props__.__dict__["description"] = description
        __props__.__dict__["destination_cidr_block"] = destination_cidr_block
        __props__.__dict__["destination_port_range"] = destination_port_range
        __props__.__dict__["direction"] = direction
        __props__.__dict__["ethertype"] = ethertype
        __props__.__dict__["priority"] = priority
        __props__.__dict__["protocol"] = protocol
        __props__.__dict__["region"] = region
        __props__.__dict__["source_cidr_block"] = source_cidr_block
        __props__.__dict__["source_port_range"] = source_port_range
        __props__.__dict__["traffic_mirror_filter_id"] = traffic_mirror_filter_id
        __props__.__dict__["updated_at"] = updated_at
        return TrafficMirrorFilterRule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def action(self) -> pulumi.Output[str]:
        """
        Specifies the policy of in the traffic mirror filter rule.
        Valid values are **accept** or **reject**.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> pulumi.Output[str]:
        """
        The creation time of the traffic mirror filter rule.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the description of the traffic mirror filter rule.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="destinationCidrBlock")
    def destination_cidr_block(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the destination IP address of the traffic traffic mirror filter
        rule.
        """
        return pulumi.get(self, "destination_cidr_block")

    @property
    @pulumi.getter(name="destinationPortRange")
    def destination_port_range(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the destination port number range of the traffic mirror filter
        rule. The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        """
        return pulumi.get(self, "destination_port_range")

    @property
    @pulumi.getter
    def direction(self) -> pulumi.Output[str]:
        """
        Specifies the direction of the traffic mirror filter rule.
        Valid values are **ingress** or **egress**. Changing this creates a new resource.
        """
        return pulumi.get(self, "direction")

    @property
    @pulumi.getter
    def ethertype(self) -> pulumi.Output[str]:
        """
        Specifies the IP address protocol type of the traffic mirror filter rule.
        Valid values are **IPv4** or **IPv6**.
        """
        return pulumi.get(self, "ethertype")

    @property
    @pulumi.getter
    def priority(self) -> pulumi.Output[int]:
        """
        Specifies the priority number of the traffic mirror filter rule.
        Valid value ranges from `1` to `65,535`.
        The smaller the priority number, the higher the priority.
        """
        return pulumi.get(self, "priority")

    @property
    @pulumi.getter
    def protocol(self) -> pulumi.Output[str]:
        """
        Specifies the protocol of the traffic mirror filter rule.
        Valid value are **tcp**, **udp**, **icmp**, **icmpv6**, **all**.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter
    def region(self) -> pulumi.Output[str]:
        """
        Specifies the region in which to create the resource.
        If omitted, the provider-level region will be used.
        Changing this creates a new resource.
        """
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="sourceCidrBlock")
    def source_cidr_block(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the source IP address of the traffic traffic mirror filter rule.
        """
        return pulumi.get(self, "source_cidr_block")

    @property
    @pulumi.getter(name="sourcePortRange")
    def source_port_range(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the source port number range of the traffic mirror filter rule.
        The value ranges from `1` to `65,535`, enter two port numbers connected by a hyphen (-). For example, **80-200**.
        """
        return pulumi.get(self, "source_port_range")

    @property
    @pulumi.getter(name="trafficMirrorFilterId")
    def traffic_mirror_filter_id(self) -> pulumi.Output[str]:
        """
        Specifies an ID of the traffic mirror filter to which
        the rule belongs. Changing this creates a new resource.
        """
        return pulumi.get(self, "traffic_mirror_filter_id")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> pulumi.Output[str]:
        """
        The latest update time of the traffic mirror filter rule.
        """
        return pulumi.get(self, "updated_at")

